import "net"

type NdcfgModule2slotType struct {
	Gpk               string `mapstructure:"gpk"`
	SlotType          string `mapstructure:"slot_type"`
	ModuleType        string `mapstructure:"module_type"`
	NumModeName       string `mapstructure:"num_mode_name"`
	NumModeLevel      int64  `mapstructure:"num_mode_level"`
	RequiredSlotWidth int64  `mapstructure:"required_slot_width"`
}

type NdcfgModuleTypeClass struct {
	Gpk              string `mapstructure:"gpk"`
	Name             string `mapstructure:"name"`
	Description      string `mapstructure:"description"`
	IsGlobalReadable bool   `mapstructure:"is_global_readable"`
}

type DnsZone struct {
	Gpk                      string  `mapstructure:"gpk"`
	Fqdn                     string  `mapstructure:"fqdn"`
	IsOwn                    bool    `mapstructure:"is_own"`
	IsApex                   bool    `mapstructure:"is_apex"`
	Description              *string `mapstructure:"description"`
	NsSetName                *string `mapstructure:"ns_set_name"`
	Nsec3Itcount             int64   `mapstructure:"nsec3_itcount"`
	DnssecDoSign             bool    `mapstructure:"dnssec_do_sign"`
	SoaDataRetry             *uint32 `mapstructure:"soa_data_retry"`
	Nsec3HashAlgo            int64   `mapstructure:"nsec3_hash_algo"`
	SoaDataExpire            *uint32 `mapstructure:"soa_data_expire"`
	SoaDataSerial            uint32  `mapstructure:"soa_data_serial"`
	SoaDataMinimum           *uint32 `mapstructure:"soa_data_minimum"`
	SoaDataRefresh           *uint32 `mapstructure:"soa_data_refresh"`
	DnssecDoEnforce          bool    `mapstructure:"dnssec_do_enforce"`
	DfltTtlRrtDbext          uint32  `mapstructure:"dflt_ttl_rrt_dbext"`
	DfltTtlRrtDbint          uint32  `mapstructure:"dflt_ttl_rrt_dbint"`
	SoaDataHostmaster        *string `mapstructure:"soa_data_hostmaster"`
	DnssecKskRrsArePublished bool    `mapstructure:"dnssec_ksk_rrs_are_published"`
}

type NdcfgPPortProto struct {
	Gpk  string `mapstructure:"gpk"`
	Name string `mapstructure:"name"`
}

type CntlSystem struct {
	Gpk         string  `mapstructure:"gpk"`
	Name        string  `mapstructure:"name"`
	Description *string `mapstructure:"description"`
}

type CntlMgr struct {
	Gpk                   string  `mapstructure:"gpk"`
	Email                 *string `mapstructure:"email"`
	IsOwn                 bool    `mapstructure:"is_own"`
	LastName              *string `mapstructure:"last_name"`
	FirstName             *string `mapstructure:"first_name"`
	KitStatus             int64   `mapstructure:"kit_status"`
	LoginName             string  `mapstructure:"login_name"`
	Description           *string `mapstructure:"description"`
	IsAdmLocked           bool    `mapstructure:"is_adm_locked"`
	IsSubAccount          bool    `mapstructure:"is_sub_account"`
	ParentLoginName       string  `mapstructure:"parent_login_name"`
	EnableDeleteDate      *string `mapstructure:"enable_delete_date"`
	KitStatusDescription  string  `mapstructure:"kit_status_description"`
	AllowDataManipulation bool    `mapstructure:"allow_data_manipulation"`
	KitOrgUnitShortName   *string `mapstructure:"kit_org_unit_short_name"`
}

type NdIpSubnet struct {
	Bcd                 string      `mapstructure:"bcd"`
	Gpk                 string      `mapstructure:"gpk"`
	Cidr                net.IPNet   `mapstructure:"cidr"`
	Type                string      `mapstructure:"type"`
	IsOwn               bool        `mapstructure:"is_own"`
	IsPrivate           bool        `mapstructure:"is_private"`
	Description         *string     `mapstructure:"description"`
	IsRoutable          bool        `mapstructure:"is_routable"`
	IsContainer         bool        `mapstructure:"is_container"`
	DefaultGateway      *net.IPAddr `mapstructure:"default_gateway"`
	DhcpLeaseCount      int64       `mapstructure:"dhcp_lease_count"`
	DnsAddrRrCount      int64       `mapstructure:"dns_addr_rr_count"`
	DhcpIpAddrCount     int64       `mapstructure:"dhcp_ip_addr_count"`
	DnsAddrRsvCount     int64       `mapstructure:"dns_addr_rsv_count"`
	IsIanaRegistered    bool        `mapstructure:"is_iana_registered"`
	AutoCreateIpAddress bool        `mapstructure:"auto_create_ip_address"`
}

type NdcfgPPort2moduleType struct {
	Gpk                    string  `mapstructure:"gpk"`
	IntGfk                 string  `mapstructure:"int_gfk"`
	PortType               string  `mapstructure:"port_type"`
	PortCount              int64   `mapstructure:"port_count"`
	PortName1              *string `mapstructure:"port_name1"`
	PortProto              string  `mapstructure:"port_proto"`
	PortSpeed              string  `mapstructure:"port_speed"`
	ModuleType             string  `mapstructure:"module_type"`
	NumModeName            string  `mapstructure:"num_mode_name"`
	NumModeLevel           int64   `mapstructure:"num_mode_level"`
	PortIncCount           int64   `mapstructure:"port_inc_count"`
	PortTypeGroup          string  `mapstructure:"port_type_group"`
	PortTypeOrder          int64   `mapstructure:"port_type_order"`
	PortNamePrefix         *string `mapstructure:"port_name_prefix"`
	PortNameSuffix         *string `mapstructure:"port_name_suffix"`
	PortNameVarprfx        *string `mapstructure:"port_name_varprfx"`
	PortNameVarprfxJoinDl  *string `mapstructure:"port_name_varprfx_join_dl"`
	PortNameVarprfxSplitDl *string `mapstructure:"port_name_varprfx_split_dl"`
}

type CntlError struct {
	Gpk            string   `mapstructure:"gpk"`
	Code           int64    `mapstructure:"code"`
	Type           int64    `mapstructure:"type"`
	Details        *string  `mapstructure:"details"`
	Description    string   `mapstructure:"description"`
	ConstraintList []string `mapstructure:"constraint_list"`
}

type DnsFqdn struct {
	Gpk                     string       `mapstructure:"gpk"`
	Type                    string       `mapstructure:"type"`
	Zone                    string       `mapstructure:"zone"`
	Label                   *string      `mapstructure:"label"`
	Value                   string       `mapstructure:"value"`
	HasRr                   bool         `mapstructure:"has_rr"`
	IsOwn                   bool         `mapstructure:"is_own"`
	IsDhcp                  bool         `mapstructure:"is_dhcp"`
	IsHost                  bool         `mapstructure:"is_host"`
	RadType                 int64        `mapstructure:"rad_type"`
	TreeLevel               int32        `mapstructure:"tree_level"`
	ValueIdna               string       `mapstructure:"value_idna"`
	Description             *string      `mapstructure:"description"`
	IsWildcard              bool         `mapstructure:"is_wildcard"`
	ParentValue             *string      `mapstructure:"parent_value"`
	RootNodeSet             []int64      `mapstructure:"root_node_set"`
	IsNonterminal           bool         `mapstructure:"is_nonterminal"`
	SubFqdnCount            int64        `mapstructure:"sub_fqdn_count"`
	IsEmptyNonterminal      bool         `mapstructure:"is_empty_nonterminal"`
	RrChainTargetIsOwn      bool         `mapstructure:"rr_chain_target_is_own"`
	RrChainTargetBcdList    *[]string    `mapstructure:"rr_chain_target_bcd_list"`
	RrChainTargetSubnetList *[]net.IPNet `mapstructure:"rr_chain_target_subnet_list"`
}

type NdcfgSlot2moduleType struct {
	Gpk                string  `mapstructure:"gpk"`
	SlotType           string  `mapstructure:"slot_type"`
	ModuleType         string  `mapstructure:"module_type"`
	NumModeName        string  `mapstructure:"num_mode_name"`
	SubslotCount       int64   `mapstructure:"subslot_count"`
	SubslotName1       *string `mapstructure:"subslot_name1"`
	NumModeLevel       int64   `mapstructure:"num_mode_level"`
	SubslotPrefix      *string `mapstructure:"subslot_prefix"`
	SubslotIncCount    int64   `mapstructure:"subslot_inc_count"`
	SubslotTypeOrder   int64   `mapstructure:"subslot_type_order"`
	BackplanePortDescr *string `mapstructure:"backplane_port_descr"`
}

type NdSlot struct {
	Gpk            string  `mapstructure:"gpk"`
	Bldg           *string `mapstructure:"bldg"`
	Room           *string `mapstructure:"room"`
	Type           string  `mapstructure:"type"`
	Label          string  `mapstructure:"label"`
	FqName         string  `mapstructure:"fq_name"`
	Description    *string `mapstructure:"description"`
	LabelSortby    string  `mapstructure:"label_sortby"`
	ParentFqModule string  `mapstructure:"parent_fq_module"`
	SubModuleCount int64   `mapstructure:"sub_module_count"`
}

type NdFloor struct {
	Gpk         string  `mapstructure:"gpk"`
	Name        string  `mapstructure:"name"`
	Description *string `mapstructure:"description"`
	NameSortby  int64   `mapstructure:"name_sortby"`
}

type NdRoom struct {
	Gpk         string  `mapstructure:"gpk"`
	Bldg        string  `mapstructure:"bldg"`
	Name        string  `mapstructure:"name"`
	Floor       string  `mapstructure:"floor"`
	Number      string  `mapstructure:"number"`
	Description *string `mapstructure:"description"`
}

type CntlColumn struct {
	Gpk              string  `mapstructure:"gpk"`
	Name             string  `mapstructure:"name"`
	IsWapi           bool    `mapstructure:"is_wapi"`
	RefName          *string `mapstructure:"ref_name"`
	DataType         string  `mapstructure:"data_type"`
	LongTitle        *string `mapstructure:"long_title"`
	TableName        string  `mapstructure:"table_name"`
	IsNullable       bool    `mapstructure:"is_nullable"`
	IsRequired       bool    `mapstructure:"is_required"`
	IsDeprecated     bool    `mapstructure:"is_deprecated"`
	AttributeName    string  `mapstructure:"attribute_name"`
	RefTableName     *string `mapstructure:"ref_table_name"`
	ShortTitleAbs    string  `mapstructure:"short_title_abs"`
	ShortTitleRel    string  `mapstructure:"short_title_rel"`
	ObjectTypeFqName string  `mapstructure:"object_type_fq_name"`
}

type NdModule struct {
	Ap           *string `mapstructure:"ap"`
	Gpk          string  `mapstructure:"gpk"`
	Bldg         *string `mapstructure:"bldg"`
	Room         *string `mapstructure:"room"`
	Type         string  `mapstructure:"type"`
	Label        string  `mapstructure:"label"`
	FqName       string  `mapstructure:"fq_name"`
	IsChild      bool    `mapstructure:"is_child"`
	RootGfk      string  `mapstructure:"root_gfk"`
	IsActive     bool    `mapstructure:"is_active"`
	TreeLevel    int32   `mapstructure:"tree_level"`
	Description  *string `mapstructure:"description"`
	HasUnqName   bool    `mapstructure:"has_unq_name"`
	IsLocDepdnt  bool    `mapstructure:"is_loc_depdnt"`
	RootNodeSet  []int64 `mapstructure:"root_node_set"`
	ParentFqSlot *string `mapstructure:"parent_fq_slot"`
}

type NdcfgPPortType struct {
	Gpk        string `mapstructure:"gpk"`
	Name       string `mapstructure:"name"`
	IsInternal bool   `mapstructure:"is_internal"`
}

type NdcfgSlotType struct {
	Gpk        string `mapstructure:"gpk"`
	Name       string `mapstructure:"name"`
	Class      string `mapstructure:"class"`
	SlotWidth  int64  `mapstructure:"slot_width"`
	SubmtCount int64  `mapstructure:"submt_count"`
}

type NdcfgPPortTypeGroup struct {
	Gpk         string `mapstructure:"gpk"`
	Name        string `mapstructure:"name"`
	IsPermanent bool   `mapstructure:"is_permanent"`
}

type NmAccessGroup struct {
	Gpk         string  `mapstructure:"gpk"`
	Name        string  `mapstructure:"name"`
	Description *string `mapstructure:"description"`
}

type NdVlanEgress struct {
	Gpk      string `mapstructure:"gpk"`
	VlanGfk  string `mapstructure:"vlan_gfk"`
	IsTagged bool   `mapstructure:"is_tagged"`
	LPortGfk string `mapstructure:"l_port_gfk"`
}

type NdcfgNetInstnc struct {
	Gpk         string  `mapstructure:"gpk"`
	Name        string  `mapstructure:"name"`
	Description *string `mapstructure:"description"`
}

type CntlConstraint struct {
	Gpk                  string   `mapstructure:"gpk"`
	Name                 string   `mapstructure:"name"`
	Type                 string   `mapstructure:"type"`
	RefName              *string  `mapstructure:"ref_name"`
	DblvlName            *string  `mapstructure:"dblvl_name"`
	TableName            string   `mapstructure:"table_name"`
	Description          *string  `mapstructure:"description"`
	IsFunction           bool     `mapstructure:"is_function"`
	IsApiLevel           bool     `mapstructure:"is_api_level"`
	ColNameList          []string `mapstructure:"col_name_list"`
	JoinOperator         string   `mapstructure:"join_operator"`
	IsReferencing        bool     `mapstructure:"is_referencing"`
	IsJoinDefault        bool     `mapstructure:"is_join_default"`
	DblvlTableName       *string  `mapstructure:"dblvl_table_name"`
	IsReferenceable      bool     `mapstructure:"is_referenceable"`
	ColDataTypeList      []string `mapstructure:"col_data_type_list"`
	JoinGrantsReadAccess bool     `mapstructure:"join_grants_read_access"`
}

type NdcfgPPortTypeData struct {
	Gpk       string `mapstructure:"gpk"`
	PortType  string `mapstructure:"port_type"`
	PortGroup string `mapstructure:"port_group"`
	PortProto string `mapstructure:"port_proto"`
	PortSpeed string `mapstructure:"port_speed"`
}

type CntlErrorType struct {
	Gpk         string `mapstructure:"gpk"`
	Code        int64  `mapstructure:"code"`
	Name        string `mapstructure:"name"`
	Description string `mapstructure:"description"`
}

type NdBldg struct {
	Gpk         string              `mapstructure:"gpk"`
	Name        string              `mapstructure:"name"`
	Number      string              `mapstructure:"number"`
	Street      *string             `mapstructure:"street"`
	PostalCode  *int64              `mapstructure:"postal_code"`
	GeoLocation *map[string]float64 `mapstructure:"geo_location"`
	SiteFqName  string              `mapstructure:"site_fq_name"`
}

type NdcfgModuleType struct {
	Gpk          string `mapstructure:"gpk"`
	Name         string `mapstructure:"name"`
	Class        string `mapstructure:"class"`
	IsChild      bool   `mapstructure:"is_child"`
	IsActive     bool   `mapstructure:"is_active"`
	IsParent     bool   `mapstructure:"is_parent"`
	HasUnqName   bool   `mapstructure:"has_unq_name"`
	IsForwarding bool   `mapstructure:"is_forwarding"`
	IsLocDepdnt  bool   `mapstructure:"is_loc_depdnt"`
}

type CntlTable struct {
	Gpk                string  `mapstructure:"gpk"`
	Name               string  `mapstructure:"name"`
	IsLogDst           bool    `mapstructure:"is_log_dst"`
	IsLogSrc           bool    `mapstructure:"is_log_src"`
	ContentPlur1       string  `mapstructure:"content_plur1"`
	ContentSing1       string  `mapstructure:"content_sing1"`
	ContentTitle       *string `mapstructure:"content_title"`
	IsOtattrDst        bool    `mapstructure:"is_otattr_dst"`
	IsOtattrSrc        bool    `mapstructure:"is_otattr_src"`
	ContentDetail      *string `mapstructure:"content_detail"`
	ContentGender      string  `mapstructure:"content_gender"`
	ContentCompound    string  `mapstructure:"content_compound"`
	ContentAbbreviated *string `mapstructure:"content_abbreviated"`
	ObjectTypeFqName   string  `mapstructure:"object_type_fq_name"`
}

type NdPPort struct {
	Gpk                   string  `mapstructure:"gpk"`
	Name                  string  `mapstructure:"name"`
	Type                  string  `mapstructure:"type"`
	Speed                 string  `mapstructure:"speed"`
	IsNnl                 bool    `mapstructure:"is_nnl"`
	MdlBldg               *string `mapstructure:"mdl_bldg"`
	MdlRoom               *string `mapstructure:"mdl_room"`
	MdlType               string  `mapstructure:"mdl_type"`
	Protocol              string  `mapstructure:"protocol"`
	TypeGroup             string  `mapstructure:"type_group"`
	Description           *string `mapstructure:"description"`
	MdlFqName             string  `mapstructure:"mdl_fq_name"`
	NameSortby            string  `mapstructure:"name_sortby"`
	TypeSortby            int64   `mapstructure:"type_sortby"`
	IsConnected           bool    `mapstructure:"is_connected"`
	IsDefective           bool    `mapstructure:"is_defective"`
	IsEdgeNode            bool    `mapstructure:"is_edge_node"`
	ConnectedGfk          string  `mapstructure:"connected_gfk"`
	ConnectedName         *string `mapstructure:"connected_name"`
	ConnectedMdlBldg      *string `mapstructure:"connected_mdl_bldg"`
	ConnectedMdlRoom      *string `mapstructure:"connected_mdl_room"`
	DestConnectedGfk      string  `mapstructure:"dest_connected_gfk"`
	ConnectionIdNodes     []int64 `mapstructure:"connection_id_nodes"`
	ConnectionPosition    int32   `mapstructure:"connection_position"`
	ConnectionHopCount    *int64  `mapstructure:"connection_hop_count"`
	ConnectedMdlFqName    *string `mapstructure:"connected_mdl_fq_name"`
	IsInternalConnected   bool    `mapstructure:"is_internal_connected"`
	InternalConnectedGfk  string  `mapstructure:"internal_connected_gfk"`
	InternalConnectedName *string `mapstructure:"internal_connected_name"`
}

type NdcfgDeviceType struct {
	Gpk                   string `mapstructure:"gpk"`
	Name                  string `mapstructure:"name"`
	Description           string `mapstructure:"description"`
	NwFwdLevel            int64  `mapstructure:"nw_fwd_level"`
	NwFwdLevelDescription string `mapstructure:"nw_fwd_level_description"`
}

type NdcfgParser struct {
	Gpk          string                 `mapstructure:"gpk"`
	Name         string                 `mapstructure:"name"`
	ExecArgs     map[string]interface{} `mapstructure:"exec_args"`
	Description  *string                `mapstructure:"description"`
	AccessGroup  string                 `mapstructure:"access_group"`
	IsExecutable bool                   `mapstructure:"is_executable"`
}

type DnsIpAddr struct {
	Gpk          string     `mapstructure:"gpk"`
	Cidr         net.IPNet  `mapstructure:"cidr"`
	Type         string     `mapstructure:"type"`
	Value        net.IPAddr `mapstructure:"value"`
	IsOwn        bool       `mapstructure:"is_own"`
	IsDhcp       bool       `mapstructure:"is_dhcp"`
	IsReserved   bool       `mapstructure:"is_reserved"`
	IsRrTarget   bool       `mapstructure:"is_rr_target"`
	IsDhcpUnique bool       `mapstructure:"is_dhcp_unique"`
}

type NdSite struct {
	Gpk          string  `mapstructure:"gpk"`
	Name         string  `mapstructure:"name"`
	Type         string  `mapstructure:"type"`
	FqName       string  `mapstructure:"fq_name"`
	IsChild      bool    `mapstructure:"is_child"`
	HasParent    bool    `mapstructure:"has_parent"`
	Description  *string `mapstructure:"description"`
	ForceIsChild bool    `mapstructure:"force_is_child"`
}

type CntlRole struct {
	Gpk                  string                 `mapstructure:"gpk"`
	Name                 string                 `mapstructure:"name"`
	System               string                 `mapstructure:"system"`
	FqName               string                 `mapstructure:"fq_name"`
	IsRole               bool                   `mapstructure:"is_role"`
	Position             int64                  `mapstructure:"position"`
	Description          *string                `mapstructure:"description"`
	IsAdminRole          bool                   `mapstructure:"is_admin_role"`
	ContainedRoles       []interface{}          `mapstructure:"contained_roles"`
	IsDirectlyAssigned   bool                   `mapstructure:"is_directly_assigned"`
	ContainedPermissions map[string]interface{} `mapstructure:"contained_permissions"`
}

type NdcfgNetCmpnd struct {
	Gpk         string  `mapstructure:"gpk"`
	Name        string  `mapstructure:"name"`
	Description *string `mapstructure:"description"`
}

type NdcfgNumMode struct {
	Gpk   string `mapstructure:"gpk"`
	Name  string `mapstructure:"name"`
	Level int64  `mapstructure:"level"`
}

type NdcfgPPortSpeed struct {
	Gpk  string `mapstructure:"gpk"`
	Name string `mapstructure:"name"`
}

type CntlMgr2role struct {
	Gpk          string `mapstructure:"gpk"`
	Role         string `mapstructure:"role"`
	System       string `mapstructure:"system"`
	RoleFqName   string `mapstructure:"role_fq_name"`
	MgrLoginName string `mapstructure:"mgr_login_name"`
}

type CntlRole2role struct {
	Gpk                 string `mapstructure:"gpk"`
	RoleFqName          string `mapstructure:"role_fq_name"`
	RoleIsRole          bool   `mapstructure:"role_is_role"`
	ContainedRoleFqName string `mapstructure:"contained_role_fq_name"`
}

type NdModule2ap struct {
	Gpk       string `mapstructure:"gpk"`
	Bldg      string `mapstructure:"bldg"`
	Room      string `mapstructure:"room"`
	ApName    string `mapstructure:"ap_name"`
	MdlFqName string `mapstructure:"mdl_fq_name"`
}

type NdBcd struct {
	Gpk                         string  `mapstructure:"gpk"`
	Name                        string  `mapstructure:"name"`
	Categ                       string  `mapstructure:"categ"`
	IsOwn                       bool    `mapstructure:"is_own"`
	Seclvl                      int64   `mapstructure:"seclvl"`
	VlanCount                   int64   `mapstructure:"vlan_count"`
	Description                 *string `mapstructure:"description"`
	DhcpDomain                  *string `mapstructure:"dhcp_domain"`
	DhcpEnabled                 bool    `mapstructure:"dhcp_enabled"`
	SubnetCount                 int64   `mapstructure:"subnet_count"`
	AdminDescription            *string `mapstructure:"admin_description"`
	DhcpAcceptNewLeases         bool    `mapstructure:"dhcp_accept_new_leases"`
	DhcpTtlValuePercent         uint8   `mapstructure:"dhcp_ttl_value_percent"`
	DhcpLeasetimeDynDays        uint8   `mapstructure:"dhcp_leasetime_dyn_days"`
	DhcpLeasetimeDynHours       uint8   `mapstructure:"dhcp_leasetime_dyn_hours"`
	DhcpLeasetimeDynMinutes     uint8   `mapstructure:"dhcp_leasetime_dyn_minutes"`
	DhcpLeasetimeStaticDays     uint8   `mapstructure:"dhcp_leasetime_static_days"`
	DhcpLeasetimeStaticHours    uint8   `mapstructure:"dhcp_leasetime_static_hours"`
	DhcpOfferRsvTimeMinutes     uint8   `mapstructure:"dhcp_offer_rsv_time_minutes"`
	DhcpOfferRsvTimeSeconds     uint8   `mapstructure:"dhcp_offer_rsv_time_seconds"`
	DhcpLeasetimeStaticMinutes  uint8   `mapstructure:"dhcp_leasetime_static_minutes"`
	DhcpAcceptRequestedHostname *bool   `mapstructure:"dhcp_accept_requested_hostname"`
}

type NdcfgBcdCateg struct {
	Gpk         string  `mapstructure:"gpk"`
	Name        string  `mapstructure:"name"`
	Description *string `mapstructure:"description"`
}

type NdcfgBcdSeclvl struct {
	Gpk         string `mapstructure:"gpk"`
	Value       int64  `mapstructure:"value"`
	Description string `mapstructure:"description"`
}

type NdDevice struct {
	Nc               string  `mapstructure:"nc"`
	Acg              string  `mapstructure:"acg"`
	Gpk              string  `mapstructure:"gpk"`
	Fqdn             string  `mapstructure:"fqdn"`
	Type             string  `mapstructure:"type"`
	IsValid          bool    `mapstructure:"is_valid"`
	Sysdescr         *string `mapstructure:"sysdescr"`
	UsesVlans        bool    `mapstructure:"uses_vlans"`
	Description      *string `mapstructure:"description"`
	AssignedParser   string  `mapstructure:"assigned_parser"`
	ExecutableParser string  `mapstructure:"executable_parser"`
}

type NdIpIntf struct {
	Gpk         string     `mapstructure:"gpk"`
	LPort       string     `mapstructure:"l_port"`
	IpAddr      net.IPAddr `mapstructure:"ip_addr"`
	IsVrrp      bool       `mapstructure:"is_vrrp"`
	DevFqdn     string     `mapstructure:"dev_fqdn"`
	IsSecondary bool       `mapstructure:"is_secondary"`
}

type NdIpRoute struct {
	Gpk        string      `mapstructure:"gpk"`
	Cidr       net.IPNet   `mapstructure:"cidr"`
	IsOwn      bool        `mapstructure:"is_own"`
	Metric     int64       `mapstructure:"metric"`
	DevFqdn    string      `mapstructure:"dev_fqdn"`
	DestLPort  *string     `mapstructure:"dest_l_port"`
	DestIpAddr *net.IPAddr `mapstructure:"dest_ip_addr"`
}

type NdLPort struct {
	Gpk                 string    `mapstructure:"gpk"`
	Lag                 *int64    `mapstructure:"lag"`
	Name                string    `mapstructure:"name"`
	Level               int64     `mapstructure:"level"`
	DevFqdn             string    `mapstructure:"dev_fqdn"`
	Priority            int64     `mapstructure:"priority"`
	TagList             *[]string `mapstructure:"tag_list"`
	AdmState            int64     `mapstructure:"adm_state"`
	Description         *string   `mapstructure:"description"`
	NameSortby          string    `mapstructure:"name_sortby"`
	HasEgressVlans      bool      `mapstructure:"has_egress_vlans"`
	IngressVlanGfk      *string   `mapstructure:"ingress_vlan_gfk"`
	AdmStateDescription string    `mapstructure:"adm_state_description"`
}

type NdcfgNetCmpnd2instnc struct {
	Gpk       string `mapstructure:"gpk"`
	NetCmpnd  string `mapstructure:"net_cmpnd"`
	NetInstnc string `mapstructure:"net_instnc"`
}

type NdVlan struct {
	Id          uint16  `mapstructure:"id"`
	Bcd         string  `mapstructure:"bcd"`
	Gpk         string  `mapstructure:"gpk"`
	Name        string  `mapstructure:"name"`
	NetInstnc   string  `mapstructure:"net_instnc"`
	Description *string `mapstructure:"description"`
}

type NdL2pPort struct {
	Gpk       string `mapstructure:"gpk"`
	LPortGfk  string `mapstructure:"l_port_gfk"`
	PPortGfk  string `mapstructure:"p_port_gfk"`
	PortOrder int64  `mapstructure:"port_order"`
}

type NdDeviceAttributeImp struct {
	Value   *string `mapstructure:"value"`
	KeyWord string  `mapstructure:"key_word"`
}

type NdIpIntfImp struct {
	IpAddr      net.IPAddr `mapstructure:"ip_addr"`
	IsVrrp      bool       `mapstructure:"is_vrrp"`
	VrrpId      *int64     `mapstructure:"vrrp_id"`
	LPortName   string     `mapstructure:"l_port_name"`
	IsSecondary bool       `mapstructure:"is_secondary"`
}

type NdIpRouteImp struct {
	Net           net.IPNet   `mapstructure:"net"`
	Metric        int64       `mapstructure:"metric"`
	IsRoutable    bool        `mapstructure:"is_routable"`
	DestIpAddr    *net.IPAddr `mapstructure:"dest_ip_addr"`
	DestLPortName *string     `mapstructure:"dest_l_port_name"`
}

type NdL2pPortImp struct {
	PortOrder    int64   `mapstructure:"port_order"`
	LPortName    string  `mapstructure:"l_port_name"`
	PPortName    string  `mapstructure:"p_port_name"`
	FqModuleName *string `mapstructure:"fq_module_name"`
}

type NdLPortImp struct {
	Lag           *int64         `mapstructure:"lag"`
	Name          string         `mapstructure:"name"`
	Prio          *int64         `mapstructure:"prio"`
	Status        *int64         `mapstructure:"status"`
	TagList       *[]interface{} `mapstructure:"tag_list"`
	PortLevel     *int64         `mapstructure:"port_level"`
	Description   *string        `mapstructure:"description"`
	VlanIdIngress *uint16        `mapstructure:"vlan_id_ingress"`
}

type NdVlanEgressImp struct {
	Id        uint16 `mapstructure:"id"`
	IsTagged  bool   `mapstructure:"is_tagged"`
	LPortName string `mapstructure:"l_port_name"`
}

type NdVlanImp struct {
	Id        uint16  `mapstructure:"id"`
	Name      *string `mapstructure:"name"`
	VxlanVni  *uint32 `mapstructure:"vxlan_vni"`
	NetInstnc *string `mapstructure:"net_instnc"`
}

type EvlogRecordType struct {
	Gpk             string  `mapstructure:"gpk"`
	Action          string  `mapstructure:"action"`
	Subject         string  `mapstructure:"subject"`
	ShortName       string  `mapstructure:"short_name"`
	CommittedAction *string `mapstructure:"committed_action"`
}

type CntlGlobalPk2obj struct {
	Gpk              string                 `mapstructure:"gpk"`
	ObjectDict       map[string]interface{} `mapstructure:"object_dict"`
	ObjectTypeFqName string                 `mapstructure:"object_type_fq_name"`
}

type CntlConstraint2error struct {
	Sqlstate             string `mapstructure:"sqlstate"`
	ErrorCode            int64  `mapstructure:"error_code"`
	ConstraintName       string `mapstructure:"constraint_name"`
	ErrorTypeCode        int64  `mapstructure:"error_type_code"`
	ConstraintTable      string `mapstructure:"constraint_table"`
	ParentKeyNotFound    *bool  `mapstructure:"parent_key_not_found"`
	ConstraintIsApiLevel bool   `mapstructure:"constraint_is_api_level"`
}

type NdcfgParser2sysdescr struct {
	Gpk          string `mapstructure:"gpk"`
	Parser       string `mapstructure:"parser"`
	Sysdescr     string `mapstructure:"sysdescr"`
	IsExecutable bool   `mapstructure:"is_executable"`
}

type OrgUnitType struct {
	Gpk       string `mapstructure:"gpk"`
	Name      string `mapstructure:"name"`
	Position  int64  `mapstructure:"position"`
	ShortName string `mapstructure:"short_name"`
}

type OrgUnit struct {
	Gpk             string  `mapstructure:"gpk"`
	Name            string  `mapstructure:"name"`
	Type            string  `mapstructure:"type"`
	ShortName       string  `mapstructure:"short_name"`
	TreeLevel       int32   `mapstructure:"tree_level"`
	SubPosition     int64   `mapstructure:"sub_position"`
	RootNodeSet     []int64 `mapstructure:"root_node_set"`
	IsMgrAssignable bool    `mapstructure:"is_mgr_assignable"`
	ParentShortName *string `mapstructure:"parent_short_name"`
}

type NdcfgSlotTypeClass struct {
	Gpk         string `mapstructure:"gpk"`
	Name        string `mapstructure:"name"`
	Description string `mapstructure:"description"`
}

type NdcfgSlot2moduleTypeTree struct {
	Gpk                   string  `mapstructure:"gpk"`
	SlotType              string  `mapstructure:"slot_type"`
	ParentGfk             *string `mapstructure:"parent_gfk"`
	ModuleType            string  `mapstructure:"module_type"`
	FqPkString            string  `mapstructure:"fq_pk_string"`
	SlotVarname1          *string `mapstructure:"slot_varname1"`
	SubportPrefix         *string `mapstructure:"subport_prefix"`
	SubportVarprfx        *string `mapstructure:"subport_varprfx"`
	SubportVarname1       *string `mapstructure:"subport_varname1"`
	SubportVarprfxJoinDl  *string `mapstructure:"subport_varprfx_join_dl"`
	SubportVarprfxSplitDl *string `mapstructure:"subport_varprfx_split_dl"`
}

type DnscfgFqdnType struct {
	Gpk                string                 `mapstructure:"gpk"`
	Name               string                 `mapstructure:"name"`
	IsOwn              bool                   `mapstructure:"is_own"`
	IsDhcp             bool                   `mapstructure:"is_dhcp"`
	IsHost             bool                   `mapstructure:"is_host"`
	Intname            string                 `mapstructure:"_intname"`
	Position           int64                  `mapstructure:"position"`
	RadType            int64                  `mapstructure:"rad_type"`
	Groupname          string                 `mapstructure:"_groupname"`
	Description        string                 `mapstructure:"description"`
	IsWildcard         bool                   `mapstructure:"is_wildcard"`
	IsNonterminal      bool                   `mapstructure:"is_nonterminal"`
	VersionNameDict    map[string]interface{} `mapstructure:"version_name_dict"`
	PermissionFqName   *string                `mapstructure:"permission_fq_name"`
	RadTypeDescription string                 `mapstructure:"rad_type_description"`
}

type DnscfgRecordType struct {
	Gpk                       string  `mapstructure:"gpk"`
	Name                      string  `mapstructure:"name"`
	RfcInfo                   *string `mapstructure:"rfc_info"`
	NumValue                  int64   `mapstructure:"num_value"`
	IsInternal                bool    `mapstructure:"is_internal"`
	IsAddrBased               bool    `mapstructure:"is_addr_based"`
	IsNameBased               bool    `mapstructure:"is_name_based"`
	ForceAutoDml              bool    `mapstructure:"force_auto_dml"`
	FqdnTypeDflt              *string `mapstructure:"fqdn_type_dflt"`
	FqdnInttypeDflt           *string `mapstructure:"_fqdn_inttype_dflt"`
	TargetIsSingletonDflt     bool    `mapstructure:"target_is_singleton_dflt"`
	TargetIsReverseUniqueDflt bool    `mapstructure:"target_is_reverse_unique_dflt"`
}

type DnscfgRecordInttype struct {
	Gpk                           string                 `mapstructure:"gpk"`
	IsOwn                         bool                   `mapstructure:"is_own"`
	Intname                       string                 `mapstructure:"_intname"`
	FqdnType                      string                 `mapstructure:"fqdn_type"`
	Description                   string                 `mapstructure:"description"`
	RecordType                    string                 `mapstructure:"record_type"`
	FqdnInttype                   string                 `mapstructure:"_fqdn_inttype"`
	TargetFqdnType                *string                `mapstructure:"target_fqdn_type"`
	VersionDefDict                map[string]interface{} `mapstructure:"version_def_dict"`
	FqdnIsSingleton               bool                   `mapstructure:"fqdn_is_singleton"`
	PermissionFqName              *string                `mapstructure:"permission_fq_name"`
	TargetIsSingleton             bool                   `mapstructure:"target_is_singleton"`
	TargetFqdnInttype             *string                `mapstructure:"_target_fqdn_inttype"`
	FqdnAutomaticLevel            int64                  `mapstructure:"fqdn_automatic_level"`
	TargetIsReverseUnique         bool                   `mapstructure:"target_is_reverse_unique"`
	FqdnAutomaticLevelDescription string                 `mapstructure:"fqdn_automatic_level_description"`
}

type DnscfgNsSet struct {
	Gpk                 string  `mapstructure:"gpk"`
	Name                string  `mapstructure:"name"`
	HasHosts            bool    `mapstructure:"has_hosts"`
	HasZones            bool    `mapstructure:"has_zones"`
	Description         *string `mapstructure:"description"`
	HasMembers          bool    `mapstructure:"has_members"`
	SoaDataRetry        uint32  `mapstructure:"soa_data_retry"`
	SoaDataExpire       uint32  `mapstructure:"soa_data_expire"`
	SoaDataMinimum      uint32  `mapstructure:"soa_data_minimum"`
	SoaDataRefresh      uint32  `mapstructure:"soa_data_refresh"`
	SoaDataHostmaster   string  `mapstructure:"soa_data_hostmaster"`
	MembersAreExclusive bool    `mapstructure:"members_are_exclusive"`
}

type DnscfgNsSetMember struct {
	Gpk              string  `mapstructure:"gpk"`
	NsFqdn           string  `mapstructure:"ns_fqdn"`
	NsSetName        string  `mapstructure:"ns_set_name"`
	NsIsMaster       bool    `mapstructure:"ns_is_master"`
	NsIsNative       bool    `mapstructure:"ns_is_native"`
	NsIsPrimary      bool    `mapstructure:"ns_is_primary"`
	NsIsRegistered   bool    `mapstructure:"ns_is_registered"`
	NsXferMasterFqdn *string `mapstructure:"ns_xfer_master_fqdn"`
}

type DnsRecord struct {
	Gpk                     string       `mapstructure:"gpk"`
	Ttl                     *uint32      `mapstructure:"ttl"`
	Data                    *string      `mapstructure:"data"`
	Fqdn                    string       `mapstructure:"fqdn"`
	Type                    string       `mapstructure:"type"`
	Zone                    string       `mapstructure:"zone"`
	IsOwn                   bool         `mapstructure:"is_own"`
	IsAuth                  bool         `mapstructure:"is_auth"`
	FqdnType                string       `mapstructure:"fqdn_type"`
	HostIsNws               bool         `mapstructure:"host_is_nws"`
	TargetFqdn              *string      `mapstructure:"target_fqdn"`
	TargetIpaddr            *net.IPAddr  `mapstructure:"target_ipaddr"`
	TtlResetDate            *string      `mapstructure:"ttl_reset_date"`
	TtlResetDays            *uint8       `mapstructure:"ttl_reset_days"`
	TargetBcdList           *[]string    `mapstructure:"target_bcd_list"`
	FqdnDescription         *string      `mapstructure:"fqdn_description"`
	TargetFqdnType          *string      `mapstructure:"target_fqdn_type"`
	TtlZoneDefault          uint32       `mapstructure:"ttl_zone_default"`
	TargetDataUnref         *string      `mapstructure:"target_data_unref"`
	TargetIsSingleton       bool         `mapstructure:"target_is_singleton"`
	TargetIsReverseUnique   bool         `mapstructure:"target_is_reverse_unique"`
	RrChainTargetSubnetList *[]net.IPNet `mapstructure:"rr_chain_target_subnet_list"`
}

type NdModule2device struct {
	Gpk       string `mapstructure:"gpk"`
	DevFqdn   string `mapstructure:"dev_fqdn"`
	MdlFqName string `mapstructure:"mdl_fq_name"`
}

type DnscfgFqdn2perm struct {
	Gpk              string `mapstructure:"gpk"`
	Fqdn             string `mapstructure:"fqdn"`
	IsRecursive      bool   `mapstructure:"is_recursive"`
	IsZoneBound      bool   `mapstructure:"is_zone_bound"`
	RecursiveMinLvl  int64  `mapstructure:"recursive_min_lvl"`
	PermissionFqName string `mapstructure:"permission_fq_name"`
}

type WapiVersion struct {
	Major                int64   `mapstructure:"major"`
	Minor                int64   `mapstructure:"minor"`
	Patch                int64   `mapstructure:"patch"`
	Status               string  `mapstructure:"status"`
	DocUri               string  `mapstructure:"doc_uri"`
	Numeric              string  `mapstructure:"numeric"`
	Semantic             string  `mapstructure:"semantic"`
	Description          *string `mapstructure:"description"`
	LastStatusChangeDate string  `mapstructure:"last_status_change_date"`
}

type WapiTransactionStmt struct {
	New    map[string]interface{} `mapstructure:"new"`
	Old    map[string]interface{} `mapstructure:"old"`
	Join   map[string]interface{} `mapstructure:"join"`
	Name   string                 `mapstructure:"name"`
	NewRef map[string]interface{} `mapstructure:"new_ref"`
	OldRef map[string]interface{} `mapstructure:"old_ref"`
}

type WapiSystem struct {
	Name        string `mapstructure:"name"`
	Description string `mapstructure:"description"`
}

type WapiObjectType struct {
	Name              string                 `mapstructure:"name"`
	System            string                 `mapstructure:"system"`
	FqName            string                 `mapstructure:"fq_name"`
	Attributes        map[string]interface{} `mapstructure:"attributes"`
	IsLogDst          bool                   `mapstructure:"is_log_dst"`
	IsLogSrc          bool                   `mapstructure:"is_log_src"`
	Constraints       map[string]interface{} `mapstructure:"constraints"`
	Referencing       map[string]interface{} `mapstructure:"referencing"`
	IsOtattrDst       bool                   `mapstructure:"is_otattr_dst"`
	IsOtattrSrc       bool                   `mapstructure:"is_otattr_src"`
	Referenceable     map[string]interface{} `mapstructure:"referenceable"`
	DescriptionTitle  *string                `mapstructure:"description_title"`
	DescriptionAbbrev *string                `mapstructure:"description_abbrev"`
	DescriptionDetail *string                `mapstructure:"description_detail"`
}

type CntlDataType struct {
	Gpk           string   `mapstructure:"gpk"`
	Name          string   `mapstructure:"name"`
	JsonName      string   `mapstructure:"json_name"`
	Description   string   `mapstructure:"description"`
	TextLength    *int64   `mapstructure:"text_length"`
	OperatorList  []string `mapstructure:"operator_list"`
	FormatLiteral *string  `mapstructure:"format_literal"`
}

type WapiFunction struct {
	Name                     string                 `mapstructure:"name"`
	System                   string                 `mapstructure:"system"`
	FqName                   string                 `mapstructure:"fq_name"`
	Parameters               map[string]interface{} `mapstructure:"parameters"`
	ObjectType               string                 `mapstructure:"object_type"`
	IsReturning              bool                   `mapstructure:"is_returning"`
	IsExecutable             bool                   `mapstructure:"is_executable"`
	IsDataManipulating       bool                   `mapstructure:"is_data_manipulating"`
	IsReturningReferenceable bool                   `mapstructure:"is_returning_referenceable"`
}

type Dhcpv4GlobalOption struct {
	Gpk         string  `mapstructure:"gpk"`
	Code        int64   `mapstructure:"code"`
	Data        string  `mapstructure:"data"`
	Name        string  `mapstructure:"name"`
	DataType    string  `mapstructure:"data_type"`
	Reference   *string `mapstructure:"reference"`
	Description *string `mapstructure:"description"`
	IsGenerated bool    `mapstructure:"is_generated"`
}

type NdcfgSiteType struct {
	Gpk          string `mapstructure:"gpk"`
	Name         string `mapstructure:"name"`
	IsChild      bool   `mapstructure:"is_child"`
	IsParent     bool   `mapstructure:"is_parent"`
	ShortName    string `mapstructure:"short_name"`
	ForceIsChild bool   `mapstructure:"force_is_child"`
}

type Dhcpv4Lease struct {
	Gpk                        string                  `mapstructure:"gpk"`
	IsOwn                      bool                    `mapstructure:"is_own"`
	TsExpires                  string                  `mapstructure:"ts_expires"`
	IpAddrValue                *net.IPAddr             `mapstructure:"ip_addr_value"`
	IpSubnetCidr               net.IPNet               `mapstructure:"ip_subnet_cidr"`
	IsStaticAddr               bool                    `mapstructure:"is_static_addr"`
	LeasetimeDays              *uint8                  `mapstructure:"leasetime_days"`
	MacAddrValue               *net.HardwareAddr       `mapstructure:"mac_addr_value"`
	IpAddrIsDhcp               *bool                   `mapstructure:"ip_addr_is_dhcp"`
	LeasetimeHours             *uint8                  `mapstructure:"leasetime_hours"`
	AdmStatusDescr             *string                 `mapstructure:"adm_status_descr"`
	ClientIdentifier           *string                 `mapstructure:"client_identifier"`
	LeasetimeMinutes           *uint8                  `mapstructure:"leasetime_minutes"`
	OperStatusDescr            *string                 `mapstructure:"oper_status_descr"`
	ClientOptionsDict          *map[string]interface{} `mapstructure:"client_options_dict"`
	ServerOptionsDict          *map[string]interface{} `mapstructure:"server_options_dict"`
	AlwaysMatchByMacAddr       bool                    `mapstructure:"always_match_by_mac_addr"`
	AcceptRequestedHostname    bool                    `mapstructure:"accept_requested_hostname"`
	BcdAcceptRequestedHostname *bool                   `mapstructure:"bcd_accept_requested_hostname"`
}

type Dhcpv4SubnetOption struct {
	Gpk          string    `mapstructure:"gpk"`
	Code         int64     `mapstructure:"code"`
	Data         string    `mapstructure:"data"`
	IsOwn        bool      `mapstructure:"is_own"`
	Priority     int64     `mapstructure:"priority"`
	CodeDataType string    `mapstructure:"code_data_type"`
	IpSubnetCidr net.IPNet `mapstructure:"ip_subnet_cidr"`
}

type Dhcpv4Og struct {
	Gpk          string    `mapstructure:"gpk"`
	Name         string    `mapstructure:"name"`
	IsOwn        bool      `mapstructure:"is_own"`
	IpSubnetCidr net.IPNet `mapstructure:"ip_subnet_cidr"`
}

type Dhcpv4GroupOption struct {
	Gpk          string `mapstructure:"gpk"`
	Code         int64  `mapstructure:"code"`
	Data         string `mapstructure:"data"`
	IsOwn        bool   `mapstructure:"is_own"`
	OgGfk        string `mapstructure:"og_gfk"`
	Priority     int64  `mapstructure:"priority"`
	CodeDataType string `mapstructure:"code_data_type"`
}

type NdcfgSiteType2type struct {
	Gpk             string `mapstructure:"gpk"`
	ChildShortName  string `mapstructure:"child_short_name"`
	ParentShortName string `mapstructure:"parent_short_name"`
}

type NdDiqTa struct {
	Gpk               string  `mapstructure:"gpk"`
	Owner             string  `mapstructure:"owner"`
	IsOwn             bool    `mapstructure:"is_own"`
	Position          *int64  `mapstructure:"position"`
	IsActive          bool    `mapstructure:"is_active"`
	IsWorking         bool    `mapstructure:"is_working"`
	ParentGfk         *string `mapstructure:"parent_gfk"`
	MailOnError       bool    `mapstructure:"mail_on_error"`
	LastDevimpTs      *string `mapstructure:"last_devimp_ts"`
	LastDevimpMsg     *string `mapstructure:"last_devimp_msg"`
	MailOnSuccess     bool    `mapstructure:"mail_on_success"`
	PreserveOnError   bool    `mapstructure:"preserve_on_error"`
	LastDevimpSuccess *bool   `mapstructure:"last_devimp_success"`
	PreserveOnSuccess bool    `mapstructure:"preserve_on_success"`
}

type NdDiqTaEntry struct {
	Gpk               string                 `mapstructure:"gpk"`
	DevNc             string                 `mapstructure:"dev_nc"`
	DevAcg            string                 `mapstructure:"dev_acg"`
	DoSave            bool                   `mapstructure:"do_save"`
	DevFqdn           string                 `mapstructure:"dev_fqdn"`
	DevType           string                 `mapstructure:"dev_type"`
	DoParse           bool                   `mapstructure:"do_parse"`
	DoImport          bool                   `mapstructure:"do_import"`
	DevParser         string                 `mapstructure:"dev_parser"`
	DiqTaGfk          string                 `mapstructure:"diq_ta_gfk"`
	DiqTaIsOwn        bool                   `mapstructure:"diq_ta_is_own"`
	DevDescription    *string                `mapstructure:"dev_description"`
	LastDevimpMsg     *string                `mapstructure:"last_devimp_msg"`
	UploadFilename    *string                `mapstructure:"upload_filename"`
	OutputVerbosity   bool                   `mapstructure:"output_verbosity"`
	DevAttributesDict map[string]interface{} `mapstructure:"dev_attributes_dict"`
	LastDevimpSuccess *bool                  `mapstructure:"last_devimp_success"`
	RplcCharsetErrors bool                   `mapstructure:"rplc_charset_errors"`
}

type DnscfgFqdnTypeGroup struct {
	Gpk         string `mapstructure:"gpk"`
	Name        string `mapstructure:"name"`
	Description string `mapstructure:"description"`
}

type WapiException struct {
	Error             map[string]interface{} `mapstructure:"error"`
	Others            map[string]interface{} `mapstructure:"others"`
	Traceback         []interface{}          `mapstructure:"traceback"`
	Constraint        map[string]interface{} `mapstructure:"constraint"`
	ErrorType         map[string]interface{} `mapstructure:"error_type"`
	StackedDiagParams map[string]interface{} `mapstructure:"stacked_diag_params"`
}

type EvlogRecord struct {
	Data             *string `mapstructure:"data"`
	Type             string  `mapstructure:"type"`
	ObjectGfk        string  `mapstructure:"object_gfk"`
	TaTimestamp      string  `mapstructure:"ta_timestamp"`
	MgrLoginName     *string `mapstructure:"mgr_login_name"`
	ObjectTypeFqName string  `mapstructure:"object_type_fq_name"`
}

type CntlWapiAuth struct {
	Gpk              string  `mapstructure:"gpk"`
	Type             string  `mapstructure:"type"`
	Token            string  `mapstructure:"token"`
	IsOwn            bool    `mapstructure:"is_own"`
	IsExpired        bool    `mapstructure:"is_expired"`
	LoginName        string  `mapstructure:"login_name"`
	DeleteDate       string  `mapstructure:"delete_date"`
	Description      *string `mapstructure:"description"`
	ExpirationDate   *string `mapstructure:"expiration_date"`
	LastLoginDate    *string `mapstructure:"last_login_date"`
	TypeDescription  string  `mapstructure:"type_description"`
	LastGenerateDate string  `mapstructure:"last_generate_date"`
}

type DnssecZoneKey struct {
	Gpk            string    `mapstructure:"gpk"`
	Fqdn           string    `mapstructure:"fqdn"`
	Flags          int64     `mapstructure:"flags"`
	IsKsk          bool      `mapstructure:"is_ksk"`
	IsActive       bool      `mapstructure:"is_active"`
	CreationTs     string    `mapstructure:"creation_ts"`
	ActivationTs   *string   `mapstructure:"activation_ts"`
	DeactivationTs *string   `mapstructure:"deactivation_ts"`
	DsRrDataList   *[]string `mapstructure:"ds_rr_data_list"`
}

type CntlMgr2group struct {
	Gpk                string  `mapstructure:"gpk"`
	IsOwn              bool    `mapstructure:"is_own"`
	GroupName          string  `mapstructure:"group_name"`
	MgrLoginName       string  `mapstructure:"mgr_login_name"`
	ParentGroupName    string  `mapstructure:"parent_group_name"`
	ParentMgrLoginName *string `mapstructure:"parent_mgr_login_name"`
}

type DnsFqdn2group struct {
	Gpk             string `mapstructure:"gpk"`
	IsOwn           bool   `mapstructure:"is_own"`
	FqdnValue       string `mapstructure:"fqdn_value"`
	GroupName       string `mapstructure:"group_name"`
	ParentGroupName string `mapstructure:"parent_group_name"`
}

type DhcpcfgOperator struct {
	Gpk         string  `mapstructure:"gpk"`
	Name        string  `mapstructure:"name"`
	Description *string `mapstructure:"description"`
}

type DhcpcfgDt2operator2dt struct {
	Gpk           string `mapstructure:"gpk"`
	Operator      string `mapstructure:"operator"`
	LeftDataType  string `mapstructure:"left_data_type"`
	RightDataType string `mapstructure:"right_data_type"`
}

type Dhcpv4SubnetOptionRule struct {
	Gpk            string `mapstructure:"gpk"`
	IsOwn          bool   `mapstructure:"is_own"`
	Operator       string `mapstructure:"operator"`
	OptCode        int64  `mapstructure:"opt_code"`
	SnOptGfk       string `mapstructure:"sn_opt_gfk"`
	LeftDataType   string `mapstructure:"left_data_type"`
	RightDataType  string `mapstructure:"right_data_type"`
	RightDataValue string `mapstructure:"right_data_value"`
}

type Dhcpv4GroupOptionRule struct {
	Gpk            string `mapstructure:"gpk"`
	IsOwn          bool   `mapstructure:"is_own"`
	Operator       string `mapstructure:"operator"`
	OptCode        int64  `mapstructure:"opt_code"`
	OgOptGfk       string `mapstructure:"og_opt_gfk"`
	LeftDataType   string `mapstructure:"left_data_type"`
	RightDataType  string `mapstructure:"right_data_type"`
	RightDataValue string `mapstructure:"right_data_value"`
}

type MacauthClient struct {
	Gpk               string           `mapstructure:"gpk"`
	IsOwn             bool             `mapstructure:"is_own"`
	WpaKey            *string          `mapstructure:"wpa_key"`
	BcdName           string           `mapstructure:"bcd_name"`
	MacAddr           net.HardwareAddr `mapstructure:"mac_addr"`
	Description       *string          `mapstructure:"description"`
	LastLoginDate     *string          `mapstructure:"last_login_date"`
	LastLoginNodeInfo *string          `mapstructure:"last_login_node_info"`
}

type NdVlan2device struct {
	Gpk     string `mapstructure:"gpk"`
	DevFqdn string `mapstructure:"dev_fqdn"`
	VlanGfk string `mapstructure:"vlan_gfk"`
}

type NdcfgLPortTag struct {
	Gpk         string  `mapstructure:"gpk"`
	Value       string  `mapstructure:"value"`
	LevelList   []int16 `mapstructure:"level_list"`
	Description *string `mapstructure:"description"`
}

type NdVxlan struct {
	Bcd         string  `mapstructure:"bcd"`
	Gpk         string  `mapstructure:"gpk"`
	Vni         uint32  `mapstructure:"vni"`
	Description *string `mapstructure:"description"`
}

type NdVxlan2device struct {
	Gpk      string `mapstructure:"gpk"`
	DevFqdn  string `mapstructure:"dev_fqdn"`
	VxlanVni uint32 `mapstructure:"vxlan_vni"`
}

type CntlGroup struct {
	Gpk                     string  `mapstructure:"gpk"`
	Name                    string  `mapstructure:"name"`
	IsOwn                   bool    `mapstructure:"is_own"`
	IsAdmin                 bool    `mapstructure:"is_admin"`
	BcdCount                int64   `mapstructure:"bcd_count"`
	MgrCount                int64   `mapstructure:"mgr_count"`
	FqdnCount               int64   `mapstructure:"fqdn_count"`
	Description             *string `mapstructure:"description"`
	DoIdmSync               bool    `mapstructure:"do_idm_sync"`
	ParentName              string  `mapstructure:"parent_name"`
	IsSubGroup              bool    `mapstructure:"is_sub_group"`
	OuShortName             *string `mapstructure:"ou_short_name"`
	IdmDescription          *string `mapstructure:"idm_description"`
	IdmSyncLastTs           *string `mapstructure:"idm_sync_last_ts"`
	IdmSyncIsActive         bool    `mapstructure:"idm_sync_is_active"`
	IdmSyncLastState        *string `mapstructure:"idm_sync_last_state"`
	IdmSyncMaxMgrCount      int64   `mapstructure:"idm_sync_max_mgr_count"`
	IdmSyncLastSuccessfulTs *string `mapstructure:"idm_sync_last_successful_ts"`
}

type NdBcd2group struct {
	Gpk             string `mapstructure:"gpk"`
	IsOwn           bool   `mapstructure:"is_own"`
	BcdName         string `mapstructure:"bcd_name"`
	GroupName       string `mapstructure:"group_name"`
	ParentGroupName string `mapstructure:"parent_group_name"`
}

type CntlMgr2ou struct {
	Gpk                string `mapstructure:"gpk"`
	IsOwn              bool   `mapstructure:"is_own"`
	OuShortName        string `mapstructure:"ou_short_name"`
	IsSubAccount       bool   `mapstructure:"is_sub_account"`
	MgrLoginName       string `mapstructure:"mgr_login_name"`
	ParentOuShortName  string `mapstructure:"parent_ou_short_name"`
	ParentMgrLoginName string `mapstructure:"parent_mgr_login_name"`
}

type DnsFqdn2ou struct {
	Gpk         string `mapstructure:"gpk"`
	IsOwn       bool   `mapstructure:"is_own"`
	FqdnValue   string `mapstructure:"fqdn_value"`
	IsRecursive bool   `mapstructure:"is_recursive"`
	OuShortName string `mapstructure:"ou_short_name"`
}

type CntlOtAttrDef struct {
	Name                       string  `mapstructure:"name"`
	KeyWord                    string  `mapstructure:"key_word"`
	DataType                   string  `mapstructure:"data_type"`
	Description                *string `mapstructure:"description"`
	ObjectTypeFqName           string  `mapstructure:"object_type_fq_name"`
	InsTrgFuncFqName           *string `mapstructure:"ins_trg_func_fq_name"`
	UpdTrgFuncFqName           *string `mapstructure:"upd_trg_func_fq_name"`
	RefObjectTypeFqName        string  `mapstructure:"ref_object_type_fq_name"`
	ObjectTypeRefAttributeName string  `mapstructure:"object_type_ref_attribute_name"`
}

type CntlOtAttrKey struct {
	SetMode                int64   `mapstructure:"set_mode"`
	DisplayMode            int64   `mapstructure:"display_mode"`
	DefaultValue           *string `mapstructure:"default_value"`
	ValIsUnique            bool    `mapstructure:"val_is_unique"`
	RefObjectGfk           *string `mapstructure:"ref_object_gfk"`
	ValIsNullable          bool    `mapstructure:"val_is_nullable"`
	DisplayPosition        int64   `mapstructure:"display_position"`
	PermissionFqName       *string `mapstructure:"permission_fq_name"`
	ObjectTypeFqName       string  `mapstructure:"object_type_fq_name"`
	OtAttrDefKeyWord       string  `mapstructure:"ot_attr_def_key_word"`
	SetModeDescription     string  `mapstructure:"set_mode_description"`
	RefObjectTypeFqName    string  `mapstructure:"ref_object_type_fq_name"`
	DisplayModeDescription string  `mapstructure:"display_mode_description"`
}

type CntlOtAttrVal struct {
	Value            *string `mapstructure:"value"`
	DataType         string  `mapstructure:"data_type"`
	ObjectGfk        string  `mapstructure:"object_gfk"`
	RefObjectGfk     *string `mapstructure:"ref_object_gfk"`
	ObjectTypeFqName string  `mapstructure:"object_type_fq_name"`
	OtAttrDefKeyWord string  `mapstructure:"ot_attr_def_key_word"`
}

type CntlDataTypeOperator struct {
	Gpk          string   `mapstructure:"gpk"`
	Name         string   `mapstructure:"name"`
	DataTypeList []string `mapstructure:"data_type_list"`
}

type NdBcd2ou struct {
	Gpk         string `mapstructure:"gpk"`
	IsOwn       bool   `mapstructure:"is_own"`
	BcdName     string `mapstructure:"bcd_name"`
	IsRecursive bool   `mapstructure:"is_recursive"`
	OuShortName string `mapstructure:"ou_short_name"`
}

type CntlReplication struct {
	Gpk      string `mapstructure:"gpk"`
	Name     string `mapstructure:"name"`
	OperMode string `mapstructure:"oper_mode"`
}

type CntlReplicationPub2sub struct {
	Gpk                   string `mapstructure:"gpk"`
	DoInit                bool   `mapstructure:"do_init"`
	PublisherFqdn         string `mapstructure:"publisher_fqdn"`
	SubscriberFqdn        string `mapstructure:"subscriber_fqdn"`
	ReplicationName       string `mapstructure:"replication_name"`
	ReplicationOperMode   string `mapstructure:"replication_oper_mode"`
	ReplicationSlotSuffix string `mapstructure:"replication_slot_suffix"`
}

type WapiDataType struct {
	Name          string   `mapstructure:"name"`
	JsonName      string   `mapstructure:"json_name"`
	Description   string   `mapstructure:"description"`
	TextLength    *int64   `mapstructure:"text_length"`
	OperatorList  []string `mapstructure:"operator_list"`
	FormatLiteral *string  `mapstructure:"format_literal"`
}

type WapiDataTypeOperator struct {
	Name         string   `mapstructure:"name"`
	DataTypeList []string `mapstructure:"data_type_list"`
}

type DnsRecordImp struct {
	Ttl                   *uint32 `mapstructure:"ttl"`
	Type                  *string `mapstructure:"type"`
	DataList              *string `mapstructure:"data_list"`
	TtlResetDays          *uint8  `mapstructure:"ttl_reset_days"`
	TargetIsSingleton     *bool   `mapstructure:"target_is_singleton"`
	TargetIsReverseUnique *bool   `mapstructure:"target_is_reverse_unique"`
}

type DnscfgNsSetHost struct {
	Gpk       string `mapstructure:"gpk"`
	HostFqdn  string `mapstructure:"host_fqdn"`
	NsSetName string `mapstructure:"ns_set_name"`
}

type Dhcpv4Og2lease struct {
	Gpk      string `mapstructure:"gpk"`
	IsOwn    bool   `mapstructure:"is_own"`
	OgGfk    string `mapstructure:"og_gfk"`
	Priority int64  `mapstructure:"priority"`
	LeaseGfk string `mapstructure:"lease_gfk"`
}

