### AUTOGENERATED
from . import _denullify_dict
from . import *
from dataclasses import dataclass
from typing import Union


@dataclass()
class GlobalOption(APIObject):
	gpk: str
	code: int
	data: str
	name: str
	data_type: str
	reference: str
	description: str
	is_generated: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.code, int):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(self.code)}")
		if not isinstance(self.data, str):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(self.data)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.data_type, str):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(self.data_type)}")
		if self.reference is not None and not isinstance(self.reference, str):
			raise ValueError(f"'reference' of incorrect type. Expected str, got {type(self.reference)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.is_generated, bool):
			raise ValueError(f"'is_generated' of incorrect type. Expected bool, got {type(self.is_generated)}")

	@staticmethod
	def create_ta(code_new: int, name_new: str, data_type_new: str, data_new: str = None, reference_new: Union[str, ExplicitNull] = None, description_new: Union[str, ExplicitNull] = None, is_generated_new: bool = False) -> dict:
		if not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if data_new is not None and not (isinstance(data_new, str)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if reference_new is not None and not (isinstance(reference_new, str) or isinstance(reference_new, ExplicitNull)):
			raise ValueError(f"'reference' of incorrect type. Expected str, got {type(reference_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if is_generated_new is not None and not (isinstance(is_generated_new, bool)):
			raise ValueError(f"'is_generated' of incorrect type. Expected bool, got {type(is_generated_new)}")

		return {'name': 'dhcpv4.global_option.create', 'new': _denullify_dict({'code': code_new, 'data': data_new, 'name': name_new, 'data_type': data_type_new, 'reference': reference_new, 'description': description_new, 'is_generated': is_generated_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, code_new: int, name_new: str, data_type_new: str, data_new: str = None, reference_new: Union[str, ExplicitNull] = None, description_new: Union[str, ExplicitNull] = None, is_generated_new: bool = False) -> list:
		if not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if data_new is not None and not (isinstance(data_new, str)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if reference_new is not None and not (isinstance(reference_new, str) or isinstance(reference_new, ExplicitNull)):
			raise ValueError(f"'reference' of incorrect type. Expected str, got {type(reference_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if is_generated_new is not None and not (isinstance(is_generated_new, bool)):
			raise ValueError(f"'is_generated' of incorrect type. Expected bool, got {type(is_generated_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(code_new=code_new, data_new=data_new, name_new=name_new, data_type_new=data_type_new, reference_new=reference_new, description_new=description_new, is_generated_new=is_generated_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dhcpv4.global_option.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, data_type_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_generated_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if data_type_old is not None and not (isinstance(data_type_old, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_generated_old is not None and not (isinstance(is_generated_old, bool)):
			raise ValueError(f"'is_generated' of incorrect type. Expected bool, got {type(is_generated_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dhcpv4.global_option.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'data_type': data_type_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'is_generated': is_generated_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, data_type_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_generated_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if data_type_old is not None and not (isinstance(data_type_old, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_generated_old is not None and not (isinstance(is_generated_old, bool)):
			raise ValueError(f"'is_generated' of incorrect type. Expected bool, got {type(is_generated_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, data_type_old=data_type_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, is_generated_old=is_generated_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(gpk_old: str, code_new: int = None, data_new: str = None, name_new: str = None, data_type_new: str = None, reference_new: Union[str, ExplicitNull] = None, description_new: Union[str, ExplicitNull] = None, is_generated_new: bool = None) -> dict:
		if code_new is not None and not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if data_new is not None and not (isinstance(data_new, str)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if data_type_new is not None and not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if reference_new is not None and not (isinstance(reference_new, str) or isinstance(reference_new, ExplicitNull)):
			raise ValueError(f"'reference' of incorrect type. Expected str, got {type(reference_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if is_generated_new is not None and not (isinstance(is_generated_new, bool)):
			raise ValueError(f"'is_generated' of incorrect type. Expected bool, got {type(is_generated_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dhcpv4.global_option.update', 'new': _denullify_dict({'code': code_new, 'data': data_new, 'name': name_new, 'data_type': data_type_new, 'reference': reference_new, 'description': description_new, 'is_generated': is_generated_new}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, gpk_old: str, code_new: int = None, data_new: str = None, name_new: str = None, data_type_new: str = None, reference_new: Union[str, ExplicitNull] = None, description_new: Union[str, ExplicitNull] = None, is_generated_new: bool = None) -> list:
		if code_new is not None and not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if data_new is not None and not (isinstance(data_new, str)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if data_type_new is not None and not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if reference_new is not None and not (isinstance(reference_new, str) or isinstance(reference_new, ExplicitNull)):
			raise ValueError(f"'reference' of incorrect type. Expected str, got {type(reference_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if is_generated_new is not None and not (isinstance(is_generated_new, bool)):
			raise ValueError(f"'is_generated' of incorrect type. Expected bool, got {type(is_generated_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(code_new=code_new, data_new=data_new, name_new=name_new, data_type_new=data_type_new, reference_new=reference_new, description_new=description_new, is_generated_new=is_generated_new, gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Lease(APIObject):
	gpk: str
	is_own: bool
	ts_expires: str
	ip_addr_value: str
	ip_subnet_cidr: str
	is_static_addr: bool
	leasetime_days: int
	mac_addr_value: str
	ip_addr_is_dhcp: bool
	leasetime_hours: int
	adm_status_descr: str
	client_identifier: str
	leasetime_minutes: int
	oper_status_descr: str
	client_options_dict: dict
	server_options_dict: dict
	always_match_by_mac_addr: bool
	accept_requested_hostname: bool
	bcd_accept_requested_hostname: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.ts_expires, str):
			raise ValueError(f"'ts_expires' of incorrect type. Expected str, got {type(self.ts_expires)}")
		if self.ip_addr_value is not None and not isinstance(self.ip_addr_value, str):
			raise ValueError(f"'ip_addr_value' of incorrect type. Expected str, got {type(self.ip_addr_value)}")
		if not isinstance(self.ip_subnet_cidr, str):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(self.ip_subnet_cidr)}")
		if not isinstance(self.is_static_addr, bool):
			raise ValueError(f"'is_static_addr' of incorrect type. Expected bool, got {type(self.is_static_addr)}")
		if self.leasetime_days is not None and not isinstance(self.leasetime_days, int):
			raise ValueError(f"'leasetime_days' of incorrect type. Expected int, got {type(self.leasetime_days)}")
		if self.mac_addr_value is not None and not isinstance(self.mac_addr_value, str):
			raise ValueError(f"'mac_addr_value' of incorrect type. Expected str, got {type(self.mac_addr_value)}")
		if self.ip_addr_is_dhcp is not None and not isinstance(self.ip_addr_is_dhcp, bool):
			raise ValueError(f"'ip_addr_is_dhcp' of incorrect type. Expected bool, got {type(self.ip_addr_is_dhcp)}")
		if self.leasetime_hours is not None and not isinstance(self.leasetime_hours, int):
			raise ValueError(f"'leasetime_hours' of incorrect type. Expected int, got {type(self.leasetime_hours)}")
		if self.adm_status_descr is not None and not isinstance(self.adm_status_descr, str):
			raise ValueError(f"'adm_status_descr' of incorrect type. Expected str, got {type(self.adm_status_descr)}")
		if self.client_identifier is not None and not isinstance(self.client_identifier, str):
			raise ValueError(f"'client_identifier' of incorrect type. Expected str, got {type(self.client_identifier)}")
		if self.leasetime_minutes is not None and not isinstance(self.leasetime_minutes, int):
			raise ValueError(f"'leasetime_minutes' of incorrect type. Expected int, got {type(self.leasetime_minutes)}")
		if self.oper_status_descr is not None and not isinstance(self.oper_status_descr, str):
			raise ValueError(f"'oper_status_descr' of incorrect type. Expected str, got {type(self.oper_status_descr)}")
		if self.client_options_dict is not None and not isinstance(self.client_options_dict, dict):
			raise ValueError(f"'client_options_dict' of incorrect type. Expected dict, got {type(self.client_options_dict)}")
		if self.server_options_dict is not None and not isinstance(self.server_options_dict, dict):
			raise ValueError(f"'server_options_dict' of incorrect type. Expected dict, got {type(self.server_options_dict)}")
		if not isinstance(self.always_match_by_mac_addr, bool):
			raise ValueError(f"'always_match_by_mac_addr' of incorrect type. Expected bool, got {type(self.always_match_by_mac_addr)}")
		if not isinstance(self.accept_requested_hostname, bool):
			raise ValueError(f"'accept_requested_hostname' of incorrect type. Expected bool, got {type(self.accept_requested_hostname)}")
		if self.bcd_accept_requested_hostname is not None and not isinstance(self.bcd_accept_requested_hostname, bool):
			raise ValueError(f"'bcd_accept_requested_hostname' of incorrect type. Expected bool, got {type(self.bcd_accept_requested_hostname)}")

	@staticmethod
	def bulk_delete_ta(ip_subnet_cidr_old: str, is_static_addr_old: bool = None) -> dict:
		if not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")
		if is_static_addr_old is not None and not (isinstance(is_static_addr_old, bool) or isinstance(is_static_addr_old, ExplicitNull)):
			raise ValueError(f"'is_static_addr' of incorrect type. Expected bool, got {type(is_static_addr_old)}")

		return {'name': 'dhcpv4.lease.bulk_delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'ip_subnet_cidr': ip_subnet_cidr_old, 'is_static_addr': is_static_addr_old})}

	# TODO: Consider is_returning
	@classmethod
	def bulk_delete(cls, api_session: APISession, ip_subnet_cidr_old: str, is_static_addr_old: bool = None) -> list:
		if not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")
		if is_static_addr_old is not None and not (isinstance(is_static_addr_old, bool) or isinstance(is_static_addr_old, ExplicitNull)):
			raise ValueError(f"'is_static_addr' of incorrect type. Expected bool, got {type(is_static_addr_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.bulk_delete_ta(ip_subnet_cidr_old=ip_subnet_cidr_old, is_static_addr_old=is_static_addr_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def bulk_update_ta(ip_subnet_cidr_new: str, ip_subnet_cidr_old: str) -> dict:
		if not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")
		if not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")

		return {'name': 'dhcpv4.lease.bulk_update', 'new': _denullify_dict({'ip_subnet_cidr': ip_subnet_cidr_new}), 'old': _denullify_dict({'ip_subnet_cidr': ip_subnet_cidr_old})}

	# TODO: Consider is_returning
	@classmethod
	def bulk_update(cls, api_session: APISession, ip_subnet_cidr_new: str, ip_subnet_cidr_old: str) -> list:
		if not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")
		if not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.bulk_update_ta(ip_subnet_cidr_new=ip_subnet_cidr_new, ip_subnet_cidr_old=ip_subnet_cidr_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def create_ta(ip_addr_value_new: Union[str, ExplicitNull] = None, ip_subnet_cidr_new: str = None, is_static_addr_new: bool = True, leasetime_days_new: Union[int, ExplicitNull] = None, mac_addr_value_new: Union[str, ExplicitNull] = None, leasetime_hours_new: Union[int, ExplicitNull] = None, adm_status_descr_new: Union[str, ExplicitNull] = None, client_identifier_new: Union[str, ExplicitNull] = None, leasetime_minutes_new: Union[int, ExplicitNull] = None, always_match_by_mac_addr_new: bool = False, accept_requested_hostname_new: bool = False) -> dict:
		if ip_addr_value_new is not None and not (isinstance(ip_addr_value_new, str) or isinstance(ip_addr_value_new, ExplicitNull)):
			raise ValueError(f"'ip_addr_value' of incorrect type. Expected str, got {type(ip_addr_value_new)}")
		if ip_subnet_cidr_new is not None and not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")
		if is_static_addr_new is not None and not (isinstance(is_static_addr_new, bool)):
			raise ValueError(f"'is_static_addr' of incorrect type. Expected bool, got {type(is_static_addr_new)}")
		if leasetime_days_new is not None and not (isinstance(leasetime_days_new, int) or isinstance(leasetime_days_new, ExplicitNull)):
			raise ValueError(f"'leasetime_days' of incorrect type. Expected int, got {type(leasetime_days_new)}")
		if mac_addr_value_new is not None and not (isinstance(mac_addr_value_new, str) or isinstance(mac_addr_value_new, ExplicitNull)):
			raise ValueError(f"'mac_addr_value' of incorrect type. Expected str, got {type(mac_addr_value_new)}")
		if leasetime_hours_new is not None and not (isinstance(leasetime_hours_new, int) or isinstance(leasetime_hours_new, ExplicitNull)):
			raise ValueError(f"'leasetime_hours' of incorrect type. Expected int, got {type(leasetime_hours_new)}")
		if adm_status_descr_new is not None and not (isinstance(adm_status_descr_new, str) or isinstance(adm_status_descr_new, ExplicitNull)):
			raise ValueError(f"'adm_status_descr' of incorrect type. Expected str, got {type(adm_status_descr_new)}")
		if client_identifier_new is not None and not (isinstance(client_identifier_new, str) or isinstance(client_identifier_new, ExplicitNull)):
			raise ValueError(f"'client_identifier' of incorrect type. Expected str, got {type(client_identifier_new)}")
		if leasetime_minutes_new is not None and not (isinstance(leasetime_minutes_new, int) or isinstance(leasetime_minutes_new, ExplicitNull)):
			raise ValueError(f"'leasetime_minutes' of incorrect type. Expected int, got {type(leasetime_minutes_new)}")
		if always_match_by_mac_addr_new is not None and not (isinstance(always_match_by_mac_addr_new, bool)):
			raise ValueError(f"'always_match_by_mac_addr' of incorrect type. Expected bool, got {type(always_match_by_mac_addr_new)}")
		if accept_requested_hostname_new is not None and not (isinstance(accept_requested_hostname_new, bool)):
			raise ValueError(f"'accept_requested_hostname' of incorrect type. Expected bool, got {type(accept_requested_hostname_new)}")

		return {'name': 'dhcpv4.lease.create', 'new': _denullify_dict({'ip_addr_value': ip_addr_value_new, 'ip_subnet_cidr': ip_subnet_cidr_new, 'is_static_addr': is_static_addr_new, 'leasetime_days': leasetime_days_new, 'mac_addr_value': mac_addr_value_new, 'leasetime_hours': leasetime_hours_new, 'adm_status_descr': adm_status_descr_new, 'client_identifier': client_identifier_new, 'leasetime_minutes': leasetime_minutes_new, 'always_match_by_mac_addr': always_match_by_mac_addr_new, 'accept_requested_hostname': accept_requested_hostname_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, ip_addr_value_new: Union[str, ExplicitNull] = None, ip_subnet_cidr_new: str = None, is_static_addr_new: bool = True, leasetime_days_new: Union[int, ExplicitNull] = None, mac_addr_value_new: Union[str, ExplicitNull] = None, leasetime_hours_new: Union[int, ExplicitNull] = None, adm_status_descr_new: Union[str, ExplicitNull] = None, client_identifier_new: Union[str, ExplicitNull] = None, leasetime_minutes_new: Union[int, ExplicitNull] = None, always_match_by_mac_addr_new: bool = False, accept_requested_hostname_new: bool = False) -> list:
		if ip_addr_value_new is not None and not (isinstance(ip_addr_value_new, str) or isinstance(ip_addr_value_new, ExplicitNull)):
			raise ValueError(f"'ip_addr_value' of incorrect type. Expected str, got {type(ip_addr_value_new)}")
		if ip_subnet_cidr_new is not None and not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")
		if is_static_addr_new is not None and not (isinstance(is_static_addr_new, bool)):
			raise ValueError(f"'is_static_addr' of incorrect type. Expected bool, got {type(is_static_addr_new)}")
		if leasetime_days_new is not None and not (isinstance(leasetime_days_new, int) or isinstance(leasetime_days_new, ExplicitNull)):
			raise ValueError(f"'leasetime_days' of incorrect type. Expected int, got {type(leasetime_days_new)}")
		if mac_addr_value_new is not None and not (isinstance(mac_addr_value_new, str) or isinstance(mac_addr_value_new, ExplicitNull)):
			raise ValueError(f"'mac_addr_value' of incorrect type. Expected str, got {type(mac_addr_value_new)}")
		if leasetime_hours_new is not None and not (isinstance(leasetime_hours_new, int) or isinstance(leasetime_hours_new, ExplicitNull)):
			raise ValueError(f"'leasetime_hours' of incorrect type. Expected int, got {type(leasetime_hours_new)}")
		if adm_status_descr_new is not None and not (isinstance(adm_status_descr_new, str) or isinstance(adm_status_descr_new, ExplicitNull)):
			raise ValueError(f"'adm_status_descr' of incorrect type. Expected str, got {type(adm_status_descr_new)}")
		if client_identifier_new is not None and not (isinstance(client_identifier_new, str) or isinstance(client_identifier_new, ExplicitNull)):
			raise ValueError(f"'client_identifier' of incorrect type. Expected str, got {type(client_identifier_new)}")
		if leasetime_minutes_new is not None and not (isinstance(leasetime_minutes_new, int) or isinstance(leasetime_minutes_new, ExplicitNull)):
			raise ValueError(f"'leasetime_minutes' of incorrect type. Expected int, got {type(leasetime_minutes_new)}")
		if always_match_by_mac_addr_new is not None and not (isinstance(always_match_by_mac_addr_new, bool)):
			raise ValueError(f"'always_match_by_mac_addr' of incorrect type. Expected bool, got {type(always_match_by_mac_addr_new)}")
		if accept_requested_hostname_new is not None and not (isinstance(accept_requested_hostname_new, bool)):
			raise ValueError(f"'accept_requested_hostname' of incorrect type. Expected bool, got {type(accept_requested_hostname_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(ip_addr_value_new=ip_addr_value_new, ip_subnet_cidr_new=ip_subnet_cidr_new, is_static_addr_new=is_static_addr_new, leasetime_days_new=leasetime_days_new, mac_addr_value_new=mac_addr_value_new, leasetime_hours_new=leasetime_hours_new, adm_status_descr_new=adm_status_descr_new, client_identifier_new=client_identifier_new, leasetime_minutes_new=leasetime_minutes_new, always_match_by_mac_addr_new=always_match_by_mac_addr_new, accept_requested_hostname_new=accept_requested_hostname_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dhcpv4.lease.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, is_own_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, ip_subnet_cidr_old: str = None, is_static_addr_old: bool = None, mac_addr_value_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if ip_subnet_cidr_old is not None and not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")
		if is_static_addr_old is not None and not (isinstance(is_static_addr_old, bool)):
			raise ValueError(f"'is_static_addr' of incorrect type. Expected bool, got {type(is_static_addr_old)}")
		if mac_addr_value_old is not None and not (isinstance(mac_addr_value_old, str)):
			raise ValueError(f"'mac_addr_value' of incorrect type. Expected str, got {type(mac_addr_value_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dhcpv4.lease.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_own': is_own_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'ip_subnet_cidr': ip_subnet_cidr_old, 'is_static_addr': is_static_addr_old, 'mac_addr_value': mac_addr_value_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_own_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, ip_subnet_cidr_old: str = None, is_static_addr_old: bool = None, mac_addr_value_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if ip_subnet_cidr_old is not None and not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")
		if is_static_addr_old is not None and not (isinstance(is_static_addr_old, bool)):
			raise ValueError(f"'is_static_addr' of incorrect type. Expected bool, got {type(is_static_addr_old)}")
		if mac_addr_value_old is not None and not (isinstance(mac_addr_value_old, str)):
			raise ValueError(f"'mac_addr_value' of incorrect type. Expected str, got {type(mac_addr_value_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_own_old=is_own_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, ip_subnet_cidr_old=ip_subnet_cidr_old, is_static_addr_old=is_static_addr_old, mac_addr_value_old=mac_addr_value_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(gpk_old: str, ip_addr_value_new: Union[str, ExplicitNull] = None, ip_subnet_cidr_new: str = None, is_static_addr_new: bool = None, leasetime_days_new: Union[int, ExplicitNull] = None, mac_addr_value_new: Union[str, ExplicitNull] = None, leasetime_hours_new: Union[int, ExplicitNull] = None, adm_status_descr_new: Union[str, ExplicitNull] = None, client_identifier_new: Union[str, ExplicitNull] = None, leasetime_minutes_new: Union[int, ExplicitNull] = None, always_match_by_mac_addr_new: bool = None, accept_requested_hostname_new: bool = None) -> dict:
		if ip_addr_value_new is not None and not (isinstance(ip_addr_value_new, str) or isinstance(ip_addr_value_new, ExplicitNull)):
			raise ValueError(f"'ip_addr_value' of incorrect type. Expected str, got {type(ip_addr_value_new)}")
		if ip_subnet_cidr_new is not None and not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")
		if is_static_addr_new is not None and not (isinstance(is_static_addr_new, bool)):
			raise ValueError(f"'is_static_addr' of incorrect type. Expected bool, got {type(is_static_addr_new)}")
		if leasetime_days_new is not None and not (isinstance(leasetime_days_new, int) or isinstance(leasetime_days_new, ExplicitNull)):
			raise ValueError(f"'leasetime_days' of incorrect type. Expected int, got {type(leasetime_days_new)}")
		if mac_addr_value_new is not None and not (isinstance(mac_addr_value_new, str) or isinstance(mac_addr_value_new, ExplicitNull)):
			raise ValueError(f"'mac_addr_value' of incorrect type. Expected str, got {type(mac_addr_value_new)}")
		if leasetime_hours_new is not None and not (isinstance(leasetime_hours_new, int) or isinstance(leasetime_hours_new, ExplicitNull)):
			raise ValueError(f"'leasetime_hours' of incorrect type. Expected int, got {type(leasetime_hours_new)}")
		if adm_status_descr_new is not None and not (isinstance(adm_status_descr_new, str) or isinstance(adm_status_descr_new, ExplicitNull)):
			raise ValueError(f"'adm_status_descr' of incorrect type. Expected str, got {type(adm_status_descr_new)}")
		if client_identifier_new is not None and not (isinstance(client_identifier_new, str) or isinstance(client_identifier_new, ExplicitNull)):
			raise ValueError(f"'client_identifier' of incorrect type. Expected str, got {type(client_identifier_new)}")
		if leasetime_minutes_new is not None and not (isinstance(leasetime_minutes_new, int) or isinstance(leasetime_minutes_new, ExplicitNull)):
			raise ValueError(f"'leasetime_minutes' of incorrect type. Expected int, got {type(leasetime_minutes_new)}")
		if always_match_by_mac_addr_new is not None and not (isinstance(always_match_by_mac_addr_new, bool)):
			raise ValueError(f"'always_match_by_mac_addr' of incorrect type. Expected bool, got {type(always_match_by_mac_addr_new)}")
		if accept_requested_hostname_new is not None and not (isinstance(accept_requested_hostname_new, bool)):
			raise ValueError(f"'accept_requested_hostname' of incorrect type. Expected bool, got {type(accept_requested_hostname_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dhcpv4.lease.update', 'new': _denullify_dict({'ip_addr_value': ip_addr_value_new, 'ip_subnet_cidr': ip_subnet_cidr_new, 'is_static_addr': is_static_addr_new, 'leasetime_days': leasetime_days_new, 'mac_addr_value': mac_addr_value_new, 'leasetime_hours': leasetime_hours_new, 'adm_status_descr': adm_status_descr_new, 'client_identifier': client_identifier_new, 'leasetime_minutes': leasetime_minutes_new, 'always_match_by_mac_addr': always_match_by_mac_addr_new, 'accept_requested_hostname': accept_requested_hostname_new}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, gpk_old: str, ip_addr_value_new: Union[str, ExplicitNull] = None, ip_subnet_cidr_new: str = None, is_static_addr_new: bool = None, leasetime_days_new: Union[int, ExplicitNull] = None, mac_addr_value_new: Union[str, ExplicitNull] = None, leasetime_hours_new: Union[int, ExplicitNull] = None, adm_status_descr_new: Union[str, ExplicitNull] = None, client_identifier_new: Union[str, ExplicitNull] = None, leasetime_minutes_new: Union[int, ExplicitNull] = None, always_match_by_mac_addr_new: bool = None, accept_requested_hostname_new: bool = None) -> list:
		if ip_addr_value_new is not None and not (isinstance(ip_addr_value_new, str) or isinstance(ip_addr_value_new, ExplicitNull)):
			raise ValueError(f"'ip_addr_value' of incorrect type. Expected str, got {type(ip_addr_value_new)}")
		if ip_subnet_cidr_new is not None and not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")
		if is_static_addr_new is not None and not (isinstance(is_static_addr_new, bool)):
			raise ValueError(f"'is_static_addr' of incorrect type. Expected bool, got {type(is_static_addr_new)}")
		if leasetime_days_new is not None and not (isinstance(leasetime_days_new, int) or isinstance(leasetime_days_new, ExplicitNull)):
			raise ValueError(f"'leasetime_days' of incorrect type. Expected int, got {type(leasetime_days_new)}")
		if mac_addr_value_new is not None and not (isinstance(mac_addr_value_new, str) or isinstance(mac_addr_value_new, ExplicitNull)):
			raise ValueError(f"'mac_addr_value' of incorrect type. Expected str, got {type(mac_addr_value_new)}")
		if leasetime_hours_new is not None and not (isinstance(leasetime_hours_new, int) or isinstance(leasetime_hours_new, ExplicitNull)):
			raise ValueError(f"'leasetime_hours' of incorrect type. Expected int, got {type(leasetime_hours_new)}")
		if adm_status_descr_new is not None and not (isinstance(adm_status_descr_new, str) or isinstance(adm_status_descr_new, ExplicitNull)):
			raise ValueError(f"'adm_status_descr' of incorrect type. Expected str, got {type(adm_status_descr_new)}")
		if client_identifier_new is not None and not (isinstance(client_identifier_new, str) or isinstance(client_identifier_new, ExplicitNull)):
			raise ValueError(f"'client_identifier' of incorrect type. Expected str, got {type(client_identifier_new)}")
		if leasetime_minutes_new is not None and not (isinstance(leasetime_minutes_new, int) or isinstance(leasetime_minutes_new, ExplicitNull)):
			raise ValueError(f"'leasetime_minutes' of incorrect type. Expected int, got {type(leasetime_minutes_new)}")
		if always_match_by_mac_addr_new is not None and not (isinstance(always_match_by_mac_addr_new, bool)):
			raise ValueError(f"'always_match_by_mac_addr' of incorrect type. Expected bool, got {type(always_match_by_mac_addr_new)}")
		if accept_requested_hostname_new is not None and not (isinstance(accept_requested_hostname_new, bool)):
			raise ValueError(f"'accept_requested_hostname' of incorrect type. Expected bool, got {type(accept_requested_hostname_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(ip_addr_value_new=ip_addr_value_new, ip_subnet_cidr_new=ip_subnet_cidr_new, is_static_addr_new=is_static_addr_new, leasetime_days_new=leasetime_days_new, mac_addr_value_new=mac_addr_value_new, leasetime_hours_new=leasetime_hours_new, adm_status_descr_new=adm_status_descr_new, client_identifier_new=client_identifier_new, leasetime_minutes_new=leasetime_minutes_new, always_match_by_mac_addr_new=always_match_by_mac_addr_new, accept_requested_hostname_new=accept_requested_hostname_new, gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class SubnetOption(APIObject):
	gpk: str
	code: int
	data: str
	is_own: bool
	priority: int
	code_data_type: str
	ip_subnet_cidr: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.code, int):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(self.code)}")
		if not isinstance(self.data, str):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(self.data)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.priority, int):
			raise ValueError(f"'priority' of incorrect type. Expected int, got {type(self.priority)}")
		if not isinstance(self.code_data_type, str):
			raise ValueError(f"'code_data_type' of incorrect type. Expected str, got {type(self.code_data_type)}")
		if not isinstance(self.ip_subnet_cidr, str):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(self.ip_subnet_cidr)}")

	@staticmethod
	def bulk_delete_ta(ip_subnet_cidr_old: str) -> dict:
		if not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")

		return {'name': 'dhcpv4.subnet_option.bulk_delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'ip_subnet_cidr': ip_subnet_cidr_old})}

	# TODO: Consider is_returning
	@classmethod
	def bulk_delete(cls, api_session: APISession, ip_subnet_cidr_old: str) -> list:
		if not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.bulk_delete_ta(ip_subnet_cidr_old=ip_subnet_cidr_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def bulk_update_ta(ip_subnet_cidr_new: str, ip_subnet_cidr_old: str) -> dict:
		if not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")
		if not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")

		return {'name': 'dhcpv4.subnet_option.bulk_update', 'new': _denullify_dict({'ip_subnet_cidr': ip_subnet_cidr_new}), 'old': _denullify_dict({'ip_subnet_cidr': ip_subnet_cidr_old})}

	# TODO: Consider is_returning
	@classmethod
	def bulk_update(cls, api_session: APISession, ip_subnet_cidr_new: str, ip_subnet_cidr_old: str) -> list:
		if not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")
		if not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.bulk_update_ta(ip_subnet_cidr_new=ip_subnet_cidr_new, ip_subnet_cidr_old=ip_subnet_cidr_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def create_ta(code_new: int, data_new: str, ip_subnet_cidr_new: str, next_gfk_new: Union[str, ExplicitNull] = None, prior_gfk_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if not (isinstance(data_new, str)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if next_gfk_new is not None and not (isinstance(next_gfk_new, str) or isinstance(next_gfk_new, ExplicitNull)):
			raise ValueError(f"'next_gfk' of incorrect type. Expected str, got {type(next_gfk_new)}")
		if prior_gfk_new is not None and not (isinstance(prior_gfk_new, str) or isinstance(prior_gfk_new, ExplicitNull)):
			raise ValueError(f"'prior_gfk' of incorrect type. Expected str, got {type(prior_gfk_new)}")
		if not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")

		return {'name': 'dhcpv4.subnet_option.create', 'new': _denullify_dict({'code': code_new, 'data': data_new, 'next_gfk': next_gfk_new, 'prior_gfk': prior_gfk_new, 'ip_subnet_cidr': ip_subnet_cidr_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, code_new: int, data_new: str, ip_subnet_cidr_new: str, next_gfk_new: Union[str, ExplicitNull] = None, prior_gfk_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if not (isinstance(data_new, str)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if next_gfk_new is not None and not (isinstance(next_gfk_new, str) or isinstance(next_gfk_new, ExplicitNull)):
			raise ValueError(f"'next_gfk' of incorrect type. Expected str, got {type(next_gfk_new)}")
		if prior_gfk_new is not None and not (isinstance(prior_gfk_new, str) or isinstance(prior_gfk_new, ExplicitNull)):
			raise ValueError(f"'prior_gfk' of incorrect type. Expected str, got {type(prior_gfk_new)}")
		if not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(code_new=code_new, data_new=data_new, next_gfk_new=next_gfk_new, prior_gfk_new=prior_gfk_new, ip_subnet_cidr_new=ip_subnet_cidr_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dhcpv4.subnet_option.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, is_own_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, ip_subnet_cidr_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if ip_subnet_cidr_old is not None and not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dhcpv4.subnet_option.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_own': is_own_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'ip_subnet_cidr': ip_subnet_cidr_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_own_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, ip_subnet_cidr_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if ip_subnet_cidr_old is not None and not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_own_old=is_own_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, ip_subnet_cidr_old=ip_subnet_cidr_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(gpk_old: str, code_new: int = None, data_new: str = None, next_gfk_new: Union[str, ExplicitNull] = None, prior_gfk_new: Union[str, ExplicitNull] = None, ip_subnet_cidr_new: str = None) -> dict:
		if code_new is not None and not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if data_new is not None and not (isinstance(data_new, str)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if next_gfk_new is not None and not (isinstance(next_gfk_new, str) or isinstance(next_gfk_new, ExplicitNull)):
			raise ValueError(f"'next_gfk' of incorrect type. Expected str, got {type(next_gfk_new)}")
		if prior_gfk_new is not None and not (isinstance(prior_gfk_new, str) or isinstance(prior_gfk_new, ExplicitNull)):
			raise ValueError(f"'prior_gfk' of incorrect type. Expected str, got {type(prior_gfk_new)}")
		if ip_subnet_cidr_new is not None and not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dhcpv4.subnet_option.update', 'new': _denullify_dict({'code': code_new, 'data': data_new, 'next_gfk': next_gfk_new, 'prior_gfk': prior_gfk_new, 'ip_subnet_cidr': ip_subnet_cidr_new}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, gpk_old: str, code_new: int = None, data_new: str = None, next_gfk_new: Union[str, ExplicitNull] = None, prior_gfk_new: Union[str, ExplicitNull] = None, ip_subnet_cidr_new: str = None) -> list:
		if code_new is not None and not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if data_new is not None and not (isinstance(data_new, str)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if next_gfk_new is not None and not (isinstance(next_gfk_new, str) or isinstance(next_gfk_new, ExplicitNull)):
			raise ValueError(f"'next_gfk' of incorrect type. Expected str, got {type(next_gfk_new)}")
		if prior_gfk_new is not None and not (isinstance(prior_gfk_new, str) or isinstance(prior_gfk_new, ExplicitNull)):
			raise ValueError(f"'prior_gfk' of incorrect type. Expected str, got {type(prior_gfk_new)}")
		if ip_subnet_cidr_new is not None and not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(code_new=code_new, data_new=data_new, next_gfk_new=next_gfk_new, prior_gfk_new=prior_gfk_new, ip_subnet_cidr_new=ip_subnet_cidr_new, gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Og(APIObject):
	gpk: str
	name: str
	is_own: bool
	ip_subnet_cidr: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.ip_subnet_cidr, str):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(self.ip_subnet_cidr)}")

	@staticmethod
	def bulk_delete_ta(ip_subnet_cidr_old: str) -> dict:
		if not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")

		return {'name': 'dhcpv4.og.bulk_delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'ip_subnet_cidr': ip_subnet_cidr_old})}

	# TODO: Consider is_returning
	@classmethod
	def bulk_delete(cls, api_session: APISession, ip_subnet_cidr_old: str) -> list:
		if not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.bulk_delete_ta(ip_subnet_cidr_old=ip_subnet_cidr_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def bulk_update_ta(ip_subnet_cidr_new: str, ip_subnet_cidr_old: str) -> dict:
		if not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")
		if not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")

		return {'name': 'dhcpv4.og.bulk_update', 'new': _denullify_dict({'ip_subnet_cidr': ip_subnet_cidr_new}), 'old': _denullify_dict({'ip_subnet_cidr': ip_subnet_cidr_old})}

	# TODO: Consider is_returning
	@classmethod
	def bulk_update(cls, api_session: APISession, ip_subnet_cidr_new: str, ip_subnet_cidr_old: str) -> list:
		if not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")
		if not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.bulk_update_ta(ip_subnet_cidr_new=ip_subnet_cidr_new, ip_subnet_cidr_old=ip_subnet_cidr_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def create_ta(name_new: str, ip_subnet_cidr_new: str) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")

		return {'name': 'dhcpv4.og.create', 'new': _denullify_dict({'name': name_new, 'ip_subnet_cidr': ip_subnet_cidr_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, ip_subnet_cidr_new: str) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, ip_subnet_cidr_new=ip_subnet_cidr_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dhcpv4.og.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, is_own_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, ip_subnet_cidr_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if ip_subnet_cidr_old is not None and not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dhcpv4.og.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_own': is_own_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'ip_subnet_cidr': ip_subnet_cidr_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_own_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, ip_subnet_cidr_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if ip_subnet_cidr_old is not None and not (isinstance(ip_subnet_cidr_old, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_own_old=is_own_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, ip_subnet_cidr_old=ip_subnet_cidr_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(gpk_old: str, name_new: str = None, ip_subnet_cidr_new: str = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if ip_subnet_cidr_new is not None and not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dhcpv4.og.update', 'new': _denullify_dict({'name': name_new, 'ip_subnet_cidr': ip_subnet_cidr_new}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, gpk_old: str, name_new: str = None, ip_subnet_cidr_new: str = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if ip_subnet_cidr_new is not None and not (isinstance(ip_subnet_cidr_new, str)):
			raise ValueError(f"'ip_subnet_cidr' of incorrect type. Expected str, got {type(ip_subnet_cidr_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, ip_subnet_cidr_new=ip_subnet_cidr_new, gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class GroupOption(APIObject):
	gpk: str
	code: int
	data: str
	is_own: bool
	og_gfk: str
	priority: int
	code_data_type: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.code, int):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(self.code)}")
		if not isinstance(self.data, str):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(self.data)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.og_gfk, str):
			raise ValueError(f"'og_gfk' of incorrect type. Expected str, got {type(self.og_gfk)}")
		if not isinstance(self.priority, int):
			raise ValueError(f"'priority' of incorrect type. Expected int, got {type(self.priority)}")
		if not isinstance(self.code_data_type, str):
			raise ValueError(f"'code_data_type' of incorrect type. Expected str, got {type(self.code_data_type)}")

	@staticmethod
	def create_ta(code_new: int, data_new: str, og_gfk_new: str, next_gfk_new: Union[str, ExplicitNull] = None, prior_gfk_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if not (isinstance(data_new, str)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if not (isinstance(og_gfk_new, str)):
			raise ValueError(f"'og_gfk' of incorrect type. Expected str, got {type(og_gfk_new)}")
		if next_gfk_new is not None and not (isinstance(next_gfk_new, str) or isinstance(next_gfk_new, ExplicitNull)):
			raise ValueError(f"'next_gfk' of incorrect type. Expected str, got {type(next_gfk_new)}")
		if prior_gfk_new is not None and not (isinstance(prior_gfk_new, str) or isinstance(prior_gfk_new, ExplicitNull)):
			raise ValueError(f"'prior_gfk' of incorrect type. Expected str, got {type(prior_gfk_new)}")

		return {'name': 'dhcpv4.group_option.create', 'new': _denullify_dict({'code': code_new, 'data': data_new, 'og_gfk': og_gfk_new, 'next_gfk': next_gfk_new, 'prior_gfk': prior_gfk_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, code_new: int, data_new: str, og_gfk_new: str, next_gfk_new: Union[str, ExplicitNull] = None, prior_gfk_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if not (isinstance(data_new, str)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if not (isinstance(og_gfk_new, str)):
			raise ValueError(f"'og_gfk' of incorrect type. Expected str, got {type(og_gfk_new)}")
		if next_gfk_new is not None and not (isinstance(next_gfk_new, str) or isinstance(next_gfk_new, ExplicitNull)):
			raise ValueError(f"'next_gfk' of incorrect type. Expected str, got {type(next_gfk_new)}")
		if prior_gfk_new is not None and not (isinstance(prior_gfk_new, str) or isinstance(prior_gfk_new, ExplicitNull)):
			raise ValueError(f"'prior_gfk' of incorrect type. Expected str, got {type(prior_gfk_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(code_new=code_new, data_new=data_new, og_gfk_new=og_gfk_new, next_gfk_new=next_gfk_new, prior_gfk_new=prior_gfk_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dhcpv4.group_option.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, is_own_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dhcpv4.group_option.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_own': is_own_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_own_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_own_old=is_own_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(gpk_old: str, code_new: int = None, data_new: str = None, og_gfk_new: str = None, next_gfk_new: Union[str, ExplicitNull] = None, prior_gfk_new: Union[str, ExplicitNull] = None) -> dict:
		if code_new is not None and not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if data_new is not None and not (isinstance(data_new, str)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if og_gfk_new is not None and not (isinstance(og_gfk_new, str)):
			raise ValueError(f"'og_gfk' of incorrect type. Expected str, got {type(og_gfk_new)}")
		if next_gfk_new is not None and not (isinstance(next_gfk_new, str) or isinstance(next_gfk_new, ExplicitNull)):
			raise ValueError(f"'next_gfk' of incorrect type. Expected str, got {type(next_gfk_new)}")
		if prior_gfk_new is not None and not (isinstance(prior_gfk_new, str) or isinstance(prior_gfk_new, ExplicitNull)):
			raise ValueError(f"'prior_gfk' of incorrect type. Expected str, got {type(prior_gfk_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dhcpv4.group_option.update', 'new': _denullify_dict({'code': code_new, 'data': data_new, 'og_gfk': og_gfk_new, 'next_gfk': next_gfk_new, 'prior_gfk': prior_gfk_new}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, gpk_old: str, code_new: int = None, data_new: str = None, og_gfk_new: str = None, next_gfk_new: Union[str, ExplicitNull] = None, prior_gfk_new: Union[str, ExplicitNull] = None) -> list:
		if code_new is not None and not (isinstance(code_new, int)):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(code_new)}")
		if data_new is not None and not (isinstance(data_new, str)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if og_gfk_new is not None and not (isinstance(og_gfk_new, str)):
			raise ValueError(f"'og_gfk' of incorrect type. Expected str, got {type(og_gfk_new)}")
		if next_gfk_new is not None and not (isinstance(next_gfk_new, str) or isinstance(next_gfk_new, ExplicitNull)):
			raise ValueError(f"'next_gfk' of incorrect type. Expected str, got {type(next_gfk_new)}")
		if prior_gfk_new is not None and not (isinstance(prior_gfk_new, str) or isinstance(prior_gfk_new, ExplicitNull)):
			raise ValueError(f"'prior_gfk' of incorrect type. Expected str, got {type(prior_gfk_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(code_new=code_new, data_new=data_new, og_gfk_new=og_gfk_new, next_gfk_new=next_gfk_new, prior_gfk_new=prior_gfk_new, gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class SubnetOptionRule(APIObject):
	gpk: str
	is_own: bool
	operator: str
	opt_code: int
	sn_opt_gfk: str
	left_data_type: str
	right_data_type: str
	right_data_value: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.operator, str):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(self.operator)}")
		if not isinstance(self.opt_code, int):
			raise ValueError(f"'opt_code' of incorrect type. Expected int, got {type(self.opt_code)}")
		if not isinstance(self.sn_opt_gfk, str):
			raise ValueError(f"'sn_opt_gfk' of incorrect type. Expected str, got {type(self.sn_opt_gfk)}")
		if not isinstance(self.left_data_type, str):
			raise ValueError(f"'left_data_type' of incorrect type. Expected str, got {type(self.left_data_type)}")
		if not isinstance(self.right_data_type, str):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(self.right_data_type)}")
		if not isinstance(self.right_data_value, str):
			raise ValueError(f"'right_data_value' of incorrect type. Expected str, got {type(self.right_data_value)}")

	@staticmethod
	def create_ta(operator_new: str, opt_code_new: int, sn_opt_gfk_new: str, right_data_type_new: str, right_data_value_new: str) -> dict:
		if not (isinstance(operator_new, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_new)}")
		if not (isinstance(opt_code_new, int)):
			raise ValueError(f"'opt_code' of incorrect type. Expected int, got {type(opt_code_new)}")
		if not (isinstance(sn_opt_gfk_new, str)):
			raise ValueError(f"'sn_opt_gfk' of incorrect type. Expected str, got {type(sn_opt_gfk_new)}")
		if not (isinstance(right_data_type_new, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_new)}")
		if not (isinstance(right_data_value_new, str)):
			raise ValueError(f"'right_data_value' of incorrect type. Expected str, got {type(right_data_value_new)}")

		return {'name': 'dhcpv4.subnet_option_rule.create', 'new': _denullify_dict({'operator': operator_new, 'opt_code': opt_code_new, 'sn_opt_gfk': sn_opt_gfk_new, 'right_data_type': right_data_type_new, 'right_data_value': right_data_value_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, operator_new: str, opt_code_new: int, sn_opt_gfk_new: str, right_data_type_new: str, right_data_value_new: str) -> list:
		if not (isinstance(operator_new, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_new)}")
		if not (isinstance(opt_code_new, int)):
			raise ValueError(f"'opt_code' of incorrect type. Expected int, got {type(opt_code_new)}")
		if not (isinstance(sn_opt_gfk_new, str)):
			raise ValueError(f"'sn_opt_gfk' of incorrect type. Expected str, got {type(sn_opt_gfk_new)}")
		if not (isinstance(right_data_type_new, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_new)}")
		if not (isinstance(right_data_value_new, str)):
			raise ValueError(f"'right_data_value' of incorrect type. Expected str, got {type(right_data_value_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(operator_new=operator_new, opt_code_new=opt_code_new, sn_opt_gfk_new=sn_opt_gfk_new, right_data_type_new=right_data_type_new, right_data_value_new=right_data_value_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dhcpv4.subnet_option_rule.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, is_own_old: bool = None, sn_opt_gfk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if sn_opt_gfk_old is not None and not (isinstance(sn_opt_gfk_old, str)):
			raise ValueError(f"'sn_opt_gfk' of incorrect type. Expected str, got {type(sn_opt_gfk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dhcpv4.subnet_option_rule.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_own': is_own_old, 'sn_opt_gfk': sn_opt_gfk_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_own_old: bool = None, sn_opt_gfk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if sn_opt_gfk_old is not None and not (isinstance(sn_opt_gfk_old, str)):
			raise ValueError(f"'sn_opt_gfk' of incorrect type. Expected str, got {type(sn_opt_gfk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_own_old=is_own_old, sn_opt_gfk_old=sn_opt_gfk_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(gpk_old: str, operator_new: str = None, opt_code_new: int = None, sn_opt_gfk_new: str = None, right_data_type_new: str = None, right_data_value_new: str = None) -> dict:
		if operator_new is not None and not (isinstance(operator_new, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_new)}")
		if opt_code_new is not None and not (isinstance(opt_code_new, int)):
			raise ValueError(f"'opt_code' of incorrect type. Expected int, got {type(opt_code_new)}")
		if sn_opt_gfk_new is not None and not (isinstance(sn_opt_gfk_new, str)):
			raise ValueError(f"'sn_opt_gfk' of incorrect type. Expected str, got {type(sn_opt_gfk_new)}")
		if right_data_type_new is not None and not (isinstance(right_data_type_new, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_new)}")
		if right_data_value_new is not None and not (isinstance(right_data_value_new, str)):
			raise ValueError(f"'right_data_value' of incorrect type. Expected str, got {type(right_data_value_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dhcpv4.subnet_option_rule.update', 'new': _denullify_dict({'operator': operator_new, 'opt_code': opt_code_new, 'sn_opt_gfk': sn_opt_gfk_new, 'right_data_type': right_data_type_new, 'right_data_value': right_data_value_new}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, gpk_old: str, operator_new: str = None, opt_code_new: int = None, sn_opt_gfk_new: str = None, right_data_type_new: str = None, right_data_value_new: str = None) -> list:
		if operator_new is not None and not (isinstance(operator_new, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_new)}")
		if opt_code_new is not None and not (isinstance(opt_code_new, int)):
			raise ValueError(f"'opt_code' of incorrect type. Expected int, got {type(opt_code_new)}")
		if sn_opt_gfk_new is not None and not (isinstance(sn_opt_gfk_new, str)):
			raise ValueError(f"'sn_opt_gfk' of incorrect type. Expected str, got {type(sn_opt_gfk_new)}")
		if right_data_type_new is not None and not (isinstance(right_data_type_new, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_new)}")
		if right_data_value_new is not None and not (isinstance(right_data_value_new, str)):
			raise ValueError(f"'right_data_value' of incorrect type. Expected str, got {type(right_data_value_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(operator_new=operator_new, opt_code_new=opt_code_new, sn_opt_gfk_new=sn_opt_gfk_new, right_data_type_new=right_data_type_new, right_data_value_new=right_data_value_new, gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class GroupOptionRule(APIObject):
	gpk: str
	is_own: bool
	operator: str
	opt_code: int
	og_opt_gfk: str
	left_data_type: str
	right_data_type: str
	right_data_value: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.operator, str):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(self.operator)}")
		if not isinstance(self.opt_code, int):
			raise ValueError(f"'opt_code' of incorrect type. Expected int, got {type(self.opt_code)}")
		if not isinstance(self.og_opt_gfk, str):
			raise ValueError(f"'og_opt_gfk' of incorrect type. Expected str, got {type(self.og_opt_gfk)}")
		if not isinstance(self.left_data_type, str):
			raise ValueError(f"'left_data_type' of incorrect type. Expected str, got {type(self.left_data_type)}")
		if not isinstance(self.right_data_type, str):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(self.right_data_type)}")
		if not isinstance(self.right_data_value, str):
			raise ValueError(f"'right_data_value' of incorrect type. Expected str, got {type(self.right_data_value)}")

	@staticmethod
	def create_ta(operator_new: str, opt_code_new: int, og_opt_gfk_new: str, right_data_type_new: str, right_data_value_new: str) -> dict:
		if not (isinstance(operator_new, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_new)}")
		if not (isinstance(opt_code_new, int)):
			raise ValueError(f"'opt_code' of incorrect type. Expected int, got {type(opt_code_new)}")
		if not (isinstance(og_opt_gfk_new, str)):
			raise ValueError(f"'og_opt_gfk' of incorrect type. Expected str, got {type(og_opt_gfk_new)}")
		if not (isinstance(right_data_type_new, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_new)}")
		if not (isinstance(right_data_value_new, str)):
			raise ValueError(f"'right_data_value' of incorrect type. Expected str, got {type(right_data_value_new)}")

		return {'name': 'dhcpv4.group_option_rule.create', 'new': _denullify_dict({'operator': operator_new, 'opt_code': opt_code_new, 'og_opt_gfk': og_opt_gfk_new, 'right_data_type': right_data_type_new, 'right_data_value': right_data_value_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, operator_new: str, opt_code_new: int, og_opt_gfk_new: str, right_data_type_new: str, right_data_value_new: str) -> list:
		if not (isinstance(operator_new, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_new)}")
		if not (isinstance(opt_code_new, int)):
			raise ValueError(f"'opt_code' of incorrect type. Expected int, got {type(opt_code_new)}")
		if not (isinstance(og_opt_gfk_new, str)):
			raise ValueError(f"'og_opt_gfk' of incorrect type. Expected str, got {type(og_opt_gfk_new)}")
		if not (isinstance(right_data_type_new, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_new)}")
		if not (isinstance(right_data_value_new, str)):
			raise ValueError(f"'right_data_value' of incorrect type. Expected str, got {type(right_data_value_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(operator_new=operator_new, opt_code_new=opt_code_new, og_opt_gfk_new=og_opt_gfk_new, right_data_type_new=right_data_type_new, right_data_value_new=right_data_value_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dhcpv4.group_option_rule.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, is_own_old: bool = None, og_opt_gfk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if og_opt_gfk_old is not None and not (isinstance(og_opt_gfk_old, str)):
			raise ValueError(f"'og_opt_gfk' of incorrect type. Expected str, got {type(og_opt_gfk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dhcpv4.group_option_rule.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_own': is_own_old, 'og_opt_gfk': og_opt_gfk_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_own_old: bool = None, og_opt_gfk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if og_opt_gfk_old is not None and not (isinstance(og_opt_gfk_old, str)):
			raise ValueError(f"'og_opt_gfk' of incorrect type. Expected str, got {type(og_opt_gfk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_own_old=is_own_old, og_opt_gfk_old=og_opt_gfk_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(gpk_old: str, operator_new: str = None, opt_code_new: int = None, og_opt_gfk_new: str = None, right_data_type_new: str = None, right_data_value_new: str = None) -> dict:
		if operator_new is not None and not (isinstance(operator_new, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_new)}")
		if opt_code_new is not None and not (isinstance(opt_code_new, int)):
			raise ValueError(f"'opt_code' of incorrect type. Expected int, got {type(opt_code_new)}")
		if og_opt_gfk_new is not None and not (isinstance(og_opt_gfk_new, str)):
			raise ValueError(f"'og_opt_gfk' of incorrect type. Expected str, got {type(og_opt_gfk_new)}")
		if right_data_type_new is not None and not (isinstance(right_data_type_new, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_new)}")
		if right_data_value_new is not None and not (isinstance(right_data_value_new, str)):
			raise ValueError(f"'right_data_value' of incorrect type. Expected str, got {type(right_data_value_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dhcpv4.group_option_rule.update', 'new': _denullify_dict({'operator': operator_new, 'opt_code': opt_code_new, 'og_opt_gfk': og_opt_gfk_new, 'right_data_type': right_data_type_new, 'right_data_value': right_data_value_new}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, gpk_old: str, operator_new: str = None, opt_code_new: int = None, og_opt_gfk_new: str = None, right_data_type_new: str = None, right_data_value_new: str = None) -> list:
		if operator_new is not None and not (isinstance(operator_new, str)):
			raise ValueError(f"'operator' of incorrect type. Expected str, got {type(operator_new)}")
		if opt_code_new is not None and not (isinstance(opt_code_new, int)):
			raise ValueError(f"'opt_code' of incorrect type. Expected int, got {type(opt_code_new)}")
		if og_opt_gfk_new is not None and not (isinstance(og_opt_gfk_new, str)):
			raise ValueError(f"'og_opt_gfk' of incorrect type. Expected str, got {type(og_opt_gfk_new)}")
		if right_data_type_new is not None and not (isinstance(right_data_type_new, str)):
			raise ValueError(f"'right_data_type' of incorrect type. Expected str, got {type(right_data_type_new)}")
		if right_data_value_new is not None and not (isinstance(right_data_value_new, str)):
			raise ValueError(f"'right_data_value' of incorrect type. Expected str, got {type(right_data_value_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(operator_new=operator_new, opt_code_new=opt_code_new, og_opt_gfk_new=og_opt_gfk_new, right_data_type_new=right_data_type_new, right_data_value_new=right_data_value_new, gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Og2lease(APIObject):
	gpk: str
	is_own: bool
	og_gfk: str
	priority: int
	lease_gfk: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.og_gfk, str):
			raise ValueError(f"'og_gfk' of incorrect type. Expected str, got {type(self.og_gfk)}")
		if not isinstance(self.priority, int):
			raise ValueError(f"'priority' of incorrect type. Expected int, got {type(self.priority)}")
		if not isinstance(self.lease_gfk, str):
			raise ValueError(f"'lease_gfk' of incorrect type. Expected str, got {type(self.lease_gfk)}")

	@staticmethod
	def create_ta(og_gfk_new: str, lease_gfk_new: str) -> dict:
		if not (isinstance(og_gfk_new, str)):
			raise ValueError(f"'og_gfk' of incorrect type. Expected str, got {type(og_gfk_new)}")
		if not (isinstance(lease_gfk_new, str)):
			raise ValueError(f"'lease_gfk' of incorrect type. Expected str, got {type(lease_gfk_new)}")

		return {'name': 'dhcpv4.og2lease.create', 'new': _denullify_dict({'og_gfk': og_gfk_new, 'lease_gfk': lease_gfk_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, og_gfk_new: str, lease_gfk_new: str) -> list:
		if not (isinstance(og_gfk_new, str)):
			raise ValueError(f"'og_gfk' of incorrect type. Expected str, got {type(og_gfk_new)}")
		if not (isinstance(lease_gfk_new, str)):
			raise ValueError(f"'lease_gfk' of incorrect type. Expected str, got {type(lease_gfk_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(og_gfk_new=og_gfk_new, lease_gfk_new=lease_gfk_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dhcpv4.og2lease.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, is_own_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'dhcpv4.og2lease.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_own': is_own_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_own_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_own_old=is_own_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(gpk_old: str, og_gfk_new: str = None, lease_gfk_new: str = None) -> dict:
		if og_gfk_new is not None and not (isinstance(og_gfk_new, str)):
			raise ValueError(f"'og_gfk' of incorrect type. Expected str, got {type(og_gfk_new)}")
		if lease_gfk_new is not None and not (isinstance(lease_gfk_new, str)):
			raise ValueError(f"'lease_gfk' of incorrect type. Expected str, got {type(lease_gfk_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'dhcpv4.og2lease.update', 'new': _denullify_dict({'og_gfk': og_gfk_new, 'lease_gfk': lease_gfk_new}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, gpk_old: str, og_gfk_new: str = None, lease_gfk_new: str = None) -> list:
		if og_gfk_new is not None and not (isinstance(og_gfk_new, str)):
			raise ValueError(f"'og_gfk' of incorrect type. Expected str, got {type(og_gfk_new)}")
		if lease_gfk_new is not None and not (isinstance(lease_gfk_new, str)):
			raise ValueError(f"'lease_gfk' of incorrect type. Expected str, got {type(lease_gfk_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(og_gfk_new=og_gfk_new, lease_gfk_new=lease_gfk_new, gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]
