### AUTOGENERATED
from . import _denullify_dict
from . import *
from dataclasses import dataclass
from typing import Union


@dataclass()
class RecordType(APIObject):
	gpk: str
	action: str
	subject: str
	short_name: str
	committed_action: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.action, str):
			raise ValueError(f"'action' of incorrect type. Expected str, got {type(self.action)}")
		if not isinstance(self.subject, str):
			raise ValueError(f"'subject' of incorrect type. Expected str, got {type(self.subject)}")
		if not isinstance(self.short_name, str):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(self.short_name)}")
		if self.committed_action is not None and not isinstance(self.committed_action, str):
			raise ValueError(f"'committed_action' of incorrect type. Expected str, got {type(self.committed_action)}")

	@staticmethod
	def create_ta(subject_new: str, committed_action_new: Union[str, ExplicitNull]) -> dict:
		if not (isinstance(subject_new, str)):
			raise ValueError(f"'subject' of incorrect type. Expected str, got {type(subject_new)}")
		if not (isinstance(committed_action_new, str) or isinstance(committed_action_new, ExplicitNull)):
			raise ValueError(f"'committed_action' of incorrect type. Expected str, got {type(committed_action_new)}")

		return {'name': 'evlog.record_type.create', 'new': _denullify_dict({'subject': subject_new, 'committed_action': committed_action_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, subject_new: str, committed_action_new: Union[str, ExplicitNull]) -> list:
		if not (isinstance(subject_new, str)):
			raise ValueError(f"'subject' of incorrect type. Expected str, got {type(subject_new)}")
		if not (isinstance(committed_action_new, str) or isinstance(committed_action_new, ExplicitNull)):
			raise ValueError(f"'committed_action' of incorrect type. Expected str, got {type(committed_action_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(subject_new=subject_new, committed_action_new=committed_action_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, subject_old: str = None, short_name_list_old: list = None, committed_action_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if subject_old is not None and not (isinstance(subject_old, str)):
			raise ValueError(f"'subject' of incorrect type. Expected str, got {type(subject_old)}")
		if short_name_list_old is not None and not (isinstance(short_name_list_old, list)):
			raise ValueError(f"'short_name_list' of incorrect type. Expected list, got {type(short_name_list_old)}")
		if committed_action_old is not None and not (isinstance(committed_action_old, str) or isinstance(committed_action_old, ExplicitNull)):
			raise ValueError(f"'committed_action' of incorrect type. Expected str, got {type(committed_action_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'evlog.record_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'subject': subject_old, 'short_name_list': short_name_list_old, 'committed_action': committed_action_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, subject_old: str = None, short_name_list_old: list = None, committed_action_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if subject_old is not None and not (isinstance(subject_old, str)):
			raise ValueError(f"'subject' of incorrect type. Expected str, got {type(subject_old)}")
		if short_name_list_old is not None and not (isinstance(short_name_list_old, list)):
			raise ValueError(f"'short_name_list' of incorrect type. Expected list, got {type(short_name_list_old)}")
		if committed_action_old is not None and not (isinstance(committed_action_old, str) or isinstance(committed_action_old, ExplicitNull)):
			raise ValueError(f"'committed_action' of incorrect type. Expected str, got {type(committed_action_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, subject_old=subject_old, short_name_list_old=short_name_list_old, committed_action_old=committed_action_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(subject_old: str, subject_new: str = None, committed_action_new: Union[str, ExplicitNull] = None) -> dict:
		if subject_new is not None and not (isinstance(subject_new, str)):
			raise ValueError(f"'subject' of incorrect type. Expected str, got {type(subject_new)}")
		if committed_action_new is not None and not (isinstance(committed_action_new, str) or isinstance(committed_action_new, ExplicitNull)):
			raise ValueError(f"'committed_action' of incorrect type. Expected str, got {type(committed_action_new)}")
		if not (isinstance(subject_old, str)):
			raise ValueError(f"'subject' of incorrect type. Expected str, got {type(subject_old)}")

		return {'name': 'evlog.record_type.update', 'new': _denullify_dict({'subject': subject_new, 'committed_action': committed_action_new}), 'old': _denullify_dict({'subject': subject_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, subject_old: str, subject_new: str = None, committed_action_new: Union[str, ExplicitNull] = None) -> list:
		if subject_new is not None and not (isinstance(subject_new, str)):
			raise ValueError(f"'subject' of incorrect type. Expected str, got {type(subject_new)}")
		if committed_action_new is not None and not (isinstance(committed_action_new, str) or isinstance(committed_action_new, ExplicitNull)):
			raise ValueError(f"'committed_action' of incorrect type. Expected str, got {type(committed_action_new)}")
		if not (isinstance(subject_old, str)):
			raise ValueError(f"'subject' of incorrect type. Expected str, got {type(subject_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(subject_new=subject_new, committed_action_new=committed_action_new, subject_old=subject_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Record(APIObject):
	data: str
	type: str
	object_gfk: str
	ta_timestamp: str
	mgr_login_name: str
	object_type_fq_name: str

	def __post_init__(self):
		if self.data is not None and not isinstance(self.data, str):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(self.data)}")
		if not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if not isinstance(self.object_gfk, str):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(self.object_gfk)}")
		if not isinstance(self.ta_timestamp, str):
			raise ValueError(f"'ta_timestamp' of incorrect type. Expected str, got {type(self.ta_timestamp)}")
		if self.mgr_login_name is not None and not isinstance(self.mgr_login_name, str):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(self.mgr_login_name)}")
		if not isinstance(self.object_type_fq_name, str):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(self.object_type_fq_name)}")

	@staticmethod
	def create_ta(data_new: str, object_gfk_new: str, ta_timestamp_new: str = None) -> dict:
		if not (isinstance(data_new, str)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if not (isinstance(object_gfk_new, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_new)}")
		if ta_timestamp_new is not None and not (isinstance(ta_timestamp_new, str)):
			raise ValueError(f"'ta_timestamp' of incorrect type. Expected str, got {type(ta_timestamp_new)}")

		return {'name': 'evlog.record.create', 'new': _denullify_dict({'data': data_new, 'object_gfk': object_gfk_new, 'ta_timestamp': ta_timestamp_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, data_new: str, object_gfk_new: str, ta_timestamp_new: str = None) -> list:
		if not (isinstance(data_new, str)):
			raise ValueError(f"'data' of incorrect type. Expected str, got {type(data_new)}")
		if not (isinstance(object_gfk_new, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_new)}")
		if ta_timestamp_new is not None and not (isinstance(ta_timestamp_new, str)):
			raise ValueError(f"'ta_timestamp' of incorrect type. Expected str, got {type(ta_timestamp_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(data_new=data_new, object_gfk_new=object_gfk_new, ta_timestamp_new=ta_timestamp_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(top_n_old: int = None, type_list_old: list = None, object_gfk_old: str = None, data_regexp_old: str = None, ta_interval_old: str = None, ta_timestamp_old: str = None, mgr_login_name_old: str = None, top_n_from_newest_old: bool = True, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if top_n_old is not None and not (isinstance(top_n_old, int)):
			raise ValueError(f"'top_n' of incorrect type. Expected int, got {type(top_n_old)}")
		if type_list_old is not None and not (isinstance(type_list_old, list)):
			raise ValueError(f"'type_list' of incorrect type. Expected list, got {type(type_list_old)}")
		if object_gfk_old is not None and not (isinstance(object_gfk_old, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_old)}")
		if data_regexp_old is not None and not (isinstance(data_regexp_old, str)):
			raise ValueError(f"'data_regexp' of incorrect type. Expected str, got {type(data_regexp_old)}")
		if ta_interval_old is not None and not (isinstance(ta_interval_old, str)):
			raise ValueError(f"'ta_interval' of incorrect type. Expected str, got {type(ta_interval_old)}")
		if ta_timestamp_old is not None and not (isinstance(ta_timestamp_old, str)):
			raise ValueError(f"'ta_timestamp' of incorrect type. Expected str, got {type(ta_timestamp_old)}")
		if mgr_login_name_old is not None and not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")
		if top_n_from_newest_old is not None and not (isinstance(top_n_from_newest_old, bool)):
			raise ValueError(f"'top_n_from_newest' of incorrect type. Expected bool, got {type(top_n_from_newest_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'evlog.record.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'top_n': top_n_old, 'type_list': type_list_old, 'object_gfk': object_gfk_old, 'data_regexp': data_regexp_old, 'ta_interval': ta_interval_old, 'ta_timestamp': ta_timestamp_old, 'mgr_login_name': mgr_login_name_old, 'top_n_from_newest': top_n_from_newest_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, top_n_old: int = None, type_list_old: list = None, object_gfk_old: str = None, data_regexp_old: str = None, ta_interval_old: str = None, ta_timestamp_old: str = None, mgr_login_name_old: str = None, top_n_from_newest_old: bool = True, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if top_n_old is not None and not (isinstance(top_n_old, int)):
			raise ValueError(f"'top_n' of incorrect type. Expected int, got {type(top_n_old)}")
		if type_list_old is not None and not (isinstance(type_list_old, list)):
			raise ValueError(f"'type_list' of incorrect type. Expected list, got {type(type_list_old)}")
		if object_gfk_old is not None and not (isinstance(object_gfk_old, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_old)}")
		if data_regexp_old is not None and not (isinstance(data_regexp_old, str)):
			raise ValueError(f"'data_regexp' of incorrect type. Expected str, got {type(data_regexp_old)}")
		if ta_interval_old is not None and not (isinstance(ta_interval_old, str)):
			raise ValueError(f"'ta_interval' of incorrect type. Expected str, got {type(ta_interval_old)}")
		if ta_timestamp_old is not None and not (isinstance(ta_timestamp_old, str)):
			raise ValueError(f"'ta_timestamp' of incorrect type. Expected str, got {type(ta_timestamp_old)}")
		if mgr_login_name_old is not None and not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")
		if top_n_from_newest_old is not None and not (isinstance(top_n_from_newest_old, bool)):
			raise ValueError(f"'top_n_from_newest' of incorrect type. Expected bool, got {type(top_n_from_newest_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(top_n_old=top_n_old, type_list_old=type_list_old, object_gfk_old=object_gfk_old, data_regexp_old=data_regexp_old, ta_interval_old=ta_interval_old, ta_timestamp_old=ta_timestamp_old, mgr_login_name_old=mgr_login_name_old, top_n_from_newest_old=top_n_from_newest_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]
