### AUTOGENERATED
from . import _denullify_dict
from . import *
from dataclasses import dataclass
from typing import Union


@dataclass()
class UnitType(APIObject):
	gpk: str
	name: str
	position: int
	short_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.position, int):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(self.position)}")
		if not isinstance(self.short_name, str):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(self.short_name)}")

	@staticmethod
	def create_ta(name_new: str, short_name_new: str, position_new: int = None) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if position_new is not None and not (isinstance(position_new, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if not (isinstance(short_name_new, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_new)}")

		return {'name': 'org.unit_type.create', 'new': _denullify_dict({'name': name_new, 'position': position_new, 'short_name': short_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, short_name_new: str, position_new: int = None) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if position_new is not None and not (isinstance(position_new, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if not (isinstance(short_name_new, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, position_new=position_new, short_name_new=short_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(short_name_old: str) -> dict:
		if not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")

		return {'name': 'org.unit_type.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'short_name': short_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, short_name_old: str) -> list:
		if not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(short_name_old=short_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, short_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if short_name_list_old is not None and not (isinstance(short_name_list_old, list)):
			raise ValueError(f"'short_name_list' of incorrect type. Expected list, got {type(short_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'org.unit_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'short_name_list': short_name_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, short_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if short_name_list_old is not None and not (isinstance(short_name_list_old, list)):
			raise ValueError(f"'short_name_list' of incorrect type. Expected list, got {type(short_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, short_name_list_old=short_name_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(short_name_old: str, name_new: str = None, position_new: int = None, short_name_new: str = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if position_new is not None and not (isinstance(position_new, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if short_name_new is not None and not (isinstance(short_name_new, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_new)}")
		if not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")

		return {'name': 'org.unit_type.update', 'new': _denullify_dict({'name': name_new, 'position': position_new, 'short_name': short_name_new}), 'old': _denullify_dict({'short_name': short_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, short_name_old: str, name_new: str = None, position_new: int = None, short_name_new: str = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if position_new is not None and not (isinstance(position_new, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if short_name_new is not None and not (isinstance(short_name_new, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_new)}")
		if not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, position_new=position_new, short_name_new=short_name_new, short_name_old=short_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Unit(APIObject):
	gpk: str
	name: str
	type: str
	short_name: str
	tree_level: int
	sub_position: int
	root_node_set: list
	is_mgr_assignable: bool
	parent_short_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if not isinstance(self.short_name, str):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(self.short_name)}")
		if not isinstance(self.tree_level, int):
			raise ValueError(f"'tree_level' of incorrect type. Expected int, got {type(self.tree_level)}")
		if not isinstance(self.sub_position, int):
			raise ValueError(f"'sub_position' of incorrect type. Expected int, got {type(self.sub_position)}")
		if not isinstance(self.root_node_set, list):
			raise ValueError(f"'root_node_set' of incorrect type. Expected list, got {type(self.root_node_set)}")
		if not isinstance(self.is_mgr_assignable, bool):
			raise ValueError(f"'is_mgr_assignable' of incorrect type. Expected bool, got {type(self.is_mgr_assignable)}")
		if self.parent_short_name is not None and not isinstance(self.parent_short_name, str):
			raise ValueError(f"'parent_short_name' of incorrect type. Expected str, got {type(self.parent_short_name)}")

	@staticmethod
	def create_ta(name_new: str, type_new: str, short_name_new: str, sub_position_new: int = None, is_mgr_assignable_new: bool = True, parent_short_name_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if not (isinstance(short_name_new, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_new)}")
		if sub_position_new is not None and not (isinstance(sub_position_new, int)):
			raise ValueError(f"'sub_position' of incorrect type. Expected int, got {type(sub_position_new)}")
		if is_mgr_assignable_new is not None and not (isinstance(is_mgr_assignable_new, bool)):
			raise ValueError(f"'is_mgr_assignable' of incorrect type. Expected bool, got {type(is_mgr_assignable_new)}")
		if parent_short_name_new is not None and not (isinstance(parent_short_name_new, str) or isinstance(parent_short_name_new, ExplicitNull)):
			raise ValueError(f"'parent_short_name' of incorrect type. Expected str, got {type(parent_short_name_new)}")

		return {'name': 'org.unit.create', 'new': _denullify_dict({'name': name_new, 'type': type_new, 'short_name': short_name_new, 'sub_position': sub_position_new, 'is_mgr_assignable': is_mgr_assignable_new, 'parent_short_name': parent_short_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, type_new: str, short_name_new: str, sub_position_new: int = None, is_mgr_assignable_new: bool = True, parent_short_name_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if not (isinstance(short_name_new, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_new)}")
		if sub_position_new is not None and not (isinstance(sub_position_new, int)):
			raise ValueError(f"'sub_position' of incorrect type. Expected int, got {type(sub_position_new)}")
		if is_mgr_assignable_new is not None and not (isinstance(is_mgr_assignable_new, bool)):
			raise ValueError(f"'is_mgr_assignable' of incorrect type. Expected bool, got {type(is_mgr_assignable_new)}")
		if parent_short_name_new is not None and not (isinstance(parent_short_name_new, str) or isinstance(parent_short_name_new, ExplicitNull)):
			raise ValueError(f"'parent_short_name' of incorrect type. Expected str, got {type(parent_short_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, type_new=type_new, short_name_new=short_name_new, sub_position_new=sub_position_new, is_mgr_assignable_new=is_mgr_assignable_new, parent_short_name_new=parent_short_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(short_name_old: str, merge_short_name_new: str = None) -> dict:
		if merge_short_name_new is not None and not (isinstance(merge_short_name_new, str)):
			raise ValueError(f"'merge_short_name' of incorrect type. Expected str, got {type(merge_short_name_new)}")
		if not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")

		return {'name': 'org.unit.delete', 'new': _denullify_dict({'merge_short_name': merge_short_name_new}), 'old': _denullify_dict({'short_name': short_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, short_name_old: str, merge_short_name_new: str = None) -> list:
		if merge_short_name_new is not None and not (isinstance(merge_short_name_new, str)):
			raise ValueError(f"'merge_short_name' of incorrect type. Expected str, got {type(merge_short_name_new)}")
		if not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(merge_short_name_new=merge_short_name_new, short_name_old=short_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, type_old: str = None, do_subtree_old: bool = False, short_name_old: str = None, tree_level_old: int = None, do_rootpath_old: bool = False, fetch_limit_old: int = None, name_regexp_old: str = None, do_root_only_old: bool = False, fetch_offset_old: int = None, is_mgr_assignable_old: bool = None, short_name_regexp_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if do_subtree_old is not None and not (isinstance(do_subtree_old, bool)):
			raise ValueError(f"'do_subtree' of incorrect type. Expected bool, got {type(do_subtree_old)}")
		if short_name_old is not None and not (isinstance(short_name_old, str) or isinstance(short_name_old, ExplicitNull)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")
		if tree_level_old is not None and not (isinstance(tree_level_old, int)):
			raise ValueError(f"'tree_level' of incorrect type. Expected int, got {type(tree_level_old)}")
		if do_rootpath_old is not None and not (isinstance(do_rootpath_old, bool)):
			raise ValueError(f"'do_rootpath' of incorrect type. Expected bool, got {type(do_rootpath_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if name_regexp_old is not None and not (isinstance(name_regexp_old, str)):
			raise ValueError(f"'name_regexp' of incorrect type. Expected str, got {type(name_regexp_old)}")
		if do_root_only_old is not None and not (isinstance(do_root_only_old, bool)):
			raise ValueError(f"'do_root_only' of incorrect type. Expected bool, got {type(do_root_only_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_mgr_assignable_old is not None and not (isinstance(is_mgr_assignable_old, bool)):
			raise ValueError(f"'is_mgr_assignable' of incorrect type. Expected bool, got {type(is_mgr_assignable_old)}")
		if short_name_regexp_old is not None and not (isinstance(short_name_regexp_old, str)):
			raise ValueError(f"'short_name_regexp' of incorrect type. Expected str, got {type(short_name_regexp_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'org.unit.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'type': type_old, 'do_subtree': do_subtree_old, 'short_name': short_name_old, 'tree_level': tree_level_old, 'do_rootpath': do_rootpath_old, 'fetch_limit': fetch_limit_old, 'name_regexp': name_regexp_old, 'do_root_only': do_root_only_old, 'fetch_offset': fetch_offset_old, 'is_mgr_assignable': is_mgr_assignable_old, 'short_name_regexp': short_name_regexp_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, type_old: str = None, do_subtree_old: bool = False, short_name_old: str = None, tree_level_old: int = None, do_rootpath_old: bool = False, fetch_limit_old: int = None, name_regexp_old: str = None, do_root_only_old: bool = False, fetch_offset_old: int = None, is_mgr_assignable_old: bool = None, short_name_regexp_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if do_subtree_old is not None and not (isinstance(do_subtree_old, bool)):
			raise ValueError(f"'do_subtree' of incorrect type. Expected bool, got {type(do_subtree_old)}")
		if short_name_old is not None and not (isinstance(short_name_old, str) or isinstance(short_name_old, ExplicitNull)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")
		if tree_level_old is not None and not (isinstance(tree_level_old, int)):
			raise ValueError(f"'tree_level' of incorrect type. Expected int, got {type(tree_level_old)}")
		if do_rootpath_old is not None and not (isinstance(do_rootpath_old, bool)):
			raise ValueError(f"'do_rootpath' of incorrect type. Expected bool, got {type(do_rootpath_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if name_regexp_old is not None and not (isinstance(name_regexp_old, str)):
			raise ValueError(f"'name_regexp' of incorrect type. Expected str, got {type(name_regexp_old)}")
		if do_root_only_old is not None and not (isinstance(do_root_only_old, bool)):
			raise ValueError(f"'do_root_only' of incorrect type. Expected bool, got {type(do_root_only_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_mgr_assignable_old is not None and not (isinstance(is_mgr_assignable_old, bool)):
			raise ValueError(f"'is_mgr_assignable' of incorrect type. Expected bool, got {type(is_mgr_assignable_old)}")
		if short_name_regexp_old is not None and not (isinstance(short_name_regexp_old, str)):
			raise ValueError(f"'short_name_regexp' of incorrect type. Expected str, got {type(short_name_regexp_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, type_old=type_old, do_subtree_old=do_subtree_old, short_name_old=short_name_old, tree_level_old=tree_level_old, do_rootpath_old=do_rootpath_old, fetch_limit_old=fetch_limit_old, name_regexp_old=name_regexp_old, do_root_only_old=do_root_only_old, fetch_offset_old=fetch_offset_old, is_mgr_assignable_old=is_mgr_assignable_old, short_name_regexp_old=short_name_regexp_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(short_name_old: str, name_new: str = None, type_new: str = None, short_name_new: str = None, sub_position_new: int = None, is_mgr_assignable_new: bool = None, parent_short_name_new: Union[str, ExplicitNull] = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if short_name_new is not None and not (isinstance(short_name_new, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_new)}")
		if sub_position_new is not None and not (isinstance(sub_position_new, int)):
			raise ValueError(f"'sub_position' of incorrect type. Expected int, got {type(sub_position_new)}")
		if is_mgr_assignable_new is not None and not (isinstance(is_mgr_assignable_new, bool)):
			raise ValueError(f"'is_mgr_assignable' of incorrect type. Expected bool, got {type(is_mgr_assignable_new)}")
		if parent_short_name_new is not None and not (isinstance(parent_short_name_new, str) or isinstance(parent_short_name_new, ExplicitNull)):
			raise ValueError(f"'parent_short_name' of incorrect type. Expected str, got {type(parent_short_name_new)}")
		if not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")

		return {'name': 'org.unit.update', 'new': _denullify_dict({'name': name_new, 'type': type_new, 'short_name': short_name_new, 'sub_position': sub_position_new, 'is_mgr_assignable': is_mgr_assignable_new, 'parent_short_name': parent_short_name_new}), 'old': _denullify_dict({'short_name': short_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, short_name_old: str, name_new: str = None, type_new: str = None, short_name_new: str = None, sub_position_new: int = None, is_mgr_assignable_new: bool = None, parent_short_name_new: Union[str, ExplicitNull] = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if short_name_new is not None and not (isinstance(short_name_new, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_new)}")
		if sub_position_new is not None and not (isinstance(sub_position_new, int)):
			raise ValueError(f"'sub_position' of incorrect type. Expected int, got {type(sub_position_new)}")
		if is_mgr_assignable_new is not None and not (isinstance(is_mgr_assignable_new, bool)):
			raise ValueError(f"'is_mgr_assignable' of incorrect type. Expected bool, got {type(is_mgr_assignable_new)}")
		if parent_short_name_new is not None and not (isinstance(parent_short_name_new, str) or isinstance(parent_short_name_new, ExplicitNull)):
			raise ValueError(f"'parent_short_name' of incorrect type. Expected str, got {type(parent_short_name_new)}")
		if not (isinstance(short_name_old, str)):
			raise ValueError(f"'short_name' of incorrect type. Expected str, got {type(short_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, type_new=type_new, short_name_new=short_name_new, sub_position_new=sub_position_new, is_mgr_assignable_new=is_mgr_assignable_new, parent_short_name_new=parent_short_name_new, short_name_old=short_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]
