### AUTOGENERATED
from . import _denullify_dict
from . import *
from dataclasses import dataclass
from typing import Union


@dataclass()
class Version(APIObject):
	major: int
	minor: int
	patch: int
	status: str
	doc_uri: str
	numeric: str
	semantic: str
	description: str
	last_status_change_date: str

	def __post_init__(self):
		if not isinstance(self.major, int):
			raise ValueError(f"'major' of incorrect type. Expected int, got {type(self.major)}")
		if not isinstance(self.minor, int):
			raise ValueError(f"'minor' of incorrect type. Expected int, got {type(self.minor)}")
		if not isinstance(self.patch, int):
			raise ValueError(f"'patch' of incorrect type. Expected int, got {type(self.patch)}")
		if not isinstance(self.status, str):
			raise ValueError(f"'status' of incorrect type. Expected str, got {type(self.status)}")
		if not isinstance(self.doc_uri, str):
			raise ValueError(f"'doc_uri' of incorrect type. Expected str, got {type(self.doc_uri)}")
		if not isinstance(self.numeric, str):
			raise ValueError(f"'numeric' of incorrect type. Expected str, got {type(self.numeric)}")
		if not isinstance(self.semantic, str):
			raise ValueError(f"'semantic' of incorrect type. Expected str, got {type(self.semantic)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.last_status_change_date, str):
			raise ValueError(f"'last_status_change_date' of incorrect type. Expected str, got {type(self.last_status_change_date)}")

@dataclass()
class TransactionStmt(APIObject):
	new: dict
	old: dict
	join: dict
	name: str
	new_ref: dict
	old_ref: dict

	def __post_init__(self):
		if not isinstance(self.new, dict):
			raise ValueError(f"'new' of incorrect type. Expected dict, got {type(self.new)}")
		if not isinstance(self.old, dict):
			raise ValueError(f"'old' of incorrect type. Expected dict, got {type(self.old)}")
		if not isinstance(self.join, dict):
			raise ValueError(f"'join' of incorrect type. Expected dict, got {type(self.join)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.new_ref, dict):
			raise ValueError(f"'new_ref' of incorrect type. Expected dict, got {type(self.new_ref)}")
		if not isinstance(self.old_ref, dict):
			raise ValueError(f"'old_ref' of incorrect type. Expected dict, got {type(self.old_ref)}")

@dataclass()
class System(APIObject):
	name: str
	description: str

	def __post_init__(self):
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")

	@staticmethod
	def list_ta(name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'wapi.system.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class ObjectType(APIObject):
	name: str
	system: str
	fq_name: str
	attributes: dict
	is_log_dst: bool
	is_log_src: bool
	constraints: dict
	referencing: dict
	is_otattr_dst: bool
	is_otattr_src: bool
	referenceable: dict
	description_title: str
	description_abbrev: str
	description_detail: str

	def __post_init__(self):
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.system, str):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(self.system)}")
		if not isinstance(self.fq_name, str):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(self.fq_name)}")
		if not isinstance(self.attributes, dict):
			raise ValueError(f"'attributes' of incorrect type. Expected dict, got {type(self.attributes)}")
		if not isinstance(self.is_log_dst, bool):
			raise ValueError(f"'is_log_dst' of incorrect type. Expected bool, got {type(self.is_log_dst)}")
		if not isinstance(self.is_log_src, bool):
			raise ValueError(f"'is_log_src' of incorrect type. Expected bool, got {type(self.is_log_src)}")
		if not isinstance(self.constraints, dict):
			raise ValueError(f"'constraints' of incorrect type. Expected dict, got {type(self.constraints)}")
		if not isinstance(self.referencing, dict):
			raise ValueError(f"'referencing' of incorrect type. Expected dict, got {type(self.referencing)}")
		if not isinstance(self.is_otattr_dst, bool):
			raise ValueError(f"'is_otattr_dst' of incorrect type. Expected bool, got {type(self.is_otattr_dst)}")
		if not isinstance(self.is_otattr_src, bool):
			raise ValueError(f"'is_otattr_src' of incorrect type. Expected bool, got {type(self.is_otattr_src)}")
		if not isinstance(self.referenceable, dict):
			raise ValueError(f"'referenceable' of incorrect type. Expected dict, got {type(self.referenceable)}")
		if self.description_title is not None and not isinstance(self.description_title, str):
			raise ValueError(f"'description_title' of incorrect type. Expected str, got {type(self.description_title)}")
		if self.description_abbrev is not None and not isinstance(self.description_abbrev, str):
			raise ValueError(f"'description_abbrev' of incorrect type. Expected str, got {type(self.description_abbrev)}")
		if self.description_detail is not None and not isinstance(self.description_detail, str):
			raise ValueError(f"'description_detail' of incorrect type. Expected str, got {type(self.description_detail)}")

	@staticmethod
	def list_ta(name_list_old: list = None, fetch_limit_old: int = None, system_list_old: list = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if system_list_old is not None and not (isinstance(system_list_old, list)):
			raise ValueError(f"'system_list' of incorrect type. Expected list, got {type(system_list_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'wapi.object_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'system_list': system_list_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, name_list_old: list = None, fetch_limit_old: int = None, system_list_old: list = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if system_list_old is not None and not (isinstance(system_list_old, list)):
			raise ValueError(f"'system_list' of incorrect type. Expected list, got {type(system_list_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, system_list_old=system_list_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Function(APIObject):
	name: str
	system: str
	fq_name: str
	parameters: dict
	object_type: str
	is_returning: bool
	is_executable: bool
	is_data_manipulating: bool
	is_returning_referenceable: bool

	def __post_init__(self):
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.system, str):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(self.system)}")
		if not isinstance(self.fq_name, str):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(self.fq_name)}")
		if not isinstance(self.parameters, dict):
			raise ValueError(f"'parameters' of incorrect type. Expected dict, got {type(self.parameters)}")
		if not isinstance(self.object_type, str):
			raise ValueError(f"'object_type' of incorrect type. Expected str, got {type(self.object_type)}")
		if not isinstance(self.is_returning, bool):
			raise ValueError(f"'is_returning' of incorrect type. Expected bool, got {type(self.is_returning)}")
		if not isinstance(self.is_executable, bool):
			raise ValueError(f"'is_executable' of incorrect type. Expected bool, got {type(self.is_executable)}")
		if not isinstance(self.is_data_manipulating, bool):
			raise ValueError(f"'is_data_manipulating' of incorrect type. Expected bool, got {type(self.is_data_manipulating)}")
		if not isinstance(self.is_returning_referenceable, bool):
			raise ValueError(f"'is_returning_referenceable' of incorrect type. Expected bool, got {type(self.is_returning_referenceable)}")

	@staticmethod
	def list_ta(name_list_old: list = None, fetch_limit_old: int = None, system_list_old: list = None, fetch_offset_old: int = None, is_returning_old: bool = None, is_executable_old: bool = None, object_type_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, is_data_manipulating_old: bool = None, is_returning_referenceable_old: bool = None) -> dict:
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if system_list_old is not None and not (isinstance(system_list_old, list)):
			raise ValueError(f"'system_list' of incorrect type. Expected list, got {type(system_list_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_returning_old is not None and not (isinstance(is_returning_old, bool)):
			raise ValueError(f"'is_returning' of incorrect type. Expected bool, got {type(is_returning_old)}")
		if is_executable_old is not None and not (isinstance(is_executable_old, bool)):
			raise ValueError(f"'is_executable' of incorrect type. Expected bool, got {type(is_executable_old)}")
		if object_type_list_old is not None and not (isinstance(object_type_list_old, list)):
			raise ValueError(f"'object_type_list' of incorrect type. Expected list, got {type(object_type_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if is_data_manipulating_old is not None and not (isinstance(is_data_manipulating_old, bool)):
			raise ValueError(f"'is_data_manipulating' of incorrect type. Expected bool, got {type(is_data_manipulating_old)}")
		if is_returning_referenceable_old is not None and not (isinstance(is_returning_referenceable_old, bool)):
			raise ValueError(f"'is_returning_referenceable' of incorrect type. Expected bool, got {type(is_returning_referenceable_old)}")

		return {'name': 'wapi.function.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'system_list': system_list_old, 'fetch_offset': fetch_offset_old, 'is_returning': is_returning_old, 'is_executable': is_executable_old, 'object_type_list': object_type_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'is_data_manipulating': is_data_manipulating_old, 'is_returning_referenceable': is_returning_referenceable_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, name_list_old: list = None, fetch_limit_old: int = None, system_list_old: list = None, fetch_offset_old: int = None, is_returning_old: bool = None, is_executable_old: bool = None, object_type_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, is_data_manipulating_old: bool = None, is_returning_referenceable_old: bool = None) -> list:
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if system_list_old is not None and not (isinstance(system_list_old, list)):
			raise ValueError(f"'system_list' of incorrect type. Expected list, got {type(system_list_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_returning_old is not None and not (isinstance(is_returning_old, bool)):
			raise ValueError(f"'is_returning' of incorrect type. Expected bool, got {type(is_returning_old)}")
		if is_executable_old is not None and not (isinstance(is_executable_old, bool)):
			raise ValueError(f"'is_executable' of incorrect type. Expected bool, got {type(is_executable_old)}")
		if object_type_list_old is not None and not (isinstance(object_type_list_old, list)):
			raise ValueError(f"'object_type_list' of incorrect type. Expected list, got {type(object_type_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if is_data_manipulating_old is not None and not (isinstance(is_data_manipulating_old, bool)):
			raise ValueError(f"'is_data_manipulating' of incorrect type. Expected bool, got {type(is_data_manipulating_old)}")
		if is_returning_referenceable_old is not None and not (isinstance(is_returning_referenceable_old, bool)):
			raise ValueError(f"'is_returning_referenceable' of incorrect type. Expected bool, got {type(is_returning_referenceable_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, system_list_old=system_list_old, fetch_offset_old=fetch_offset_old, is_returning_old=is_returning_old, is_executable_old=is_executable_old, object_type_list_old=object_type_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, is_data_manipulating_old=is_data_manipulating_old, is_returning_referenceable_old=is_returning_referenceable_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Exception(APIObject):
	error: dict
	others: dict
	traceback: list
	constraint: dict
	error_type: dict
	stacked_diag_params: dict

	def __post_init__(self):
		if not isinstance(self.error, dict):
			raise ValueError(f"'error' of incorrect type. Expected dict, got {type(self.error)}")
		if not isinstance(self.others, dict):
			raise ValueError(f"'others' of incorrect type. Expected dict, got {type(self.others)}")
		if not isinstance(self.traceback, list):
			raise ValueError(f"'traceback' of incorrect type. Expected list, got {type(self.traceback)}")
		if not isinstance(self.constraint, dict):
			raise ValueError(f"'constraint' of incorrect type. Expected dict, got {type(self.constraint)}")
		if not isinstance(self.error_type, dict):
			raise ValueError(f"'error_type' of incorrect type. Expected dict, got {type(self.error_type)}")
		if not isinstance(self.stacked_diag_params, dict):
			raise ValueError(f"'stacked_diag_params' of incorrect type. Expected dict, got {type(self.stacked_diag_params)}")

@dataclass()
class DataType(APIObject):
	name: str
	json_name: str
	description: str
	text_length: int
	operator_list: list
	format_literal: str

	def __post_init__(self):
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.json_name, str):
			raise ValueError(f"'json_name' of incorrect type. Expected str, got {type(self.json_name)}")
		if not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if self.text_length is not None and not isinstance(self.text_length, int):
			raise ValueError(f"'text_length' of incorrect type. Expected int, got {type(self.text_length)}")
		if not isinstance(self.operator_list, list):
			raise ValueError(f"'operator_list' of incorrect type. Expected list, got {type(self.operator_list)}")
		if self.format_literal is not None and not isinstance(self.format_literal, str):
			raise ValueError(f"'format_literal' of incorrect type. Expected str, got {type(self.format_literal)}")

	@staticmethod
	def list_ta(json_name_old: str = None, fetch_limit_old: int = None, text_length_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if json_name_old is not None and not (isinstance(json_name_old, str)):
			raise ValueError(f"'json_name' of incorrect type. Expected str, got {type(json_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if text_length_old is not None and not (isinstance(text_length_old, int) or isinstance(text_length_old, ExplicitNull)):
			raise ValueError(f"'text_length' of incorrect type. Expected int, got {type(text_length_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'wapi.data_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'json_name': json_name_old, 'fetch_limit': fetch_limit_old, 'text_length': text_length_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, json_name_old: str = None, fetch_limit_old: int = None, text_length_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if json_name_old is not None and not (isinstance(json_name_old, str)):
			raise ValueError(f"'json_name' of incorrect type. Expected str, got {type(json_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if text_length_old is not None and not (isinstance(text_length_old, int) or isinstance(text_length_old, ExplicitNull)):
			raise ValueError(f"'text_length' of incorrect type. Expected int, got {type(text_length_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(json_name_old=json_name_old, fetch_limit_old=fetch_limit_old, text_length_old=text_length_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class DataTypeOperator(APIObject):
	name: str
	data_type_list: list

	def __post_init__(self):
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.data_type_list, list):
			raise ValueError(f"'data_type_list' of incorrect type. Expected list, got {type(self.data_type_list)}")

	@staticmethod
	def list_ta(name_old: str = None, data_type_old: str = None) -> dict:
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if data_type_old is not None and not (isinstance(data_type_old, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_old)}")

		return {'name': 'wapi.data_type_operator.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old, 'data_type': data_type_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, name_old: str = None, data_type_old: str = None) -> list:
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if data_type_old is not None and not (isinstance(data_type_old, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(name_old=name_old, data_type_old=data_type_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]
