### AUTOGENERATED
from . import _denullify_dict
from . import *
from dataclasses import dataclass
from typing import Union


@dataclass()
class Version(APIObject):
	gpk: str
	major: int
	minor: int
	patch: int
	doc_uri: str
	numeric: str
	semantic: str
	language_dict: dict
	operation_mode: str
	last_status_change_date: str
	transaction_json_schema: dict

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.major, int):
			raise ValueError(f"'major' of incorrect type. Expected int, got {type(self.major)}")
		if not isinstance(self.minor, int):
			raise ValueError(f"'minor' of incorrect type. Expected int, got {type(self.minor)}")
		if not isinstance(self.patch, int):
			raise ValueError(f"'patch' of incorrect type. Expected int, got {type(self.patch)}")
		if not isinstance(self.doc_uri, str):
			raise ValueError(f"'doc_uri' of incorrect type. Expected str, got {type(self.doc_uri)}")
		if not isinstance(self.numeric, str):
			raise ValueError(f"'numeric' of incorrect type. Expected str, got {type(self.numeric)}")
		if not isinstance(self.semantic, str):
			raise ValueError(f"'semantic' of incorrect type. Expected str, got {type(self.semantic)}")
		if not isinstance(self.language_dict, dict):
			raise ValueError(f"'language_dict' of incorrect type. Expected dict, got {type(self.language_dict)}")
		if not isinstance(self.operation_mode, str):
			raise ValueError(f"'operation_mode' of incorrect type. Expected str, got {type(self.operation_mode)}")
		if not isinstance(self.last_status_change_date, str):
			raise ValueError(f"'last_status_change_date' of incorrect type. Expected str, got {type(self.last_status_change_date)}")
		if not isinstance(self.transaction_json_schema, dict):
			raise ValueError(f"'transaction_json_schema' of incorrect type. Expected dict, got {type(self.transaction_json_schema)}")

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, major_list_old: list = None, minor_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if major_list_old is not None and not (isinstance(major_list_old, list)):
			raise ValueError(f"'major_list' of incorrect type. Expected list, got {type(major_list_old)}")
		if minor_list_old is not None and not (isinstance(minor_list_old, list)):
			raise ValueError(f"'minor_list' of incorrect type. Expected list, got {type(minor_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'wapi.version.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'major_list': major_list_old, 'minor_list': minor_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, major_list_old: list = None, minor_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if major_list_old is not None and not (isinstance(major_list_old, list)):
			raise ValueError(f"'major_list' of incorrect type. Expected list, got {type(major_list_old)}")
		if minor_list_old is not None and not (isinstance(minor_list_old, list)):
			raise ValueError(f"'minor_list' of incorrect type. Expected list, got {type(minor_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, major_list_old=major_list_old, minor_list_old=minor_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class VersionState(APIObject):
	gpk: str
	numeric: int
	semantic: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.numeric, int):
			raise ValueError(f"'numeric' of incorrect type. Expected int, got {type(self.numeric)}")
		if not isinstance(self.semantic, str):
			raise ValueError(f"'semantic' of incorrect type. Expected str, got {type(self.semantic)}")

	@staticmethod
	def list_ta(gpk_old: str = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, semantic_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if semantic_list_old is not None and not (isinstance(semantic_list_old, list)):
			raise ValueError(f"'semantic_list' of incorrect type. Expected list, got {type(semantic_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'wapi.version_state.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'gpk_list': gpk_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'semantic_list': semantic_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, gpk_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, semantic_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if gpk_list_old is not None and not (isinstance(gpk_list_old, list)):
			raise ValueError(f"'gpk_list' of incorrect type. Expected list, got {type(gpk_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if semantic_list_old is not None and not (isinstance(semantic_list_old, list)):
			raise ValueError(f"'semantic_list' of incorrect type. Expected list, got {type(semantic_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, gpk_list_old=gpk_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, semantic_list_old=semantic_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class System(APIObject):
	name: str
	language_dict: dict

	def __post_init__(self):
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.language_dict, dict):
			raise ValueError(f"'language_dict' of incorrect type. Expected dict, got {type(self.language_dict)}")

	@staticmethod
	def list_ta(name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'wapi.system.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, name_list_old: list = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class ObjectType(APIObject):
	name: str
	system: str
	fq_name: str
	attributes: dict
	is_log_dst: bool
	is_log_src: bool
	constraints: dict
	is_lang_dst: bool
	is_lang_src: bool
	referencing: dict
	is_otattr_dst: bool
	is_otattr_src: bool
	referenceable: dict
	do_activate_global_pk2obj: bool
	object_type_grants_read_access: bool

	def __post_init__(self):
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.system, str):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(self.system)}")
		if not isinstance(self.fq_name, str):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(self.fq_name)}")
		if not isinstance(self.attributes, dict):
			raise ValueError(f"'attributes' of incorrect type. Expected dict, got {type(self.attributes)}")
		if not isinstance(self.is_log_dst, bool):
			raise ValueError(f"'is_log_dst' of incorrect type. Expected bool, got {type(self.is_log_dst)}")
		if not isinstance(self.is_log_src, bool):
			raise ValueError(f"'is_log_src' of incorrect type. Expected bool, got {type(self.is_log_src)}")
		if not isinstance(self.constraints, dict):
			raise ValueError(f"'constraints' of incorrect type. Expected dict, got {type(self.constraints)}")
		if not isinstance(self.is_lang_dst, bool):
			raise ValueError(f"'is_lang_dst' of incorrect type. Expected bool, got {type(self.is_lang_dst)}")
		if not isinstance(self.is_lang_src, bool):
			raise ValueError(f"'is_lang_src' of incorrect type. Expected bool, got {type(self.is_lang_src)}")
		if not isinstance(self.referencing, dict):
			raise ValueError(f"'referencing' of incorrect type. Expected dict, got {type(self.referencing)}")
		if not isinstance(self.is_otattr_dst, bool):
			raise ValueError(f"'is_otattr_dst' of incorrect type. Expected bool, got {type(self.is_otattr_dst)}")
		if not isinstance(self.is_otattr_src, bool):
			raise ValueError(f"'is_otattr_src' of incorrect type. Expected bool, got {type(self.is_otattr_src)}")
		if not isinstance(self.referenceable, dict):
			raise ValueError(f"'referenceable' of incorrect type. Expected dict, got {type(self.referenceable)}")
		if not isinstance(self.do_activate_global_pk2obj, bool):
			raise ValueError(f"'do_activate_global_pk2obj' of incorrect type. Expected bool, got {type(self.do_activate_global_pk2obj)}")
		if not isinstance(self.object_type_grants_read_access, bool):
			raise ValueError(f"'object_type_grants_read_access' of incorrect type. Expected bool, got {type(self.object_type_grants_read_access)}")

	@staticmethod
	def list_ta(name_list_old: list = None, fetch_limit_old: int = None, system_list_old: list = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if system_list_old is not None and not (isinstance(system_list_old, list)):
			raise ValueError(f"'system_list' of incorrect type. Expected list, got {type(system_list_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'wapi.object_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'system_list': system_list_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, name_list_old: list = None, fetch_limit_old: int = None, system_list_old: list = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if system_list_old is not None and not (isinstance(system_list_old, list)):
			raise ValueError(f"'system_list' of incorrect type. Expected list, got {type(system_list_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, system_list_old=system_list_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Function(APIObject):
	name: str
	system: str
	fq_name: str
	parameters: dict
	object_type: str
	is_returning: bool
	is_executable: bool
	is_data_manipulating: bool

	def __post_init__(self):
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.system, str):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(self.system)}")
		if not isinstance(self.fq_name, str):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(self.fq_name)}")
		if not isinstance(self.parameters, dict):
			raise ValueError(f"'parameters' of incorrect type. Expected dict, got {type(self.parameters)}")
		if not isinstance(self.object_type, str):
			raise ValueError(f"'object_type' of incorrect type. Expected str, got {type(self.object_type)}")
		if not isinstance(self.is_returning, bool):
			raise ValueError(f"'is_returning' of incorrect type. Expected bool, got {type(self.is_returning)}")
		if not isinstance(self.is_executable, bool):
			raise ValueError(f"'is_executable' of incorrect type. Expected bool, got {type(self.is_executable)}")
		if not isinstance(self.is_data_manipulating, bool):
			raise ValueError(f"'is_data_manipulating' of incorrect type. Expected bool, got {type(self.is_data_manipulating)}")

	@staticmethod
	def list_ta(name_list_old: list = None, fetch_limit_old: int = None, system_list_old: list = None, fetch_offset_old: int = None, is_returning_old: bool = None, is_executable_old: bool = None, parameter_list_old: list = None, object_type_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, is_data_manipulating_old: bool = None, parameter_is_deprecated_old: bool = None) -> dict:
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if system_list_old is not None and not (isinstance(system_list_old, list)):
			raise ValueError(f"'system_list' of incorrect type. Expected list, got {type(system_list_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_returning_old is not None and not (isinstance(is_returning_old, bool)):
			raise ValueError(f"'is_returning' of incorrect type. Expected bool, got {type(is_returning_old)}")
		if is_executable_old is not None and not (isinstance(is_executable_old, bool)):
			raise ValueError(f"'is_executable' of incorrect type. Expected bool, got {type(is_executable_old)}")
		if parameter_list_old is not None and not (isinstance(parameter_list_old, list)):
			raise ValueError(f"'parameter_list' of incorrect type. Expected list, got {type(parameter_list_old)}")
		if object_type_list_old is not None and not (isinstance(object_type_list_old, list)):
			raise ValueError(f"'object_type_list' of incorrect type. Expected list, got {type(object_type_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if is_data_manipulating_old is not None and not (isinstance(is_data_manipulating_old, bool)):
			raise ValueError(f"'is_data_manipulating' of incorrect type. Expected bool, got {type(is_data_manipulating_old)}")
		if parameter_is_deprecated_old is not None and not (isinstance(parameter_is_deprecated_old, bool)):
			raise ValueError(f"'parameter_is_deprecated' of incorrect type. Expected bool, got {type(parameter_is_deprecated_old)}")

		return {'name': 'wapi.function.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'system_list': system_list_old, 'fetch_offset': fetch_offset_old, 'is_returning': is_returning_old, 'is_executable': is_executable_old, 'parameter_list': parameter_list_old, 'object_type_list': object_type_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'is_data_manipulating': is_data_manipulating_old, 'parameter_is_deprecated': parameter_is_deprecated_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, name_list_old: list = None, fetch_limit_old: int = None, system_list_old: list = None, fetch_offset_old: int = None, is_returning_old: bool = None, is_executable_old: bool = None, parameter_list_old: list = None, object_type_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, is_data_manipulating_old: bool = None, parameter_is_deprecated_old: bool = None) -> list:
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if system_list_old is not None and not (isinstance(system_list_old, list)):
			raise ValueError(f"'system_list' of incorrect type. Expected list, got {type(system_list_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_returning_old is not None and not (isinstance(is_returning_old, bool)):
			raise ValueError(f"'is_returning' of incorrect type. Expected bool, got {type(is_returning_old)}")
		if is_executable_old is not None and not (isinstance(is_executable_old, bool)):
			raise ValueError(f"'is_executable' of incorrect type. Expected bool, got {type(is_executable_old)}")
		if parameter_list_old is not None and not (isinstance(parameter_list_old, list)):
			raise ValueError(f"'parameter_list' of incorrect type. Expected list, got {type(parameter_list_old)}")
		if object_type_list_old is not None and not (isinstance(object_type_list_old, list)):
			raise ValueError(f"'object_type_list' of incorrect type. Expected list, got {type(object_type_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if is_data_manipulating_old is not None and not (isinstance(is_data_manipulating_old, bool)):
			raise ValueError(f"'is_data_manipulating' of incorrect type. Expected bool, got {type(is_data_manipulating_old)}")
		if parameter_is_deprecated_old is not None and not (isinstance(parameter_is_deprecated_old, bool)):
			raise ValueError(f"'parameter_is_deprecated' of incorrect type. Expected bool, got {type(parameter_is_deprecated_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, system_list_old=system_list_old, fetch_offset_old=fetch_offset_old, is_returning_old=is_returning_old, is_executable_old=is_executable_old, parameter_list_old=parameter_list_old, object_type_list_old=object_type_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, is_data_manipulating_old=is_data_manipulating_old, parameter_is_deprecated_old=parameter_is_deprecated_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Exception(APIObject):
	hint: str
	error: dict
	others: dict
	traceback: list
	constraint: dict
	error_type: dict
	stacked_diag_params: dict

	def __post_init__(self):
		if self.hint is not None and not isinstance(self.hint, str):
			raise ValueError(f"'hint' of incorrect type. Expected str, got {type(self.hint)}")
		if not isinstance(self.error, dict):
			raise ValueError(f"'error' of incorrect type. Expected dict, got {type(self.error)}")
		if not isinstance(self.others, dict):
			raise ValueError(f"'others' of incorrect type. Expected dict, got {type(self.others)}")
		if not isinstance(self.traceback, list):
			raise ValueError(f"'traceback' of incorrect type. Expected list, got {type(self.traceback)}")
		if not isinstance(self.constraint, dict):
			raise ValueError(f"'constraint' of incorrect type. Expected dict, got {type(self.constraint)}")
		if not isinstance(self.error_type, dict):
			raise ValueError(f"'error_type' of incorrect type. Expected dict, got {type(self.error_type)}")
		if not isinstance(self.stacked_diag_params, dict):
			raise ValueError(f"'stacked_diag_params' of incorrect type. Expected dict, got {type(self.stacked_diag_params)}")

@dataclass()
class DataType(APIObject):
	name: str
	json_name: str
	text_length: int
	language_dict: dict
	operator_list: list
	format_literal: str

	def __post_init__(self):
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.json_name, str):
			raise ValueError(f"'json_name' of incorrect type. Expected str, got {type(self.json_name)}")
		if self.text_length is not None and not isinstance(self.text_length, int):
			raise ValueError(f"'text_length' of incorrect type. Expected int, got {type(self.text_length)}")
		if not isinstance(self.language_dict, dict):
			raise ValueError(f"'language_dict' of incorrect type. Expected dict, got {type(self.language_dict)}")
		if not isinstance(self.operator_list, list):
			raise ValueError(f"'operator_list' of incorrect type. Expected list, got {type(self.operator_list)}")
		if self.format_literal is not None and not isinstance(self.format_literal, str):
			raise ValueError(f"'format_literal' of incorrect type. Expected str, got {type(self.format_literal)}")

	@staticmethod
	def list_ta(json_name_old: str = None, fetch_limit_old: int = None, text_length_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if json_name_old is not None and not (isinstance(json_name_old, str)):
			raise ValueError(f"'json_name' of incorrect type. Expected str, got {type(json_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if text_length_old is not None and not (isinstance(text_length_old, int) or isinstance(text_length_old, ExplicitNull)):
			raise ValueError(f"'text_length' of incorrect type. Expected int, got {type(text_length_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'wapi.data_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'json_name': json_name_old, 'fetch_limit': fetch_limit_old, 'text_length': text_length_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, json_name_old: str = None, fetch_limit_old: int = None, text_length_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if json_name_old is not None and not (isinstance(json_name_old, str)):
			raise ValueError(f"'json_name' of incorrect type. Expected str, got {type(json_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if text_length_old is not None and not (isinstance(text_length_old, int) or isinstance(text_length_old, ExplicitNull)):
			raise ValueError(f"'text_length' of incorrect type. Expected int, got {type(text_length_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(json_name_old=json_name_old, fetch_limit_old=fetch_limit_old, text_length_old=text_length_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class DataTypeOperator(APIObject):
	name: str
	language_dict: dict
	data_type_list: list

	def __post_init__(self):
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.language_dict, dict):
			raise ValueError(f"'language_dict' of incorrect type. Expected dict, got {type(self.language_dict)}")
		if not isinstance(self.data_type_list, list):
			raise ValueError(f"'data_type_list' of incorrect type. Expected list, got {type(self.data_type_list)}")

	@staticmethod
	def list_ta(name_old: str = None, data_type_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if data_type_old is not None and not (isinstance(data_type_old, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'wapi.data_type_operator.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old, 'data_type': data_type_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, name_old: str = None, data_type_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if data_type_old is not None and not (isinstance(data_type_old, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(name_old=name_old, data_type_old=data_type_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class MaintState(APIObject):
	pk: int
	ts_end: str
	subject: str
	duration: str
	ts_begin: str
	is_active: bool
	language_dict: dict
	cntl_error_code: int
	cntl_error_type_code: int
	cntl_error_type_name: str

	def __post_init__(self):
		if not isinstance(self.pk, int):
			raise ValueError(f"'pk' of incorrect type. Expected int, got {type(self.pk)}")
		if not isinstance(self.ts_end, str):
			raise ValueError(f"'ts_end' of incorrect type. Expected str, got {type(self.ts_end)}")
		if not isinstance(self.subject, str):
			raise ValueError(f"'subject' of incorrect type. Expected str, got {type(self.subject)}")
		if not isinstance(self.duration, str):
			raise ValueError(f"'duration' of incorrect type. Expected str, got {type(self.duration)}")
		if not isinstance(self.ts_begin, str):
			raise ValueError(f"'ts_begin' of incorrect type. Expected str, got {type(self.ts_begin)}")
		if not isinstance(self.is_active, bool):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(self.is_active)}")
		if not isinstance(self.language_dict, dict):
			raise ValueError(f"'language_dict' of incorrect type. Expected dict, got {type(self.language_dict)}")
		if not isinstance(self.cntl_error_code, int):
			raise ValueError(f"'cntl_error_code' of incorrect type. Expected int, got {type(self.cntl_error_code)}")
		if not isinstance(self.cntl_error_type_code, int):
			raise ValueError(f"'cntl_error_type_code' of incorrect type. Expected int, got {type(self.cntl_error_type_code)}")
		if not isinstance(self.cntl_error_type_name, str):
			raise ValueError(f"'cntl_error_type_name' of incorrect type. Expected str, got {type(self.cntl_error_type_name)}")

	@staticmethod
	def list_ta(is_active_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if is_active_old is not None and not (isinstance(is_active_old, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'wapi.maint_state.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'is_active': is_active_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, is_active_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if is_active_old is not None and not (isinstance(is_active_old, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(is_active_old=is_active_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Language(APIObject):
	tag: str
	name: str
	is_default: bool

	def __post_init__(self):
		if not isinstance(self.tag, str):
			raise ValueError(f"'tag' of incorrect type. Expected str, got {type(self.tag)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.is_default, bool):
			raise ValueError(f"'is_default' of incorrect type. Expected bool, got {type(self.is_default)}")

	@staticmethod
	def list_ta(fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'wapi.language.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class ObjectTypeLangDict(APIObject):
	fq_name: str
	language_dict: dict

	def __post_init__(self):
		if not isinstance(self.fq_name, str):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(self.fq_name)}")
		if not isinstance(self.language_dict, dict):
			raise ValueError(f"'language_dict' of incorrect type. Expected dict, got {type(self.language_dict)}")

	@staticmethod
	def list_ta(name_list_old: list = None, fetch_limit_old: int = None, system_list_old: list = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if system_list_old is not None and not (isinstance(system_list_old, list)):
			raise ValueError(f"'system_list' of incorrect type. Expected list, got {type(system_list_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'wapi.object_type_lang_dict.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'name_list': name_list_old, 'fetch_limit': fetch_limit_old, 'system_list': system_list_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, name_list_old: list = None, fetch_limit_old: int = None, system_list_old: list = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if system_list_old is not None and not (isinstance(system_list_old, list)):
			raise ValueError(f"'system_list' of incorrect type. Expected list, got {type(system_list_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(name_list_old=name_list_old, fetch_limit_old=fetch_limit_old, system_list_old=system_list_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class ObjectTypeAttrLangDict(APIObject):
	fq_name: str
	language_dict: dict

	def __post_init__(self):
		if not isinstance(self.fq_name, str):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(self.fq_name)}")
		if not isinstance(self.language_dict, dict):
			raise ValueError(f"'language_dict' of incorrect type. Expected dict, got {type(self.language_dict)}")

	@staticmethod
	def list_ta(fetch_limit_old: int = None, system_list_old: list = None, fetch_offset_old: int = None, object_type_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if system_list_old is not None and not (isinstance(system_list_old, list)):
			raise ValueError(f"'system_list' of incorrect type. Expected list, got {type(system_list_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if object_type_list_old is not None and not (isinstance(object_type_list_old, list)):
			raise ValueError(f"'object_type_list' of incorrect type. Expected list, got {type(object_type_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'wapi.object_type_attr_lang_dict.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'fetch_limit': fetch_limit_old, 'system_list': system_list_old, 'fetch_offset': fetch_offset_old, 'object_type_list': object_type_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, fetch_limit_old: int = None, system_list_old: list = None, fetch_offset_old: int = None, object_type_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if system_list_old is not None and not (isinstance(system_list_old, list)):
			raise ValueError(f"'system_list' of incorrect type. Expected list, got {type(system_list_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if object_type_list_old is not None and not (isinstance(object_type_list_old, list)):
			raise ValueError(f"'object_type_list' of incorrect type. Expected list, got {type(object_type_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(fetch_limit_old=fetch_limit_old, system_list_old=system_list_old, fetch_offset_old=fetch_offset_old, object_type_list_old=object_type_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]
