### AUTOGENERATED
from . import _denullify_dict
from . import *
from dataclasses import dataclass
from typing import Union


@dataclass()
class System(APIObject):
	gpk: str
	name: str
	description: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")

	@staticmethod
	def create_ta(name_new: str, description_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		return {'name': 'cntl.system.create', 'new': _denullify_dict({'name': name_new, 'description': description_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, description_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, description_new=description_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'cntl.system.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.system.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, description_new: Union[str, ExplicitNull] = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'cntl.system.update', 'new': _denullify_dict({'name': name_new, 'description': description_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, description_new: Union[str, ExplicitNull] = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, description_new=description_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Mgr(APIObject):
	gpk: str
	email: str
	is_own: bool
	last_name: str
	first_name: str
	kit_status: int
	login_name: str
	description: str
	is_adm_locked: bool
	is_sub_account: bool
	parent_login_name: str
	enable_delete_date: str
	kit_status_description: str
	allow_data_manipulation: bool
	kit_org_unit_short_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if self.email is not None and not isinstance(self.email, str):
			raise ValueError(f"'email' of incorrect type. Expected str, got {type(self.email)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if self.last_name is not None and not isinstance(self.last_name, str):
			raise ValueError(f"'last_name' of incorrect type. Expected str, got {type(self.last_name)}")
		if self.first_name is not None and not isinstance(self.first_name, str):
			raise ValueError(f"'first_name' of incorrect type. Expected str, got {type(self.first_name)}")
		if not isinstance(self.kit_status, int):
			raise ValueError(f"'kit_status' of incorrect type. Expected int, got {type(self.kit_status)}")
		if not isinstance(self.login_name, str):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(self.login_name)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.is_adm_locked, bool):
			raise ValueError(f"'is_adm_locked' of incorrect type. Expected bool, got {type(self.is_adm_locked)}")
		if not isinstance(self.is_sub_account, bool):
			raise ValueError(f"'is_sub_account' of incorrect type. Expected bool, got {type(self.is_sub_account)}")
		if not isinstance(self.parent_login_name, str):
			raise ValueError(f"'parent_login_name' of incorrect type. Expected str, got {type(self.parent_login_name)}")
		if self.enable_delete_date is not None and not isinstance(self.enable_delete_date, str):
			raise ValueError(f"'enable_delete_date' of incorrect type. Expected str, got {type(self.enable_delete_date)}")
		if not isinstance(self.kit_status_description, str):
			raise ValueError(f"'kit_status_description' of incorrect type. Expected str, got {type(self.kit_status_description)}")
		if not isinstance(self.allow_data_manipulation, bool):
			raise ValueError(f"'allow_data_manipulation' of incorrect type. Expected bool, got {type(self.allow_data_manipulation)}")
		if self.kit_org_unit_short_name is not None and not isinstance(self.kit_org_unit_short_name, str):
			raise ValueError(f"'kit_org_unit_short_name' of incorrect type. Expected str, got {type(self.kit_org_unit_short_name)}")

	@staticmethod
	def create_ta(login_name_new: str = None, description_new: Union[str, ExplicitNull] = None, do_copy_roles_new: bool = True, allow_data_manipulation_new: bool = True) -> dict:
		if login_name_new is not None and not (isinstance(login_name_new, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if do_copy_roles_new is not None and not (isinstance(do_copy_roles_new, bool)):
			raise ValueError(f"'do_copy_roles' of incorrect type. Expected bool, got {type(do_copy_roles_new)}")
		if allow_data_manipulation_new is not None and not (isinstance(allow_data_manipulation_new, bool)):
			raise ValueError(f"'allow_data_manipulation' of incorrect type. Expected bool, got {type(allow_data_manipulation_new)}")

		return {'name': 'cntl.mgr.create', 'new': _denullify_dict({'login_name': login_name_new, 'description': description_new, 'do_copy_roles': do_copy_roles_new, 'allow_data_manipulation': allow_data_manipulation_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, login_name_new: str = None, description_new: Union[str, ExplicitNull] = None, do_copy_roles_new: bool = True, allow_data_manipulation_new: bool = True) -> list:
		if login_name_new is not None and not (isinstance(login_name_new, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if do_copy_roles_new is not None and not (isinstance(do_copy_roles_new, bool)):
			raise ValueError(f"'do_copy_roles' of incorrect type. Expected bool, got {type(do_copy_roles_new)}")
		if allow_data_manipulation_new is not None and not (isinstance(allow_data_manipulation_new, bool)):
			raise ValueError(f"'allow_data_manipulation' of incorrect type. Expected bool, got {type(allow_data_manipulation_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(login_name_new=login_name_new, description_new=description_new, do_copy_roles_new=do_copy_roles_new, allow_data_manipulation_new=allow_data_manipulation_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(login_name_old: str) -> dict:
		if not (isinstance(login_name_old, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_old)}")

		return {'name': 'cntl.mgr.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'login_name': login_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, login_name_old: str) -> list:
		if not (isinstance(login_name_old, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(login_name_old=login_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, is_own_old: bool = None, kit_status_old: int = None, login_name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_adm_locked_old: bool = None, is_sub_account_old: bool = None, login_name_list_old: list = None, login_name_regexp_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, allow_data_manipulation_old: bool = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if kit_status_old is not None and not (isinstance(kit_status_old, int)):
			raise ValueError(f"'kit_status' of incorrect type. Expected int, got {type(kit_status_old)}")
		if login_name_old is not None and not (isinstance(login_name_old, str) or isinstance(login_name_old, ExplicitNull)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_adm_locked_old is not None and not (isinstance(is_adm_locked_old, bool)):
			raise ValueError(f"'is_adm_locked' of incorrect type. Expected bool, got {type(is_adm_locked_old)}")
		if is_sub_account_old is not None and not (isinstance(is_sub_account_old, bool)):
			raise ValueError(f"'is_sub_account' of incorrect type. Expected bool, got {type(is_sub_account_old)}")
		if login_name_list_old is not None and not (isinstance(login_name_list_old, list)):
			raise ValueError(f"'login_name_list' of incorrect type. Expected list, got {type(login_name_list_old)}")
		if login_name_regexp_old is not None and not (isinstance(login_name_regexp_old, str)):
			raise ValueError(f"'login_name_regexp' of incorrect type. Expected str, got {type(login_name_regexp_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if allow_data_manipulation_old is not None and not (isinstance(allow_data_manipulation_old, bool)):
			raise ValueError(f"'allow_data_manipulation' of incorrect type. Expected bool, got {type(allow_data_manipulation_old)}")

		return {'name': 'cntl.mgr.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_own': is_own_old, 'kit_status': kit_status_old, 'login_name': login_name_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'is_adm_locked': is_adm_locked_old, 'is_sub_account': is_sub_account_old, 'login_name_list': login_name_list_old, 'login_name_regexp': login_name_regexp_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'allow_data_manipulation': allow_data_manipulation_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_own_old: bool = None, kit_status_old: int = None, login_name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_adm_locked_old: bool = None, is_sub_account_old: bool = None, login_name_list_old: list = None, login_name_regexp_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, allow_data_manipulation_old: bool = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if kit_status_old is not None and not (isinstance(kit_status_old, int)):
			raise ValueError(f"'kit_status' of incorrect type. Expected int, got {type(kit_status_old)}")
		if login_name_old is not None and not (isinstance(login_name_old, str) or isinstance(login_name_old, ExplicitNull)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_adm_locked_old is not None and not (isinstance(is_adm_locked_old, bool)):
			raise ValueError(f"'is_adm_locked' of incorrect type. Expected bool, got {type(is_adm_locked_old)}")
		if is_sub_account_old is not None and not (isinstance(is_sub_account_old, bool)):
			raise ValueError(f"'is_sub_account' of incorrect type. Expected bool, got {type(is_sub_account_old)}")
		if login_name_list_old is not None and not (isinstance(login_name_list_old, list)):
			raise ValueError(f"'login_name_list' of incorrect type. Expected list, got {type(login_name_list_old)}")
		if login_name_regexp_old is not None and not (isinstance(login_name_regexp_old, str)):
			raise ValueError(f"'login_name_regexp' of incorrect type. Expected str, got {type(login_name_regexp_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if allow_data_manipulation_old is not None and not (isinstance(allow_data_manipulation_old, bool)):
			raise ValueError(f"'allow_data_manipulation' of incorrect type. Expected bool, got {type(allow_data_manipulation_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_own_old=is_own_old, kit_status_old=kit_status_old, login_name_old=login_name_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, is_adm_locked_old=is_adm_locked_old, is_sub_account_old=is_sub_account_old, login_name_list_old=login_name_list_old, login_name_regexp_old=login_name_regexp_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, allow_data_manipulation_old=allow_data_manipulation_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(login_name_old: str, login_name_new: str = None, description_new: Union[str, ExplicitNull] = None, allow_data_manipulation_new: bool = None) -> dict:
		if login_name_new is not None and not (isinstance(login_name_new, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if allow_data_manipulation_new is not None and not (isinstance(allow_data_manipulation_new, bool)):
			raise ValueError(f"'allow_data_manipulation' of incorrect type. Expected bool, got {type(allow_data_manipulation_new)}")
		if not (isinstance(login_name_old, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_old)}")

		return {'name': 'cntl.mgr.update', 'new': _denullify_dict({'login_name': login_name_new, 'description': description_new, 'allow_data_manipulation': allow_data_manipulation_new}), 'old': _denullify_dict({'login_name': login_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, login_name_old: str, login_name_new: str = None, description_new: Union[str, ExplicitNull] = None, allow_data_manipulation_new: bool = None) -> list:
		if login_name_new is not None and not (isinstance(login_name_new, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if allow_data_manipulation_new is not None and not (isinstance(allow_data_manipulation_new, bool)):
			raise ValueError(f"'allow_data_manipulation' of incorrect type. Expected bool, got {type(allow_data_manipulation_new)}")
		if not (isinstance(login_name_old, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(login_name_new=login_name_new, description_new=description_new, allow_data_manipulation_new=allow_data_manipulation_new, login_name_old=login_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Error(APIObject):
	gpk: str
	code: int
	type: int
	details: str
	description: str
	constraint_list: list

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.code, int):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(self.code)}")
		if not isinstance(self.type, int):
			raise ValueError(f"'type' of incorrect type. Expected int, got {type(self.type)}")
		if self.details is not None and not isinstance(self.details, str):
			raise ValueError(f"'details' of incorrect type. Expected str, got {type(self.details)}")
		if not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.constraint_list, list):
			raise ValueError(f"'constraint_list' of incorrect type. Expected list, got {type(self.constraint_list)}")

	@staticmethod
	def list_ta(gpk_old: str = None, type_old: int = None, fetch_limit_old: int = None, fetch_offset_old: int = None, constraint_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if type_old is not None and not (isinstance(type_old, int)):
			raise ValueError(f"'type' of incorrect type. Expected int, got {type(type_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if constraint_list_old is not None and not (isinstance(constraint_list_old, list)):
			raise ValueError(f"'constraint_list' of incorrect type. Expected list, got {type(constraint_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.error.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'type': type_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'constraint_list': constraint_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, type_old: int = None, fetch_limit_old: int = None, fetch_offset_old: int = None, constraint_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if type_old is not None and not (isinstance(type_old, int)):
			raise ValueError(f"'type' of incorrect type. Expected int, got {type(type_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if constraint_list_old is not None and not (isinstance(constraint_list_old, list)):
			raise ValueError(f"'constraint_list' of incorrect type. Expected list, got {type(constraint_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, type_old=type_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, constraint_list_old=constraint_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Column(APIObject):
	gpk: str
	name: str
	is_wapi: bool
	ref_name: str
	data_type: str
	long_title: str
	table_name: str
	is_nullable: bool
	is_required: bool
	is_deprecated: bool
	attribute_name: str
	ref_table_name: str
	short_title_abs: str
	short_title_rel: str
	object_type_fq_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.is_wapi, bool):
			raise ValueError(f"'is_wapi' of incorrect type. Expected bool, got {type(self.is_wapi)}")
		if self.ref_name is not None and not isinstance(self.ref_name, str):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(self.ref_name)}")
		if not isinstance(self.data_type, str):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(self.data_type)}")
		if self.long_title is not None and not isinstance(self.long_title, str):
			raise ValueError(f"'long_title' of incorrect type. Expected str, got {type(self.long_title)}")
		if not isinstance(self.table_name, str):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(self.table_name)}")
		if not isinstance(self.is_nullable, bool):
			raise ValueError(f"'is_nullable' of incorrect type. Expected bool, got {type(self.is_nullable)}")
		if not isinstance(self.is_required, bool):
			raise ValueError(f"'is_required' of incorrect type. Expected bool, got {type(self.is_required)}")
		if not isinstance(self.is_deprecated, bool):
			raise ValueError(f"'is_deprecated' of incorrect type. Expected bool, got {type(self.is_deprecated)}")
		if not isinstance(self.attribute_name, str):
			raise ValueError(f"'attribute_name' of incorrect type. Expected str, got {type(self.attribute_name)}")
		if self.ref_table_name is not None and not isinstance(self.ref_table_name, str):
			raise ValueError(f"'ref_table_name' of incorrect type. Expected str, got {type(self.ref_table_name)}")
		if not isinstance(self.short_title_abs, str):
			raise ValueError(f"'short_title_abs' of incorrect type. Expected str, got {type(self.short_title_abs)}")
		if not isinstance(self.short_title_rel, str):
			raise ValueError(f"'short_title_rel' of incorrect type. Expected str, got {type(self.short_title_rel)}")
		if not isinstance(self.object_type_fq_name, str):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(self.object_type_fq_name)}")

	@staticmethod
	def create_ta(name_new: str, is_wapi_new: bool, data_type_new: str, table_name_new: str, is_nullable_new: bool, is_required_new: bool, attribute_name_new: str, short_title_abs_new: str, short_title_rel_new: str, ref_name_new: Union[str, ExplicitNull] = None, long_title_new: Union[str, ExplicitNull] = None, is_deprecated_new: bool = False, ref_table_name_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(is_wapi_new, bool)):
			raise ValueError(f"'is_wapi' of incorrect type. Expected bool, got {type(is_wapi_new)}")
		if ref_name_new is not None and not (isinstance(ref_name_new, str) or isinstance(ref_name_new, ExplicitNull)):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(ref_name_new)}")
		if not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if long_title_new is not None and not (isinstance(long_title_new, str) or isinstance(long_title_new, ExplicitNull)):
			raise ValueError(f"'long_title' of incorrect type. Expected str, got {type(long_title_new)}")
		if not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if not (isinstance(is_nullable_new, bool)):
			raise ValueError(f"'is_nullable' of incorrect type. Expected bool, got {type(is_nullable_new)}")
		if not (isinstance(is_required_new, bool)):
			raise ValueError(f"'is_required' of incorrect type. Expected bool, got {type(is_required_new)}")
		if not (isinstance(is_deprecated_new, bool)):
			raise ValueError(f"'is_deprecated' of incorrect type. Expected bool, got {type(is_deprecated_new)}")
		if not (isinstance(attribute_name_new, str)):
			raise ValueError(f"'attribute_name' of incorrect type. Expected str, got {type(attribute_name_new)}")
		if ref_table_name_new is not None and not (isinstance(ref_table_name_new, str) or isinstance(ref_table_name_new, ExplicitNull)):
			raise ValueError(f"'ref_table_name' of incorrect type. Expected str, got {type(ref_table_name_new)}")
		if not (isinstance(short_title_abs_new, str)):
			raise ValueError(f"'short_title_abs' of incorrect type. Expected str, got {type(short_title_abs_new)}")
		if not (isinstance(short_title_rel_new, str)):
			raise ValueError(f"'short_title_rel' of incorrect type. Expected str, got {type(short_title_rel_new)}")

		return {'name': 'cntl.column.create', 'new': _denullify_dict({'name': name_new, 'is_wapi': is_wapi_new, 'ref_name': ref_name_new, 'data_type': data_type_new, 'long_title': long_title_new, 'table_name': table_name_new, 'is_nullable': is_nullable_new, 'is_required': is_required_new, 'is_deprecated': is_deprecated_new, 'attribute_name': attribute_name_new, 'ref_table_name': ref_table_name_new, 'short_title_abs': short_title_abs_new, 'short_title_rel': short_title_rel_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, is_wapi_new: bool, data_type_new: str, table_name_new: str, is_nullable_new: bool, is_required_new: bool, attribute_name_new: str, short_title_abs_new: str, short_title_rel_new: str, ref_name_new: Union[str, ExplicitNull] = None, long_title_new: Union[str, ExplicitNull] = None, is_deprecated_new: bool = False, ref_table_name_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(is_wapi_new, bool)):
			raise ValueError(f"'is_wapi' of incorrect type. Expected bool, got {type(is_wapi_new)}")
		if ref_name_new is not None and not (isinstance(ref_name_new, str) or isinstance(ref_name_new, ExplicitNull)):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(ref_name_new)}")
		if not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if long_title_new is not None and not (isinstance(long_title_new, str) or isinstance(long_title_new, ExplicitNull)):
			raise ValueError(f"'long_title' of incorrect type. Expected str, got {type(long_title_new)}")
		if not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if not (isinstance(is_nullable_new, bool)):
			raise ValueError(f"'is_nullable' of incorrect type. Expected bool, got {type(is_nullable_new)}")
		if not (isinstance(is_required_new, bool)):
			raise ValueError(f"'is_required' of incorrect type. Expected bool, got {type(is_required_new)}")
		if not (isinstance(is_deprecated_new, bool)):
			raise ValueError(f"'is_deprecated' of incorrect type. Expected bool, got {type(is_deprecated_new)}")
		if not (isinstance(attribute_name_new, str)):
			raise ValueError(f"'attribute_name' of incorrect type. Expected str, got {type(attribute_name_new)}")
		if ref_table_name_new is not None and not (isinstance(ref_table_name_new, str) or isinstance(ref_table_name_new, ExplicitNull)):
			raise ValueError(f"'ref_table_name' of incorrect type. Expected str, got {type(ref_table_name_new)}")
		if not (isinstance(short_title_abs_new, str)):
			raise ValueError(f"'short_title_abs' of incorrect type. Expected str, got {type(short_title_abs_new)}")
		if not (isinstance(short_title_rel_new, str)):
			raise ValueError(f"'short_title_rel' of incorrect type. Expected str, got {type(short_title_rel_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, is_wapi_new=is_wapi_new, ref_name_new=ref_name_new, data_type_new=data_type_new, long_title_new=long_title_new, table_name_new=table_name_new, is_nullable_new=is_nullable_new, is_required_new=is_required_new, is_deprecated_new=is_deprecated_new, attribute_name_new=attribute_name_new, ref_table_name_new=ref_table_name_new, short_title_abs_new=short_title_abs_new, short_title_rel_new=short_title_rel_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str, table_name_old: str = None, do_ref_set_null_old: bool = None) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if table_name_old is not None and not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")
		if do_ref_set_null_old is not None and not (isinstance(do_ref_set_null_old, bool)):
			raise ValueError(f"'do_ref_set_null' of incorrect type. Expected bool, got {type(do_ref_set_null_old)}")

		return {'name': 'cntl.column.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old, 'table_name': table_name_old, 'do_ref_set_null': do_ref_set_null_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str, table_name_old: str = None, do_ref_set_null_old: bool = None) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if table_name_old is not None and not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")
		if do_ref_set_null_old is not None and not (isinstance(do_ref_set_null_old, bool)):
			raise ValueError(f"'do_ref_set_null' of incorrect type. Expected bool, got {type(do_ref_set_null_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old, table_name_old=table_name_old, do_ref_set_null_old=do_ref_set_null_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, data_type_old: str = None, table_name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_deprecated_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if data_type_old is not None and not (isinstance(data_type_old, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_old)}")
		if table_name_old is not None and not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_deprecated_old is not None and not (isinstance(is_deprecated_old, bool)):
			raise ValueError(f"'is_deprecated' of incorrect type. Expected bool, got {type(is_deprecated_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.column.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'data_type': data_type_old, 'table_name': table_name_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'is_deprecated': is_deprecated_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, data_type_old: str = None, table_name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_deprecated_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if data_type_old is not None and not (isinstance(data_type_old, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_old)}")
		if table_name_old is not None and not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_deprecated_old is not None and not (isinstance(is_deprecated_old, bool)):
			raise ValueError(f"'is_deprecated' of incorrect type. Expected bool, got {type(is_deprecated_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, data_type_old=data_type_old, table_name_old=table_name_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, is_deprecated_old=is_deprecated_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, table_name_old: str, name_new: str = None, is_wapi_new: bool = None, ref_name_new: Union[str, ExplicitNull] = None, data_type_new: str = None, long_title_new: Union[str, ExplicitNull] = None, table_name_new: str = None, is_nullable_new: bool = None, is_required_new: bool = None, is_deprecated_new: bool = None, attribute_name_new: str = None, ref_table_name_new: Union[str, ExplicitNull] = None, short_title_abs_new: str = None, short_title_rel_new: str = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if is_wapi_new is not None and not (isinstance(is_wapi_new, bool)):
			raise ValueError(f"'is_wapi' of incorrect type. Expected bool, got {type(is_wapi_new)}")
		if ref_name_new is not None and not (isinstance(ref_name_new, str) or isinstance(ref_name_new, ExplicitNull)):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(ref_name_new)}")
		if data_type_new is not None and not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if long_title_new is not None and not (isinstance(long_title_new, str) or isinstance(long_title_new, ExplicitNull)):
			raise ValueError(f"'long_title' of incorrect type. Expected str, got {type(long_title_new)}")
		if table_name_new is not None and not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if is_nullable_new is not None and not (isinstance(is_nullable_new, bool)):
			raise ValueError(f"'is_nullable' of incorrect type. Expected bool, got {type(is_nullable_new)}")
		if is_required_new is not None and not (isinstance(is_required_new, bool)):
			raise ValueError(f"'is_required' of incorrect type. Expected bool, got {type(is_required_new)}")
		if is_deprecated_new is not None and not (isinstance(is_deprecated_new, bool)):
			raise ValueError(f"'is_deprecated' of incorrect type. Expected bool, got {type(is_deprecated_new)}")
		if attribute_name_new is not None and not (isinstance(attribute_name_new, str)):
			raise ValueError(f"'attribute_name' of incorrect type. Expected str, got {type(attribute_name_new)}")
		if ref_table_name_new is not None and not (isinstance(ref_table_name_new, str) or isinstance(ref_table_name_new, ExplicitNull)):
			raise ValueError(f"'ref_table_name' of incorrect type. Expected str, got {type(ref_table_name_new)}")
		if short_title_abs_new is not None and not (isinstance(short_title_abs_new, str)):
			raise ValueError(f"'short_title_abs' of incorrect type. Expected str, got {type(short_title_abs_new)}")
		if short_title_rel_new is not None and not (isinstance(short_title_rel_new, str)):
			raise ValueError(f"'short_title_rel' of incorrect type. Expected str, got {type(short_title_rel_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")

		return {'name': 'cntl.column.update', 'new': _denullify_dict({'name': name_new, 'is_wapi': is_wapi_new, 'ref_name': ref_name_new, 'data_type': data_type_new, 'long_title': long_title_new, 'table_name': table_name_new, 'is_nullable': is_nullable_new, 'is_required': is_required_new, 'is_deprecated': is_deprecated_new, 'attribute_name': attribute_name_new, 'ref_table_name': ref_table_name_new, 'short_title_abs': short_title_abs_new, 'short_title_rel': short_title_rel_new}), 'old': _denullify_dict({'name': name_old, 'table_name': table_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, table_name_old: str, name_new: str = None, is_wapi_new: bool = None, ref_name_new: Union[str, ExplicitNull] = None, data_type_new: str = None, long_title_new: Union[str, ExplicitNull] = None, table_name_new: str = None, is_nullable_new: bool = None, is_required_new: bool = None, is_deprecated_new: bool = None, attribute_name_new: str = None, ref_table_name_new: Union[str, ExplicitNull] = None, short_title_abs_new: str = None, short_title_rel_new: str = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if is_wapi_new is not None and not (isinstance(is_wapi_new, bool)):
			raise ValueError(f"'is_wapi' of incorrect type. Expected bool, got {type(is_wapi_new)}")
		if ref_name_new is not None and not (isinstance(ref_name_new, str) or isinstance(ref_name_new, ExplicitNull)):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(ref_name_new)}")
		if data_type_new is not None and not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if long_title_new is not None and not (isinstance(long_title_new, str) or isinstance(long_title_new, ExplicitNull)):
			raise ValueError(f"'long_title' of incorrect type. Expected str, got {type(long_title_new)}")
		if table_name_new is not None and not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if is_nullable_new is not None and not (isinstance(is_nullable_new, bool)):
			raise ValueError(f"'is_nullable' of incorrect type. Expected bool, got {type(is_nullable_new)}")
		if is_required_new is not None and not (isinstance(is_required_new, bool)):
			raise ValueError(f"'is_required' of incorrect type. Expected bool, got {type(is_required_new)}")
		if is_deprecated_new is not None and not (isinstance(is_deprecated_new, bool)):
			raise ValueError(f"'is_deprecated' of incorrect type. Expected bool, got {type(is_deprecated_new)}")
		if attribute_name_new is not None and not (isinstance(attribute_name_new, str)):
			raise ValueError(f"'attribute_name' of incorrect type. Expected str, got {type(attribute_name_new)}")
		if ref_table_name_new is not None and not (isinstance(ref_table_name_new, str) or isinstance(ref_table_name_new, ExplicitNull)):
			raise ValueError(f"'ref_table_name' of incorrect type. Expected str, got {type(ref_table_name_new)}")
		if short_title_abs_new is not None and not (isinstance(short_title_abs_new, str)):
			raise ValueError(f"'short_title_abs' of incorrect type. Expected str, got {type(short_title_abs_new)}")
		if short_title_rel_new is not None and not (isinstance(short_title_rel_new, str)):
			raise ValueError(f"'short_title_rel' of incorrect type. Expected str, got {type(short_title_rel_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, is_wapi_new=is_wapi_new, ref_name_new=ref_name_new, data_type_new=data_type_new, long_title_new=long_title_new, table_name_new=table_name_new, is_nullable_new=is_nullable_new, is_required_new=is_required_new, is_deprecated_new=is_deprecated_new, attribute_name_new=attribute_name_new, ref_table_name_new=ref_table_name_new, short_title_abs_new=short_title_abs_new, short_title_rel_new=short_title_rel_new, name_old=name_old, table_name_old=table_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Constraint(APIObject):
	gpk: str
	name: str
	type: str
	ref_name: str
	dblvl_name: str
	table_name: str
	description: str
	is_function: bool
	is_api_level: bool
	col_name_list: list
	join_operator: str
	is_referencing: bool
	is_join_default: bool
	dblvl_table_name: str
	is_referenceable: bool
	col_data_type_list: list
	join_grants_read_access: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if self.ref_name is not None and not isinstance(self.ref_name, str):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(self.ref_name)}")
		if self.dblvl_name is not None and not isinstance(self.dblvl_name, str):
			raise ValueError(f"'dblvl_name' of incorrect type. Expected str, got {type(self.dblvl_name)}")
		if not isinstance(self.table_name, str):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(self.table_name)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.is_function, bool):
			raise ValueError(f"'is_function' of incorrect type. Expected bool, got {type(self.is_function)}")
		if not isinstance(self.is_api_level, bool):
			raise ValueError(f"'is_api_level' of incorrect type. Expected bool, got {type(self.is_api_level)}")
		if not isinstance(self.col_name_list, list):
			raise ValueError(f"'col_name_list' of incorrect type. Expected list, got {type(self.col_name_list)}")
		if not isinstance(self.join_operator, str):
			raise ValueError(f"'join_operator' of incorrect type. Expected str, got {type(self.join_operator)}")
		if not isinstance(self.is_referencing, bool):
			raise ValueError(f"'is_referencing' of incorrect type. Expected bool, got {type(self.is_referencing)}")
		if not isinstance(self.is_join_default, bool):
			raise ValueError(f"'is_join_default' of incorrect type. Expected bool, got {type(self.is_join_default)}")
		if self.dblvl_table_name is not None and not isinstance(self.dblvl_table_name, str):
			raise ValueError(f"'dblvl_table_name' of incorrect type. Expected str, got {type(self.dblvl_table_name)}")
		if not isinstance(self.is_referenceable, bool):
			raise ValueError(f"'is_referenceable' of incorrect type. Expected bool, got {type(self.is_referenceable)}")
		if not isinstance(self.col_data_type_list, list):
			raise ValueError(f"'col_data_type_list' of incorrect type. Expected list, got {type(self.col_data_type_list)}")
		if not isinstance(self.join_grants_read_access, bool):
			raise ValueError(f"'join_grants_read_access' of incorrect type. Expected bool, got {type(self.join_grants_read_access)}")

	@staticmethod
	def create_ta(name_new: str, type_new: str, table_name_new: str, col_name_list_new: list, is_referencing_new: bool, is_join_default_new: bool, is_referenceable_new: bool, join_grants_read_access_new: bool, ref_name_new: Union[str, ExplicitNull] = None, dblvl_name_new: Union[str, ExplicitNull] = None, description_new: Union[str, ExplicitNull] = None, join_operator_new: str = '=', dblvl_table_name_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if ref_name_new is not None and not (isinstance(ref_name_new, str) or isinstance(ref_name_new, ExplicitNull)):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(ref_name_new)}")
		if dblvl_name_new is not None and not (isinstance(dblvl_name_new, str) or isinstance(dblvl_name_new, ExplicitNull)):
			raise ValueError(f"'dblvl_name' of incorrect type. Expected str, got {type(dblvl_name_new)}")
		if not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(col_name_list_new, list)):
			raise ValueError(f"'col_name_list' of incorrect type. Expected list, got {type(col_name_list_new)}")
		if not (isinstance(join_operator_new, str)):
			raise ValueError(f"'join_operator' of incorrect type. Expected str, got {type(join_operator_new)}")
		if not (isinstance(is_referencing_new, bool)):
			raise ValueError(f"'is_referencing' of incorrect type. Expected bool, got {type(is_referencing_new)}")
		if not (isinstance(is_join_default_new, bool)):
			raise ValueError(f"'is_join_default' of incorrect type. Expected bool, got {type(is_join_default_new)}")
		if dblvl_table_name_new is not None and not (isinstance(dblvl_table_name_new, str) or isinstance(dblvl_table_name_new, ExplicitNull)):
			raise ValueError(f"'dblvl_table_name' of incorrect type. Expected str, got {type(dblvl_table_name_new)}")
		if not (isinstance(is_referenceable_new, bool)):
			raise ValueError(f"'is_referenceable' of incorrect type. Expected bool, got {type(is_referenceable_new)}")
		if not (isinstance(join_grants_read_access_new, bool)):
			raise ValueError(f"'join_grants_read_access' of incorrect type. Expected bool, got {type(join_grants_read_access_new)}")

		return {'name': 'cntl.constraint.create', 'new': _denullify_dict({'name': name_new, 'type': type_new, 'ref_name': ref_name_new, 'dblvl_name': dblvl_name_new, 'table_name': table_name_new, 'description': description_new, 'col_name_list': col_name_list_new, 'join_operator': join_operator_new, 'is_referencing': is_referencing_new, 'is_join_default': is_join_default_new, 'dblvl_table_name': dblvl_table_name_new, 'is_referenceable': is_referenceable_new, 'join_grants_read_access': join_grants_read_access_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, type_new: str, table_name_new: str, col_name_list_new: list, is_referencing_new: bool, is_join_default_new: bool, is_referenceable_new: bool, join_grants_read_access_new: bool, ref_name_new: Union[str, ExplicitNull] = None, dblvl_name_new: Union[str, ExplicitNull] = None, description_new: Union[str, ExplicitNull] = None, join_operator_new: str = '=', dblvl_table_name_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if ref_name_new is not None and not (isinstance(ref_name_new, str) or isinstance(ref_name_new, ExplicitNull)):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(ref_name_new)}")
		if dblvl_name_new is not None and not (isinstance(dblvl_name_new, str) or isinstance(dblvl_name_new, ExplicitNull)):
			raise ValueError(f"'dblvl_name' of incorrect type. Expected str, got {type(dblvl_name_new)}")
		if not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(col_name_list_new, list)):
			raise ValueError(f"'col_name_list' of incorrect type. Expected list, got {type(col_name_list_new)}")
		if not (isinstance(join_operator_new, str)):
			raise ValueError(f"'join_operator' of incorrect type. Expected str, got {type(join_operator_new)}")
		if not (isinstance(is_referencing_new, bool)):
			raise ValueError(f"'is_referencing' of incorrect type. Expected bool, got {type(is_referencing_new)}")
		if not (isinstance(is_join_default_new, bool)):
			raise ValueError(f"'is_join_default' of incorrect type. Expected bool, got {type(is_join_default_new)}")
		if dblvl_table_name_new is not None and not (isinstance(dblvl_table_name_new, str) or isinstance(dblvl_table_name_new, ExplicitNull)):
			raise ValueError(f"'dblvl_table_name' of incorrect type. Expected str, got {type(dblvl_table_name_new)}")
		if not (isinstance(is_referenceable_new, bool)):
			raise ValueError(f"'is_referenceable' of incorrect type. Expected bool, got {type(is_referenceable_new)}")
		if not (isinstance(join_grants_read_access_new, bool)):
			raise ValueError(f"'join_grants_read_access' of incorrect type. Expected bool, got {type(join_grants_read_access_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, type_new=type_new, ref_name_new=ref_name_new, dblvl_name_new=dblvl_name_new, table_name_new=table_name_new, description_new=description_new, col_name_list_new=col_name_list_new, join_operator_new=join_operator_new, is_referencing_new=is_referencing_new, is_join_default_new=is_join_default_new, dblvl_table_name_new=dblvl_table_name_new, is_referenceable_new=is_referenceable_new, join_grants_read_access_new=join_grants_read_access_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str = None, table_name_old: str = None) -> dict:
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if table_name_old is not None and not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")

		return {'name': 'cntl.constraint.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old, 'table_name': table_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str = None, table_name_old: str = None) -> list:
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if table_name_old is not None and not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old, table_name_old=table_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, type_old: str = None, ref_name_old: str = None, table_name_old: str = None, fetch_limit_old: int = None, is_function_old: bool = None, fetch_offset_old: int = None, is_api_level_old: bool = None, is_join_default_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, join_grants_read_access_old: bool = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if ref_name_old is not None and not (isinstance(ref_name_old, str) or isinstance(ref_name_old, ExplicitNull)):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(ref_name_old)}")
		if table_name_old is not None and not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if is_function_old is not None and not (isinstance(is_function_old, bool)):
			raise ValueError(f"'is_function' of incorrect type. Expected bool, got {type(is_function_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_api_level_old is not None and not (isinstance(is_api_level_old, bool)):
			raise ValueError(f"'is_api_level' of incorrect type. Expected bool, got {type(is_api_level_old)}")
		if is_join_default_old is not None and not (isinstance(is_join_default_old, bool)):
			raise ValueError(f"'is_join_default' of incorrect type. Expected bool, got {type(is_join_default_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if join_grants_read_access_old is not None and not (isinstance(join_grants_read_access_old, bool)):
			raise ValueError(f"'join_grants_read_access' of incorrect type. Expected bool, got {type(join_grants_read_access_old)}")

		return {'name': 'cntl.constraint.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'type': type_old, 'ref_name': ref_name_old, 'table_name': table_name_old, 'fetch_limit': fetch_limit_old, 'is_function': is_function_old, 'fetch_offset': fetch_offset_old, 'is_api_level': is_api_level_old, 'is_join_default': is_join_default_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'join_grants_read_access': join_grants_read_access_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, type_old: str = None, ref_name_old: str = None, table_name_old: str = None, fetch_limit_old: int = None, is_function_old: bool = None, fetch_offset_old: int = None, is_api_level_old: bool = None, is_join_default_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, join_grants_read_access_old: bool = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if ref_name_old is not None and not (isinstance(ref_name_old, str) or isinstance(ref_name_old, ExplicitNull)):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(ref_name_old)}")
		if table_name_old is not None and not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if is_function_old is not None and not (isinstance(is_function_old, bool)):
			raise ValueError(f"'is_function' of incorrect type. Expected bool, got {type(is_function_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_api_level_old is not None and not (isinstance(is_api_level_old, bool)):
			raise ValueError(f"'is_api_level' of incorrect type. Expected bool, got {type(is_api_level_old)}")
		if is_join_default_old is not None and not (isinstance(is_join_default_old, bool)):
			raise ValueError(f"'is_join_default' of incorrect type. Expected bool, got {type(is_join_default_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if join_grants_read_access_old is not None and not (isinstance(join_grants_read_access_old, bool)):
			raise ValueError(f"'join_grants_read_access' of incorrect type. Expected bool, got {type(join_grants_read_access_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, type_old=type_old, ref_name_old=ref_name_old, table_name_old=table_name_old, fetch_limit_old=fetch_limit_old, is_function_old=is_function_old, fetch_offset_old=fetch_offset_old, is_api_level_old=is_api_level_old, is_join_default_old=is_join_default_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, join_grants_read_access_old=join_grants_read_access_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, table_name_old: str, name_new: str = None, type_new: str = None, ref_name_new: Union[str, ExplicitNull] = None, dblvl_name_new: Union[str, ExplicitNull] = None, table_name_new: str = None, description_new: Union[str, ExplicitNull] = None, col_name_list_new: list = None, join_operator_new: str = None, is_referencing_new: bool = None, is_join_default_new: bool = None, dblvl_table_name_new: Union[str, ExplicitNull] = None, is_referenceable_new: bool = None, join_grants_read_access_new: bool = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if ref_name_new is not None and not (isinstance(ref_name_new, str) or isinstance(ref_name_new, ExplicitNull)):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(ref_name_new)}")
		if dblvl_name_new is not None and not (isinstance(dblvl_name_new, str) or isinstance(dblvl_name_new, ExplicitNull)):
			raise ValueError(f"'dblvl_name' of incorrect type. Expected str, got {type(dblvl_name_new)}")
		if table_name_new is not None and not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if col_name_list_new is not None and not (isinstance(col_name_list_new, list)):
			raise ValueError(f"'col_name_list' of incorrect type. Expected list, got {type(col_name_list_new)}")
		if join_operator_new is not None and not (isinstance(join_operator_new, str)):
			raise ValueError(f"'join_operator' of incorrect type. Expected str, got {type(join_operator_new)}")
		if is_referencing_new is not None and not (isinstance(is_referencing_new, bool)):
			raise ValueError(f"'is_referencing' of incorrect type. Expected bool, got {type(is_referencing_new)}")
		if is_join_default_new is not None and not (isinstance(is_join_default_new, bool)):
			raise ValueError(f"'is_join_default' of incorrect type. Expected bool, got {type(is_join_default_new)}")
		if dblvl_table_name_new is not None and not (isinstance(dblvl_table_name_new, str) or isinstance(dblvl_table_name_new, ExplicitNull)):
			raise ValueError(f"'dblvl_table_name' of incorrect type. Expected str, got {type(dblvl_table_name_new)}")
		if is_referenceable_new is not None and not (isinstance(is_referenceable_new, bool)):
			raise ValueError(f"'is_referenceable' of incorrect type. Expected bool, got {type(is_referenceable_new)}")
		if join_grants_read_access_new is not None and not (isinstance(join_grants_read_access_new, bool)):
			raise ValueError(f"'join_grants_read_access' of incorrect type. Expected bool, got {type(join_grants_read_access_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")

		return {'name': 'cntl.constraint.update', 'new': _denullify_dict({'name': name_new, 'type': type_new, 'ref_name': ref_name_new, 'dblvl_name': dblvl_name_new, 'table_name': table_name_new, 'description': description_new, 'col_name_list': col_name_list_new, 'join_operator': join_operator_new, 'is_referencing': is_referencing_new, 'is_join_default': is_join_default_new, 'dblvl_table_name': dblvl_table_name_new, 'is_referenceable': is_referenceable_new, 'join_grants_read_access': join_grants_read_access_new}), 'old': _denullify_dict({'name': name_old, 'table_name': table_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, table_name_old: str, name_new: str = None, type_new: str = None, ref_name_new: Union[str, ExplicitNull] = None, dblvl_name_new: Union[str, ExplicitNull] = None, table_name_new: str = None, description_new: Union[str, ExplicitNull] = None, col_name_list_new: list = None, join_operator_new: str = None, is_referencing_new: bool = None, is_join_default_new: bool = None, dblvl_table_name_new: Union[str, ExplicitNull] = None, is_referenceable_new: bool = None, join_grants_read_access_new: bool = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if ref_name_new is not None and not (isinstance(ref_name_new, str) or isinstance(ref_name_new, ExplicitNull)):
			raise ValueError(f"'ref_name' of incorrect type. Expected str, got {type(ref_name_new)}")
		if dblvl_name_new is not None and not (isinstance(dblvl_name_new, str) or isinstance(dblvl_name_new, ExplicitNull)):
			raise ValueError(f"'dblvl_name' of incorrect type. Expected str, got {type(dblvl_name_new)}")
		if table_name_new is not None and not (isinstance(table_name_new, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if col_name_list_new is not None and not (isinstance(col_name_list_new, list)):
			raise ValueError(f"'col_name_list' of incorrect type. Expected list, got {type(col_name_list_new)}")
		if join_operator_new is not None and not (isinstance(join_operator_new, str)):
			raise ValueError(f"'join_operator' of incorrect type. Expected str, got {type(join_operator_new)}")
		if is_referencing_new is not None and not (isinstance(is_referencing_new, bool)):
			raise ValueError(f"'is_referencing' of incorrect type. Expected bool, got {type(is_referencing_new)}")
		if is_join_default_new is not None and not (isinstance(is_join_default_new, bool)):
			raise ValueError(f"'is_join_default' of incorrect type. Expected bool, got {type(is_join_default_new)}")
		if dblvl_table_name_new is not None and not (isinstance(dblvl_table_name_new, str) or isinstance(dblvl_table_name_new, ExplicitNull)):
			raise ValueError(f"'dblvl_table_name' of incorrect type. Expected str, got {type(dblvl_table_name_new)}")
		if is_referenceable_new is not None and not (isinstance(is_referenceable_new, bool)):
			raise ValueError(f"'is_referenceable' of incorrect type. Expected bool, got {type(is_referenceable_new)}")
		if join_grants_read_access_new is not None and not (isinstance(join_grants_read_access_new, bool)):
			raise ValueError(f"'join_grants_read_access' of incorrect type. Expected bool, got {type(join_grants_read_access_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(table_name_old, str)):
			raise ValueError(f"'table_name' of incorrect type. Expected str, got {type(table_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, type_new=type_new, ref_name_new=ref_name_new, dblvl_name_new=dblvl_name_new, table_name_new=table_name_new, description_new=description_new, col_name_list_new=col_name_list_new, join_operator_new=join_operator_new, is_referencing_new=is_referencing_new, is_join_default_new=is_join_default_new, dblvl_table_name_new=dblvl_table_name_new, is_referenceable_new=is_referenceable_new, join_grants_read_access_new=join_grants_read_access_new, name_old=name_old, table_name_old=table_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class ErrorType(APIObject):
	gpk: str
	code: int
	name: str
	description: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.code, int):
			raise ValueError(f"'code' of incorrect type. Expected int, got {type(self.code)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")

	@staticmethod
	def list_ta(gpk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.error_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Table(APIObject):
	gpk: str
	name: str
	is_log_dst: bool
	is_log_src: bool
	content_plur1: str
	content_sing1: str
	content_title: str
	is_otattr_dst: bool
	is_otattr_src: bool
	content_detail: str
	content_gender: str
	content_compound: str
	content_abbreviated: str
	object_type_fq_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.is_log_dst, bool):
			raise ValueError(f"'is_log_dst' of incorrect type. Expected bool, got {type(self.is_log_dst)}")
		if not isinstance(self.is_log_src, bool):
			raise ValueError(f"'is_log_src' of incorrect type. Expected bool, got {type(self.is_log_src)}")
		if not isinstance(self.content_plur1, str):
			raise ValueError(f"'content_plur1' of incorrect type. Expected str, got {type(self.content_plur1)}")
		if not isinstance(self.content_sing1, str):
			raise ValueError(f"'content_sing1' of incorrect type. Expected str, got {type(self.content_sing1)}")
		if self.content_title is not None and not isinstance(self.content_title, str):
			raise ValueError(f"'content_title' of incorrect type. Expected str, got {type(self.content_title)}")
		if not isinstance(self.is_otattr_dst, bool):
			raise ValueError(f"'is_otattr_dst' of incorrect type. Expected bool, got {type(self.is_otattr_dst)}")
		if not isinstance(self.is_otattr_src, bool):
			raise ValueError(f"'is_otattr_src' of incorrect type. Expected bool, got {type(self.is_otattr_src)}")
		if self.content_detail is not None and not isinstance(self.content_detail, str):
			raise ValueError(f"'content_detail' of incorrect type. Expected str, got {type(self.content_detail)}")
		if not isinstance(self.content_gender, str):
			raise ValueError(f"'content_gender' of incorrect type. Expected str, got {type(self.content_gender)}")
		if not isinstance(self.content_compound, str):
			raise ValueError(f"'content_compound' of incorrect type. Expected str, got {type(self.content_compound)}")
		if self.content_abbreviated is not None and not isinstance(self.content_abbreviated, str):
			raise ValueError(f"'content_abbreviated' of incorrect type. Expected str, got {type(self.content_abbreviated)}")
		if not isinstance(self.object_type_fq_name, str):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(self.object_type_fq_name)}")

	@staticmethod
	def create_ta(name_new: str, is_log_dst_new: bool, is_log_src_new: bool, content_plur1_new: str, content_sing1_new: str, content_title_new: Union[str, ExplicitNull], is_otattr_src_new: bool, content_detail_new: Union[str, ExplicitNull], content_gender_new: str, content_compound_new: str, content_abbreviated_new: Union[str, ExplicitNull], is_otattr_dst_new: bool = False) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(is_log_dst_new, bool)):
			raise ValueError(f"'is_log_dst' of incorrect type. Expected bool, got {type(is_log_dst_new)}")
		if not (isinstance(is_log_src_new, bool)):
			raise ValueError(f"'is_log_src' of incorrect type. Expected bool, got {type(is_log_src_new)}")
		if not (isinstance(content_plur1_new, str)):
			raise ValueError(f"'content_plur1' of incorrect type. Expected str, got {type(content_plur1_new)}")
		if not (isinstance(content_sing1_new, str)):
			raise ValueError(f"'content_sing1' of incorrect type. Expected str, got {type(content_sing1_new)}")
		if not (isinstance(content_title_new, str) or isinstance(content_title_new, ExplicitNull)):
			raise ValueError(f"'content_title' of incorrect type. Expected str, got {type(content_title_new)}")
		if not (isinstance(is_otattr_dst_new, bool)):
			raise ValueError(f"'is_otattr_dst' of incorrect type. Expected bool, got {type(is_otattr_dst_new)}")
		if not (isinstance(is_otattr_src_new, bool)):
			raise ValueError(f"'is_otattr_src' of incorrect type. Expected bool, got {type(is_otattr_src_new)}")
		if not (isinstance(content_detail_new, str) or isinstance(content_detail_new, ExplicitNull)):
			raise ValueError(f"'content_detail' of incorrect type. Expected str, got {type(content_detail_new)}")
		if not (isinstance(content_gender_new, str)):
			raise ValueError(f"'content_gender' of incorrect type. Expected str, got {type(content_gender_new)}")
		if not (isinstance(content_compound_new, str)):
			raise ValueError(f"'content_compound' of incorrect type. Expected str, got {type(content_compound_new)}")
		if not (isinstance(content_abbreviated_new, str) or isinstance(content_abbreviated_new, ExplicitNull)):
			raise ValueError(f"'content_abbreviated' of incorrect type. Expected str, got {type(content_abbreviated_new)}")

		return {'name': 'cntl.table.create', 'new': _denullify_dict({'name': name_new, 'is_log_dst': is_log_dst_new, 'is_log_src': is_log_src_new, 'content_plur1': content_plur1_new, 'content_sing1': content_sing1_new, 'content_title': content_title_new, 'is_otattr_dst': is_otattr_dst_new, 'is_otattr_src': is_otattr_src_new, 'content_detail': content_detail_new, 'content_gender': content_gender_new, 'content_compound': content_compound_new, 'content_abbreviated': content_abbreviated_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, is_log_dst_new: bool, is_log_src_new: bool, content_plur1_new: str, content_sing1_new: str, content_title_new: Union[str, ExplicitNull], is_otattr_src_new: bool, content_detail_new: Union[str, ExplicitNull], content_gender_new: str, content_compound_new: str, content_abbreviated_new: Union[str, ExplicitNull], is_otattr_dst_new: bool = False) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(is_log_dst_new, bool)):
			raise ValueError(f"'is_log_dst' of incorrect type. Expected bool, got {type(is_log_dst_new)}")
		if not (isinstance(is_log_src_new, bool)):
			raise ValueError(f"'is_log_src' of incorrect type. Expected bool, got {type(is_log_src_new)}")
		if not (isinstance(content_plur1_new, str)):
			raise ValueError(f"'content_plur1' of incorrect type. Expected str, got {type(content_plur1_new)}")
		if not (isinstance(content_sing1_new, str)):
			raise ValueError(f"'content_sing1' of incorrect type. Expected str, got {type(content_sing1_new)}")
		if not (isinstance(content_title_new, str) or isinstance(content_title_new, ExplicitNull)):
			raise ValueError(f"'content_title' of incorrect type. Expected str, got {type(content_title_new)}")
		if not (isinstance(is_otattr_dst_new, bool)):
			raise ValueError(f"'is_otattr_dst' of incorrect type. Expected bool, got {type(is_otattr_dst_new)}")
		if not (isinstance(is_otattr_src_new, bool)):
			raise ValueError(f"'is_otattr_src' of incorrect type. Expected bool, got {type(is_otattr_src_new)}")
		if not (isinstance(content_detail_new, str) or isinstance(content_detail_new, ExplicitNull)):
			raise ValueError(f"'content_detail' of incorrect type. Expected str, got {type(content_detail_new)}")
		if not (isinstance(content_gender_new, str)):
			raise ValueError(f"'content_gender' of incorrect type. Expected str, got {type(content_gender_new)}")
		if not (isinstance(content_compound_new, str)):
			raise ValueError(f"'content_compound' of incorrect type. Expected str, got {type(content_compound_new)}")
		if not (isinstance(content_abbreviated_new, str) or isinstance(content_abbreviated_new, ExplicitNull)):
			raise ValueError(f"'content_abbreviated' of incorrect type. Expected str, got {type(content_abbreviated_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, is_log_dst_new=is_log_dst_new, is_log_src_new=is_log_src_new, content_plur1_new=content_plur1_new, content_sing1_new=content_sing1_new, content_title_new=content_title_new, is_otattr_dst_new=is_otattr_dst_new, is_otattr_src_new=is_otattr_src_new, content_detail_new=content_detail_new, content_gender_new=content_gender_new, content_compound_new=content_compound_new, content_abbreviated_new=content_abbreviated_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str, do_del_cols_old: bool = None) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if do_del_cols_old is not None and not (isinstance(do_del_cols_old, bool)):
			raise ValueError(f"'do_del_cols' of incorrect type. Expected bool, got {type(do_del_cols_old)}")

		return {'name': 'cntl.table.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old, 'do_del_cols': do_del_cols_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str, do_del_cols_old: bool = None) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if do_del_cols_old is not None and not (isinstance(do_del_cols_old, bool)):
			raise ValueError(f"'do_del_cols' of incorrect type. Expected bool, got {type(do_del_cols_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old, do_del_cols_old=do_del_cols_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, is_log_dst_old: bool = None, is_log_src_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_otattr_dst_old: bool = None, is_otattr_src_old: bool = None, filter_params_dict_old: dict = None, object_type_fq_name_old: str = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if is_log_dst_old is not None and not (isinstance(is_log_dst_old, bool)):
			raise ValueError(f"'is_log_dst' of incorrect type. Expected bool, got {type(is_log_dst_old)}")
		if is_log_src_old is not None and not (isinstance(is_log_src_old, bool)):
			raise ValueError(f"'is_log_src' of incorrect type. Expected bool, got {type(is_log_src_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_otattr_dst_old is not None and not (isinstance(is_otattr_dst_old, bool)):
			raise ValueError(f"'is_otattr_dst' of incorrect type. Expected bool, got {type(is_otattr_dst_old)}")
		if is_otattr_src_old is not None and not (isinstance(is_otattr_src_old, bool)):
			raise ValueError(f"'is_otattr_src' of incorrect type. Expected bool, got {type(is_otattr_src_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if object_type_fq_name_old is not None and not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.table.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'is_log_dst': is_log_dst_old, 'is_log_src': is_log_src_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'is_otattr_dst': is_otattr_dst_old, 'is_otattr_src': is_otattr_src_old, 'filter_params_dict': filter_params_dict_old, 'object_type_fq_name': object_type_fq_name_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, is_log_dst_old: bool = None, is_log_src_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_otattr_dst_old: bool = None, is_otattr_src_old: bool = None, filter_params_dict_old: dict = None, object_type_fq_name_old: str = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if is_log_dst_old is not None and not (isinstance(is_log_dst_old, bool)):
			raise ValueError(f"'is_log_dst' of incorrect type. Expected bool, got {type(is_log_dst_old)}")
		if is_log_src_old is not None and not (isinstance(is_log_src_old, bool)):
			raise ValueError(f"'is_log_src' of incorrect type. Expected bool, got {type(is_log_src_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_otattr_dst_old is not None and not (isinstance(is_otattr_dst_old, bool)):
			raise ValueError(f"'is_otattr_dst' of incorrect type. Expected bool, got {type(is_otattr_dst_old)}")
		if is_otattr_src_old is not None and not (isinstance(is_otattr_src_old, bool)):
			raise ValueError(f"'is_otattr_src' of incorrect type. Expected bool, got {type(is_otattr_src_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if object_type_fq_name_old is not None and not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, is_log_dst_old=is_log_dst_old, is_log_src_old=is_log_src_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, is_otattr_dst_old=is_otattr_dst_old, is_otattr_src_old=is_otattr_src_old, filter_params_dict_old=filter_params_dict_old, object_type_fq_name_old=object_type_fq_name_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, is_log_dst_new: bool = None, is_log_src_new: bool = None, content_plur1_new: str = None, content_sing1_new: str = None, content_title_new: Union[str, ExplicitNull] = None, is_otattr_dst_new: bool = None, is_otattr_src_new: bool = None, content_detail_new: Union[str, ExplicitNull] = None, content_gender_new: str = None, content_compound_new: str = None, content_abbreviated_new: Union[str, ExplicitNull] = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if is_log_dst_new is not None and not (isinstance(is_log_dst_new, bool)):
			raise ValueError(f"'is_log_dst' of incorrect type. Expected bool, got {type(is_log_dst_new)}")
		if is_log_src_new is not None and not (isinstance(is_log_src_new, bool)):
			raise ValueError(f"'is_log_src' of incorrect type. Expected bool, got {type(is_log_src_new)}")
		if content_plur1_new is not None and not (isinstance(content_plur1_new, str)):
			raise ValueError(f"'content_plur1' of incorrect type. Expected str, got {type(content_plur1_new)}")
		if content_sing1_new is not None and not (isinstance(content_sing1_new, str)):
			raise ValueError(f"'content_sing1' of incorrect type. Expected str, got {type(content_sing1_new)}")
		if content_title_new is not None and not (isinstance(content_title_new, str) or isinstance(content_title_new, ExplicitNull)):
			raise ValueError(f"'content_title' of incorrect type. Expected str, got {type(content_title_new)}")
		if is_otattr_dst_new is not None and not (isinstance(is_otattr_dst_new, bool)):
			raise ValueError(f"'is_otattr_dst' of incorrect type. Expected bool, got {type(is_otattr_dst_new)}")
		if is_otattr_src_new is not None and not (isinstance(is_otattr_src_new, bool)):
			raise ValueError(f"'is_otattr_src' of incorrect type. Expected bool, got {type(is_otattr_src_new)}")
		if content_detail_new is not None and not (isinstance(content_detail_new, str) or isinstance(content_detail_new, ExplicitNull)):
			raise ValueError(f"'content_detail' of incorrect type. Expected str, got {type(content_detail_new)}")
		if content_gender_new is not None and not (isinstance(content_gender_new, str)):
			raise ValueError(f"'content_gender' of incorrect type. Expected str, got {type(content_gender_new)}")
		if content_compound_new is not None and not (isinstance(content_compound_new, str)):
			raise ValueError(f"'content_compound' of incorrect type. Expected str, got {type(content_compound_new)}")
		if content_abbreviated_new is not None and not (isinstance(content_abbreviated_new, str) or isinstance(content_abbreviated_new, ExplicitNull)):
			raise ValueError(f"'content_abbreviated' of incorrect type. Expected str, got {type(content_abbreviated_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'cntl.table.update', 'new': _denullify_dict({'name': name_new, 'is_log_dst': is_log_dst_new, 'is_log_src': is_log_src_new, 'content_plur1': content_plur1_new, 'content_sing1': content_sing1_new, 'content_title': content_title_new, 'is_otattr_dst': is_otattr_dst_new, 'is_otattr_src': is_otattr_src_new, 'content_detail': content_detail_new, 'content_gender': content_gender_new, 'content_compound': content_compound_new, 'content_abbreviated': content_abbreviated_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, is_log_dst_new: bool = None, is_log_src_new: bool = None, content_plur1_new: str = None, content_sing1_new: str = None, content_title_new: Union[str, ExplicitNull] = None, is_otattr_dst_new: bool = None, is_otattr_src_new: bool = None, content_detail_new: Union[str, ExplicitNull] = None, content_gender_new: str = None, content_compound_new: str = None, content_abbreviated_new: Union[str, ExplicitNull] = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if is_log_dst_new is not None and not (isinstance(is_log_dst_new, bool)):
			raise ValueError(f"'is_log_dst' of incorrect type. Expected bool, got {type(is_log_dst_new)}")
		if is_log_src_new is not None and not (isinstance(is_log_src_new, bool)):
			raise ValueError(f"'is_log_src' of incorrect type. Expected bool, got {type(is_log_src_new)}")
		if content_plur1_new is not None and not (isinstance(content_plur1_new, str)):
			raise ValueError(f"'content_plur1' of incorrect type. Expected str, got {type(content_plur1_new)}")
		if content_sing1_new is not None and not (isinstance(content_sing1_new, str)):
			raise ValueError(f"'content_sing1' of incorrect type. Expected str, got {type(content_sing1_new)}")
		if content_title_new is not None and not (isinstance(content_title_new, str) or isinstance(content_title_new, ExplicitNull)):
			raise ValueError(f"'content_title' of incorrect type. Expected str, got {type(content_title_new)}")
		if is_otattr_dst_new is not None and not (isinstance(is_otattr_dst_new, bool)):
			raise ValueError(f"'is_otattr_dst' of incorrect type. Expected bool, got {type(is_otattr_dst_new)}")
		if is_otattr_src_new is not None and not (isinstance(is_otattr_src_new, bool)):
			raise ValueError(f"'is_otattr_src' of incorrect type. Expected bool, got {type(is_otattr_src_new)}")
		if content_detail_new is not None and not (isinstance(content_detail_new, str) or isinstance(content_detail_new, ExplicitNull)):
			raise ValueError(f"'content_detail' of incorrect type. Expected str, got {type(content_detail_new)}")
		if content_gender_new is not None and not (isinstance(content_gender_new, str)):
			raise ValueError(f"'content_gender' of incorrect type. Expected str, got {type(content_gender_new)}")
		if content_compound_new is not None and not (isinstance(content_compound_new, str)):
			raise ValueError(f"'content_compound' of incorrect type. Expected str, got {type(content_compound_new)}")
		if content_abbreviated_new is not None and not (isinstance(content_abbreviated_new, str) or isinstance(content_abbreviated_new, ExplicitNull)):
			raise ValueError(f"'content_abbreviated' of incorrect type. Expected str, got {type(content_abbreviated_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, is_log_dst_new=is_log_dst_new, is_log_src_new=is_log_src_new, content_plur1_new=content_plur1_new, content_sing1_new=content_sing1_new, content_title_new=content_title_new, is_otattr_dst_new=is_otattr_dst_new, is_otattr_src_new=is_otattr_src_new, content_detail_new=content_detail_new, content_gender_new=content_gender_new, content_compound_new=content_compound_new, content_abbreviated_new=content_abbreviated_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Role(APIObject):
	gpk: str
	name: str
	system: str
	fq_name: str
	is_role: bool
	position: int
	description: str
	is_admin_role: bool
	contained_roles: list
	is_directly_assigned: bool
	contained_permissions: dict

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.system, str):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(self.system)}")
		if not isinstance(self.fq_name, str):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(self.fq_name)}")
		if not isinstance(self.is_role, bool):
			raise ValueError(f"'is_role' of incorrect type. Expected bool, got {type(self.is_role)}")
		if not isinstance(self.position, int):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(self.position)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.is_admin_role, bool):
			raise ValueError(f"'is_admin_role' of incorrect type. Expected bool, got {type(self.is_admin_role)}")
		if not isinstance(self.contained_roles, list):
			raise ValueError(f"'contained_roles' of incorrect type. Expected list, got {type(self.contained_roles)}")
		if not isinstance(self.is_directly_assigned, bool):
			raise ValueError(f"'is_directly_assigned' of incorrect type. Expected bool, got {type(self.is_directly_assigned)}")
		if not isinstance(self.contained_permissions, dict):
			raise ValueError(f"'contained_permissions' of incorrect type. Expected dict, got {type(self.contained_permissions)}")

	@staticmethod
	def create_ta(fq_name_new: str, is_role_new: bool, is_admin_role_new: bool, position_new: int = None, description_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if not (isinstance(is_role_new, bool)):
			raise ValueError(f"'is_role' of incorrect type. Expected bool, got {type(is_role_new)}")
		if position_new is not None and not (isinstance(position_new, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(is_admin_role_new, bool)):
			raise ValueError(f"'is_admin_role' of incorrect type. Expected bool, got {type(is_admin_role_new)}")

		return {'name': 'cntl.role.create', 'new': _denullify_dict({'fq_name': fq_name_new, 'is_role': is_role_new, 'position': position_new, 'description': description_new, 'is_admin_role': is_admin_role_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, fq_name_new: str, is_role_new: bool, is_admin_role_new: bool, position_new: int = None, description_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if not (isinstance(is_role_new, bool)):
			raise ValueError(f"'is_role' of incorrect type. Expected bool, got {type(is_role_new)}")
		if position_new is not None and not (isinstance(position_new, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(is_admin_role_new, bool)):
			raise ValueError(f"'is_admin_role' of incorrect type. Expected bool, got {type(is_admin_role_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(fq_name_new=fq_name_new, is_role_new=is_role_new, position_new=position_new, description_new=description_new, is_admin_role_new=is_admin_role_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(fq_name_old: str) -> dict:
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")

		return {'name': 'cntl.role.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'fq_name': fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, fq_name_old: str) -> list:
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(fq_name_old=fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, is_role_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, fq_name_list_old: list = None, is_admin_role_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, is_directly_assigned_old: bool = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_role_old is not None and not (isinstance(is_role_old, bool)):
			raise ValueError(f"'is_role' of incorrect type. Expected bool, got {type(is_role_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if fq_name_list_old is not None and not (isinstance(fq_name_list_old, list)):
			raise ValueError(f"'fq_name_list' of incorrect type. Expected list, got {type(fq_name_list_old)}")
		if is_admin_role_old is not None and not (isinstance(is_admin_role_old, bool)):
			raise ValueError(f"'is_admin_role' of incorrect type. Expected bool, got {type(is_admin_role_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if is_directly_assigned_old is not None and not (isinstance(is_directly_assigned_old, bool)):
			raise ValueError(f"'is_directly_assigned' of incorrect type. Expected bool, got {type(is_directly_assigned_old)}")

		return {'name': 'cntl.role.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_role': is_role_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'fq_name_list': fq_name_list_old, 'is_admin_role': is_admin_role_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'is_directly_assigned': is_directly_assigned_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_role_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, fq_name_list_old: list = None, is_admin_role_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, is_directly_assigned_old: bool = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_role_old is not None and not (isinstance(is_role_old, bool)):
			raise ValueError(f"'is_role' of incorrect type. Expected bool, got {type(is_role_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if fq_name_list_old is not None and not (isinstance(fq_name_list_old, list)):
			raise ValueError(f"'fq_name_list' of incorrect type. Expected list, got {type(fq_name_list_old)}")
		if is_admin_role_old is not None and not (isinstance(is_admin_role_old, bool)):
			raise ValueError(f"'is_admin_role' of incorrect type. Expected bool, got {type(is_admin_role_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if is_directly_assigned_old is not None and not (isinstance(is_directly_assigned_old, bool)):
			raise ValueError(f"'is_directly_assigned' of incorrect type. Expected bool, got {type(is_directly_assigned_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_role_old=is_role_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, fq_name_list_old=fq_name_list_old, is_admin_role_old=is_admin_role_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, is_directly_assigned_old=is_directly_assigned_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(fq_name_old: str, fq_name_new: str = None, is_role_new: bool = None, position_new: int = None, description_new: Union[str, ExplicitNull] = None, is_admin_role_new: bool = None) -> dict:
		if fq_name_new is not None and not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if is_role_new is not None and not (isinstance(is_role_new, bool)):
			raise ValueError(f"'is_role' of incorrect type. Expected bool, got {type(is_role_new)}")
		if position_new is not None and not (isinstance(position_new, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if is_admin_role_new is not None and not (isinstance(is_admin_role_new, bool)):
			raise ValueError(f"'is_admin_role' of incorrect type. Expected bool, got {type(is_admin_role_new)}")
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")

		return {'name': 'cntl.role.update', 'new': _denullify_dict({'fq_name': fq_name_new, 'is_role': is_role_new, 'position': position_new, 'description': description_new, 'is_admin_role': is_admin_role_new}), 'old': _denullify_dict({'fq_name': fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, fq_name_old: str, fq_name_new: str = None, is_role_new: bool = None, position_new: int = None, description_new: Union[str, ExplicitNull] = None, is_admin_role_new: bool = None) -> list:
		if fq_name_new is not None and not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if is_role_new is not None and not (isinstance(is_role_new, bool)):
			raise ValueError(f"'is_role' of incorrect type. Expected bool, got {type(is_role_new)}")
		if position_new is not None and not (isinstance(position_new, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if is_admin_role_new is not None and not (isinstance(is_admin_role_new, bool)):
			raise ValueError(f"'is_admin_role' of incorrect type. Expected bool, got {type(is_admin_role_new)}")
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(fq_name_new=fq_name_new, is_role_new=is_role_new, position_new=position_new, description_new=description_new, is_admin_role_new=is_admin_role_new, fq_name_old=fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Mgr2role(APIObject):
	gpk: str
	role: str
	system: str
	role_fq_name: str
	mgr_login_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.role, str):
			raise ValueError(f"'role' of incorrect type. Expected str, got {type(self.role)}")
		if not isinstance(self.system, str):
			raise ValueError(f"'system' of incorrect type. Expected str, got {type(self.system)}")
		if not isinstance(self.role_fq_name, str):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(self.role_fq_name)}")
		if not isinstance(self.mgr_login_name, str):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(self.mgr_login_name)}")

	@staticmethod
	def bulk_update_ta(mgr_login_name_old: str, role_fq_name_list_new: list = None, do_preserve_contained_on_delete_new: bool = None, role_fq_name_list_old: list = None) -> dict:
		if role_fq_name_list_new is not None and not (isinstance(role_fq_name_list_new, list)):
			raise ValueError(f"'role_fq_name_list' of incorrect type. Expected list, got {type(role_fq_name_list_new)}")
		if do_preserve_contained_on_delete_new is not None and not (isinstance(do_preserve_contained_on_delete_new, bool)):
			raise ValueError(f"'do_preserve_contained_on_delete' of incorrect type. Expected bool, got {type(do_preserve_contained_on_delete_new)}")
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")
		if role_fq_name_list_old is not None and not (isinstance(role_fq_name_list_old, list)):
			raise ValueError(f"'role_fq_name_list' of incorrect type. Expected list, got {type(role_fq_name_list_old)}")

		return {'name': 'cntl.mgr2role.bulk_update', 'new': _denullify_dict({'role_fq_name_list': role_fq_name_list_new, 'do_preserve_contained_on_delete': do_preserve_contained_on_delete_new}), 'old': _denullify_dict({'mgr_login_name': mgr_login_name_old, 'role_fq_name_list': role_fq_name_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def bulk_update(cls, api_session: APISession, mgr_login_name_old: str, role_fq_name_list_new: list = None, do_preserve_contained_on_delete_new: bool = None, role_fq_name_list_old: list = None) -> list:
		if role_fq_name_list_new is not None and not (isinstance(role_fq_name_list_new, list)):
			raise ValueError(f"'role_fq_name_list' of incorrect type. Expected list, got {type(role_fq_name_list_new)}")
		if do_preserve_contained_on_delete_new is not None and not (isinstance(do_preserve_contained_on_delete_new, bool)):
			raise ValueError(f"'do_preserve_contained_on_delete' of incorrect type. Expected bool, got {type(do_preserve_contained_on_delete_new)}")
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")
		if role_fq_name_list_old is not None and not (isinstance(role_fq_name_list_old, list)):
			raise ValueError(f"'role_fq_name_list' of incorrect type. Expected list, got {type(role_fq_name_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.bulk_update_ta(role_fq_name_list_new=role_fq_name_list_new, do_preserve_contained_on_delete_new=do_preserve_contained_on_delete_new, mgr_login_name_old=mgr_login_name_old, role_fq_name_list_old=role_fq_name_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.mgr2role.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Role2role(APIObject):
	gpk: str
	role_fq_name: str
	role_is_role: bool
	contained_role_fq_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.role_fq_name, str):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(self.role_fq_name)}")
		if not isinstance(self.role_is_role, bool):
			raise ValueError(f"'role_is_role' of incorrect type. Expected bool, got {type(self.role_is_role)}")
		if not isinstance(self.contained_role_fq_name, str):
			raise ValueError(f"'contained_role_fq_name' of incorrect type. Expected str, got {type(self.contained_role_fq_name)}")

	@staticmethod
	def create_ta(role_fq_name_new: str, contained_role_fq_name_new: str) -> dict:
		if not (isinstance(role_fq_name_new, str)):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(role_fq_name_new)}")
		if not (isinstance(contained_role_fq_name_new, str)):
			raise ValueError(f"'contained_role_fq_name' of incorrect type. Expected str, got {type(contained_role_fq_name_new)}")

		return {'name': 'cntl.role2role.create', 'new': _denullify_dict({'role_fq_name': role_fq_name_new, 'contained_role_fq_name': contained_role_fq_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, role_fq_name_new: str, contained_role_fq_name_new: str) -> list:
		if not (isinstance(role_fq_name_new, str)):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(role_fq_name_new)}")
		if not (isinstance(contained_role_fq_name_new, str)):
			raise ValueError(f"'contained_role_fq_name' of incorrect type. Expected str, got {type(contained_role_fq_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(role_fq_name_new=role_fq_name_new, contained_role_fq_name_new=contained_role_fq_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(role_fq_name_old: str, contained_role_fq_name_old: str, do_preserve_contained_on_delete_old: bool = None) -> dict:
		if not (isinstance(role_fq_name_old, str)):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(role_fq_name_old)}")
		if not (isinstance(contained_role_fq_name_old, str)):
			raise ValueError(f"'contained_role_fq_name' of incorrect type. Expected str, got {type(contained_role_fq_name_old)}")
		if do_preserve_contained_on_delete_old is not None and not (isinstance(do_preserve_contained_on_delete_old, bool)):
			raise ValueError(f"'do_preserve_contained_on_delete' of incorrect type. Expected bool, got {type(do_preserve_contained_on_delete_old)}")

		return {'name': 'cntl.role2role.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'role_fq_name': role_fq_name_old, 'contained_role_fq_name': contained_role_fq_name_old, 'do_preserve_contained_on_delete': do_preserve_contained_on_delete_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, role_fq_name_old: str, contained_role_fq_name_old: str, do_preserve_contained_on_delete_old: bool = None) -> list:
		if not (isinstance(role_fq_name_old, str)):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(role_fq_name_old)}")
		if not (isinstance(contained_role_fq_name_old, str)):
			raise ValueError(f"'contained_role_fq_name' of incorrect type. Expected str, got {type(contained_role_fq_name_old)}")
		if do_preserve_contained_on_delete_old is not None and not (isinstance(do_preserve_contained_on_delete_old, bool)):
			raise ValueError(f"'do_preserve_contained_on_delete' of incorrect type. Expected bool, got {type(do_preserve_contained_on_delete_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(role_fq_name_old=role_fq_name_old, contained_role_fq_name_old=contained_role_fq_name_old, do_preserve_contained_on_delete_old=do_preserve_contained_on_delete_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, role_fq_name_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, contained_role_fq_name_old: str = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if role_fq_name_old is not None and not (isinstance(role_fq_name_old, str)):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(role_fq_name_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if contained_role_fq_name_old is not None and not (isinstance(contained_role_fq_name_old, str)):
			raise ValueError(f"'contained_role_fq_name' of incorrect type. Expected str, got {type(contained_role_fq_name_old)}")

		return {'name': 'cntl.role2role.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'role_fq_name': role_fq_name_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'contained_role_fq_name': contained_role_fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, role_fq_name_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, contained_role_fq_name_old: str = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if role_fq_name_old is not None and not (isinstance(role_fq_name_old, str)):
			raise ValueError(f"'role_fq_name' of incorrect type. Expected str, got {type(role_fq_name_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if contained_role_fq_name_old is not None and not (isinstance(contained_role_fq_name_old, str)):
			raise ValueError(f"'contained_role_fq_name' of incorrect type. Expected str, got {type(contained_role_fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, role_fq_name_old=role_fq_name_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, contained_role_fq_name_old=contained_role_fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class GlobalPk2obj(APIObject):
	gpk: str
	object_dict: dict
	object_type_fq_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.object_dict, dict):
			raise ValueError(f"'object_dict' of incorrect type. Expected dict, got {type(self.object_dict)}")
		if not isinstance(self.object_type_fq_name, str):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(self.object_type_fq_name)}")

	@staticmethod
	def list_ta(gpk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, do_only_unqpr_object_attrs_old: bool = False) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if do_only_unqpr_object_attrs_old is not None and not (isinstance(do_only_unqpr_object_attrs_old, bool)):
			raise ValueError(f"'do_only_unqpr_object_attrs' of incorrect type. Expected bool, got {type(do_only_unqpr_object_attrs_old)}")

		return {'name': 'cntl.global_pk2obj.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'do_only_unqpr_object_attrs': do_only_unqpr_object_attrs_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, do_only_unqpr_object_attrs_old: bool = False) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if do_only_unqpr_object_attrs_old is not None and not (isinstance(do_only_unqpr_object_attrs_old, bool)):
			raise ValueError(f"'do_only_unqpr_object_attrs' of incorrect type. Expected bool, got {type(do_only_unqpr_object_attrs_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, do_only_unqpr_object_attrs_old=do_only_unqpr_object_attrs_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Constraint2error(APIObject):
	sqlstate: str
	error_code: int
	constraint_name: str
	error_type_code: int
	constraint_table: str
	parent_key_not_found: bool
	constraint_is_api_level: bool

	def __post_init__(self):
		if not isinstance(self.sqlstate, str):
			raise ValueError(f"'sqlstate' of incorrect type. Expected str, got {type(self.sqlstate)}")
		if not isinstance(self.error_code, int):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(self.error_code)}")
		if not isinstance(self.constraint_name, str):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(self.constraint_name)}")
		if not isinstance(self.error_type_code, int):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(self.error_type_code)}")
		if not isinstance(self.constraint_table, str):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(self.constraint_table)}")
		if self.parent_key_not_found is not None and not isinstance(self.parent_key_not_found, bool):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(self.parent_key_not_found)}")
		if not isinstance(self.constraint_is_api_level, bool):
			raise ValueError(f"'constraint_is_api_level' of incorrect type. Expected bool, got {type(self.constraint_is_api_level)}")

	@staticmethod
	def create_ta(sqlstate_new: str, error_code_new: int, constraint_name_new: str, error_type_code_new: int, constraint_table_new: str, parent_key_not_found_new: Union[bool, ExplicitNull] = None) -> dict:
		if not (isinstance(sqlstate_new, str)):
			raise ValueError(f"'sqlstate' of incorrect type. Expected str, got {type(sqlstate_new)}")
		if not (isinstance(error_code_new, int)):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(error_code_new)}")
		if not (isinstance(constraint_name_new, str)):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(constraint_name_new)}")
		if not (isinstance(error_type_code_new, int)):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(error_type_code_new)}")
		if not (isinstance(constraint_table_new, str)):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(constraint_table_new)}")
		if parent_key_not_found_new is not None and not (isinstance(parent_key_not_found_new, bool) or isinstance(parent_key_not_found_new, ExplicitNull)):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(parent_key_not_found_new)}")

		return {'name': 'cntl.constraint2error.create', 'new': _denullify_dict({'sqlstate': sqlstate_new, 'error_code': error_code_new, 'constraint_name': constraint_name_new, 'error_type_code': error_type_code_new, 'constraint_table': constraint_table_new, 'parent_key_not_found': parent_key_not_found_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, sqlstate_new: str, error_code_new: int, constraint_name_new: str, error_type_code_new: int, constraint_table_new: str, parent_key_not_found_new: Union[bool, ExplicitNull] = None) -> list:
		if not (isinstance(sqlstate_new, str)):
			raise ValueError(f"'sqlstate' of incorrect type. Expected str, got {type(sqlstate_new)}")
		if not (isinstance(error_code_new, int)):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(error_code_new)}")
		if not (isinstance(constraint_name_new, str)):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(constraint_name_new)}")
		if not (isinstance(error_type_code_new, int)):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(error_type_code_new)}")
		if not (isinstance(constraint_table_new, str)):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(constraint_table_new)}")
		if parent_key_not_found_new is not None and not (isinstance(parent_key_not_found_new, bool) or isinstance(parent_key_not_found_new, ExplicitNull)):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(parent_key_not_found_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(sqlstate_new=sqlstate_new, error_code_new=error_code_new, constraint_name_new=constraint_name_new, error_type_code_new=error_type_code_new, constraint_table_new=constraint_table_new, parent_key_not_found_new=parent_key_not_found_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(error_code_old: int, constraint_name_old: str, error_type_code_old: int, constraint_table_old: str, parent_key_not_found_old: bool = None) -> dict:
		if not (isinstance(error_code_old, int)):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(error_code_old)}")
		if not (isinstance(constraint_name_old, str)):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(constraint_name_old)}")
		if not (isinstance(error_type_code_old, int)):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(error_type_code_old)}")
		if not (isinstance(constraint_table_old, str)):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(constraint_table_old)}")
		if parent_key_not_found_old is not None and not (isinstance(parent_key_not_found_old, bool) or isinstance(parent_key_not_found_old, ExplicitNull)):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(parent_key_not_found_old)}")

		return {'name': 'cntl.constraint2error.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'error_code': error_code_old, 'constraint_name': constraint_name_old, 'error_type_code': error_type_code_old, 'constraint_table': constraint_table_old, 'parent_key_not_found': parent_key_not_found_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, error_code_old: int, constraint_name_old: str, error_type_code_old: int, constraint_table_old: str, parent_key_not_found_old: bool = None) -> list:
		if not (isinstance(error_code_old, int)):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(error_code_old)}")
		if not (isinstance(constraint_name_old, str)):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(constraint_name_old)}")
		if not (isinstance(error_type_code_old, int)):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(error_type_code_old)}")
		if not (isinstance(constraint_table_old, str)):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(constraint_table_old)}")
		if parent_key_not_found_old is not None and not (isinstance(parent_key_not_found_old, bool) or isinstance(parent_key_not_found_old, ExplicitNull)):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(parent_key_not_found_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(error_code_old=error_code_old, constraint_name_old=constraint_name_old, error_type_code_old=error_type_code_old, constraint_table_old=constraint_table_old, parent_key_not_found_old=parent_key_not_found_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(sqlstate_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, parent_key_not_found_old: bool = None) -> dict:
		if sqlstate_old is not None and not (isinstance(sqlstate_old, str)):
			raise ValueError(f"'sqlstate' of incorrect type. Expected str, got {type(sqlstate_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if parent_key_not_found_old is not None and not (isinstance(parent_key_not_found_old, bool)):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(parent_key_not_found_old)}")

		return {'name': 'cntl.constraint2error.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'sqlstate': sqlstate_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'parent_key_not_found': parent_key_not_found_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, sqlstate_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, parent_key_not_found_old: bool = None) -> list:
		if sqlstate_old is not None and not (isinstance(sqlstate_old, str)):
			raise ValueError(f"'sqlstate' of incorrect type. Expected str, got {type(sqlstate_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if parent_key_not_found_old is not None and not (isinstance(parent_key_not_found_old, bool)):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(parent_key_not_found_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(sqlstate_old=sqlstate_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, parent_key_not_found_old=parent_key_not_found_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(error_code_old: int, constraint_name_old: str, error_type_code_old: int, constraint_table_old: str, sqlstate_new: str = None, error_code_new: int = None, constraint_name_new: str = None, error_type_code_new: int = None, constraint_table_new: str = None, parent_key_not_found_new: Union[bool, ExplicitNull] = None, parent_key_not_found_old: bool = None) -> dict:
		if sqlstate_new is not None and not (isinstance(sqlstate_new, str)):
			raise ValueError(f"'sqlstate' of incorrect type. Expected str, got {type(sqlstate_new)}")
		if error_code_new is not None and not (isinstance(error_code_new, int)):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(error_code_new)}")
		if constraint_name_new is not None and not (isinstance(constraint_name_new, str)):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(constraint_name_new)}")
		if error_type_code_new is not None and not (isinstance(error_type_code_new, int)):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(error_type_code_new)}")
		if constraint_table_new is not None and not (isinstance(constraint_table_new, str)):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(constraint_table_new)}")
		if parent_key_not_found_new is not None and not (isinstance(parent_key_not_found_new, bool) or isinstance(parent_key_not_found_new, ExplicitNull)):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(parent_key_not_found_new)}")
		if not (isinstance(error_code_old, int)):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(error_code_old)}")
		if not (isinstance(constraint_name_old, str)):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(constraint_name_old)}")
		if not (isinstance(error_type_code_old, int)):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(error_type_code_old)}")
		if not (isinstance(constraint_table_old, str)):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(constraint_table_old)}")
		if parent_key_not_found_old is not None and not (isinstance(parent_key_not_found_old, bool) or isinstance(parent_key_not_found_old, ExplicitNull)):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(parent_key_not_found_old)}")

		return {'name': 'cntl.constraint2error.update', 'new': _denullify_dict({'sqlstate': sqlstate_new, 'error_code': error_code_new, 'constraint_name': constraint_name_new, 'error_type_code': error_type_code_new, 'constraint_table': constraint_table_new, 'parent_key_not_found': parent_key_not_found_new}), 'old': _denullify_dict({'error_code': error_code_old, 'constraint_name': constraint_name_old, 'error_type_code': error_type_code_old, 'constraint_table': constraint_table_old, 'parent_key_not_found': parent_key_not_found_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, error_code_old: int, constraint_name_old: str, error_type_code_old: int, constraint_table_old: str, sqlstate_new: str = None, error_code_new: int = None, constraint_name_new: str = None, error_type_code_new: int = None, constraint_table_new: str = None, parent_key_not_found_new: Union[bool, ExplicitNull] = None, parent_key_not_found_old: bool = None) -> list:
		if sqlstate_new is not None and not (isinstance(sqlstate_new, str)):
			raise ValueError(f"'sqlstate' of incorrect type. Expected str, got {type(sqlstate_new)}")
		if error_code_new is not None and not (isinstance(error_code_new, int)):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(error_code_new)}")
		if constraint_name_new is not None and not (isinstance(constraint_name_new, str)):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(constraint_name_new)}")
		if error_type_code_new is not None and not (isinstance(error_type_code_new, int)):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(error_type_code_new)}")
		if constraint_table_new is not None and not (isinstance(constraint_table_new, str)):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(constraint_table_new)}")
		if parent_key_not_found_new is not None and not (isinstance(parent_key_not_found_new, bool) or isinstance(parent_key_not_found_new, ExplicitNull)):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(parent_key_not_found_new)}")
		if not (isinstance(error_code_old, int)):
			raise ValueError(f"'error_code' of incorrect type. Expected int, got {type(error_code_old)}")
		if not (isinstance(constraint_name_old, str)):
			raise ValueError(f"'constraint_name' of incorrect type. Expected str, got {type(constraint_name_old)}")
		if not (isinstance(error_type_code_old, int)):
			raise ValueError(f"'error_type_code' of incorrect type. Expected int, got {type(error_type_code_old)}")
		if not (isinstance(constraint_table_old, str)):
			raise ValueError(f"'constraint_table' of incorrect type. Expected str, got {type(constraint_table_old)}")
		if parent_key_not_found_old is not None and not (isinstance(parent_key_not_found_old, bool) or isinstance(parent_key_not_found_old, ExplicitNull)):
			raise ValueError(f"'parent_key_not_found' of incorrect type. Expected bool, got {type(parent_key_not_found_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(sqlstate_new=sqlstate_new, error_code_new=error_code_new, constraint_name_new=constraint_name_new, error_type_code_new=error_type_code_new, constraint_table_new=constraint_table_new, parent_key_not_found_new=parent_key_not_found_new, error_code_old=error_code_old, constraint_name_old=constraint_name_old, error_type_code_old=error_type_code_old, constraint_table_old=constraint_table_old, parent_key_not_found_old=parent_key_not_found_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class DataType(APIObject):
	gpk: str
	name: str
	json_name: str
	description: str
	text_length: int
	operator_list: list
	format_literal: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.json_name, str):
			raise ValueError(f"'json_name' of incorrect type. Expected str, got {type(self.json_name)}")
		if not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if self.text_length is not None and not isinstance(self.text_length, int):
			raise ValueError(f"'text_length' of incorrect type. Expected int, got {type(self.text_length)}")
		if not isinstance(self.operator_list, list):
			raise ValueError(f"'operator_list' of incorrect type. Expected list, got {type(self.operator_list)}")
		if self.format_literal is not None and not isinstance(self.format_literal, str):
			raise ValueError(f"'format_literal' of incorrect type. Expected str, got {type(self.format_literal)}")

	@staticmethod
	def list_ta(gpk_old: str = None, json_name_old: str = None, fetch_limit_old: int = None, text_length_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if json_name_old is not None and not (isinstance(json_name_old, str)):
			raise ValueError(f"'json_name' of incorrect type. Expected str, got {type(json_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if text_length_old is not None and not (isinstance(text_length_old, int) or isinstance(text_length_old, ExplicitNull)):
			raise ValueError(f"'text_length' of incorrect type. Expected int, got {type(text_length_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.data_type.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'json_name': json_name_old, 'fetch_limit': fetch_limit_old, 'text_length': text_length_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, json_name_old: str = None, fetch_limit_old: int = None, text_length_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if json_name_old is not None and not (isinstance(json_name_old, str)):
			raise ValueError(f"'json_name' of incorrect type. Expected str, got {type(json_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if text_length_old is not None and not (isinstance(text_length_old, int) or isinstance(text_length_old, ExplicitNull)):
			raise ValueError(f"'text_length' of incorrect type. Expected int, got {type(text_length_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, json_name_old=json_name_old, fetch_limit_old=fetch_limit_old, text_length_old=text_length_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class WapiAuth(APIObject):
	gpk: str
	type: str
	token: str
	is_own: bool
	is_expired: bool
	login_name: str
	delete_date: str
	description: str
	expiration_date: str
	last_login_date: str
	type_description: str
	last_generate_date: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if not isinstance(self.token, str):
			raise ValueError(f"'token' of incorrect type. Expected str, got {type(self.token)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.is_expired, bool):
			raise ValueError(f"'is_expired' of incorrect type. Expected bool, got {type(self.is_expired)}")
		if not isinstance(self.login_name, str):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(self.login_name)}")
		if not isinstance(self.delete_date, str):
			raise ValueError(f"'delete_date' of incorrect type. Expected str, got {type(self.delete_date)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if self.expiration_date is not None and not isinstance(self.expiration_date, str):
			raise ValueError(f"'expiration_date' of incorrect type. Expected str, got {type(self.expiration_date)}")
		if self.last_login_date is not None and not isinstance(self.last_login_date, str):
			raise ValueError(f"'last_login_date' of incorrect type. Expected str, got {type(self.last_login_date)}")
		if not isinstance(self.type_description, str):
			raise ValueError(f"'type_description' of incorrect type. Expected str, got {type(self.type_description)}")
		if not isinstance(self.last_generate_date, str):
			raise ValueError(f"'last_generate_date' of incorrect type. Expected str, got {type(self.last_generate_date)}")

	@staticmethod
	def create_ta(login_name_new: str, description_new: Union[str, ExplicitNull] = None, expiration_date_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(login_name_new, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if expiration_date_new is not None and not (isinstance(expiration_date_new, str) or isinstance(expiration_date_new, ExplicitNull)):
			raise ValueError(f"'expiration_date' of incorrect type. Expected str, got {type(expiration_date_new)}")

		return {'name': 'cntl.wapi_auth.create', 'new': _denullify_dict({'login_name': login_name_new, 'description': description_new, 'expiration_date': expiration_date_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, login_name_new: str, description_new: Union[str, ExplicitNull] = None, expiration_date_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(login_name_new, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if expiration_date_new is not None and not (isinstance(expiration_date_new, str) or isinstance(expiration_date_new, ExplicitNull)):
			raise ValueError(f"'expiration_date' of incorrect type. Expected str, got {type(expiration_date_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(login_name_new=login_name_new, description_new=description_new, expiration_date_new=expiration_date_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'cntl.wapi_auth.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, type_old: str = None, is_own_old: bool = None, is_expired_old: bool = None, login_name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_expired_old is not None and not (isinstance(is_expired_old, bool)):
			raise ValueError(f"'is_expired' of incorrect type. Expected bool, got {type(is_expired_old)}")
		if login_name_old is not None and not (isinstance(login_name_old, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.wapi_auth.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'type': type_old, 'is_own': is_own_old, 'is_expired': is_expired_old, 'login_name': login_name_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, type_old: str = None, is_own_old: bool = None, is_expired_old: bool = None, login_name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_expired_old is not None and not (isinstance(is_expired_old, bool)):
			raise ValueError(f"'is_expired' of incorrect type. Expected bool, got {type(is_expired_old)}")
		if login_name_old is not None and not (isinstance(login_name_old, str)):
			raise ValueError(f"'login_name' of incorrect type. Expected str, got {type(login_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, type_old=type_old, is_own_old=is_own_old, is_expired_old=is_expired_old, login_name_old=login_name_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(gpk_old: str, description_new: Union[str, ExplicitNull] = None, expiration_date_new: Union[str, ExplicitNull] = None, do_refresh_token_new: bool = None) -> dict:
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if expiration_date_new is not None and not (isinstance(expiration_date_new, str) or isinstance(expiration_date_new, ExplicitNull)):
			raise ValueError(f"'expiration_date' of incorrect type. Expected str, got {type(expiration_date_new)}")
		if do_refresh_token_new is not None and not (isinstance(do_refresh_token_new, bool)):
			raise ValueError(f"'do_refresh_token' of incorrect type. Expected bool, got {type(do_refresh_token_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'cntl.wapi_auth.update', 'new': _denullify_dict({'description': description_new, 'expiration_date': expiration_date_new, 'do_refresh_token': do_refresh_token_new}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, gpk_old: str, description_new: Union[str, ExplicitNull] = None, expiration_date_new: Union[str, ExplicitNull] = None, do_refresh_token_new: bool = None) -> list:
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if expiration_date_new is not None and not (isinstance(expiration_date_new, str) or isinstance(expiration_date_new, ExplicitNull)):
			raise ValueError(f"'expiration_date' of incorrect type. Expected str, got {type(expiration_date_new)}")
		if do_refresh_token_new is not None and not (isinstance(do_refresh_token_new, bool)):
			raise ValueError(f"'do_refresh_token' of incorrect type. Expected bool, got {type(do_refresh_token_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(description_new=description_new, expiration_date_new=expiration_date_new, do_refresh_token_new=do_refresh_token_new, gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Mgr2group(APIObject):
	gpk: str
	is_own: bool
	group_name: str
	mgr_login_name: str
	parent_group_name: str
	parent_mgr_login_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.group_name, str):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(self.group_name)}")
		if not isinstance(self.mgr_login_name, str):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(self.mgr_login_name)}")
		if not isinstance(self.parent_group_name, str):
			raise ValueError(f"'parent_group_name' of incorrect type. Expected str, got {type(self.parent_group_name)}")
		if self.parent_mgr_login_name is not None and not isinstance(self.parent_mgr_login_name, str):
			raise ValueError(f"'parent_mgr_login_name' of incorrect type. Expected str, got {type(self.parent_mgr_login_name)}")

	@staticmethod
	def bulk_delete_ta(mgr_login_name_old: str) -> dict:
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")

		return {'name': 'cntl.mgr2group.bulk_delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'mgr_login_name': mgr_login_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def bulk_delete(cls, api_session: APISession, mgr_login_name_old: str) -> list:
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.bulk_delete_ta(mgr_login_name_old=mgr_login_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def bulk_update_ta(ou_short_name_new: str = None, group_name_list_new: list = None, mgr_login_name_list_new: list = None, group_name_old: str = None, ou_short_name_old: str = None, mgr_login_name_old: str = None, group_name_list_old: list = None, mgr_login_name_list_old: list = None) -> dict:
		if ou_short_name_new is not None and not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if group_name_list_new is not None and not (isinstance(group_name_list_new, list)):
			raise ValueError(f"'group_name_list' of incorrect type. Expected list, got {type(group_name_list_new)}")
		if mgr_login_name_list_new is not None and not (isinstance(mgr_login_name_list_new, list)):
			raise ValueError(f"'mgr_login_name_list' of incorrect type. Expected list, got {type(mgr_login_name_list_new)}")
		if group_name_old is not None and not (isinstance(group_name_old, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_old)}")
		if ou_short_name_old is not None and not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")
		if mgr_login_name_old is not None and not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")
		if group_name_list_old is not None and not (isinstance(group_name_list_old, list)):
			raise ValueError(f"'group_name_list' of incorrect type. Expected list, got {type(group_name_list_old)}")
		if mgr_login_name_list_old is not None and not (isinstance(mgr_login_name_list_old, list)):
			raise ValueError(f"'mgr_login_name_list' of incorrect type. Expected list, got {type(mgr_login_name_list_old)}")

		return {'name': 'cntl.mgr2group.bulk_update', 'new': _denullify_dict({'ou_short_name': ou_short_name_new, 'group_name_list': group_name_list_new, 'mgr_login_name_list': mgr_login_name_list_new}), 'old': _denullify_dict({'group_name': group_name_old, 'ou_short_name': ou_short_name_old, 'mgr_login_name': mgr_login_name_old, 'group_name_list': group_name_list_old, 'mgr_login_name_list': mgr_login_name_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def bulk_update(cls, api_session: APISession, ou_short_name_new: str = None, group_name_list_new: list = None, mgr_login_name_list_new: list = None, group_name_old: str = None, ou_short_name_old: str = None, mgr_login_name_old: str = None, group_name_list_old: list = None, mgr_login_name_list_old: list = None) -> list:
		if ou_short_name_new is not None and not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if group_name_list_new is not None and not (isinstance(group_name_list_new, list)):
			raise ValueError(f"'group_name_list' of incorrect type. Expected list, got {type(group_name_list_new)}")
		if mgr_login_name_list_new is not None and not (isinstance(mgr_login_name_list_new, list)):
			raise ValueError(f"'mgr_login_name_list' of incorrect type. Expected list, got {type(mgr_login_name_list_new)}")
		if group_name_old is not None and not (isinstance(group_name_old, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_old)}")
		if ou_short_name_old is not None and not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")
		if mgr_login_name_old is not None and not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")
		if group_name_list_old is not None and not (isinstance(group_name_list_old, list)):
			raise ValueError(f"'group_name_list' of incorrect type. Expected list, got {type(group_name_list_old)}")
		if mgr_login_name_list_old is not None and not (isinstance(mgr_login_name_list_old, list)):
			raise ValueError(f"'mgr_login_name_list' of incorrect type. Expected list, got {type(mgr_login_name_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.bulk_update_ta(ou_short_name_new=ou_short_name_new, group_name_list_new=group_name_list_new, mgr_login_name_list_new=mgr_login_name_list_new, group_name_old=group_name_old, ou_short_name_old=ou_short_name_old, mgr_login_name_old=mgr_login_name_old, group_name_list_old=group_name_list_old, mgr_login_name_list_old=mgr_login_name_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def copy_ta(copy_mgr_login_name_new: str = None, copy_mgr_login_name_old: str = None) -> dict:
		if copy_mgr_login_name_new is not None and not (isinstance(copy_mgr_login_name_new, str)):
			raise ValueError(f"'copy_mgr_login_name' of incorrect type. Expected str, got {type(copy_mgr_login_name_new)}")
		if copy_mgr_login_name_old is not None and not (isinstance(copy_mgr_login_name_old, str)):
			raise ValueError(f"'copy_mgr_login_name' of incorrect type. Expected str, got {type(copy_mgr_login_name_old)}")

		return {'name': 'cntl.mgr2group.copy', 'new': _denullify_dict({'copy_mgr_login_name': copy_mgr_login_name_new}), 'old': _denullify_dict({'copy_mgr_login_name': copy_mgr_login_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def copy(cls, api_session: APISession, copy_mgr_login_name_new: str = None, copy_mgr_login_name_old: str = None) -> list:
		if copy_mgr_login_name_new is not None and not (isinstance(copy_mgr_login_name_new, str)):
			raise ValueError(f"'copy_mgr_login_name' of incorrect type. Expected str, got {type(copy_mgr_login_name_new)}")
		if copy_mgr_login_name_old is not None and not (isinstance(copy_mgr_login_name_old, str)):
			raise ValueError(f"'copy_mgr_login_name' of incorrect type. Expected str, got {type(copy_mgr_login_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.copy_ta(copy_mgr_login_name_new=copy_mgr_login_name_new, copy_mgr_login_name_old=copy_mgr_login_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def create_ta(group_name_new: str, mgr_login_name_new: str) -> dict:
		if not (isinstance(group_name_new, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_new)}")
		if not (isinstance(mgr_login_name_new, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_new)}")

		return {'name': 'cntl.mgr2group.create', 'new': _denullify_dict({'group_name': group_name_new, 'mgr_login_name': mgr_login_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, group_name_new: str, mgr_login_name_new: str) -> list:
		if not (isinstance(group_name_new, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_new)}")
		if not (isinstance(mgr_login_name_new, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(group_name_new=group_name_new, mgr_login_name_new=mgr_login_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(group_name_old: str, mgr_login_name_old: str) -> dict:
		if not (isinstance(group_name_old, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_old)}")
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")

		return {'name': 'cntl.mgr2group.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'group_name': group_name_old, 'mgr_login_name': mgr_login_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, group_name_old: str, mgr_login_name_old: str) -> list:
		if not (isinstance(group_name_old, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_old)}")
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(group_name_old=group_name_old, mgr_login_name_old=mgr_login_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, is_own_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, group_name_list_old: list = None, filter_params_dict_old: dict = None, mgr_login_name_list_old: list = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if group_name_list_old is not None and not (isinstance(group_name_list_old, list)):
			raise ValueError(f"'group_name_list' of incorrect type. Expected list, got {type(group_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if mgr_login_name_list_old is not None and not (isinstance(mgr_login_name_list_old, list)):
			raise ValueError(f"'mgr_login_name_list' of incorrect type. Expected list, got {type(mgr_login_name_list_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.mgr2group.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_own': is_own_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'group_name_list': group_name_list_old, 'filter_params_dict': filter_params_dict_old, 'mgr_login_name_list': mgr_login_name_list_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_own_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, group_name_list_old: list = None, filter_params_dict_old: dict = None, mgr_login_name_list_old: list = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if group_name_list_old is not None and not (isinstance(group_name_list_old, list)):
			raise ValueError(f"'group_name_list' of incorrect type. Expected list, got {type(group_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if mgr_login_name_list_old is not None and not (isinstance(mgr_login_name_list_old, list)):
			raise ValueError(f"'mgr_login_name_list' of incorrect type. Expected list, got {type(mgr_login_name_list_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_own_old=is_own_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, group_name_list_old=group_name_list_old, filter_params_dict_old=filter_params_dict_old, mgr_login_name_list_old=mgr_login_name_list_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Group(APIObject):
	gpk: str
	name: str
	is_own: bool
	is_admin: bool
	bcd_count: int
	mgr_count: int
	fqdn_count: int
	description: str
	do_idm_sync: bool
	parent_name: str
	is_sub_group: bool
	ou_short_name: str
	idm_description: str
	idm_sync_last_ts: str
	idm_sync_is_active: bool
	idm_sync_last_state: str
	idm_sync_max_mgr_count: int
	idm_sync_last_successful_ts: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.is_admin, bool):
			raise ValueError(f"'is_admin' of incorrect type. Expected bool, got {type(self.is_admin)}")
		if not isinstance(self.bcd_count, int):
			raise ValueError(f"'bcd_count' of incorrect type. Expected int, got {type(self.bcd_count)}")
		if not isinstance(self.mgr_count, int):
			raise ValueError(f"'mgr_count' of incorrect type. Expected int, got {type(self.mgr_count)}")
		if not isinstance(self.fqdn_count, int):
			raise ValueError(f"'fqdn_count' of incorrect type. Expected int, got {type(self.fqdn_count)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.do_idm_sync, bool):
			raise ValueError(f"'do_idm_sync' of incorrect type. Expected bool, got {type(self.do_idm_sync)}")
		if not isinstance(self.parent_name, str):
			raise ValueError(f"'parent_name' of incorrect type. Expected str, got {type(self.parent_name)}")
		if not isinstance(self.is_sub_group, bool):
			raise ValueError(f"'is_sub_group' of incorrect type. Expected bool, got {type(self.is_sub_group)}")
		if self.ou_short_name is not None and not isinstance(self.ou_short_name, str):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(self.ou_short_name)}")
		if self.idm_description is not None and not isinstance(self.idm_description, str):
			raise ValueError(f"'idm_description' of incorrect type. Expected str, got {type(self.idm_description)}")
		if self.idm_sync_last_ts is not None and not isinstance(self.idm_sync_last_ts, str):
			raise ValueError(f"'idm_sync_last_ts' of incorrect type. Expected str, got {type(self.idm_sync_last_ts)}")
		if not isinstance(self.idm_sync_is_active, bool):
			raise ValueError(f"'idm_sync_is_active' of incorrect type. Expected bool, got {type(self.idm_sync_is_active)}")
		if self.idm_sync_last_state is not None and not isinstance(self.idm_sync_last_state, str):
			raise ValueError(f"'idm_sync_last_state' of incorrect type. Expected str, got {type(self.idm_sync_last_state)}")
		if not isinstance(self.idm_sync_max_mgr_count, int):
			raise ValueError(f"'idm_sync_max_mgr_count' of incorrect type. Expected int, got {type(self.idm_sync_max_mgr_count)}")
		if self.idm_sync_last_successful_ts is not None and not isinstance(self.idm_sync_last_successful_ts, str):
			raise ValueError(f"'idm_sync_last_successful_ts' of incorrect type. Expected str, got {type(self.idm_sync_last_successful_ts)}")

	@staticmethod
	def create_ta(name_new: str = None, description_new: Union[str, ExplicitNull] = None, do_idm_sync_new: bool = False, parent_name_new: str = None, ou_short_name_new: str = None, do_copy_assignments_new: bool = True, do_refresh_idm_sync_new: bool = None, idm_sync_max_mgr_count_new: int = 20) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if do_idm_sync_new is not None and not (isinstance(do_idm_sync_new, bool)):
			raise ValueError(f"'do_idm_sync' of incorrect type. Expected bool, got {type(do_idm_sync_new)}")
		if parent_name_new is not None and not (isinstance(parent_name_new, str)):
			raise ValueError(f"'parent_name' of incorrect type. Expected str, got {type(parent_name_new)}")
		if ou_short_name_new is not None and not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if do_copy_assignments_new is not None and not (isinstance(do_copy_assignments_new, bool)):
			raise ValueError(f"'do_copy_assignments' of incorrect type. Expected bool, got {type(do_copy_assignments_new)}")
		if do_refresh_idm_sync_new is not None and not (isinstance(do_refresh_idm_sync_new, bool)):
			raise ValueError(f"'do_refresh_idm_sync' of incorrect type. Expected bool, got {type(do_refresh_idm_sync_new)}")
		if idm_sync_max_mgr_count_new is not None and not (isinstance(idm_sync_max_mgr_count_new, int)):
			raise ValueError(f"'idm_sync_max_mgr_count' of incorrect type. Expected int, got {type(idm_sync_max_mgr_count_new)}")

		return {'name': 'cntl.group.create', 'new': _denullify_dict({'name': name_new, 'description': description_new, 'do_idm_sync': do_idm_sync_new, 'parent_name': parent_name_new, 'ou_short_name': ou_short_name_new, 'do_copy_assignments': do_copy_assignments_new, 'do_refresh_idm_sync': do_refresh_idm_sync_new, 'idm_sync_max_mgr_count': idm_sync_max_mgr_count_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str = None, description_new: Union[str, ExplicitNull] = None, do_idm_sync_new: bool = False, parent_name_new: str = None, ou_short_name_new: str = None, do_copy_assignments_new: bool = True, do_refresh_idm_sync_new: bool = None, idm_sync_max_mgr_count_new: int = 20) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if do_idm_sync_new is not None and not (isinstance(do_idm_sync_new, bool)):
			raise ValueError(f"'do_idm_sync' of incorrect type. Expected bool, got {type(do_idm_sync_new)}")
		if parent_name_new is not None and not (isinstance(parent_name_new, str)):
			raise ValueError(f"'parent_name' of incorrect type. Expected str, got {type(parent_name_new)}")
		if ou_short_name_new is not None and not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if do_copy_assignments_new is not None and not (isinstance(do_copy_assignments_new, bool)):
			raise ValueError(f"'do_copy_assignments' of incorrect type. Expected bool, got {type(do_copy_assignments_new)}")
		if do_refresh_idm_sync_new is not None and not (isinstance(do_refresh_idm_sync_new, bool)):
			raise ValueError(f"'do_refresh_idm_sync' of incorrect type. Expected bool, got {type(do_refresh_idm_sync_new)}")
		if idm_sync_max_mgr_count_new is not None and not (isinstance(idm_sync_max_mgr_count_new, int)):
			raise ValueError(f"'idm_sync_max_mgr_count' of incorrect type. Expected int, got {type(idm_sync_max_mgr_count_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, description_new=description_new, do_idm_sync_new=do_idm_sync_new, parent_name_new=parent_name_new, ou_short_name_new=ou_short_name_new, do_copy_assignments_new=do_copy_assignments_new, do_refresh_idm_sync_new=do_refresh_idm_sync_new, idm_sync_max_mgr_count_new=idm_sync_max_mgr_count_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'cntl.group.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, is_own_old: bool = None, has_bcd_old: bool = None, has_mgr_old: bool = None, has_fqdn_old: bool = None, is_admin_old: bool = None, name_list_old: list = None, do_idm_sync_old: bool = None, fetch_limit_old: int = None, name_regexp_old: str = None, fetch_offset_old: int = None, is_sub_group_old: bool = None, ou_short_name_old: str = None, filter_params_dict_old: dict = None, idm_sync_is_active_old: bool = None, is_admin_or_is_own_old: bool = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str) or isinstance(name_old, ExplicitNull)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if has_bcd_old is not None and not (isinstance(has_bcd_old, bool)):
			raise ValueError(f"'has_bcd' of incorrect type. Expected bool, got {type(has_bcd_old)}")
		if has_mgr_old is not None and not (isinstance(has_mgr_old, bool)):
			raise ValueError(f"'has_mgr' of incorrect type. Expected bool, got {type(has_mgr_old)}")
		if has_fqdn_old is not None and not (isinstance(has_fqdn_old, bool)):
			raise ValueError(f"'has_fqdn' of incorrect type. Expected bool, got {type(has_fqdn_old)}")
		if is_admin_old is not None and not (isinstance(is_admin_old, bool)):
			raise ValueError(f"'is_admin' of incorrect type. Expected bool, got {type(is_admin_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if do_idm_sync_old is not None and not (isinstance(do_idm_sync_old, bool)):
			raise ValueError(f"'do_idm_sync' of incorrect type. Expected bool, got {type(do_idm_sync_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if name_regexp_old is not None and not (isinstance(name_regexp_old, str)):
			raise ValueError(f"'name_regexp' of incorrect type. Expected str, got {type(name_regexp_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_sub_group_old is not None and not (isinstance(is_sub_group_old, bool)):
			raise ValueError(f"'is_sub_group' of incorrect type. Expected bool, got {type(is_sub_group_old)}")
		if ou_short_name_old is not None and not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if idm_sync_is_active_old is not None and not (isinstance(idm_sync_is_active_old, bool)):
			raise ValueError(f"'idm_sync_is_active' of incorrect type. Expected bool, got {type(idm_sync_is_active_old)}")
		if is_admin_or_is_own_old is not None and not (isinstance(is_admin_or_is_own_old, bool)):
			raise ValueError(f"'is_admin_or_is_own' of incorrect type. Expected bool, got {type(is_admin_or_is_own_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.group.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'is_own': is_own_old, 'has_bcd': has_bcd_old, 'has_mgr': has_mgr_old, 'has_fqdn': has_fqdn_old, 'is_admin': is_admin_old, 'name_list': name_list_old, 'do_idm_sync': do_idm_sync_old, 'fetch_limit': fetch_limit_old, 'name_regexp': name_regexp_old, 'fetch_offset': fetch_offset_old, 'is_sub_group': is_sub_group_old, 'ou_short_name': ou_short_name_old, 'filter_params_dict': filter_params_dict_old, 'idm_sync_is_active': idm_sync_is_active_old, 'is_admin_or_is_own': is_admin_or_is_own_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, is_own_old: bool = None, has_bcd_old: bool = None, has_mgr_old: bool = None, has_fqdn_old: bool = None, is_admin_old: bool = None, name_list_old: list = None, do_idm_sync_old: bool = None, fetch_limit_old: int = None, name_regexp_old: str = None, fetch_offset_old: int = None, is_sub_group_old: bool = None, ou_short_name_old: str = None, filter_params_dict_old: dict = None, idm_sync_is_active_old: bool = None, is_admin_or_is_own_old: bool = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str) or isinstance(name_old, ExplicitNull)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if has_bcd_old is not None and not (isinstance(has_bcd_old, bool)):
			raise ValueError(f"'has_bcd' of incorrect type. Expected bool, got {type(has_bcd_old)}")
		if has_mgr_old is not None and not (isinstance(has_mgr_old, bool)):
			raise ValueError(f"'has_mgr' of incorrect type. Expected bool, got {type(has_mgr_old)}")
		if has_fqdn_old is not None and not (isinstance(has_fqdn_old, bool)):
			raise ValueError(f"'has_fqdn' of incorrect type. Expected bool, got {type(has_fqdn_old)}")
		if is_admin_old is not None and not (isinstance(is_admin_old, bool)):
			raise ValueError(f"'is_admin' of incorrect type. Expected bool, got {type(is_admin_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if do_idm_sync_old is not None and not (isinstance(do_idm_sync_old, bool)):
			raise ValueError(f"'do_idm_sync' of incorrect type. Expected bool, got {type(do_idm_sync_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if name_regexp_old is not None and not (isinstance(name_regexp_old, str)):
			raise ValueError(f"'name_regexp' of incorrect type. Expected str, got {type(name_regexp_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_sub_group_old is not None and not (isinstance(is_sub_group_old, bool)):
			raise ValueError(f"'is_sub_group' of incorrect type. Expected bool, got {type(is_sub_group_old)}")
		if ou_short_name_old is not None and not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if idm_sync_is_active_old is not None and not (isinstance(idm_sync_is_active_old, bool)):
			raise ValueError(f"'idm_sync_is_active' of incorrect type. Expected bool, got {type(idm_sync_is_active_old)}")
		if is_admin_or_is_own_old is not None and not (isinstance(is_admin_or_is_own_old, bool)):
			raise ValueError(f"'is_admin_or_is_own' of incorrect type. Expected bool, got {type(is_admin_or_is_own_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, is_own_old=is_own_old, has_bcd_old=has_bcd_old, has_mgr_old=has_mgr_old, has_fqdn_old=has_fqdn_old, is_admin_old=is_admin_old, name_list_old=name_list_old, do_idm_sync_old=do_idm_sync_old, fetch_limit_old=fetch_limit_old, name_regexp_old=name_regexp_old, fetch_offset_old=fetch_offset_old, is_sub_group_old=is_sub_group_old, ou_short_name_old=ou_short_name_old, filter_params_dict_old=filter_params_dict_old, idm_sync_is_active_old=idm_sync_is_active_old, is_admin_or_is_own_old=is_admin_or_is_own_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, description_new: Union[str, ExplicitNull] = None, do_idm_sync_new: bool = None, ou_short_name_new: str = None, do_refresh_idm_sync_new: bool = None, idm_sync_max_mgr_count_new: int = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if do_idm_sync_new is not None and not (isinstance(do_idm_sync_new, bool)):
			raise ValueError(f"'do_idm_sync' of incorrect type. Expected bool, got {type(do_idm_sync_new)}")
		if ou_short_name_new is not None and not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if do_refresh_idm_sync_new is not None and not (isinstance(do_refresh_idm_sync_new, bool)):
			raise ValueError(f"'do_refresh_idm_sync' of incorrect type. Expected bool, got {type(do_refresh_idm_sync_new)}")
		if idm_sync_max_mgr_count_new is not None and not (isinstance(idm_sync_max_mgr_count_new, int)):
			raise ValueError(f"'idm_sync_max_mgr_count' of incorrect type. Expected int, got {type(idm_sync_max_mgr_count_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'cntl.group.update', 'new': _denullify_dict({'name': name_new, 'description': description_new, 'do_idm_sync': do_idm_sync_new, 'ou_short_name': ou_short_name_new, 'do_refresh_idm_sync': do_refresh_idm_sync_new, 'idm_sync_max_mgr_count': idm_sync_max_mgr_count_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, description_new: Union[str, ExplicitNull] = None, do_idm_sync_new: bool = None, ou_short_name_new: str = None, do_refresh_idm_sync_new: bool = None, idm_sync_max_mgr_count_new: int = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if do_idm_sync_new is not None and not (isinstance(do_idm_sync_new, bool)):
			raise ValueError(f"'do_idm_sync' of incorrect type. Expected bool, got {type(do_idm_sync_new)}")
		if ou_short_name_new is not None and not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if do_refresh_idm_sync_new is not None and not (isinstance(do_refresh_idm_sync_new, bool)):
			raise ValueError(f"'do_refresh_idm_sync' of incorrect type. Expected bool, got {type(do_refresh_idm_sync_new)}")
		if idm_sync_max_mgr_count_new is not None and not (isinstance(idm_sync_max_mgr_count_new, int)):
			raise ValueError(f"'idm_sync_max_mgr_count' of incorrect type. Expected int, got {type(idm_sync_max_mgr_count_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, description_new=description_new, do_idm_sync_new=do_idm_sync_new, ou_short_name_new=ou_short_name_new, do_refresh_idm_sync_new=do_refresh_idm_sync_new, idm_sync_max_mgr_count_new=idm_sync_max_mgr_count_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Mgr2ou(APIObject):
	gpk: str
	is_own: bool
	ou_short_name: str
	is_sub_account: bool
	mgr_login_name: str
	parent_ou_short_name: str
	parent_mgr_login_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.ou_short_name, str):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(self.ou_short_name)}")
		if not isinstance(self.is_sub_account, bool):
			raise ValueError(f"'is_sub_account' of incorrect type. Expected bool, got {type(self.is_sub_account)}")
		if not isinstance(self.mgr_login_name, str):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(self.mgr_login_name)}")
		if not isinstance(self.parent_ou_short_name, str):
			raise ValueError(f"'parent_ou_short_name' of incorrect type. Expected str, got {type(self.parent_ou_short_name)}")
		if not isinstance(self.parent_mgr_login_name, str):
			raise ValueError(f"'parent_mgr_login_name' of incorrect type. Expected str, got {type(self.parent_mgr_login_name)}")

	@staticmethod
	def create_ta(ou_short_name_new: str, mgr_login_name_new: str) -> dict:
		if not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if not (isinstance(mgr_login_name_new, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_new)}")

		return {'name': 'cntl.mgr2ou.create', 'new': _denullify_dict({'ou_short_name': ou_short_name_new, 'mgr_login_name': mgr_login_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, ou_short_name_new: str, mgr_login_name_new: str) -> list:
		if not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if not (isinstance(mgr_login_name_new, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(ou_short_name_new=ou_short_name_new, mgr_login_name_new=mgr_login_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(ou_short_name_old: str, mgr_login_name_old: str) -> dict:
		if not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")

		return {'name': 'cntl.mgr2ou.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'ou_short_name': ou_short_name_old, 'mgr_login_name': mgr_login_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, ou_short_name_old: str, mgr_login_name_old: str) -> list:
		if not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(ou_short_name_old=ou_short_name_old, mgr_login_name_old=mgr_login_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, is_own_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_sub_account_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_sub_account_old is not None and not (isinstance(is_sub_account_old, bool)):
			raise ValueError(f"'is_sub_account' of incorrect type. Expected bool, got {type(is_sub_account_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.mgr2ou.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_own': is_own_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'is_sub_account': is_sub_account_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_own_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_sub_account_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_sub_account_old is not None and not (isinstance(is_sub_account_old, bool)):
			raise ValueError(f"'is_sub_account' of incorrect type. Expected bool, got {type(is_sub_account_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_own_old=is_own_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, is_sub_account_old=is_sub_account_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(ou_short_name_new: str, ou_short_name_old: str, mgr_login_name_old: str) -> dict:
		if not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")

		return {'name': 'cntl.mgr2ou.update', 'new': _denullify_dict({'ou_short_name': ou_short_name_new}), 'old': _denullify_dict({'ou_short_name': ou_short_name_old, 'mgr_login_name': mgr_login_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, ou_short_name_new: str, ou_short_name_old: str, mgr_login_name_old: str) -> list:
		if not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")
		if not (isinstance(mgr_login_name_old, str)):
			raise ValueError(f"'mgr_login_name' of incorrect type. Expected str, got {type(mgr_login_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(ou_short_name_new=ou_short_name_new, ou_short_name_old=ou_short_name_old, mgr_login_name_old=mgr_login_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class OtAttrDef(APIObject):
	name: str
	key_word: str
	data_type: str
	description: str
	object_type_fq_name: str
	ins_trg_func_fq_name: str
	upd_trg_func_fq_name: str
	ref_object_type_fq_name: str
	object_type_ref_attribute_name: str

	def __post_init__(self):
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.key_word, str):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(self.key_word)}")
		if not isinstance(self.data_type, str):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(self.data_type)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.object_type_fq_name, str):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(self.object_type_fq_name)}")
		if self.ins_trg_func_fq_name is not None and not isinstance(self.ins_trg_func_fq_name, str):
			raise ValueError(f"'ins_trg_func_fq_name' of incorrect type. Expected str, got {type(self.ins_trg_func_fq_name)}")
		if self.upd_trg_func_fq_name is not None and not isinstance(self.upd_trg_func_fq_name, str):
			raise ValueError(f"'upd_trg_func_fq_name' of incorrect type. Expected str, got {type(self.upd_trg_func_fq_name)}")
		if not isinstance(self.ref_object_type_fq_name, str):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(self.ref_object_type_fq_name)}")
		if not isinstance(self.object_type_ref_attribute_name, str):
			raise ValueError(f"'object_type_ref_attribute_name' of incorrect type. Expected str, got {type(self.object_type_ref_attribute_name)}")

	@staticmethod
	def create_ta(name_new: str, key_word_new: str, data_type_new: str, object_type_fq_name_new: str, ref_object_type_fq_name_new: str, object_type_ref_attribute_name_new: str, description_new: Union[str, ExplicitNull] = None, ins_trg_func_fq_name_new: Union[str, ExplicitNull] = None, upd_trg_func_fq_name_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(key_word_new, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_new)}")
		if not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")
		if ins_trg_func_fq_name_new is not None and not (isinstance(ins_trg_func_fq_name_new, str) or isinstance(ins_trg_func_fq_name_new, ExplicitNull)):
			raise ValueError(f"'ins_trg_func_fq_name' of incorrect type. Expected str, got {type(ins_trg_func_fq_name_new)}")
		if upd_trg_func_fq_name_new is not None and not (isinstance(upd_trg_func_fq_name_new, str) or isinstance(upd_trg_func_fq_name_new, ExplicitNull)):
			raise ValueError(f"'upd_trg_func_fq_name' of incorrect type. Expected str, got {type(upd_trg_func_fq_name_new)}")
		if not (isinstance(ref_object_type_fq_name_new, str)):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(ref_object_type_fq_name_new)}")
		if not (isinstance(object_type_ref_attribute_name_new, str)):
			raise ValueError(f"'object_type_ref_attribute_name' of incorrect type. Expected str, got {type(object_type_ref_attribute_name_new)}")

		return {'name': 'cntl.ot_attr_def.create', 'new': _denullify_dict({'name': name_new, 'key_word': key_word_new, 'data_type': data_type_new, 'description': description_new, 'object_type_fq_name': object_type_fq_name_new, 'ins_trg_func_fq_name': ins_trg_func_fq_name_new, 'upd_trg_func_fq_name': upd_trg_func_fq_name_new, 'ref_object_type_fq_name': ref_object_type_fq_name_new, 'object_type_ref_attribute_name': object_type_ref_attribute_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, key_word_new: str, data_type_new: str, object_type_fq_name_new: str, ref_object_type_fq_name_new: str, object_type_ref_attribute_name_new: str, description_new: Union[str, ExplicitNull] = None, ins_trg_func_fq_name_new: Union[str, ExplicitNull] = None, upd_trg_func_fq_name_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(key_word_new, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_new)}")
		if not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")
		if ins_trg_func_fq_name_new is not None and not (isinstance(ins_trg_func_fq_name_new, str) or isinstance(ins_trg_func_fq_name_new, ExplicitNull)):
			raise ValueError(f"'ins_trg_func_fq_name' of incorrect type. Expected str, got {type(ins_trg_func_fq_name_new)}")
		if upd_trg_func_fq_name_new is not None and not (isinstance(upd_trg_func_fq_name_new, str) or isinstance(upd_trg_func_fq_name_new, ExplicitNull)):
			raise ValueError(f"'upd_trg_func_fq_name' of incorrect type. Expected str, got {type(upd_trg_func_fq_name_new)}")
		if not (isinstance(ref_object_type_fq_name_new, str)):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(ref_object_type_fq_name_new)}")
		if not (isinstance(object_type_ref_attribute_name_new, str)):
			raise ValueError(f"'object_type_ref_attribute_name' of incorrect type. Expected str, got {type(object_type_ref_attribute_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, key_word_new=key_word_new, data_type_new=data_type_new, description_new=description_new, object_type_fq_name_new=object_type_fq_name_new, ins_trg_func_fq_name_new=ins_trg_func_fq_name_new, upd_trg_func_fq_name_new=upd_trg_func_fq_name_new, ref_object_type_fq_name_new=ref_object_type_fq_name_new, object_type_ref_attribute_name_new=object_type_ref_attribute_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(key_word_old: str, object_type_fq_name_old: str) -> dict:
		if not (isinstance(key_word_old, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")

		return {'name': 'cntl.ot_attr_def.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'key_word': key_word_old, 'object_type_fq_name': object_type_fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, key_word_old: str, object_type_fq_name_old: str) -> list:
		if not (isinstance(key_word_old, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(key_word_old=key_word_old, object_type_fq_name_old=object_type_fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(key_word_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, object_type_fq_name_old: str = None, sorting_params_list_old: list = None, ref_object_type_fq_name_old: str = None) -> dict:
		if key_word_old is not None and not (isinstance(key_word_old, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if object_type_fq_name_old is not None and not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if ref_object_type_fq_name_old is not None and not (isinstance(ref_object_type_fq_name_old, str)):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(ref_object_type_fq_name_old)}")

		return {'name': 'cntl.ot_attr_def.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'key_word': key_word_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'object_type_fq_name': object_type_fq_name_old, 'sorting_params_list': sorting_params_list_old, 'ref_object_type_fq_name': ref_object_type_fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, key_word_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, object_type_fq_name_old: str = None, sorting_params_list_old: list = None, ref_object_type_fq_name_old: str = None) -> list:
		if key_word_old is not None and not (isinstance(key_word_old, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if object_type_fq_name_old is not None and not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if ref_object_type_fq_name_old is not None and not (isinstance(ref_object_type_fq_name_old, str)):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(ref_object_type_fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(key_word_old=key_word_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, object_type_fq_name_old=object_type_fq_name_old, sorting_params_list_old=sorting_params_list_old, ref_object_type_fq_name_old=ref_object_type_fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(key_word_old: str, object_type_fq_name_old: str, name_new: str = None, key_word_new: str = None, data_type_new: str = None, description_new: Union[str, ExplicitNull] = None, object_type_fq_name_new: str = None, ins_trg_func_fq_name_new: Union[str, ExplicitNull] = None, upd_trg_func_fq_name_new: Union[str, ExplicitNull] = None, ref_object_type_fq_name_new: str = None, object_type_ref_attribute_name_new: str = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if key_word_new is not None and not (isinstance(key_word_new, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_new)}")
		if data_type_new is not None and not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if object_type_fq_name_new is not None and not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")
		if ins_trg_func_fq_name_new is not None and not (isinstance(ins_trg_func_fq_name_new, str) or isinstance(ins_trg_func_fq_name_new, ExplicitNull)):
			raise ValueError(f"'ins_trg_func_fq_name' of incorrect type. Expected str, got {type(ins_trg_func_fq_name_new)}")
		if upd_trg_func_fq_name_new is not None and not (isinstance(upd_trg_func_fq_name_new, str) or isinstance(upd_trg_func_fq_name_new, ExplicitNull)):
			raise ValueError(f"'upd_trg_func_fq_name' of incorrect type. Expected str, got {type(upd_trg_func_fq_name_new)}")
		if ref_object_type_fq_name_new is not None and not (isinstance(ref_object_type_fq_name_new, str)):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(ref_object_type_fq_name_new)}")
		if object_type_ref_attribute_name_new is not None and not (isinstance(object_type_ref_attribute_name_new, str)):
			raise ValueError(f"'object_type_ref_attribute_name' of incorrect type. Expected str, got {type(object_type_ref_attribute_name_new)}")
		if not (isinstance(key_word_old, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")

		return {'name': 'cntl.ot_attr_def.update', 'new': _denullify_dict({'name': name_new, 'key_word': key_word_new, 'data_type': data_type_new, 'description': description_new, 'object_type_fq_name': object_type_fq_name_new, 'ins_trg_func_fq_name': ins_trg_func_fq_name_new, 'upd_trg_func_fq_name': upd_trg_func_fq_name_new, 'ref_object_type_fq_name': ref_object_type_fq_name_new, 'object_type_ref_attribute_name': object_type_ref_attribute_name_new}), 'old': _denullify_dict({'key_word': key_word_old, 'object_type_fq_name': object_type_fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, key_word_old: str, object_type_fq_name_old: str, name_new: str = None, key_word_new: str = None, data_type_new: str = None, description_new: Union[str, ExplicitNull] = None, object_type_fq_name_new: str = None, ins_trg_func_fq_name_new: Union[str, ExplicitNull] = None, upd_trg_func_fq_name_new: Union[str, ExplicitNull] = None, ref_object_type_fq_name_new: str = None, object_type_ref_attribute_name_new: str = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if key_word_new is not None and not (isinstance(key_word_new, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_new)}")
		if data_type_new is not None and not (isinstance(data_type_new, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if object_type_fq_name_new is not None and not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")
		if ins_trg_func_fq_name_new is not None and not (isinstance(ins_trg_func_fq_name_new, str) or isinstance(ins_trg_func_fq_name_new, ExplicitNull)):
			raise ValueError(f"'ins_trg_func_fq_name' of incorrect type. Expected str, got {type(ins_trg_func_fq_name_new)}")
		if upd_trg_func_fq_name_new is not None and not (isinstance(upd_trg_func_fq_name_new, str) or isinstance(upd_trg_func_fq_name_new, ExplicitNull)):
			raise ValueError(f"'upd_trg_func_fq_name' of incorrect type. Expected str, got {type(upd_trg_func_fq_name_new)}")
		if ref_object_type_fq_name_new is not None and not (isinstance(ref_object_type_fq_name_new, str)):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(ref_object_type_fq_name_new)}")
		if object_type_ref_attribute_name_new is not None and not (isinstance(object_type_ref_attribute_name_new, str)):
			raise ValueError(f"'object_type_ref_attribute_name' of incorrect type. Expected str, got {type(object_type_ref_attribute_name_new)}")
		if not (isinstance(key_word_old, str)):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(key_word_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, key_word_new=key_word_new, data_type_new=data_type_new, description_new=description_new, object_type_fq_name_new=object_type_fq_name_new, ins_trg_func_fq_name_new=ins_trg_func_fq_name_new, upd_trg_func_fq_name_new=upd_trg_func_fq_name_new, ref_object_type_fq_name_new=ref_object_type_fq_name_new, object_type_ref_attribute_name_new=object_type_ref_attribute_name_new, key_word_old=key_word_old, object_type_fq_name_old=object_type_fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class OtAttrKey(APIObject):
	set_mode: int
	display_mode: int
	default_value: str
	val_is_unique: bool
	ref_object_gfk: str
	val_is_nullable: bool
	display_position: int
	permission_fq_name: str
	object_type_fq_name: str
	ot_attr_def_key_word: str
	set_mode_description: str
	ref_object_type_fq_name: str
	display_mode_description: str

	def __post_init__(self):
		if not isinstance(self.set_mode, int):
			raise ValueError(f"'set_mode' of incorrect type. Expected int, got {type(self.set_mode)}")
		if not isinstance(self.display_mode, int):
			raise ValueError(f"'display_mode' of incorrect type. Expected int, got {type(self.display_mode)}")
		if self.default_value is not None and not isinstance(self.default_value, str):
			raise ValueError(f"'default_value' of incorrect type. Expected str, got {type(self.default_value)}")
		if not isinstance(self.val_is_unique, bool):
			raise ValueError(f"'val_is_unique' of incorrect type. Expected bool, got {type(self.val_is_unique)}")
		if self.ref_object_gfk is not None and not isinstance(self.ref_object_gfk, str):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(self.ref_object_gfk)}")
		if not isinstance(self.val_is_nullable, bool):
			raise ValueError(f"'val_is_nullable' of incorrect type. Expected bool, got {type(self.val_is_nullable)}")
		if not isinstance(self.display_position, int):
			raise ValueError(f"'display_position' of incorrect type. Expected int, got {type(self.display_position)}")
		if self.permission_fq_name is not None and not isinstance(self.permission_fq_name, str):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(self.permission_fq_name)}")
		if not isinstance(self.object_type_fq_name, str):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(self.object_type_fq_name)}")
		if not isinstance(self.ot_attr_def_key_word, str):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(self.ot_attr_def_key_word)}")
		if not isinstance(self.set_mode_description, str):
			raise ValueError(f"'set_mode_description' of incorrect type. Expected str, got {type(self.set_mode_description)}")
		if not isinstance(self.ref_object_type_fq_name, str):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(self.ref_object_type_fq_name)}")
		if not isinstance(self.display_mode_description, str):
			raise ValueError(f"'display_mode_description' of incorrect type. Expected str, got {type(self.display_mode_description)}")

	@staticmethod
	def create_ta(display_position_new: int, object_type_fq_name_new: str, ot_attr_def_key_word_new: str, set_mode_new: int = 0, display_mode_new: int = 0, default_value_new: Union[str, ExplicitNull] = None, val_is_unique_new: bool = False, ref_object_gfk_new: Union[str, ExplicitNull] = None, val_is_nullable_new: bool = True, permission_fq_name_new: Union[str, ExplicitNull] = None) -> dict:
		if set_mode_new is not None and not (isinstance(set_mode_new, int)):
			raise ValueError(f"'set_mode' of incorrect type. Expected int, got {type(set_mode_new)}")
		if display_mode_new is not None and not (isinstance(display_mode_new, int)):
			raise ValueError(f"'display_mode' of incorrect type. Expected int, got {type(display_mode_new)}")
		if default_value_new is not None and not (isinstance(default_value_new, str) or isinstance(default_value_new, ExplicitNull)):
			raise ValueError(f"'default_value' of incorrect type. Expected str, got {type(default_value_new)}")
		if val_is_unique_new is not None and not (isinstance(val_is_unique_new, bool)):
			raise ValueError(f"'val_is_unique' of incorrect type. Expected bool, got {type(val_is_unique_new)}")
		if ref_object_gfk_new is not None and not (isinstance(ref_object_gfk_new, str) or isinstance(ref_object_gfk_new, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_new)}")
		if val_is_nullable_new is not None and not (isinstance(val_is_nullable_new, bool)):
			raise ValueError(f"'val_is_nullable' of incorrect type. Expected bool, got {type(val_is_nullable_new)}")
		if not (isinstance(display_position_new, int)):
			raise ValueError(f"'display_position' of incorrect type. Expected int, got {type(display_position_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str) or isinstance(permission_fq_name_new, ExplicitNull)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")
		if not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")
		if not (isinstance(ot_attr_def_key_word_new, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_new)}")

		return {'name': 'cntl.ot_attr_key.create', 'new': _denullify_dict({'set_mode': set_mode_new, 'display_mode': display_mode_new, 'default_value': default_value_new, 'val_is_unique': val_is_unique_new, 'ref_object_gfk': ref_object_gfk_new, 'val_is_nullable': val_is_nullable_new, 'display_position': display_position_new, 'permission_fq_name': permission_fq_name_new, 'object_type_fq_name': object_type_fq_name_new, 'ot_attr_def_key_word': ot_attr_def_key_word_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, display_position_new: int, object_type_fq_name_new: str, ot_attr_def_key_word_new: str, set_mode_new: int = 0, display_mode_new: int = 0, default_value_new: Union[str, ExplicitNull] = None, val_is_unique_new: bool = False, ref_object_gfk_new: Union[str, ExplicitNull] = None, val_is_nullable_new: bool = True, permission_fq_name_new: Union[str, ExplicitNull] = None) -> list:
		if set_mode_new is not None and not (isinstance(set_mode_new, int)):
			raise ValueError(f"'set_mode' of incorrect type. Expected int, got {type(set_mode_new)}")
		if display_mode_new is not None and not (isinstance(display_mode_new, int)):
			raise ValueError(f"'display_mode' of incorrect type. Expected int, got {type(display_mode_new)}")
		if default_value_new is not None and not (isinstance(default_value_new, str) or isinstance(default_value_new, ExplicitNull)):
			raise ValueError(f"'default_value' of incorrect type. Expected str, got {type(default_value_new)}")
		if val_is_unique_new is not None and not (isinstance(val_is_unique_new, bool)):
			raise ValueError(f"'val_is_unique' of incorrect type. Expected bool, got {type(val_is_unique_new)}")
		if ref_object_gfk_new is not None and not (isinstance(ref_object_gfk_new, str) or isinstance(ref_object_gfk_new, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_new)}")
		if val_is_nullable_new is not None and not (isinstance(val_is_nullable_new, bool)):
			raise ValueError(f"'val_is_nullable' of incorrect type. Expected bool, got {type(val_is_nullable_new)}")
		if not (isinstance(display_position_new, int)):
			raise ValueError(f"'display_position' of incorrect type. Expected int, got {type(display_position_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str) or isinstance(permission_fq_name_new, ExplicitNull)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")
		if not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")
		if not (isinstance(ot_attr_def_key_word_new, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(set_mode_new=set_mode_new, display_mode_new=display_mode_new, default_value_new=default_value_new, val_is_unique_new=val_is_unique_new, ref_object_gfk_new=ref_object_gfk_new, val_is_nullable_new=val_is_nullable_new, display_position_new=display_position_new, permission_fq_name_new=permission_fq_name_new, object_type_fq_name_new=object_type_fq_name_new, ot_attr_def_key_word_new=ot_attr_def_key_word_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(object_type_fq_name_old: str, ot_attr_def_key_word_old: str, ref_object_gfk_old: str = None) -> dict:
		if ref_object_gfk_old is not None and not (isinstance(ref_object_gfk_old, str) or isinstance(ref_object_gfk_old, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if not (isinstance(ot_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_old)}")

		return {'name': 'cntl.ot_attr_key.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'ref_object_gfk': ref_object_gfk_old, 'object_type_fq_name': object_type_fq_name_old, 'ot_attr_def_key_word': ot_attr_def_key_word_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, object_type_fq_name_old: str, ot_attr_def_key_word_old: str, ref_object_gfk_old: str = None) -> list:
		if ref_object_gfk_old is not None and not (isinstance(ref_object_gfk_old, str) or isinstance(ref_object_gfk_old, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if not (isinstance(ot_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(ref_object_gfk_old=ref_object_gfk_old, object_type_fq_name_old=object_type_fq_name_old, ot_attr_def_key_word_old=ot_attr_def_key_word_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(fetch_limit_old: int = None, fetch_offset_old: int = None, ref_object_gfk_old: str = None, filter_params_dict_old: dict = None, object_type_fq_name_old: str = None, sorting_params_list_old: list = None, ot_attr_def_key_word_old: str = None, ref_object_type_fq_name_old: str = None) -> dict:
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if ref_object_gfk_old is not None and not (isinstance(ref_object_gfk_old, str) or isinstance(ref_object_gfk_old, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if object_type_fq_name_old is not None and not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if ot_attr_def_key_word_old is not None and not (isinstance(ot_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_old)}")
		if ref_object_type_fq_name_old is not None and not (isinstance(ref_object_type_fq_name_old, str)):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(ref_object_type_fq_name_old)}")

		return {'name': 'cntl.ot_attr_key.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'ref_object_gfk': ref_object_gfk_old, 'filter_params_dict': filter_params_dict_old, 'object_type_fq_name': object_type_fq_name_old, 'sorting_params_list': sorting_params_list_old, 'ot_attr_def_key_word': ot_attr_def_key_word_old, 'ref_object_type_fq_name': ref_object_type_fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, fetch_limit_old: int = None, fetch_offset_old: int = None, ref_object_gfk_old: str = None, filter_params_dict_old: dict = None, object_type_fq_name_old: str = None, sorting_params_list_old: list = None, ot_attr_def_key_word_old: str = None, ref_object_type_fq_name_old: str = None) -> list:
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if ref_object_gfk_old is not None and not (isinstance(ref_object_gfk_old, str) or isinstance(ref_object_gfk_old, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if object_type_fq_name_old is not None and not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if ot_attr_def_key_word_old is not None and not (isinstance(ot_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_old)}")
		if ref_object_type_fq_name_old is not None and not (isinstance(ref_object_type_fq_name_old, str)):
			raise ValueError(f"'ref_object_type_fq_name' of incorrect type. Expected str, got {type(ref_object_type_fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, ref_object_gfk_old=ref_object_gfk_old, filter_params_dict_old=filter_params_dict_old, object_type_fq_name_old=object_type_fq_name_old, sorting_params_list_old=sorting_params_list_old, ot_attr_def_key_word_old=ot_attr_def_key_word_old, ref_object_type_fq_name_old=ref_object_type_fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(object_type_fq_name_old: str, ot_attr_def_key_word_old: str, set_mode_new: int = None, display_mode_new: int = None, default_value_new: Union[str, ExplicitNull] = None, val_is_unique_new: bool = None, ref_object_gfk_new: Union[str, ExplicitNull] = None, val_is_nullable_new: bool = None, display_position_new: int = None, permission_fq_name_new: Union[str, ExplicitNull] = None, object_type_fq_name_new: str = None, ot_attr_def_key_word_new: str = None, ref_object_gfk_old: str = None) -> dict:
		if set_mode_new is not None and not (isinstance(set_mode_new, int)):
			raise ValueError(f"'set_mode' of incorrect type. Expected int, got {type(set_mode_new)}")
		if display_mode_new is not None and not (isinstance(display_mode_new, int)):
			raise ValueError(f"'display_mode' of incorrect type. Expected int, got {type(display_mode_new)}")
		if default_value_new is not None and not (isinstance(default_value_new, str) or isinstance(default_value_new, ExplicitNull)):
			raise ValueError(f"'default_value' of incorrect type. Expected str, got {type(default_value_new)}")
		if val_is_unique_new is not None and not (isinstance(val_is_unique_new, bool)):
			raise ValueError(f"'val_is_unique' of incorrect type. Expected bool, got {type(val_is_unique_new)}")
		if ref_object_gfk_new is not None and not (isinstance(ref_object_gfk_new, str) or isinstance(ref_object_gfk_new, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_new)}")
		if val_is_nullable_new is not None and not (isinstance(val_is_nullable_new, bool)):
			raise ValueError(f"'val_is_nullable' of incorrect type. Expected bool, got {type(val_is_nullable_new)}")
		if display_position_new is not None and not (isinstance(display_position_new, int)):
			raise ValueError(f"'display_position' of incorrect type. Expected int, got {type(display_position_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str) or isinstance(permission_fq_name_new, ExplicitNull)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")
		if object_type_fq_name_new is not None and not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")
		if ot_attr_def_key_word_new is not None and not (isinstance(ot_attr_def_key_word_new, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_new)}")
		if ref_object_gfk_old is not None and not (isinstance(ref_object_gfk_old, str) or isinstance(ref_object_gfk_old, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if not (isinstance(ot_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_old)}")

		return {'name': 'cntl.ot_attr_key.update', 'new': _denullify_dict({'set_mode': set_mode_new, 'display_mode': display_mode_new, 'default_value': default_value_new, 'val_is_unique': val_is_unique_new, 'ref_object_gfk': ref_object_gfk_new, 'val_is_nullable': val_is_nullable_new, 'display_position': display_position_new, 'permission_fq_name': permission_fq_name_new, 'object_type_fq_name': object_type_fq_name_new, 'ot_attr_def_key_word': ot_attr_def_key_word_new}), 'old': _denullify_dict({'ref_object_gfk': ref_object_gfk_old, 'object_type_fq_name': object_type_fq_name_old, 'ot_attr_def_key_word': ot_attr_def_key_word_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, object_type_fq_name_old: str, ot_attr_def_key_word_old: str, set_mode_new: int = None, display_mode_new: int = None, default_value_new: Union[str, ExplicitNull] = None, val_is_unique_new: bool = None, ref_object_gfk_new: Union[str, ExplicitNull] = None, val_is_nullable_new: bool = None, display_position_new: int = None, permission_fq_name_new: Union[str, ExplicitNull] = None, object_type_fq_name_new: str = None, ot_attr_def_key_word_new: str = None, ref_object_gfk_old: str = None) -> list:
		if set_mode_new is not None and not (isinstance(set_mode_new, int)):
			raise ValueError(f"'set_mode' of incorrect type. Expected int, got {type(set_mode_new)}")
		if display_mode_new is not None and not (isinstance(display_mode_new, int)):
			raise ValueError(f"'display_mode' of incorrect type. Expected int, got {type(display_mode_new)}")
		if default_value_new is not None and not (isinstance(default_value_new, str) or isinstance(default_value_new, ExplicitNull)):
			raise ValueError(f"'default_value' of incorrect type. Expected str, got {type(default_value_new)}")
		if val_is_unique_new is not None and not (isinstance(val_is_unique_new, bool)):
			raise ValueError(f"'val_is_unique' of incorrect type. Expected bool, got {type(val_is_unique_new)}")
		if ref_object_gfk_new is not None and not (isinstance(ref_object_gfk_new, str) or isinstance(ref_object_gfk_new, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_new)}")
		if val_is_nullable_new is not None and not (isinstance(val_is_nullable_new, bool)):
			raise ValueError(f"'val_is_nullable' of incorrect type. Expected bool, got {type(val_is_nullable_new)}")
		if display_position_new is not None and not (isinstance(display_position_new, int)):
			raise ValueError(f"'display_position' of incorrect type. Expected int, got {type(display_position_new)}")
		if permission_fq_name_new is not None and not (isinstance(permission_fq_name_new, str) or isinstance(permission_fq_name_new, ExplicitNull)):
			raise ValueError(f"'permission_fq_name' of incorrect type. Expected str, got {type(permission_fq_name_new)}")
		if object_type_fq_name_new is not None and not (isinstance(object_type_fq_name_new, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_new)}")
		if ot_attr_def_key_word_new is not None and not (isinstance(ot_attr_def_key_word_new, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_new)}")
		if ref_object_gfk_old is not None and not (isinstance(ref_object_gfk_old, str) or isinstance(ref_object_gfk_old, ExplicitNull)):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(ref_object_gfk_old)}")
		if not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if not (isinstance(ot_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(set_mode_new=set_mode_new, display_mode_new=display_mode_new, default_value_new=default_value_new, val_is_unique_new=val_is_unique_new, ref_object_gfk_new=ref_object_gfk_new, val_is_nullable_new=val_is_nullable_new, display_position_new=display_position_new, permission_fq_name_new=permission_fq_name_new, object_type_fq_name_new=object_type_fq_name_new, ot_attr_def_key_word_new=ot_attr_def_key_word_new, ref_object_gfk_old=ref_object_gfk_old, object_type_fq_name_old=object_type_fq_name_old, ot_attr_def_key_word_old=ot_attr_def_key_word_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class OtAttrVal(APIObject):
	value: str
	data_type: str
	object_gfk: str
	ref_object_gfk: str
	object_type_fq_name: str
	ot_attr_def_key_word: str

	def __post_init__(self):
		if self.value is not None and not isinstance(self.value, str):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(self.value)}")
		if not isinstance(self.data_type, str):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(self.data_type)}")
		if not isinstance(self.object_gfk, str):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(self.object_gfk)}")
		if self.ref_object_gfk is not None and not isinstance(self.ref_object_gfk, str):
			raise ValueError(f"'ref_object_gfk' of incorrect type. Expected str, got {type(self.ref_object_gfk)}")
		if not isinstance(self.object_type_fq_name, str):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(self.object_type_fq_name)}")
		if not isinstance(self.ot_attr_def_key_word, str):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(self.ot_attr_def_key_word)}")

	@staticmethod
	def bulk_update_ta(key_val_dict_new: dict, object_gfk_old: str) -> dict:
		if not (isinstance(key_val_dict_new, dict)):
			raise ValueError(f"'key_val_dict' of incorrect type. Expected dict, got {type(key_val_dict_new)}")
		if not (isinstance(object_gfk_old, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_old)}")

		return {'name': 'cntl.ot_attr_val.bulk_update', 'new': _denullify_dict({'key_val_dict': key_val_dict_new}), 'old': _denullify_dict({'object_gfk': object_gfk_old})}

	# TODO: Consider is_returning
	@classmethod
	def bulk_update(cls, api_session: APISession, key_val_dict_new: dict, object_gfk_old: str) -> list:
		if not (isinstance(key_val_dict_new, dict)):
			raise ValueError(f"'key_val_dict' of incorrect type. Expected dict, got {type(key_val_dict_new)}")
		if not (isinstance(object_gfk_old, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.bulk_update_ta(key_val_dict_new=key_val_dict_new, object_gfk_old=object_gfk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(value_old: str = None, object_gfk_old: str = None, fetch_limit_old: int = None, value_range_old: str = None, fetch_offset_old: int = None, value_operator_old: str = None, filter_params_dict_old: dict = None, object_type_fq_name_old: str = None, sorting_params_list_old: list = None, ot_attr_def_key_word_old: str = None, ot_attr_def_key_word_list_old: list = None) -> dict:
		if value_old is not None and not (isinstance(value_old, str) or isinstance(value_old, ExplicitNull)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")
		if object_gfk_old is not None and not (isinstance(object_gfk_old, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if value_range_old is not None and not (isinstance(value_range_old, str)):
			raise ValueError(f"'value_range' of incorrect type. Expected str, got {type(value_range_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if value_operator_old is not None and not (isinstance(value_operator_old, str)):
			raise ValueError(f"'value_operator' of incorrect type. Expected str, got {type(value_operator_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if object_type_fq_name_old is not None and not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if ot_attr_def_key_word_old is not None and not (isinstance(ot_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_old)}")
		if ot_attr_def_key_word_list_old is not None and not (isinstance(ot_attr_def_key_word_list_old, list)):
			raise ValueError(f"'ot_attr_def_key_word_list' of incorrect type. Expected list, got {type(ot_attr_def_key_word_list_old)}")

		return {'name': 'cntl.ot_attr_val.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'value': value_old, 'object_gfk': object_gfk_old, 'fetch_limit': fetch_limit_old, 'value_range': value_range_old, 'fetch_offset': fetch_offset_old, 'value_operator': value_operator_old, 'filter_params_dict': filter_params_dict_old, 'object_type_fq_name': object_type_fq_name_old, 'sorting_params_list': sorting_params_list_old, 'ot_attr_def_key_word': ot_attr_def_key_word_old, 'ot_attr_def_key_word_list': ot_attr_def_key_word_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, value_old: str = None, object_gfk_old: str = None, fetch_limit_old: int = None, value_range_old: str = None, fetch_offset_old: int = None, value_operator_old: str = None, filter_params_dict_old: dict = None, object_type_fq_name_old: str = None, sorting_params_list_old: list = None, ot_attr_def_key_word_old: str = None, ot_attr_def_key_word_list_old: list = None) -> list:
		if value_old is not None and not (isinstance(value_old, str) or isinstance(value_old, ExplicitNull)):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(value_old)}")
		if object_gfk_old is not None and not (isinstance(object_gfk_old, str)):
			raise ValueError(f"'object_gfk' of incorrect type. Expected str, got {type(object_gfk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if value_range_old is not None and not (isinstance(value_range_old, str)):
			raise ValueError(f"'value_range' of incorrect type. Expected str, got {type(value_range_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if value_operator_old is not None and not (isinstance(value_operator_old, str)):
			raise ValueError(f"'value_operator' of incorrect type. Expected str, got {type(value_operator_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if object_type_fq_name_old is not None and not (isinstance(object_type_fq_name_old, str)):
			raise ValueError(f"'object_type_fq_name' of incorrect type. Expected str, got {type(object_type_fq_name_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if ot_attr_def_key_word_old is not None and not (isinstance(ot_attr_def_key_word_old, str)):
			raise ValueError(f"'ot_attr_def_key_word' of incorrect type. Expected str, got {type(ot_attr_def_key_word_old)}")
		if ot_attr_def_key_word_list_old is not None and not (isinstance(ot_attr_def_key_word_list_old, list)):
			raise ValueError(f"'ot_attr_def_key_word_list' of incorrect type. Expected list, got {type(ot_attr_def_key_word_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(value_old=value_old, object_gfk_old=object_gfk_old, fetch_limit_old=fetch_limit_old, value_range_old=value_range_old, fetch_offset_old=fetch_offset_old, value_operator_old=value_operator_old, filter_params_dict_old=filter_params_dict_old, object_type_fq_name_old=object_type_fq_name_old, sorting_params_list_old=sorting_params_list_old, ot_attr_def_key_word_old=ot_attr_def_key_word_old, ot_attr_def_key_word_list_old=ot_attr_def_key_word_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class DataTypeOperator(APIObject):
	gpk: str
	name: str
	data_type_list: list

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.data_type_list, list):
			raise ValueError(f"'data_type_list' of incorrect type. Expected list, got {type(self.data_type_list)}")

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, data_type_old: str = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if data_type_old is not None and not (isinstance(data_type_old, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_old)}")

		return {'name': 'cntl.__data_type_operator.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'data_type': data_type_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, data_type_old: str = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if data_type_old is not None and not (isinstance(data_type_old, str)):
			raise ValueError(f"'data_type' of incorrect type. Expected str, got {type(data_type_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, data_type_old=data_type_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Replication(APIObject):
	gpk: str
	name: str
	oper_mode: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.oper_mode, str):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(self.oper_mode)}")

	@staticmethod
	def create_ta(name_new: str, oper_mode_new: str) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(oper_mode_new, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_new)}")

		return {'name': 'cntl.replication.create', 'new': _denullify_dict({'name': name_new, 'oper_mode': oper_mode_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, oper_mode_new: str) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(oper_mode_new, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, oper_mode_new=oper_mode_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str, oper_mode_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(oper_mode_old, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_old)}")

		return {'name': 'cntl.replication.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old, 'oper_mode': oper_mode_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str, oper_mode_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(oper_mode_old, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old, oper_mode_old=oper_mode_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, oper_mode_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if oper_mode_old is not None and not (isinstance(oper_mode_old, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'cntl.replication.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'oper_mode': oper_mode_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, oper_mode_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if oper_mode_old is not None and not (isinstance(oper_mode_old, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, oper_mode_old=oper_mode_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, oper_mode_old: str, name_new: str = None, oper_mode_new: str = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if oper_mode_new is not None and not (isinstance(oper_mode_new, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(oper_mode_old, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_old)}")

		return {'name': 'cntl.replication.update', 'new': _denullify_dict({'name': name_new, 'oper_mode': oper_mode_new}), 'old': _denullify_dict({'name': name_old, 'oper_mode': oper_mode_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, oper_mode_old: str, name_new: str = None, oper_mode_new: str = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if oper_mode_new is not None and not (isinstance(oper_mode_new, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if not (isinstance(oper_mode_old, str)):
			raise ValueError(f"'oper_mode' of incorrect type. Expected str, got {type(oper_mode_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, oper_mode_new=oper_mode_new, name_old=name_old, oper_mode_old=oper_mode_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class ReplicationPub2sub(APIObject):
	gpk: str
	do_init: bool
	publisher_fqdn: str
	subscriber_fqdn: str
	replication_name: str
	replication_oper_mode: str
	replication_slot_suffix: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.do_init, bool):
			raise ValueError(f"'do_init' of incorrect type. Expected bool, got {type(self.do_init)}")
		if not isinstance(self.publisher_fqdn, str):
			raise ValueError(f"'publisher_fqdn' of incorrect type. Expected str, got {type(self.publisher_fqdn)}")
		if not isinstance(self.subscriber_fqdn, str):
			raise ValueError(f"'subscriber_fqdn' of incorrect type. Expected str, got {type(self.subscriber_fqdn)}")
		if not isinstance(self.replication_name, str):
			raise ValueError(f"'replication_name' of incorrect type. Expected str, got {type(self.replication_name)}")
		if not isinstance(self.replication_oper_mode, str):
			raise ValueError(f"'replication_oper_mode' of incorrect type. Expected str, got {type(self.replication_oper_mode)}")
		if not isinstance(self.replication_slot_suffix, str):
			raise ValueError(f"'replication_slot_suffix' of incorrect type. Expected str, got {type(self.replication_slot_suffix)}")

	@staticmethod
	def create_ta(publisher_fqdn_new: str, subscriber_fqdn_new: str, replication_name_new: str, replication_oper_mode_new: str, replication_slot_suffix_new: str, do_init_new: bool = True) -> dict:
		if do_init_new is not None and not (isinstance(do_init_new, bool)):
			raise ValueError(f"'do_init' of incorrect type. Expected bool, got {type(do_init_new)}")
		if not (isinstance(publisher_fqdn_new, str)):
			raise ValueError(f"'publisher_fqdn' of incorrect type. Expected str, got {type(publisher_fqdn_new)}")
		if not (isinstance(subscriber_fqdn_new, str)):
			raise ValueError(f"'subscriber_fqdn' of incorrect type. Expected str, got {type(subscriber_fqdn_new)}")
		if not (isinstance(replication_name_new, str)):
			raise ValueError(f"'replication_name' of incorrect type. Expected str, got {type(replication_name_new)}")
		if not (isinstance(replication_oper_mode_new, str)):
			raise ValueError(f"'replication_oper_mode' of incorrect type. Expected str, got {type(replication_oper_mode_new)}")
		if not (isinstance(replication_slot_suffix_new, str)):
			raise ValueError(f"'replication_slot_suffix' of incorrect type. Expected str, got {type(replication_slot_suffix_new)}")

		return {'name': 'cntl.replication_pub2sub.create', 'new': _denullify_dict({'do_init': do_init_new, 'publisher_fqdn': publisher_fqdn_new, 'subscriber_fqdn': subscriber_fqdn_new, 'replication_name': replication_name_new, 'replication_oper_mode': replication_oper_mode_new, 'replication_slot_suffix': replication_slot_suffix_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, publisher_fqdn_new: str, subscriber_fqdn_new: str, replication_name_new: str, replication_oper_mode_new: str, replication_slot_suffix_new: str, do_init_new: bool = True) -> list:
		if do_init_new is not None and not (isinstance(do_init_new, bool)):
			raise ValueError(f"'do_init' of incorrect type. Expected bool, got {type(do_init_new)}")
		if not (isinstance(publisher_fqdn_new, str)):
			raise ValueError(f"'publisher_fqdn' of incorrect type. Expected str, got {type(publisher_fqdn_new)}")
		if not (isinstance(subscriber_fqdn_new, str)):
			raise ValueError(f"'subscriber_fqdn' of incorrect type. Expected str, got {type(subscriber_fqdn_new)}")
		if not (isinstance(replication_name_new, str)):
			raise ValueError(f"'replication_name' of incorrect type. Expected str, got {type(replication_name_new)}")
		if not (isinstance(replication_oper_mode_new, str)):
			raise ValueError(f"'replication_oper_mode' of incorrect type. Expected str, got {type(replication_oper_mode_new)}")
		if not (isinstance(replication_slot_suffix_new, str)):
			raise ValueError(f"'replication_slot_suffix' of incorrect type. Expected str, got {type(replication_slot_suffix_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(do_init_new=do_init_new, publisher_fqdn_new=publisher_fqdn_new, subscriber_fqdn_new=subscriber_fqdn_new, replication_name_new=replication_name_new, replication_oper_mode_new=replication_oper_mode_new, replication_slot_suffix_new=replication_slot_suffix_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'cntl.replication_pub2sub.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, do_init_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, publisher_fqdn_old: str = None, replication_name_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, replication_oper_mode_old: str = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if do_init_old is not None and not (isinstance(do_init_old, bool)):
			raise ValueError(f"'do_init' of incorrect type. Expected bool, got {type(do_init_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if publisher_fqdn_old is not None and not (isinstance(publisher_fqdn_old, str)):
			raise ValueError(f"'publisher_fqdn' of incorrect type. Expected str, got {type(publisher_fqdn_old)}")
		if replication_name_old is not None and not (isinstance(replication_name_old, str)):
			raise ValueError(f"'replication_name' of incorrect type. Expected str, got {type(replication_name_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if replication_oper_mode_old is not None and not (isinstance(replication_oper_mode_old, str)):
			raise ValueError(f"'replication_oper_mode' of incorrect type. Expected str, got {type(replication_oper_mode_old)}")

		return {'name': 'cntl.replication_pub2sub.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'do_init': do_init_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'publisher_fqdn': publisher_fqdn_old, 'replication_name': replication_name_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'replication_oper_mode': replication_oper_mode_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, do_init_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, publisher_fqdn_old: str = None, replication_name_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, replication_oper_mode_old: str = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if do_init_old is not None and not (isinstance(do_init_old, bool)):
			raise ValueError(f"'do_init' of incorrect type. Expected bool, got {type(do_init_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if publisher_fqdn_old is not None and not (isinstance(publisher_fqdn_old, str)):
			raise ValueError(f"'publisher_fqdn' of incorrect type. Expected str, got {type(publisher_fqdn_old)}")
		if replication_name_old is not None and not (isinstance(replication_name_old, str)):
			raise ValueError(f"'replication_name' of incorrect type. Expected str, got {type(replication_name_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if replication_oper_mode_old is not None and not (isinstance(replication_oper_mode_old, str)):
			raise ValueError(f"'replication_oper_mode' of incorrect type. Expected str, got {type(replication_oper_mode_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, do_init_old=do_init_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, publisher_fqdn_old=publisher_fqdn_old, replication_name_old=replication_name_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, replication_oper_mode_old=replication_oper_mode_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(gpk_old: str, do_init_new: bool = None, publisher_fqdn_new: str = None, subscriber_fqdn_new: str = None, replication_name_new: str = None, do_init_is_recursive_new: bool = False, replication_oper_mode_new: str = None, replication_slot_suffix_new: str = None) -> dict:
		if do_init_new is not None and not (isinstance(do_init_new, bool)):
			raise ValueError(f"'do_init' of incorrect type. Expected bool, got {type(do_init_new)}")
		if publisher_fqdn_new is not None and not (isinstance(publisher_fqdn_new, str)):
			raise ValueError(f"'publisher_fqdn' of incorrect type. Expected str, got {type(publisher_fqdn_new)}")
		if subscriber_fqdn_new is not None and not (isinstance(subscriber_fqdn_new, str)):
			raise ValueError(f"'subscriber_fqdn' of incorrect type. Expected str, got {type(subscriber_fqdn_new)}")
		if replication_name_new is not None and not (isinstance(replication_name_new, str)):
			raise ValueError(f"'replication_name' of incorrect type. Expected str, got {type(replication_name_new)}")
		if do_init_is_recursive_new is not None and not (isinstance(do_init_is_recursive_new, bool)):
			raise ValueError(f"'do_init_is_recursive' of incorrect type. Expected bool, got {type(do_init_is_recursive_new)}")
		if replication_oper_mode_new is not None and not (isinstance(replication_oper_mode_new, str)):
			raise ValueError(f"'replication_oper_mode' of incorrect type. Expected str, got {type(replication_oper_mode_new)}")
		if replication_slot_suffix_new is not None and not (isinstance(replication_slot_suffix_new, str)):
			raise ValueError(f"'replication_slot_suffix' of incorrect type. Expected str, got {type(replication_slot_suffix_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'cntl.replication_pub2sub.update', 'new': _denullify_dict({'do_init': do_init_new, 'publisher_fqdn': publisher_fqdn_new, 'subscriber_fqdn': subscriber_fqdn_new, 'replication_name': replication_name_new, 'do_init_is_recursive': do_init_is_recursive_new, 'replication_oper_mode': replication_oper_mode_new, 'replication_slot_suffix': replication_slot_suffix_new}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, gpk_old: str, do_init_new: bool = None, publisher_fqdn_new: str = None, subscriber_fqdn_new: str = None, replication_name_new: str = None, do_init_is_recursive_new: bool = False, replication_oper_mode_new: str = None, replication_slot_suffix_new: str = None) -> list:
		if do_init_new is not None and not (isinstance(do_init_new, bool)):
			raise ValueError(f"'do_init' of incorrect type. Expected bool, got {type(do_init_new)}")
		if publisher_fqdn_new is not None and not (isinstance(publisher_fqdn_new, str)):
			raise ValueError(f"'publisher_fqdn' of incorrect type. Expected str, got {type(publisher_fqdn_new)}")
		if subscriber_fqdn_new is not None and not (isinstance(subscriber_fqdn_new, str)):
			raise ValueError(f"'subscriber_fqdn' of incorrect type. Expected str, got {type(subscriber_fqdn_new)}")
		if replication_name_new is not None and not (isinstance(replication_name_new, str)):
			raise ValueError(f"'replication_name' of incorrect type. Expected str, got {type(replication_name_new)}")
		if do_init_is_recursive_new is not None and not (isinstance(do_init_is_recursive_new, bool)):
			raise ValueError(f"'do_init_is_recursive' of incorrect type. Expected bool, got {type(do_init_is_recursive_new)}")
		if replication_oper_mode_new is not None and not (isinstance(replication_oper_mode_new, str)):
			raise ValueError(f"'replication_oper_mode' of incorrect type. Expected str, got {type(replication_oper_mode_new)}")
		if replication_slot_suffix_new is not None and not (isinstance(replication_slot_suffix_new, str)):
			raise ValueError(f"'replication_slot_suffix' of incorrect type. Expected str, got {type(replication_slot_suffix_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(do_init_new=do_init_new, publisher_fqdn_new=publisher_fqdn_new, subscriber_fqdn_new=subscriber_fqdn_new, replication_name_new=replication_name_new, do_init_is_recursive_new=do_init_is_recursive_new, replication_oper_mode_new=replication_oper_mode_new, replication_slot_suffix_new=replication_slot_suffix_new, gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]
