### AUTOGENERATED
from . import _denullify_dict
from . import *
from dataclasses import dataclass
from typing import Union


@dataclass()
class IpSubnet(APIObject):
	bcd: str
	gpk: str
	cidr: str
	type: str
	is_own: bool
	is_private: bool
	description: str
	is_routable: bool
	is_container: bool
	default_gateway: str
	dhcp_lease_count: int
	dns_addr_rr_count: int
	dhcp_ip_addr_count: int
	dns_addr_rsv_count: int
	is_iana_registered: bool
	auto_create_ip_address: bool

	def __post_init__(self):
		if not isinstance(self.bcd, str):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(self.bcd)}")
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.cidr, str):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(self.cidr)}")
		if not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.is_private, bool):
			raise ValueError(f"'is_private' of incorrect type. Expected bool, got {type(self.is_private)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.is_routable, bool):
			raise ValueError(f"'is_routable' of incorrect type. Expected bool, got {type(self.is_routable)}")
		if not isinstance(self.is_container, bool):
			raise ValueError(f"'is_container' of incorrect type. Expected bool, got {type(self.is_container)}")
		if self.default_gateway is not None and not isinstance(self.default_gateway, str):
			raise ValueError(f"'default_gateway' of incorrect type. Expected str, got {type(self.default_gateway)}")
		if not isinstance(self.dhcp_lease_count, int):
			raise ValueError(f"'dhcp_lease_count' of incorrect type. Expected int, got {type(self.dhcp_lease_count)}")
		if not isinstance(self.dns_addr_rr_count, int):
			raise ValueError(f"'dns_addr_rr_count' of incorrect type. Expected int, got {type(self.dns_addr_rr_count)}")
		if not isinstance(self.dhcp_ip_addr_count, int):
			raise ValueError(f"'dhcp_ip_addr_count' of incorrect type. Expected int, got {type(self.dhcp_ip_addr_count)}")
		if not isinstance(self.dns_addr_rsv_count, int):
			raise ValueError(f"'dns_addr_rsv_count' of incorrect type. Expected int, got {type(self.dns_addr_rsv_count)}")
		if not isinstance(self.is_iana_registered, bool):
			raise ValueError(f"'is_iana_registered' of incorrect type. Expected bool, got {type(self.is_iana_registered)}")
		if not isinstance(self.auto_create_ip_address, bool):
			raise ValueError(f"'auto_create_ip_address' of incorrect type. Expected bool, got {type(self.auto_create_ip_address)}")

	@staticmethod
	def create_ta(bcd_new: str, cidr_new: str, description_new: Union[str, ExplicitNull] = None, is_routable_new: bool = True, is_container_new: bool = False, create_ipaddrs_new: bool = True, default_gateway_new: Union[str, ExplicitNull] = None, is_iana_registered_new: bool = False, auto_create_ip_address_new: bool = True, auto_create_default_gateway_new: bool = False) -> dict:
		if not (isinstance(bcd_new, str)):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(bcd_new)}")
		if not (isinstance(cidr_new, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if is_routable_new is not None and not (isinstance(is_routable_new, bool)):
			raise ValueError(f"'is_routable' of incorrect type. Expected bool, got {type(is_routable_new)}")
		if is_container_new is not None and not (isinstance(is_container_new, bool)):
			raise ValueError(f"'is_container' of incorrect type. Expected bool, got {type(is_container_new)}")
		if create_ipaddrs_new is not None and not (isinstance(create_ipaddrs_new, bool)):
			raise ValueError(f"'create_ipaddrs' of incorrect type. Expected bool, got {type(create_ipaddrs_new)}")
		if default_gateway_new is not None and not (isinstance(default_gateway_new, str) or isinstance(default_gateway_new, ExplicitNull)):
			raise ValueError(f"'default_gateway' of incorrect type. Expected str, got {type(default_gateway_new)}")
		if is_iana_registered_new is not None and not (isinstance(is_iana_registered_new, bool)):
			raise ValueError(f"'is_iana_registered' of incorrect type. Expected bool, got {type(is_iana_registered_new)}")
		if auto_create_ip_address_new is not None and not (isinstance(auto_create_ip_address_new, bool)):
			raise ValueError(f"'auto_create_ip_address' of incorrect type. Expected bool, got {type(auto_create_ip_address_new)}")
		if auto_create_default_gateway_new is not None and not (isinstance(auto_create_default_gateway_new, bool)):
			raise ValueError(f"'auto_create_default_gateway' of incorrect type. Expected bool, got {type(auto_create_default_gateway_new)}")

		return {'name': 'nd.ip_subnet.create', 'new': _denullify_dict({'bcd': bcd_new, 'cidr': cidr_new, 'description': description_new, 'is_routable': is_routable_new, 'is_container': is_container_new, 'create_ipaddrs': create_ipaddrs_new, 'default_gateway': default_gateway_new, 'is_iana_registered': is_iana_registered_new, 'auto_create_ip_address': auto_create_ip_address_new, 'auto_create_default_gateway': auto_create_default_gateway_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, bcd_new: str, cidr_new: str, description_new: Union[str, ExplicitNull] = None, is_routable_new: bool = True, is_container_new: bool = False, create_ipaddrs_new: bool = True, default_gateway_new: Union[str, ExplicitNull] = None, is_iana_registered_new: bool = False, auto_create_ip_address_new: bool = True, auto_create_default_gateway_new: bool = False) -> list:
		if not (isinstance(bcd_new, str)):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(bcd_new)}")
		if not (isinstance(cidr_new, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if is_routable_new is not None and not (isinstance(is_routable_new, bool)):
			raise ValueError(f"'is_routable' of incorrect type. Expected bool, got {type(is_routable_new)}")
		if is_container_new is not None and not (isinstance(is_container_new, bool)):
			raise ValueError(f"'is_container' of incorrect type. Expected bool, got {type(is_container_new)}")
		if create_ipaddrs_new is not None and not (isinstance(create_ipaddrs_new, bool)):
			raise ValueError(f"'create_ipaddrs' of incorrect type. Expected bool, got {type(create_ipaddrs_new)}")
		if default_gateway_new is not None and not (isinstance(default_gateway_new, str) or isinstance(default_gateway_new, ExplicitNull)):
			raise ValueError(f"'default_gateway' of incorrect type. Expected str, got {type(default_gateway_new)}")
		if is_iana_registered_new is not None and not (isinstance(is_iana_registered_new, bool)):
			raise ValueError(f"'is_iana_registered' of incorrect type. Expected bool, got {type(is_iana_registered_new)}")
		if auto_create_ip_address_new is not None and not (isinstance(auto_create_ip_address_new, bool)):
			raise ValueError(f"'auto_create_ip_address' of incorrect type. Expected bool, got {type(auto_create_ip_address_new)}")
		if auto_create_default_gateway_new is not None and not (isinstance(auto_create_default_gateway_new, bool)):
			raise ValueError(f"'auto_create_default_gateway' of incorrect type. Expected bool, got {type(auto_create_default_gateway_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(bcd_new=bcd_new, cidr_new=cidr_new, description_new=description_new, is_routable_new=is_routable_new, is_container_new=is_container_new, create_ipaddrs_new=create_ipaddrs_new, default_gateway_new=default_gateway_new, is_iana_registered_new=is_iana_registered_new, auto_create_ip_address_new=auto_create_ip_address_new, auto_create_default_gateway_new=auto_create_default_gateway_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(cidr_old: str, delete_dns_rrs_old: bool = False, delete_ipaddrs_old: bool = False, delete_dhcp_objects_old: bool = False) -> dict:
		if not (isinstance(cidr_old, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_old)}")
		if delete_dns_rrs_old is not None and not (isinstance(delete_dns_rrs_old, bool)):
			raise ValueError(f"'delete_dns_rrs' of incorrect type. Expected bool, got {type(delete_dns_rrs_old)}")
		if delete_ipaddrs_old is not None and not (isinstance(delete_ipaddrs_old, bool)):
			raise ValueError(f"'delete_ipaddrs' of incorrect type. Expected bool, got {type(delete_ipaddrs_old)}")
		if delete_dhcp_objects_old is not None and not (isinstance(delete_dhcp_objects_old, bool)):
			raise ValueError(f"'delete_dhcp_objects' of incorrect type. Expected bool, got {type(delete_dhcp_objects_old)}")

		return {'name': 'nd.ip_subnet.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'cidr': cidr_old, 'delete_dns_rrs': delete_dns_rrs_old, 'delete_ipaddrs': delete_ipaddrs_old, 'delete_dhcp_objects': delete_dhcp_objects_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, cidr_old: str, delete_dns_rrs_old: bool = False, delete_ipaddrs_old: bool = False, delete_dhcp_objects_old: bool = False) -> list:
		if not (isinstance(cidr_old, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_old)}")
		if delete_dns_rrs_old is not None and not (isinstance(delete_dns_rrs_old, bool)):
			raise ValueError(f"'delete_dns_rrs' of incorrect type. Expected bool, got {type(delete_dns_rrs_old)}")
		if delete_ipaddrs_old is not None and not (isinstance(delete_ipaddrs_old, bool)):
			raise ValueError(f"'delete_ipaddrs' of incorrect type. Expected bool, got {type(delete_ipaddrs_old)}")
		if delete_dhcp_objects_old is not None and not (isinstance(delete_dhcp_objects_old, bool)):
			raise ValueError(f"'delete_dhcp_objects' of incorrect type. Expected bool, got {type(delete_dhcp_objects_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(cidr_old=cidr_old, delete_dns_rrs_old=delete_dns_rrs_old, delete_ipaddrs_old=delete_ipaddrs_old, delete_dhcp_objects_old=delete_dhcp_objects_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(bcd_old: str = None, gpk_old: str = None, cidr_old: str = None, type_old: str = None, is_own_old: bool = None, is_private_old: bool = None, fetch_limit_old: int = None, is_routable_old: bool = None, fetch_offset_old: int = None, is_container_old: bool = None, cidr_operator_old: str = None, default_gateway_old: str = None, filter_params_dict_old: dict = None, is_iana_registered_old: bool = None, sorting_params_list_old: list = None, auto_create_ip_address_old: bool = None) -> dict:
		if bcd_old is not None and not (isinstance(bcd_old, str)):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(bcd_old)}")
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if cidr_old is not None and not (isinstance(cidr_old, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_private_old is not None and not (isinstance(is_private_old, bool)):
			raise ValueError(f"'is_private' of incorrect type. Expected bool, got {type(is_private_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if is_routable_old is not None and not (isinstance(is_routable_old, bool)):
			raise ValueError(f"'is_routable' of incorrect type. Expected bool, got {type(is_routable_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_container_old is not None and not (isinstance(is_container_old, bool)):
			raise ValueError(f"'is_container' of incorrect type. Expected bool, got {type(is_container_old)}")
		if cidr_operator_old is not None and not (isinstance(cidr_operator_old, str)):
			raise ValueError(f"'cidr_operator' of incorrect type. Expected str, got {type(cidr_operator_old)}")
		if default_gateway_old is not None and not (isinstance(default_gateway_old, str) or isinstance(default_gateway_old, ExplicitNull)):
			raise ValueError(f"'default_gateway' of incorrect type. Expected str, got {type(default_gateway_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if is_iana_registered_old is not None and not (isinstance(is_iana_registered_old, bool)):
			raise ValueError(f"'is_iana_registered' of incorrect type. Expected bool, got {type(is_iana_registered_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if auto_create_ip_address_old is not None and not (isinstance(auto_create_ip_address_old, bool)):
			raise ValueError(f"'auto_create_ip_address' of incorrect type. Expected bool, got {type(auto_create_ip_address_old)}")

		return {'name': 'nd.ip_subnet.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'bcd': bcd_old, 'gpk': gpk_old, 'cidr': cidr_old, 'type': type_old, 'is_own': is_own_old, 'is_private': is_private_old, 'fetch_limit': fetch_limit_old, 'is_routable': is_routable_old, 'fetch_offset': fetch_offset_old, 'is_container': is_container_old, 'cidr_operator': cidr_operator_old, 'default_gateway': default_gateway_old, 'filter_params_dict': filter_params_dict_old, 'is_iana_registered': is_iana_registered_old, 'sorting_params_list': sorting_params_list_old, 'auto_create_ip_address': auto_create_ip_address_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, bcd_old: str = None, gpk_old: str = None, cidr_old: str = None, type_old: str = None, is_own_old: bool = None, is_private_old: bool = None, fetch_limit_old: int = None, is_routable_old: bool = None, fetch_offset_old: int = None, is_container_old: bool = None, cidr_operator_old: str = None, default_gateway_old: str = None, filter_params_dict_old: dict = None, is_iana_registered_old: bool = None, sorting_params_list_old: list = None, auto_create_ip_address_old: bool = None) -> list:
		if bcd_old is not None and not (isinstance(bcd_old, str)):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(bcd_old)}")
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if cidr_old is not None and not (isinstance(cidr_old, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if is_private_old is not None and not (isinstance(is_private_old, bool)):
			raise ValueError(f"'is_private' of incorrect type. Expected bool, got {type(is_private_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if is_routable_old is not None and not (isinstance(is_routable_old, bool)):
			raise ValueError(f"'is_routable' of incorrect type. Expected bool, got {type(is_routable_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_container_old is not None and not (isinstance(is_container_old, bool)):
			raise ValueError(f"'is_container' of incorrect type. Expected bool, got {type(is_container_old)}")
		if cidr_operator_old is not None and not (isinstance(cidr_operator_old, str)):
			raise ValueError(f"'cidr_operator' of incorrect type. Expected str, got {type(cidr_operator_old)}")
		if default_gateway_old is not None and not (isinstance(default_gateway_old, str) or isinstance(default_gateway_old, ExplicitNull)):
			raise ValueError(f"'default_gateway' of incorrect type. Expected str, got {type(default_gateway_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if is_iana_registered_old is not None and not (isinstance(is_iana_registered_old, bool)):
			raise ValueError(f"'is_iana_registered' of incorrect type. Expected bool, got {type(is_iana_registered_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if auto_create_ip_address_old is not None and not (isinstance(auto_create_ip_address_old, bool)):
			raise ValueError(f"'auto_create_ip_address' of incorrect type. Expected bool, got {type(auto_create_ip_address_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(bcd_old=bcd_old, gpk_old=gpk_old, cidr_old=cidr_old, type_old=type_old, is_own_old=is_own_old, is_private_old=is_private_old, fetch_limit_old=fetch_limit_old, is_routable_old=is_routable_old, fetch_offset_old=fetch_offset_old, is_container_old=is_container_old, cidr_operator_old=cidr_operator_old, default_gateway_old=default_gateway_old, filter_params_dict_old=filter_params_dict_old, is_iana_registered_old=is_iana_registered_old, sorting_params_list_old=sorting_params_list_old, auto_create_ip_address_old=auto_create_ip_address_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(cidr_old: str, bcd_new: str = None, cidr_new: str = None, description_new: Union[str, ExplicitNull] = None, is_routable_new: bool = None, is_container_new: bool = None, default_gateway_new: Union[str, ExplicitNull] = None, is_iana_registered_new: bool = None, auto_create_ip_address_new: bool = None) -> dict:
		if bcd_new is not None and not (isinstance(bcd_new, str)):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(bcd_new)}")
		if cidr_new is not None and not (isinstance(cidr_new, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if is_routable_new is not None and not (isinstance(is_routable_new, bool)):
			raise ValueError(f"'is_routable' of incorrect type. Expected bool, got {type(is_routable_new)}")
		if is_container_new is not None and not (isinstance(is_container_new, bool)):
			raise ValueError(f"'is_container' of incorrect type. Expected bool, got {type(is_container_new)}")
		if default_gateway_new is not None and not (isinstance(default_gateway_new, str) or isinstance(default_gateway_new, ExplicitNull)):
			raise ValueError(f"'default_gateway' of incorrect type. Expected str, got {type(default_gateway_new)}")
		if is_iana_registered_new is not None and not (isinstance(is_iana_registered_new, bool)):
			raise ValueError(f"'is_iana_registered' of incorrect type. Expected bool, got {type(is_iana_registered_new)}")
		if auto_create_ip_address_new is not None and not (isinstance(auto_create_ip_address_new, bool)):
			raise ValueError(f"'auto_create_ip_address' of incorrect type. Expected bool, got {type(auto_create_ip_address_new)}")
		if not (isinstance(cidr_old, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_old)}")

		return {'name': 'nd.ip_subnet.update', 'new': _denullify_dict({'bcd': bcd_new, 'cidr': cidr_new, 'description': description_new, 'is_routable': is_routable_new, 'is_container': is_container_new, 'default_gateway': default_gateway_new, 'is_iana_registered': is_iana_registered_new, 'auto_create_ip_address': auto_create_ip_address_new}), 'old': _denullify_dict({'cidr': cidr_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, cidr_old: str, bcd_new: str = None, cidr_new: str = None, description_new: Union[str, ExplicitNull] = None, is_routable_new: bool = None, is_container_new: bool = None, default_gateway_new: Union[str, ExplicitNull] = None, is_iana_registered_new: bool = None, auto_create_ip_address_new: bool = None) -> list:
		if bcd_new is not None and not (isinstance(bcd_new, str)):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(bcd_new)}")
		if cidr_new is not None and not (isinstance(cidr_new, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if is_routable_new is not None and not (isinstance(is_routable_new, bool)):
			raise ValueError(f"'is_routable' of incorrect type. Expected bool, got {type(is_routable_new)}")
		if is_container_new is not None and not (isinstance(is_container_new, bool)):
			raise ValueError(f"'is_container' of incorrect type. Expected bool, got {type(is_container_new)}")
		if default_gateway_new is not None and not (isinstance(default_gateway_new, str) or isinstance(default_gateway_new, ExplicitNull)):
			raise ValueError(f"'default_gateway' of incorrect type. Expected str, got {type(default_gateway_new)}")
		if is_iana_registered_new is not None and not (isinstance(is_iana_registered_new, bool)):
			raise ValueError(f"'is_iana_registered' of incorrect type. Expected bool, got {type(is_iana_registered_new)}")
		if auto_create_ip_address_new is not None and not (isinstance(auto_create_ip_address_new, bool)):
			raise ValueError(f"'auto_create_ip_address' of incorrect type. Expected bool, got {type(auto_create_ip_address_new)}")
		if not (isinstance(cidr_old, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(bcd_new=bcd_new, cidr_new=cidr_new, description_new=description_new, is_routable_new=is_routable_new, is_container_new=is_container_new, default_gateway_new=default_gateway_new, is_iana_registered_new=is_iana_registered_new, auto_create_ip_address_new=auto_create_ip_address_new, cidr_old=cidr_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Slot(APIObject):
	gpk: str
	bldg: str
	room: str
	type: str
	label: str
	fq_name: str
	description: str
	label_sortby: str
	parent_fq_module: str
	sub_module_count: int

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if self.bldg is not None and not isinstance(self.bldg, str):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(self.bldg)}")
		if self.room is not None and not isinstance(self.room, str):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(self.room)}")
		if not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if not isinstance(self.label, str):
			raise ValueError(f"'label' of incorrect type. Expected str, got {type(self.label)}")
		if not isinstance(self.fq_name, str):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(self.fq_name)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.label_sortby, str):
			raise ValueError(f"'label_sortby' of incorrect type. Expected str, got {type(self.label_sortby)}")
		if not isinstance(self.parent_fq_module, str):
			raise ValueError(f"'parent_fq_module' of incorrect type. Expected str, got {type(self.parent_fq_module)}")
		if not isinstance(self.sub_module_count, int):
			raise ValueError(f"'sub_module_count' of incorrect type. Expected int, got {type(self.sub_module_count)}")

	@staticmethod
	def list_ta(gpk_old: str = None, type_old: str = None, fq_name_old: str = None, has_submdl_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, parent_fq_module_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if fq_name_old is not None and not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")
		if has_submdl_old is not None and not (isinstance(has_submdl_old, bool)):
			raise ValueError(f"'has_submdl' of incorrect type. Expected bool, got {type(has_submdl_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if parent_fq_module_old is not None and not (isinstance(parent_fq_module_old, str)):
			raise ValueError(f"'parent_fq_module' of incorrect type. Expected str, got {type(parent_fq_module_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.slot.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'type': type_old, 'fq_name': fq_name_old, 'has_submdl': has_submdl_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'parent_fq_module': parent_fq_module_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, type_old: str = None, fq_name_old: str = None, has_submdl_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, parent_fq_module_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if fq_name_old is not None and not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")
		if has_submdl_old is not None and not (isinstance(has_submdl_old, bool)):
			raise ValueError(f"'has_submdl' of incorrect type. Expected bool, got {type(has_submdl_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if parent_fq_module_old is not None and not (isinstance(parent_fq_module_old, str)):
			raise ValueError(f"'parent_fq_module' of incorrect type. Expected str, got {type(parent_fq_module_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, type_old=type_old, fq_name_old=fq_name_old, has_submdl_old=has_submdl_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, parent_fq_module_old=parent_fq_module_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(fq_name_old: str, bldg_new: str = None, room_new: str = None, fq_name_new: str = None, description_new: Union[str, ExplicitNull] = None, bldg_old: str = None, room_old: str = None, description_old: str = None) -> dict:
		if bldg_new is not None and not (isinstance(bldg_new, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_new)}")
		if room_new is not None and not (isinstance(room_new, str)):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(room_new)}")
		if fq_name_new is not None and not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if bldg_old is not None and not (isinstance(bldg_old, str) or isinstance(bldg_old, ExplicitNull)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_old)}")
		if room_old is not None and not (isinstance(room_old, str) or isinstance(room_old, ExplicitNull)):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(room_old)}")
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")
		if description_old is not None and not (isinstance(description_old, str) or isinstance(description_old, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_old)}")

		return {'name': 'nd.slot.update', 'new': _denullify_dict({'bldg': bldg_new, 'room': room_new, 'fq_name': fq_name_new, 'description': description_new}), 'old': _denullify_dict({'bldg': bldg_old, 'room': room_old, 'fq_name': fq_name_old, 'description': description_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, fq_name_old: str, bldg_new: str = None, room_new: str = None, fq_name_new: str = None, description_new: Union[str, ExplicitNull] = None, bldg_old: str = None, room_old: str = None, description_old: str = None) -> list:
		if bldg_new is not None and not (isinstance(bldg_new, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_new)}")
		if room_new is not None and not (isinstance(room_new, str)):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(room_new)}")
		if fq_name_new is not None and not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if bldg_old is not None and not (isinstance(bldg_old, str) or isinstance(bldg_old, ExplicitNull)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_old)}")
		if room_old is not None and not (isinstance(room_old, str) or isinstance(room_old, ExplicitNull)):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(room_old)}")
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")
		if description_old is not None and not (isinstance(description_old, str) or isinstance(description_old, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(bldg_new=bldg_new, room_new=room_new, fq_name_new=fq_name_new, description_new=description_new, bldg_old=bldg_old, room_old=room_old, fq_name_old=fq_name_old, description_old=description_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Floor(APIObject):
	gpk: str
	name: str
	description: str
	name_sortby: int

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.name_sortby, int):
			raise ValueError(f"'name_sortby' of incorrect type. Expected int, got {type(self.name_sortby)}")

	@staticmethod
	def create_ta(name_new: str, name_sortby_new: int, description_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(name_sortby_new, int)):
			raise ValueError(f"'name_sortby' of incorrect type. Expected int, got {type(name_sortby_new)}")

		return {'name': 'nd.floor.create', 'new': _denullify_dict({'name': name_new, 'description': description_new, 'name_sortby': name_sortby_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, name_sortby_new: int, description_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(name_sortby_new, int)):
			raise ValueError(f"'name_sortby' of incorrect type. Expected int, got {type(name_sortby_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, description_new=description_new, name_sortby_new=name_sortby_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'nd.floor.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.floor.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, description_new: Union[str, ExplicitNull] = None, name_sortby_new: int = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if name_sortby_new is not None and not (isinstance(name_sortby_new, int)):
			raise ValueError(f"'name_sortby' of incorrect type. Expected int, got {type(name_sortby_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'nd.floor.update', 'new': _denullify_dict({'name': name_new, 'description': description_new, 'name_sortby': name_sortby_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, description_new: Union[str, ExplicitNull] = None, name_sortby_new: int = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if name_sortby_new is not None and not (isinstance(name_sortby_new, int)):
			raise ValueError(f"'name_sortby' of incorrect type. Expected int, got {type(name_sortby_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, description_new=description_new, name_sortby_new=name_sortby_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Room(APIObject):
	gpk: str
	bldg: str
	name: str
	floor: str
	number: str
	description: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.bldg, str):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(self.bldg)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.floor, str):
			raise ValueError(f"'floor' of incorrect type. Expected str, got {type(self.floor)}")
		if not isinstance(self.number, str):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(self.number)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")

	@staticmethod
	def create_ta(bldg_new: str, name_new: str, floor_new: str, number_new: str, description_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(bldg_new, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_new)}")
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(floor_new, str)):
			raise ValueError(f"'floor' of incorrect type. Expected str, got {type(floor_new)}")
		if not (isinstance(number_new, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		return {'name': 'nd.room.create', 'new': _denullify_dict({'bldg': bldg_new, 'name': name_new, 'floor': floor_new, 'number': number_new, 'description': description_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, bldg_new: str, name_new: str, floor_new: str, number_new: str, description_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(bldg_new, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_new)}")
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(floor_new, str)):
			raise ValueError(f"'floor' of incorrect type. Expected str, got {type(floor_new)}")
		if not (isinstance(number_new, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(bldg_new=bldg_new, name_new=name_new, floor_new=floor_new, number_new=number_new, description_new=description_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(bldg_old: str, number_old: str) -> dict:
		if not (isinstance(bldg_old, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_old)}")
		if not (isinstance(number_old, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_old)}")

		return {'name': 'nd.room.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'bldg': bldg_old, 'number': number_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, bldg_old: str, number_old: str) -> list:
		if not (isinstance(bldg_old, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_old)}")
		if not (isinstance(number_old, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(bldg_old=bldg_old, number_old=number_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, bldg_old: str = None, name_old: str = None, floor_old: str = None, number_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if bldg_old is not None and not (isinstance(bldg_old, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if floor_old is not None and not (isinstance(floor_old, str)):
			raise ValueError(f"'floor' of incorrect type. Expected str, got {type(floor_old)}")
		if number_old is not None and not (isinstance(number_old, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.room.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'bldg': bldg_old, 'name': name_old, 'floor': floor_old, 'number': number_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, bldg_old: str = None, name_old: str = None, floor_old: str = None, number_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if bldg_old is not None and not (isinstance(bldg_old, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if floor_old is not None and not (isinstance(floor_old, str)):
			raise ValueError(f"'floor' of incorrect type. Expected str, got {type(floor_old)}")
		if number_old is not None and not (isinstance(number_old, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, bldg_old=bldg_old, name_old=name_old, floor_old=floor_old, number_old=number_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(bldg_old: str, number_old: str, bldg_new: str = None, name_new: str = None, floor_new: str = None, number_new: str = None, description_new: Union[str, ExplicitNull] = None) -> dict:
		if bldg_new is not None and not (isinstance(bldg_new, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_new)}")
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if floor_new is not None and not (isinstance(floor_new, str)):
			raise ValueError(f"'floor' of incorrect type. Expected str, got {type(floor_new)}")
		if number_new is not None and not (isinstance(number_new, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(bldg_old, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_old)}")
		if not (isinstance(number_old, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_old)}")

		return {'name': 'nd.room.update', 'new': _denullify_dict({'bldg': bldg_new, 'name': name_new, 'floor': floor_new, 'number': number_new, 'description': description_new}), 'old': _denullify_dict({'bldg': bldg_old, 'number': number_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, bldg_old: str, number_old: str, bldg_new: str = None, name_new: str = None, floor_new: str = None, number_new: str = None, description_new: Union[str, ExplicitNull] = None) -> list:
		if bldg_new is not None and not (isinstance(bldg_new, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_new)}")
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if floor_new is not None and not (isinstance(floor_new, str)):
			raise ValueError(f"'floor' of incorrect type. Expected str, got {type(floor_new)}")
		if number_new is not None and not (isinstance(number_new, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(bldg_old, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_old)}")
		if not (isinstance(number_old, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(bldg_new=bldg_new, name_new=name_new, floor_new=floor_new, number_new=number_new, description_new=description_new, bldg_old=bldg_old, number_old=number_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Module(APIObject):
	ap: str
	gpk: str
	bldg: str
	room: str
	type: str
	label: str
	fq_name: str
	is_child: bool
	root_gfk: str
	is_active: bool
	tree_level: int
	description: str
	has_unq_name: bool
	is_loc_depdnt: bool
	root_node_set: list
	parent_fq_slot: str

	def __post_init__(self):
		if self.ap is not None and not isinstance(self.ap, str):
			raise ValueError(f"'ap' of incorrect type. Expected str, got {type(self.ap)}")
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if self.bldg is not None and not isinstance(self.bldg, str):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(self.bldg)}")
		if self.room is not None and not isinstance(self.room, str):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(self.room)}")
		if not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if not isinstance(self.label, str):
			raise ValueError(f"'label' of incorrect type. Expected str, got {type(self.label)}")
		if not isinstance(self.fq_name, str):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(self.fq_name)}")
		if not isinstance(self.is_child, bool):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(self.is_child)}")
		if not isinstance(self.root_gfk, str):
			raise ValueError(f"'root_gfk' of incorrect type. Expected str, got {type(self.root_gfk)}")
		if not isinstance(self.is_active, bool):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(self.is_active)}")
		if not isinstance(self.tree_level, int):
			raise ValueError(f"'tree_level' of incorrect type. Expected int, got {type(self.tree_level)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.has_unq_name, bool):
			raise ValueError(f"'has_unq_name' of incorrect type. Expected bool, got {type(self.has_unq_name)}")
		if not isinstance(self.is_loc_depdnt, bool):
			raise ValueError(f"'is_loc_depdnt' of incorrect type. Expected bool, got {type(self.is_loc_depdnt)}")
		if not isinstance(self.root_node_set, list):
			raise ValueError(f"'root_node_set' of incorrect type. Expected list, got {type(self.root_node_set)}")
		if self.parent_fq_slot is not None and not isinstance(self.parent_fq_slot, str):
			raise ValueError(f"'parent_fq_slot' of incorrect type. Expected str, got {type(self.parent_fq_slot)}")

	@staticmethod
	def create_ta(type_new: str, fq_name_new: str, ap_new: str = None, bldg_new: str = None, room_new: str = None, description_new: Union[str, ExplicitNull] = None, attributes_dict_new: dict = None) -> dict:
		if ap_new is not None and not (isinstance(ap_new, str)):
			raise ValueError(f"'ap' of incorrect type. Expected str, got {type(ap_new)}")
		if bldg_new is not None and not (isinstance(bldg_new, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_new)}")
		if room_new is not None and not (isinstance(room_new, str)):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(room_new)}")
		if not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if attributes_dict_new is not None and not (isinstance(attributes_dict_new, dict)):
			raise ValueError(f"'attributes_dict' of incorrect type. Expected dict, got {type(attributes_dict_new)}")

		return {'name': 'nd.module.create', 'new': _denullify_dict({'ap': ap_new, 'bldg': bldg_new, 'room': room_new, 'type': type_new, 'fq_name': fq_name_new, 'description': description_new, 'attributes_dict': attributes_dict_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, type_new: str, fq_name_new: str, ap_new: str = None, bldg_new: str = None, room_new: str = None, description_new: Union[str, ExplicitNull] = None, attributes_dict_new: dict = None) -> list:
		if ap_new is not None and not (isinstance(ap_new, str)):
			raise ValueError(f"'ap' of incorrect type. Expected str, got {type(ap_new)}")
		if bldg_new is not None and not (isinstance(bldg_new, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_new)}")
		if room_new is not None and not (isinstance(room_new, str)):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(room_new)}")
		if not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if attributes_dict_new is not None and not (isinstance(attributes_dict_new, dict)):
			raise ValueError(f"'attributes_dict' of incorrect type. Expected dict, got {type(attributes_dict_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(ap_new=ap_new, bldg_new=bldg_new, room_new=room_new, type_new=type_new, fq_name_new=fq_name_new, description_new=description_new, attributes_dict_new=attributes_dict_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(fq_name_old: str, ap_old: str = None, bldg_old: str = None, room_old: str = None, force_delete_devs_old: bool = False, force_disconnect_pp_old: bool = False) -> dict:
		if ap_old is not None and not (isinstance(ap_old, str)):
			raise ValueError(f"'ap' of incorrect type. Expected str, got {type(ap_old)}")
		if bldg_old is not None and not (isinstance(bldg_old, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_old)}")
		if room_old is not None and not (isinstance(room_old, str)):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(room_old)}")
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")
		if force_delete_devs_old is not None and not (isinstance(force_delete_devs_old, bool)):
			raise ValueError(f"'force_delete_devs' of incorrect type. Expected bool, got {type(force_delete_devs_old)}")
		if force_disconnect_pp_old is not None and not (isinstance(force_disconnect_pp_old, bool)):
			raise ValueError(f"'force_disconnect_pp' of incorrect type. Expected bool, got {type(force_disconnect_pp_old)}")

		return {'name': 'nd.module.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'ap': ap_old, 'bldg': bldg_old, 'room': room_old, 'fq_name': fq_name_old, 'force_delete_devs': force_delete_devs_old, 'force_disconnect_pp': force_disconnect_pp_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, fq_name_old: str, ap_old: str = None, bldg_old: str = None, room_old: str = None, force_delete_devs_old: bool = False, force_disconnect_pp_old: bool = False) -> list:
		if ap_old is not None and not (isinstance(ap_old, str)):
			raise ValueError(f"'ap' of incorrect type. Expected str, got {type(ap_old)}")
		if bldg_old is not None and not (isinstance(bldg_old, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_old)}")
		if room_old is not None and not (isinstance(room_old, str)):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(room_old)}")
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")
		if force_delete_devs_old is not None and not (isinstance(force_delete_devs_old, bool)):
			raise ValueError(f"'force_delete_devs' of incorrect type. Expected bool, got {type(force_delete_devs_old)}")
		if force_disconnect_pp_old is not None and not (isinstance(force_disconnect_pp_old, bool)):
			raise ValueError(f"'force_disconnect_pp' of incorrect type. Expected bool, got {type(force_disconnect_pp_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(ap_old=ap_old, bldg_old=bldg_old, room_old=room_old, fq_name_old=fq_name_old, force_delete_devs_old=force_delete_devs_old, force_disconnect_pp_old=force_disconnect_pp_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, bldg_old: str = None, room_old: str = None, type_old: str = None, fq_name_old: str = None, is_child_old: bool = None, is_active_old: bool = None, do_subtree_old: bool = False, label_list_old: list = None, tree_level_old: int = None, do_rootpath_old: bool = False, fetch_limit_old: int = None, do_root_only_old: bool = False, fetch_offset_old: int = None, fq_name_list_old: list = None, has_unq_name_old: bool = None, label_regexp_old: str = None, is_loc_depdnt_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if bldg_old is not None and not (isinstance(bldg_old, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_old)}")
		if room_old is not None and not (isinstance(room_old, str)):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(room_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if fq_name_old is not None and not (isinstance(fq_name_old, str) or isinstance(fq_name_old, ExplicitNull)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")
		if is_child_old is not None and not (isinstance(is_child_old, bool)):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(is_child_old)}")
		if is_active_old is not None and not (isinstance(is_active_old, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_old)}")
		if do_subtree_old is not None and not (isinstance(do_subtree_old, bool)):
			raise ValueError(f"'do_subtree' of incorrect type. Expected bool, got {type(do_subtree_old)}")
		if label_list_old is not None and not (isinstance(label_list_old, list)):
			raise ValueError(f"'label_list' of incorrect type. Expected list, got {type(label_list_old)}")
		if tree_level_old is not None and not (isinstance(tree_level_old, int)):
			raise ValueError(f"'tree_level' of incorrect type. Expected int, got {type(tree_level_old)}")
		if do_rootpath_old is not None and not (isinstance(do_rootpath_old, bool)):
			raise ValueError(f"'do_rootpath' of incorrect type. Expected bool, got {type(do_rootpath_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if do_root_only_old is not None and not (isinstance(do_root_only_old, bool)):
			raise ValueError(f"'do_root_only' of incorrect type. Expected bool, got {type(do_root_only_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if fq_name_list_old is not None and not (isinstance(fq_name_list_old, list)):
			raise ValueError(f"'fq_name_list' of incorrect type. Expected list, got {type(fq_name_list_old)}")
		if has_unq_name_old is not None and not (isinstance(has_unq_name_old, bool)):
			raise ValueError(f"'has_unq_name' of incorrect type. Expected bool, got {type(has_unq_name_old)}")
		if label_regexp_old is not None and not (isinstance(label_regexp_old, str)):
			raise ValueError(f"'label_regexp' of incorrect type. Expected str, got {type(label_regexp_old)}")
		if is_loc_depdnt_old is not None and not (isinstance(is_loc_depdnt_old, bool)):
			raise ValueError(f"'is_loc_depdnt' of incorrect type. Expected bool, got {type(is_loc_depdnt_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.module.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'bldg': bldg_old, 'room': room_old, 'type': type_old, 'fq_name': fq_name_old, 'is_child': is_child_old, 'is_active': is_active_old, 'do_subtree': do_subtree_old, 'label_list': label_list_old, 'tree_level': tree_level_old, 'do_rootpath': do_rootpath_old, 'fetch_limit': fetch_limit_old, 'do_root_only': do_root_only_old, 'fetch_offset': fetch_offset_old, 'fq_name_list': fq_name_list_old, 'has_unq_name': has_unq_name_old, 'label_regexp': label_regexp_old, 'is_loc_depdnt': is_loc_depdnt_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, bldg_old: str = None, room_old: str = None, type_old: str = None, fq_name_old: str = None, is_child_old: bool = None, is_active_old: bool = None, do_subtree_old: bool = False, label_list_old: list = None, tree_level_old: int = None, do_rootpath_old: bool = False, fetch_limit_old: int = None, do_root_only_old: bool = False, fetch_offset_old: int = None, fq_name_list_old: list = None, has_unq_name_old: bool = None, label_regexp_old: str = None, is_loc_depdnt_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if bldg_old is not None and not (isinstance(bldg_old, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_old)}")
		if room_old is not None and not (isinstance(room_old, str)):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(room_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if fq_name_old is not None and not (isinstance(fq_name_old, str) or isinstance(fq_name_old, ExplicitNull)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")
		if is_child_old is not None and not (isinstance(is_child_old, bool)):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(is_child_old)}")
		if is_active_old is not None and not (isinstance(is_active_old, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_old)}")
		if do_subtree_old is not None and not (isinstance(do_subtree_old, bool)):
			raise ValueError(f"'do_subtree' of incorrect type. Expected bool, got {type(do_subtree_old)}")
		if label_list_old is not None and not (isinstance(label_list_old, list)):
			raise ValueError(f"'label_list' of incorrect type. Expected list, got {type(label_list_old)}")
		if tree_level_old is not None and not (isinstance(tree_level_old, int)):
			raise ValueError(f"'tree_level' of incorrect type. Expected int, got {type(tree_level_old)}")
		if do_rootpath_old is not None and not (isinstance(do_rootpath_old, bool)):
			raise ValueError(f"'do_rootpath' of incorrect type. Expected bool, got {type(do_rootpath_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if do_root_only_old is not None and not (isinstance(do_root_only_old, bool)):
			raise ValueError(f"'do_root_only' of incorrect type. Expected bool, got {type(do_root_only_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if fq_name_list_old is not None and not (isinstance(fq_name_list_old, list)):
			raise ValueError(f"'fq_name_list' of incorrect type. Expected list, got {type(fq_name_list_old)}")
		if has_unq_name_old is not None and not (isinstance(has_unq_name_old, bool)):
			raise ValueError(f"'has_unq_name' of incorrect type. Expected bool, got {type(has_unq_name_old)}")
		if label_regexp_old is not None and not (isinstance(label_regexp_old, str)):
			raise ValueError(f"'label_regexp' of incorrect type. Expected str, got {type(label_regexp_old)}")
		if is_loc_depdnt_old is not None and not (isinstance(is_loc_depdnt_old, bool)):
			raise ValueError(f"'is_loc_depdnt' of incorrect type. Expected bool, got {type(is_loc_depdnt_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, bldg_old=bldg_old, room_old=room_old, type_old=type_old, fq_name_old=fq_name_old, is_child_old=is_child_old, is_active_old=is_active_old, do_subtree_old=do_subtree_old, label_list_old=label_list_old, tree_level_old=tree_level_old, do_rootpath_old=do_rootpath_old, fetch_limit_old=fetch_limit_old, do_root_only_old=do_root_only_old, fetch_offset_old=fetch_offset_old, fq_name_list_old=fq_name_list_old, has_unq_name_old=has_unq_name_old, label_regexp_old=label_regexp_old, is_loc_depdnt_old=is_loc_depdnt_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(fq_name_old: str, ap_new: Union[str, ExplicitNull] = None, bldg_new: str = None, room_new: str = None, fq_name_new: str = None, description_new: Union[str, ExplicitNull] = None, ap_old: str = None, bldg_old: str = None, room_old: str = None, description_old: str = None) -> dict:
		if ap_new is not None and not (isinstance(ap_new, str) or isinstance(ap_new, ExplicitNull)):
			raise ValueError(f"'ap' of incorrect type. Expected str, got {type(ap_new)}")
		if bldg_new is not None and not (isinstance(bldg_new, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_new)}")
		if room_new is not None and not (isinstance(room_new, str)):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(room_new)}")
		if fq_name_new is not None and not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if ap_old is not None and not (isinstance(ap_old, str)):
			raise ValueError(f"'ap' of incorrect type. Expected str, got {type(ap_old)}")
		if bldg_old is not None and not (isinstance(bldg_old, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_old)}")
		if room_old is not None and not (isinstance(room_old, str)):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(room_old)}")
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")
		if description_old is not None and not (isinstance(description_old, str) or isinstance(description_old, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_old)}")

		return {'name': 'nd.module.update', 'new': _denullify_dict({'ap': ap_new, 'bldg': bldg_new, 'room': room_new, 'fq_name': fq_name_new, 'description': description_new}), 'old': _denullify_dict({'ap': ap_old, 'bldg': bldg_old, 'room': room_old, 'fq_name': fq_name_old, 'description': description_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, fq_name_old: str, ap_new: Union[str, ExplicitNull] = None, bldg_new: str = None, room_new: str = None, fq_name_new: str = None, description_new: Union[str, ExplicitNull] = None, ap_old: str = None, bldg_old: str = None, room_old: str = None, description_old: str = None) -> list:
		if ap_new is not None and not (isinstance(ap_new, str) or isinstance(ap_new, ExplicitNull)):
			raise ValueError(f"'ap' of incorrect type. Expected str, got {type(ap_new)}")
		if bldg_new is not None and not (isinstance(bldg_new, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_new)}")
		if room_new is not None and not (isinstance(room_new, str)):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(room_new)}")
		if fq_name_new is not None and not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if ap_old is not None and not (isinstance(ap_old, str)):
			raise ValueError(f"'ap' of incorrect type. Expected str, got {type(ap_old)}")
		if bldg_old is not None and not (isinstance(bldg_old, str)):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(bldg_old)}")
		if room_old is not None and not (isinstance(room_old, str)):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(room_old)}")
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")
		if description_old is not None and not (isinstance(description_old, str) or isinstance(description_old, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(ap_new=ap_new, bldg_new=bldg_new, room_new=room_new, fq_name_new=fq_name_new, description_new=description_new, ap_old=ap_old, bldg_old=bldg_old, room_old=room_old, fq_name_old=fq_name_old, description_old=description_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class VlanEgress(APIObject):
	gpk: str
	vlan_gfk: str
	is_tagged: bool
	l_port_gfk: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.vlan_gfk, str):
			raise ValueError(f"'vlan_gfk' of incorrect type. Expected str, got {type(self.vlan_gfk)}")
		if not isinstance(self.is_tagged, bool):
			raise ValueError(f"'is_tagged' of incorrect type. Expected bool, got {type(self.is_tagged)}")
		if not isinstance(self.l_port_gfk, str):
			raise ValueError(f"'l_port_gfk' of incorrect type. Expected str, got {type(self.l_port_gfk)}")

	@staticmethod
	def list_ta(gpk_old: str = None, is_tagged_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_tagged_old is not None and not (isinstance(is_tagged_old, bool)):
			raise ValueError(f"'is_tagged' of incorrect type. Expected bool, got {type(is_tagged_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.vlan_egress.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_tagged': is_tagged_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_tagged_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_tagged_old is not None and not (isinstance(is_tagged_old, bool)):
			raise ValueError(f"'is_tagged' of incorrect type. Expected bool, got {type(is_tagged_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_tagged_old=is_tagged_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Bldg(APIObject):
	gpk: str
	name: str
	number: str
	street: str
	postal_code: int
	geo_location: dict
	site_fq_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.number, str):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(self.number)}")
		if self.street is not None and not isinstance(self.street, str):
			raise ValueError(f"'street' of incorrect type. Expected str, got {type(self.street)}")
		if self.postal_code is not None and not isinstance(self.postal_code, int):
			raise ValueError(f"'postal_code' of incorrect type. Expected int, got {type(self.postal_code)}")
		if self.geo_location is not None and not isinstance(self.geo_location, dict):
			raise ValueError(f"'geo_location' of incorrect type. Expected dict, got {type(self.geo_location)}")
		if not isinstance(self.site_fq_name, str):
			raise ValueError(f"'site_fq_name' of incorrect type. Expected str, got {type(self.site_fq_name)}")

	@staticmethod
	def create_ta(name_new: str, number_new: str, site_fq_name_new: str, street_new: Union[str, ExplicitNull] = None, postal_code_new: Union[int, ExplicitNull] = None, geo_location_new: Union[dict, ExplicitNull] = None) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(number_new, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_new)}")
		if street_new is not None and not (isinstance(street_new, str) or isinstance(street_new, ExplicitNull)):
			raise ValueError(f"'street' of incorrect type. Expected str, got {type(street_new)}")
		if postal_code_new is not None and not (isinstance(postal_code_new, int) or isinstance(postal_code_new, ExplicitNull)):
			raise ValueError(f"'postal_code' of incorrect type. Expected int, got {type(postal_code_new)}")
		if geo_location_new is not None and not (isinstance(geo_location_new, dict) or isinstance(geo_location_new, ExplicitNull)):
			raise ValueError(f"'geo_location' of incorrect type. Expected dict, got {type(geo_location_new)}")
		if not (isinstance(site_fq_name_new, str)):
			raise ValueError(f"'site_fq_name' of incorrect type. Expected str, got {type(site_fq_name_new)}")

		return {'name': 'nd.bldg.create', 'new': _denullify_dict({'name': name_new, 'number': number_new, 'street': street_new, 'postal_code': postal_code_new, 'geo_location': geo_location_new, 'site_fq_name': site_fq_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, number_new: str, site_fq_name_new: str, street_new: Union[str, ExplicitNull] = None, postal_code_new: Union[int, ExplicitNull] = None, geo_location_new: Union[dict, ExplicitNull] = None) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(number_new, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_new)}")
		if street_new is not None and not (isinstance(street_new, str) or isinstance(street_new, ExplicitNull)):
			raise ValueError(f"'street' of incorrect type. Expected str, got {type(street_new)}")
		if postal_code_new is not None and not (isinstance(postal_code_new, int) or isinstance(postal_code_new, ExplicitNull)):
			raise ValueError(f"'postal_code' of incorrect type. Expected int, got {type(postal_code_new)}")
		if geo_location_new is not None and not (isinstance(geo_location_new, dict) or isinstance(geo_location_new, ExplicitNull)):
			raise ValueError(f"'geo_location' of incorrect type. Expected dict, got {type(geo_location_new)}")
		if not (isinstance(site_fq_name_new, str)):
			raise ValueError(f"'site_fq_name' of incorrect type. Expected str, got {type(site_fq_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, number_new=number_new, street_new=street_new, postal_code_new=postal_code_new, geo_location_new=geo_location_new, site_fq_name_new=site_fq_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(number_old: str) -> dict:
		if not (isinstance(number_old, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_old)}")

		return {'name': 'nd.bldg.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'number': number_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, number_old: str) -> list:
		if not (isinstance(number_old, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(number_old=number_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, number_old: str = None, fetch_limit_old: int = None, postal_code_old: int = None, fetch_offset_old: int = None, geo_location_old: dict = None, site_fq_name_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, geo_location_distance_old: int = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if number_old is not None and not (isinstance(number_old, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if postal_code_old is not None and not (isinstance(postal_code_old, int)):
			raise ValueError(f"'postal_code' of incorrect type. Expected int, got {type(postal_code_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if geo_location_old is not None and not (isinstance(geo_location_old, dict)):
			raise ValueError(f"'geo_location' of incorrect type. Expected dict, got {type(geo_location_old)}")
		if site_fq_name_old is not None and not (isinstance(site_fq_name_old, str)):
			raise ValueError(f"'site_fq_name' of incorrect type. Expected str, got {type(site_fq_name_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if geo_location_distance_old is not None and not (isinstance(geo_location_distance_old, int)):
			raise ValueError(f"'geo_location_distance' of incorrect type. Expected int, got {type(geo_location_distance_old)}")

		return {'name': 'nd.bldg.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'number': number_old, 'fetch_limit': fetch_limit_old, 'postal_code': postal_code_old, 'fetch_offset': fetch_offset_old, 'geo_location': geo_location_old, 'site_fq_name': site_fq_name_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'geo_location_distance': geo_location_distance_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, number_old: str = None, fetch_limit_old: int = None, postal_code_old: int = None, fetch_offset_old: int = None, geo_location_old: dict = None, site_fq_name_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, geo_location_distance_old: int = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if number_old is not None and not (isinstance(number_old, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if postal_code_old is not None and not (isinstance(postal_code_old, int)):
			raise ValueError(f"'postal_code' of incorrect type. Expected int, got {type(postal_code_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if geo_location_old is not None and not (isinstance(geo_location_old, dict)):
			raise ValueError(f"'geo_location' of incorrect type. Expected dict, got {type(geo_location_old)}")
		if site_fq_name_old is not None and not (isinstance(site_fq_name_old, str)):
			raise ValueError(f"'site_fq_name' of incorrect type. Expected str, got {type(site_fq_name_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if geo_location_distance_old is not None and not (isinstance(geo_location_distance_old, int)):
			raise ValueError(f"'geo_location_distance' of incorrect type. Expected int, got {type(geo_location_distance_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, number_old=number_old, fetch_limit_old=fetch_limit_old, postal_code_old=postal_code_old, fetch_offset_old=fetch_offset_old, geo_location_old=geo_location_old, site_fq_name_old=site_fq_name_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, geo_location_distance_old=geo_location_distance_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(number_old: str, name_new: str = None, number_new: str = None, street_new: Union[str, ExplicitNull] = None, postal_code_new: Union[int, ExplicitNull] = None, geo_location_new: Union[dict, ExplicitNull] = None, site_fq_name_new: str = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if number_new is not None and not (isinstance(number_new, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_new)}")
		if street_new is not None and not (isinstance(street_new, str) or isinstance(street_new, ExplicitNull)):
			raise ValueError(f"'street' of incorrect type. Expected str, got {type(street_new)}")
		if postal_code_new is not None and not (isinstance(postal_code_new, int) or isinstance(postal_code_new, ExplicitNull)):
			raise ValueError(f"'postal_code' of incorrect type. Expected int, got {type(postal_code_new)}")
		if geo_location_new is not None and not (isinstance(geo_location_new, dict) or isinstance(geo_location_new, ExplicitNull)):
			raise ValueError(f"'geo_location' of incorrect type. Expected dict, got {type(geo_location_new)}")
		if site_fq_name_new is not None and not (isinstance(site_fq_name_new, str)):
			raise ValueError(f"'site_fq_name' of incorrect type. Expected str, got {type(site_fq_name_new)}")
		if not (isinstance(number_old, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_old)}")

		return {'name': 'nd.bldg.update', 'new': _denullify_dict({'name': name_new, 'number': number_new, 'street': street_new, 'postal_code': postal_code_new, 'geo_location': geo_location_new, 'site_fq_name': site_fq_name_new}), 'old': _denullify_dict({'number': number_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, number_old: str, name_new: str = None, number_new: str = None, street_new: Union[str, ExplicitNull] = None, postal_code_new: Union[int, ExplicitNull] = None, geo_location_new: Union[dict, ExplicitNull] = None, site_fq_name_new: str = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if number_new is not None and not (isinstance(number_new, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_new)}")
		if street_new is not None and not (isinstance(street_new, str) or isinstance(street_new, ExplicitNull)):
			raise ValueError(f"'street' of incorrect type. Expected str, got {type(street_new)}")
		if postal_code_new is not None and not (isinstance(postal_code_new, int) or isinstance(postal_code_new, ExplicitNull)):
			raise ValueError(f"'postal_code' of incorrect type. Expected int, got {type(postal_code_new)}")
		if geo_location_new is not None and not (isinstance(geo_location_new, dict) or isinstance(geo_location_new, ExplicitNull)):
			raise ValueError(f"'geo_location' of incorrect type. Expected dict, got {type(geo_location_new)}")
		if site_fq_name_new is not None and not (isinstance(site_fq_name_new, str)):
			raise ValueError(f"'site_fq_name' of incorrect type. Expected str, got {type(site_fq_name_new)}")
		if not (isinstance(number_old, str)):
			raise ValueError(f"'number' of incorrect type. Expected str, got {type(number_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, number_new=number_new, street_new=street_new, postal_code_new=postal_code_new, geo_location_new=geo_location_new, site_fq_name_new=site_fq_name_new, number_old=number_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class PPort(APIObject):
	gpk: str
	name: str
	type: str
	speed: str
	is_nnl: bool
	mdl_bldg: str
	mdl_room: str
	mdl_type: str
	protocol: str
	type_group: str
	description: str
	mdl_fq_name: str
	name_sortby: str
	type_sortby: int
	is_connected: bool
	is_defective: bool
	is_edge_node: bool
	connected_gfk: str
	connected_name: str
	connected_mdl_bldg: str
	connected_mdl_room: str
	dest_connected_gfk: str
	connection_id_nodes: list
	connection_position: int
	connection_hop_count: int
	connected_mdl_fq_name: str
	is_internal_connected: bool
	internal_connected_gfk: str
	internal_connected_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if not isinstance(self.speed, str):
			raise ValueError(f"'speed' of incorrect type. Expected str, got {type(self.speed)}")
		if not isinstance(self.is_nnl, bool):
			raise ValueError(f"'is_nnl' of incorrect type. Expected bool, got {type(self.is_nnl)}")
		if self.mdl_bldg is not None and not isinstance(self.mdl_bldg, str):
			raise ValueError(f"'mdl_bldg' of incorrect type. Expected str, got {type(self.mdl_bldg)}")
		if self.mdl_room is not None and not isinstance(self.mdl_room, str):
			raise ValueError(f"'mdl_room' of incorrect type. Expected str, got {type(self.mdl_room)}")
		if not isinstance(self.mdl_type, str):
			raise ValueError(f"'mdl_type' of incorrect type. Expected str, got {type(self.mdl_type)}")
		if not isinstance(self.protocol, str):
			raise ValueError(f"'protocol' of incorrect type. Expected str, got {type(self.protocol)}")
		if not isinstance(self.type_group, str):
			raise ValueError(f"'type_group' of incorrect type. Expected str, got {type(self.type_group)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.mdl_fq_name, str):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(self.mdl_fq_name)}")
		if not isinstance(self.name_sortby, str):
			raise ValueError(f"'name_sortby' of incorrect type. Expected str, got {type(self.name_sortby)}")
		if not isinstance(self.type_sortby, int):
			raise ValueError(f"'type_sortby' of incorrect type. Expected int, got {type(self.type_sortby)}")
		if not isinstance(self.is_connected, bool):
			raise ValueError(f"'is_connected' of incorrect type. Expected bool, got {type(self.is_connected)}")
		if not isinstance(self.is_defective, bool):
			raise ValueError(f"'is_defective' of incorrect type. Expected bool, got {type(self.is_defective)}")
		if not isinstance(self.is_edge_node, bool):
			raise ValueError(f"'is_edge_node' of incorrect type. Expected bool, got {type(self.is_edge_node)}")
		if not isinstance(self.connected_gfk, str):
			raise ValueError(f"'connected_gfk' of incorrect type. Expected str, got {type(self.connected_gfk)}")
		if self.connected_name is not None and not isinstance(self.connected_name, str):
			raise ValueError(f"'connected_name' of incorrect type. Expected str, got {type(self.connected_name)}")
		if self.connected_mdl_bldg is not None and not isinstance(self.connected_mdl_bldg, str):
			raise ValueError(f"'connected_mdl_bldg' of incorrect type. Expected str, got {type(self.connected_mdl_bldg)}")
		if self.connected_mdl_room is not None and not isinstance(self.connected_mdl_room, str):
			raise ValueError(f"'connected_mdl_room' of incorrect type. Expected str, got {type(self.connected_mdl_room)}")
		if not isinstance(self.dest_connected_gfk, str):
			raise ValueError(f"'dest_connected_gfk' of incorrect type. Expected str, got {type(self.dest_connected_gfk)}")
		if not isinstance(self.connection_id_nodes, list):
			raise ValueError(f"'connection_id_nodes' of incorrect type. Expected list, got {type(self.connection_id_nodes)}")
		if not isinstance(self.connection_position, int):
			raise ValueError(f"'connection_position' of incorrect type. Expected int, got {type(self.connection_position)}")
		if self.connection_hop_count is not None and not isinstance(self.connection_hop_count, int):
			raise ValueError(f"'connection_hop_count' of incorrect type. Expected int, got {type(self.connection_hop_count)}")
		if self.connected_mdl_fq_name is not None and not isinstance(self.connected_mdl_fq_name, str):
			raise ValueError(f"'connected_mdl_fq_name' of incorrect type. Expected str, got {type(self.connected_mdl_fq_name)}")
		if not isinstance(self.is_internal_connected, bool):
			raise ValueError(f"'is_internal_connected' of incorrect type. Expected bool, got {type(self.is_internal_connected)}")
		if not isinstance(self.internal_connected_gfk, str):
			raise ValueError(f"'internal_connected_gfk' of incorrect type. Expected str, got {type(self.internal_connected_gfk)}")
		if self.internal_connected_name is not None and not isinstance(self.internal_connected_name, str):
			raise ValueError(f"'internal_connected_name' of incorrect type. Expected str, got {type(self.internal_connected_name)}")

	@staticmethod
	def bulk_connect_ta(mdl_fq_name_new: str, mdl_bldg_new: Union[str, ExplicitNull] = None, mdl_room_new: Union[str, ExplicitNull] = None, name_stop_new: str = None, name_start_new: str = None, include_all_ports_new: bool = False, type_group_is_fix_new: bool = None, connected_mdl_bldg_new: str = None, connected_mdl_room_new: str = None, connected_name_start_new: str = None, connected_mdl_fq_name_new: str = None) -> dict:
		if mdl_bldg_new is not None and not (isinstance(mdl_bldg_new, str) or isinstance(mdl_bldg_new, ExplicitNull)):
			raise ValueError(f"'mdl_bldg' of incorrect type. Expected str, got {type(mdl_bldg_new)}")
		if mdl_room_new is not None and not (isinstance(mdl_room_new, str) or isinstance(mdl_room_new, ExplicitNull)):
			raise ValueError(f"'mdl_room' of incorrect type. Expected str, got {type(mdl_room_new)}")
		if name_stop_new is not None and not (isinstance(name_stop_new, str)):
			raise ValueError(f"'name_stop' of incorrect type. Expected str, got {type(name_stop_new)}")
		if name_start_new is not None and not (isinstance(name_start_new, str)):
			raise ValueError(f"'name_start' of incorrect type. Expected str, got {type(name_start_new)}")
		if not (isinstance(mdl_fq_name_new, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_new)}")
		if include_all_ports_new is not None and not (isinstance(include_all_ports_new, bool)):
			raise ValueError(f"'include_all_ports' of incorrect type. Expected bool, got {type(include_all_ports_new)}")
		if type_group_is_fix_new is not None and not (isinstance(type_group_is_fix_new, bool)):
			raise ValueError(f"'type_group_is_fix' of incorrect type. Expected bool, got {type(type_group_is_fix_new)}")
		if connected_mdl_bldg_new is not None and not (isinstance(connected_mdl_bldg_new, str)):
			raise ValueError(f"'connected_mdl_bldg' of incorrect type. Expected str, got {type(connected_mdl_bldg_new)}")
		if connected_mdl_room_new is not None and not (isinstance(connected_mdl_room_new, str)):
			raise ValueError(f"'connected_mdl_room' of incorrect type. Expected str, got {type(connected_mdl_room_new)}")
		if connected_name_start_new is not None and not (isinstance(connected_name_start_new, str)):
			raise ValueError(f"'connected_name_start' of incorrect type. Expected str, got {type(connected_name_start_new)}")
		if connected_mdl_fq_name_new is not None and not (isinstance(connected_mdl_fq_name_new, str)):
			raise ValueError(f"'connected_mdl_fq_name' of incorrect type. Expected str, got {type(connected_mdl_fq_name_new)}")

		return {'name': 'nd.p_port.bulk_connect', 'new': _denullify_dict({'mdl_bldg': mdl_bldg_new, 'mdl_room': mdl_room_new, 'name_stop': name_stop_new, 'name_start': name_start_new, 'mdl_fq_name': mdl_fq_name_new, 'include_all_ports': include_all_ports_new, 'type_group_is_fix': type_group_is_fix_new, 'connected_mdl_bldg': connected_mdl_bldg_new, 'connected_mdl_room': connected_mdl_room_new, 'connected_name_start': connected_name_start_new, 'connected_mdl_fq_name': connected_mdl_fq_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def bulk_connect(cls, api_session: APISession, mdl_fq_name_new: str, mdl_bldg_new: Union[str, ExplicitNull] = None, mdl_room_new: Union[str, ExplicitNull] = None, name_stop_new: str = None, name_start_new: str = None, include_all_ports_new: bool = False, type_group_is_fix_new: bool = None, connected_mdl_bldg_new: str = None, connected_mdl_room_new: str = None, connected_name_start_new: str = None, connected_mdl_fq_name_new: str = None) -> list:
		if mdl_bldg_new is not None and not (isinstance(mdl_bldg_new, str) or isinstance(mdl_bldg_new, ExplicitNull)):
			raise ValueError(f"'mdl_bldg' of incorrect type. Expected str, got {type(mdl_bldg_new)}")
		if mdl_room_new is not None and not (isinstance(mdl_room_new, str) or isinstance(mdl_room_new, ExplicitNull)):
			raise ValueError(f"'mdl_room' of incorrect type. Expected str, got {type(mdl_room_new)}")
		if name_stop_new is not None and not (isinstance(name_stop_new, str)):
			raise ValueError(f"'name_stop' of incorrect type. Expected str, got {type(name_stop_new)}")
		if name_start_new is not None and not (isinstance(name_start_new, str)):
			raise ValueError(f"'name_start' of incorrect type. Expected str, got {type(name_start_new)}")
		if not (isinstance(mdl_fq_name_new, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_new)}")
		if include_all_ports_new is not None and not (isinstance(include_all_ports_new, bool)):
			raise ValueError(f"'include_all_ports' of incorrect type. Expected bool, got {type(include_all_ports_new)}")
		if type_group_is_fix_new is not None and not (isinstance(type_group_is_fix_new, bool)):
			raise ValueError(f"'type_group_is_fix' of incorrect type. Expected bool, got {type(type_group_is_fix_new)}")
		if connected_mdl_bldg_new is not None and not (isinstance(connected_mdl_bldg_new, str)):
			raise ValueError(f"'connected_mdl_bldg' of incorrect type. Expected str, got {type(connected_mdl_bldg_new)}")
		if connected_mdl_room_new is not None and not (isinstance(connected_mdl_room_new, str)):
			raise ValueError(f"'connected_mdl_room' of incorrect type. Expected str, got {type(connected_mdl_room_new)}")
		if connected_name_start_new is not None and not (isinstance(connected_name_start_new, str)):
			raise ValueError(f"'connected_name_start' of incorrect type. Expected str, got {type(connected_name_start_new)}")
		if connected_mdl_fq_name_new is not None and not (isinstance(connected_mdl_fq_name_new, str)):
			raise ValueError(f"'connected_mdl_fq_name' of incorrect type. Expected str, got {type(connected_mdl_fq_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.bulk_connect_ta(mdl_bldg_new=mdl_bldg_new, mdl_room_new=mdl_room_new, name_stop_new=name_stop_new, name_start_new=name_start_new, mdl_fq_name_new=mdl_fq_name_new, include_all_ports_new=include_all_ports_new, type_group_is_fix_new=type_group_is_fix_new, connected_mdl_bldg_new=connected_mdl_bldg_new, connected_mdl_room_new=connected_mdl_room_new, connected_name_start_new=connected_name_start_new, connected_mdl_fq_name_new=connected_mdl_fq_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def bulk_disconnect_ta(mdl_fq_name_old: str, mdl_bldg_old: str = None, mdl_room_old: str = None, name_stop_old: str = None, name_start_old: str = None, include_all_ports_old: bool = False, type_group_is_fix_old: bool = None, include_all_submdls_old: bool = False, do_delete_patch_cable_old: bool = False) -> dict:
		if mdl_bldg_old is not None and not (isinstance(mdl_bldg_old, str) or isinstance(mdl_bldg_old, ExplicitNull)):
			raise ValueError(f"'mdl_bldg' of incorrect type. Expected str, got {type(mdl_bldg_old)}")
		if mdl_room_old is not None and not (isinstance(mdl_room_old, str) or isinstance(mdl_room_old, ExplicitNull)):
			raise ValueError(f"'mdl_room' of incorrect type. Expected str, got {type(mdl_room_old)}")
		if name_stop_old is not None and not (isinstance(name_stop_old, str)):
			raise ValueError(f"'name_stop' of incorrect type. Expected str, got {type(name_stop_old)}")
		if name_start_old is not None and not (isinstance(name_start_old, str)):
			raise ValueError(f"'name_start' of incorrect type. Expected str, got {type(name_start_old)}")
		if not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")
		if include_all_ports_old is not None and not (isinstance(include_all_ports_old, bool)):
			raise ValueError(f"'include_all_ports' of incorrect type. Expected bool, got {type(include_all_ports_old)}")
		if type_group_is_fix_old is not None and not (isinstance(type_group_is_fix_old, bool)):
			raise ValueError(f"'type_group_is_fix' of incorrect type. Expected bool, got {type(type_group_is_fix_old)}")
		if include_all_submdls_old is not None and not (isinstance(include_all_submdls_old, bool)):
			raise ValueError(f"'include_all_submdls' of incorrect type. Expected bool, got {type(include_all_submdls_old)}")
		if do_delete_patch_cable_old is not None and not (isinstance(do_delete_patch_cable_old, bool)):
			raise ValueError(f"'do_delete_patch_cable' of incorrect type. Expected bool, got {type(do_delete_patch_cable_old)}")

		return {'name': 'nd.p_port.bulk_disconnect', 'new': _denullify_dict({}), 'old': _denullify_dict({'mdl_bldg': mdl_bldg_old, 'mdl_room': mdl_room_old, 'name_stop': name_stop_old, 'name_start': name_start_old, 'mdl_fq_name': mdl_fq_name_old, 'include_all_ports': include_all_ports_old, 'type_group_is_fix': type_group_is_fix_old, 'include_all_submdls': include_all_submdls_old, 'do_delete_patch_cable': do_delete_patch_cable_old})}

	# TODO: Consider is_returning
	@classmethod
	def bulk_disconnect(cls, api_session: APISession, mdl_fq_name_old: str, mdl_bldg_old: str = None, mdl_room_old: str = None, name_stop_old: str = None, name_start_old: str = None, include_all_ports_old: bool = False, type_group_is_fix_old: bool = None, include_all_submdls_old: bool = False, do_delete_patch_cable_old: bool = False) -> list:
		if mdl_bldg_old is not None and not (isinstance(mdl_bldg_old, str) or isinstance(mdl_bldg_old, ExplicitNull)):
			raise ValueError(f"'mdl_bldg' of incorrect type. Expected str, got {type(mdl_bldg_old)}")
		if mdl_room_old is not None and not (isinstance(mdl_room_old, str) or isinstance(mdl_room_old, ExplicitNull)):
			raise ValueError(f"'mdl_room' of incorrect type. Expected str, got {type(mdl_room_old)}")
		if name_stop_old is not None and not (isinstance(name_stop_old, str)):
			raise ValueError(f"'name_stop' of incorrect type. Expected str, got {type(name_stop_old)}")
		if name_start_old is not None and not (isinstance(name_start_old, str)):
			raise ValueError(f"'name_start' of incorrect type. Expected str, got {type(name_start_old)}")
		if not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")
		if include_all_ports_old is not None and not (isinstance(include_all_ports_old, bool)):
			raise ValueError(f"'include_all_ports' of incorrect type. Expected bool, got {type(include_all_ports_old)}")
		if type_group_is_fix_old is not None and not (isinstance(type_group_is_fix_old, bool)):
			raise ValueError(f"'type_group_is_fix' of incorrect type. Expected bool, got {type(type_group_is_fix_old)}")
		if include_all_submdls_old is not None and not (isinstance(include_all_submdls_old, bool)):
			raise ValueError(f"'include_all_submdls' of incorrect type. Expected bool, got {type(include_all_submdls_old)}")
		if do_delete_patch_cable_old is not None and not (isinstance(do_delete_patch_cable_old, bool)):
			raise ValueError(f"'do_delete_patch_cable' of incorrect type. Expected bool, got {type(do_delete_patch_cable_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.bulk_disconnect_ta(mdl_bldg_old=mdl_bldg_old, mdl_room_old=mdl_room_old, name_stop_old=name_stop_old, name_start_old=name_start_old, mdl_fq_name_old=mdl_fq_name_old, include_all_ports_old=include_all_ports_old, type_group_is_fix_old=type_group_is_fix_old, include_all_submdls_old=include_all_submdls_old, do_delete_patch_cable_old=do_delete_patch_cable_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def bulk_move_connection_ta(connected_name_start_new: str, connected_mdl_fq_name_new: str, name_stop_old: str, name_start_old: str, mdl_fq_name_old: str, connected_mdl_bldg_new: Union[str, ExplicitNull] = None, connected_mdl_room_new: Union[str, ExplicitNull] = None, mdl_bldg_old: str = None, mdl_room_old: str = None, type_group_is_fix_old: bool = False, do_copy_pp_description_old: bool = False) -> dict:
		if connected_mdl_bldg_new is not None and not (isinstance(connected_mdl_bldg_new, str) or isinstance(connected_mdl_bldg_new, ExplicitNull)):
			raise ValueError(f"'connected_mdl_bldg' of incorrect type. Expected str, got {type(connected_mdl_bldg_new)}")
		if connected_mdl_room_new is not None and not (isinstance(connected_mdl_room_new, str) or isinstance(connected_mdl_room_new, ExplicitNull)):
			raise ValueError(f"'connected_mdl_room' of incorrect type. Expected str, got {type(connected_mdl_room_new)}")
		if not (isinstance(connected_name_start_new, str)):
			raise ValueError(f"'connected_name_start' of incorrect type. Expected str, got {type(connected_name_start_new)}")
		if not (isinstance(connected_mdl_fq_name_new, str)):
			raise ValueError(f"'connected_mdl_fq_name' of incorrect type. Expected str, got {type(connected_mdl_fq_name_new)}")
		if mdl_bldg_old is not None and not (isinstance(mdl_bldg_old, str) or isinstance(mdl_bldg_old, ExplicitNull)):
			raise ValueError(f"'mdl_bldg' of incorrect type. Expected str, got {type(mdl_bldg_old)}")
		if mdl_room_old is not None and not (isinstance(mdl_room_old, str) or isinstance(mdl_room_old, ExplicitNull)):
			raise ValueError(f"'mdl_room' of incorrect type. Expected str, got {type(mdl_room_old)}")
		if not (isinstance(name_stop_old, str)):
			raise ValueError(f"'name_stop' of incorrect type. Expected str, got {type(name_stop_old)}")
		if not (isinstance(name_start_old, str)):
			raise ValueError(f"'name_start' of incorrect type. Expected str, got {type(name_start_old)}")
		if not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")
		if type_group_is_fix_old is not None and not (isinstance(type_group_is_fix_old, bool)):
			raise ValueError(f"'type_group_is_fix' of incorrect type. Expected bool, got {type(type_group_is_fix_old)}")
		if do_copy_pp_description_old is not None and not (isinstance(do_copy_pp_description_old, bool)):
			raise ValueError(f"'do_copy_pp_description' of incorrect type. Expected bool, got {type(do_copy_pp_description_old)}")

		return {'name': 'nd.p_port.bulk_move_connection', 'new': _denullify_dict({'connected_mdl_bldg': connected_mdl_bldg_new, 'connected_mdl_room': connected_mdl_room_new, 'connected_name_start': connected_name_start_new, 'connected_mdl_fq_name': connected_mdl_fq_name_new}), 'old': _denullify_dict({'mdl_bldg': mdl_bldg_old, 'mdl_room': mdl_room_old, 'name_stop': name_stop_old, 'name_start': name_start_old, 'mdl_fq_name': mdl_fq_name_old, 'type_group_is_fix': type_group_is_fix_old, 'do_copy_pp_description': do_copy_pp_description_old})}

	# TODO: Consider is_returning
	@classmethod
	def bulk_move_connection(cls, api_session: APISession, connected_name_start_new: str, connected_mdl_fq_name_new: str, name_stop_old: str, name_start_old: str, mdl_fq_name_old: str, connected_mdl_bldg_new: Union[str, ExplicitNull] = None, connected_mdl_room_new: Union[str, ExplicitNull] = None, mdl_bldg_old: str = None, mdl_room_old: str = None, type_group_is_fix_old: bool = False, do_copy_pp_description_old: bool = False) -> list:
		if connected_mdl_bldg_new is not None and not (isinstance(connected_mdl_bldg_new, str) or isinstance(connected_mdl_bldg_new, ExplicitNull)):
			raise ValueError(f"'connected_mdl_bldg' of incorrect type. Expected str, got {type(connected_mdl_bldg_new)}")
		if connected_mdl_room_new is not None and not (isinstance(connected_mdl_room_new, str) or isinstance(connected_mdl_room_new, ExplicitNull)):
			raise ValueError(f"'connected_mdl_room' of incorrect type. Expected str, got {type(connected_mdl_room_new)}")
		if not (isinstance(connected_name_start_new, str)):
			raise ValueError(f"'connected_name_start' of incorrect type. Expected str, got {type(connected_name_start_new)}")
		if not (isinstance(connected_mdl_fq_name_new, str)):
			raise ValueError(f"'connected_mdl_fq_name' of incorrect type. Expected str, got {type(connected_mdl_fq_name_new)}")
		if mdl_bldg_old is not None and not (isinstance(mdl_bldg_old, str) or isinstance(mdl_bldg_old, ExplicitNull)):
			raise ValueError(f"'mdl_bldg' of incorrect type. Expected str, got {type(mdl_bldg_old)}")
		if mdl_room_old is not None and not (isinstance(mdl_room_old, str) or isinstance(mdl_room_old, ExplicitNull)):
			raise ValueError(f"'mdl_room' of incorrect type. Expected str, got {type(mdl_room_old)}")
		if not (isinstance(name_stop_old, str)):
			raise ValueError(f"'name_stop' of incorrect type. Expected str, got {type(name_stop_old)}")
		if not (isinstance(name_start_old, str)):
			raise ValueError(f"'name_start' of incorrect type. Expected str, got {type(name_start_old)}")
		if not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")
		if type_group_is_fix_old is not None and not (isinstance(type_group_is_fix_old, bool)):
			raise ValueError(f"'type_group_is_fix' of incorrect type. Expected bool, got {type(type_group_is_fix_old)}")
		if do_copy_pp_description_old is not None and not (isinstance(do_copy_pp_description_old, bool)):
			raise ValueError(f"'do_copy_pp_description' of incorrect type. Expected bool, got {type(do_copy_pp_description_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.bulk_move_connection_ta(connected_mdl_bldg_new=connected_mdl_bldg_new, connected_mdl_room_new=connected_mdl_room_new, connected_name_start_new=connected_name_start_new, connected_mdl_fq_name_new=connected_mdl_fq_name_new, mdl_bldg_old=mdl_bldg_old, mdl_room_old=mdl_room_old, name_stop_old=name_stop_old, name_start_old=name_start_old, mdl_fq_name_old=mdl_fq_name_old, type_group_is_fix_old=type_group_is_fix_old, do_copy_pp_description_old=do_copy_pp_description_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def connect_ta(name_new: str, mdl_fq_name_new: str, connected_name_new: str, connected_mdl_fq_name_new: str, mdl_bldg_new: Union[str, ExplicitNull] = None, mdl_room_new: Union[str, ExplicitNull] = None, patch_cable_name_new: str = None, type_group_is_fix_new: bool = None, connected_mdl_bldg_new: Union[str, ExplicitNull] = None, connected_mdl_room_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if mdl_bldg_new is not None and not (isinstance(mdl_bldg_new, str) or isinstance(mdl_bldg_new, ExplicitNull)):
			raise ValueError(f"'mdl_bldg' of incorrect type. Expected str, got {type(mdl_bldg_new)}")
		if mdl_room_new is not None and not (isinstance(mdl_room_new, str) or isinstance(mdl_room_new, ExplicitNull)):
			raise ValueError(f"'mdl_room' of incorrect type. Expected str, got {type(mdl_room_new)}")
		if not (isinstance(mdl_fq_name_new, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_new)}")
		if not (isinstance(connected_name_new, str)):
			raise ValueError(f"'connected_name' of incorrect type. Expected str, got {type(connected_name_new)}")
		if patch_cable_name_new is not None and not (isinstance(patch_cable_name_new, str)):
			raise ValueError(f"'patch_cable_name' of incorrect type. Expected str, got {type(patch_cable_name_new)}")
		if type_group_is_fix_new is not None and not (isinstance(type_group_is_fix_new, bool)):
			raise ValueError(f"'type_group_is_fix' of incorrect type. Expected bool, got {type(type_group_is_fix_new)}")
		if connected_mdl_bldg_new is not None and not (isinstance(connected_mdl_bldg_new, str) or isinstance(connected_mdl_bldg_new, ExplicitNull)):
			raise ValueError(f"'connected_mdl_bldg' of incorrect type. Expected str, got {type(connected_mdl_bldg_new)}")
		if connected_mdl_room_new is not None and not (isinstance(connected_mdl_room_new, str) or isinstance(connected_mdl_room_new, ExplicitNull)):
			raise ValueError(f"'connected_mdl_room' of incorrect type. Expected str, got {type(connected_mdl_room_new)}")
		if not (isinstance(connected_mdl_fq_name_new, str)):
			raise ValueError(f"'connected_mdl_fq_name' of incorrect type. Expected str, got {type(connected_mdl_fq_name_new)}")

		return {'name': 'nd.p_port.connect', 'new': _denullify_dict({'name': name_new, 'mdl_bldg': mdl_bldg_new, 'mdl_room': mdl_room_new, 'mdl_fq_name': mdl_fq_name_new, 'connected_name': connected_name_new, 'patch_cable_name': patch_cable_name_new, 'type_group_is_fix': type_group_is_fix_new, 'connected_mdl_bldg': connected_mdl_bldg_new, 'connected_mdl_room': connected_mdl_room_new, 'connected_mdl_fq_name': connected_mdl_fq_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def connect(cls, api_session: APISession, name_new: str, mdl_fq_name_new: str, connected_name_new: str, connected_mdl_fq_name_new: str, mdl_bldg_new: Union[str, ExplicitNull] = None, mdl_room_new: Union[str, ExplicitNull] = None, patch_cable_name_new: str = None, type_group_is_fix_new: bool = None, connected_mdl_bldg_new: Union[str, ExplicitNull] = None, connected_mdl_room_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if mdl_bldg_new is not None and not (isinstance(mdl_bldg_new, str) or isinstance(mdl_bldg_new, ExplicitNull)):
			raise ValueError(f"'mdl_bldg' of incorrect type. Expected str, got {type(mdl_bldg_new)}")
		if mdl_room_new is not None and not (isinstance(mdl_room_new, str) or isinstance(mdl_room_new, ExplicitNull)):
			raise ValueError(f"'mdl_room' of incorrect type. Expected str, got {type(mdl_room_new)}")
		if not (isinstance(mdl_fq_name_new, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_new)}")
		if not (isinstance(connected_name_new, str)):
			raise ValueError(f"'connected_name' of incorrect type. Expected str, got {type(connected_name_new)}")
		if patch_cable_name_new is not None and not (isinstance(patch_cable_name_new, str)):
			raise ValueError(f"'patch_cable_name' of incorrect type. Expected str, got {type(patch_cable_name_new)}")
		if type_group_is_fix_new is not None and not (isinstance(type_group_is_fix_new, bool)):
			raise ValueError(f"'type_group_is_fix' of incorrect type. Expected bool, got {type(type_group_is_fix_new)}")
		if connected_mdl_bldg_new is not None and not (isinstance(connected_mdl_bldg_new, str) or isinstance(connected_mdl_bldg_new, ExplicitNull)):
			raise ValueError(f"'connected_mdl_bldg' of incorrect type. Expected str, got {type(connected_mdl_bldg_new)}")
		if connected_mdl_room_new is not None and not (isinstance(connected_mdl_room_new, str) or isinstance(connected_mdl_room_new, ExplicitNull)):
			raise ValueError(f"'connected_mdl_room' of incorrect type. Expected str, got {type(connected_mdl_room_new)}")
		if not (isinstance(connected_mdl_fq_name_new, str)):
			raise ValueError(f"'connected_mdl_fq_name' of incorrect type. Expected str, got {type(connected_mdl_fq_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.connect_ta(name_new=name_new, mdl_bldg_new=mdl_bldg_new, mdl_room_new=mdl_room_new, mdl_fq_name_new=mdl_fq_name_new, connected_name_new=connected_name_new, patch_cable_name_new=patch_cable_name_new, type_group_is_fix_new=type_group_is_fix_new, connected_mdl_bldg_new=connected_mdl_bldg_new, connected_mdl_room_new=connected_mdl_room_new, connected_mdl_fq_name_new=connected_mdl_fq_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def disconnect_ta(name_old: str, mdl_fq_name_old: str, mdl_bldg_old: str = None, mdl_room_old: str = None, type_group_is_fix_old: bool = False, do_delete_patch_cable_old: bool = False) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if mdl_bldg_old is not None and not (isinstance(mdl_bldg_old, str) or isinstance(mdl_bldg_old, ExplicitNull)):
			raise ValueError(f"'mdl_bldg' of incorrect type. Expected str, got {type(mdl_bldg_old)}")
		if mdl_room_old is not None and not (isinstance(mdl_room_old, str) or isinstance(mdl_room_old, ExplicitNull)):
			raise ValueError(f"'mdl_room' of incorrect type. Expected str, got {type(mdl_room_old)}")
		if not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")
		if type_group_is_fix_old is not None and not (isinstance(type_group_is_fix_old, bool)):
			raise ValueError(f"'type_group_is_fix' of incorrect type. Expected bool, got {type(type_group_is_fix_old)}")
		if do_delete_patch_cable_old is not None and not (isinstance(do_delete_patch_cable_old, bool)):
			raise ValueError(f"'do_delete_patch_cable' of incorrect type. Expected bool, got {type(do_delete_patch_cable_old)}")

		return {'name': 'nd.p_port.disconnect', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old, 'mdl_bldg': mdl_bldg_old, 'mdl_room': mdl_room_old, 'mdl_fq_name': mdl_fq_name_old, 'type_group_is_fix': type_group_is_fix_old, 'do_delete_patch_cable': do_delete_patch_cable_old})}

	# TODO: Consider is_returning
	@classmethod
	def disconnect(cls, api_session: APISession, name_old: str, mdl_fq_name_old: str, mdl_bldg_old: str = None, mdl_room_old: str = None, type_group_is_fix_old: bool = False, do_delete_patch_cable_old: bool = False) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if mdl_bldg_old is not None and not (isinstance(mdl_bldg_old, str) or isinstance(mdl_bldg_old, ExplicitNull)):
			raise ValueError(f"'mdl_bldg' of incorrect type. Expected str, got {type(mdl_bldg_old)}")
		if mdl_room_old is not None and not (isinstance(mdl_room_old, str) or isinstance(mdl_room_old, ExplicitNull)):
			raise ValueError(f"'mdl_room' of incorrect type. Expected str, got {type(mdl_room_old)}")
		if not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")
		if type_group_is_fix_old is not None and not (isinstance(type_group_is_fix_old, bool)):
			raise ValueError(f"'type_group_is_fix' of incorrect type. Expected bool, got {type(type_group_is_fix_old)}")
		if do_delete_patch_cable_old is not None and not (isinstance(do_delete_patch_cable_old, bool)):
			raise ValueError(f"'do_delete_patch_cable' of incorrect type. Expected bool, got {type(do_delete_patch_cable_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.disconnect_ta(name_old=name_old, mdl_bldg_old=mdl_bldg_old, mdl_room_old=mdl_room_old, mdl_fq_name_old=mdl_fq_name_old, type_group_is_fix_old=type_group_is_fix_old, do_delete_patch_cable_old=do_delete_patch_cable_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, type_old: str = None, speed_old: str = None, is_nnl_old: bool = None, mdl_bldg_old: str = None, mdl_room_old: str = None, protocol_old: str = None, type_group_old: str = None, fetch_limit_old: int = None, mdl_fq_name_old: str = None, name_regexp_old: str = None, fetch_offset_old: int = None, is_connected_old: bool = None, is_edge_node_old: bool = None, do_connection_path_old: bool = False, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, is_internal_connected_old: bool = None, do_connection_dest_only_old: bool = False) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if speed_old is not None and not (isinstance(speed_old, str)):
			raise ValueError(f"'speed' of incorrect type. Expected str, got {type(speed_old)}")
		if is_nnl_old is not None and not (isinstance(is_nnl_old, bool)):
			raise ValueError(f"'is_nnl' of incorrect type. Expected bool, got {type(is_nnl_old)}")
		if mdl_bldg_old is not None and not (isinstance(mdl_bldg_old, str)):
			raise ValueError(f"'mdl_bldg' of incorrect type. Expected str, got {type(mdl_bldg_old)}")
		if mdl_room_old is not None and not (isinstance(mdl_room_old, str)):
			raise ValueError(f"'mdl_room' of incorrect type. Expected str, got {type(mdl_room_old)}")
		if protocol_old is not None and not (isinstance(protocol_old, str)):
			raise ValueError(f"'protocol' of incorrect type. Expected str, got {type(protocol_old)}")
		if type_group_old is not None and not (isinstance(type_group_old, str)):
			raise ValueError(f"'type_group' of incorrect type. Expected str, got {type(type_group_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if mdl_fq_name_old is not None and not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")
		if name_regexp_old is not None and not (isinstance(name_regexp_old, str)):
			raise ValueError(f"'name_regexp' of incorrect type. Expected str, got {type(name_regexp_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_connected_old is not None and not (isinstance(is_connected_old, bool)):
			raise ValueError(f"'is_connected' of incorrect type. Expected bool, got {type(is_connected_old)}")
		if is_edge_node_old is not None and not (isinstance(is_edge_node_old, bool)):
			raise ValueError(f"'is_edge_node' of incorrect type. Expected bool, got {type(is_edge_node_old)}")
		if do_connection_path_old is not None and not (isinstance(do_connection_path_old, bool)):
			raise ValueError(f"'do_connection_path' of incorrect type. Expected bool, got {type(do_connection_path_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if is_internal_connected_old is not None and not (isinstance(is_internal_connected_old, bool)):
			raise ValueError(f"'is_internal_connected' of incorrect type. Expected bool, got {type(is_internal_connected_old)}")
		if do_connection_dest_only_old is not None and not (isinstance(do_connection_dest_only_old, bool)):
			raise ValueError(f"'do_connection_dest_only' of incorrect type. Expected bool, got {type(do_connection_dest_only_old)}")

		return {'name': 'nd.p_port.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'type': type_old, 'speed': speed_old, 'is_nnl': is_nnl_old, 'mdl_bldg': mdl_bldg_old, 'mdl_room': mdl_room_old, 'protocol': protocol_old, 'type_group': type_group_old, 'fetch_limit': fetch_limit_old, 'mdl_fq_name': mdl_fq_name_old, 'name_regexp': name_regexp_old, 'fetch_offset': fetch_offset_old, 'is_connected': is_connected_old, 'is_edge_node': is_edge_node_old, 'do_connection_path': do_connection_path_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old, 'is_internal_connected': is_internal_connected_old, 'do_connection_dest_only': do_connection_dest_only_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, type_old: str = None, speed_old: str = None, is_nnl_old: bool = None, mdl_bldg_old: str = None, mdl_room_old: str = None, protocol_old: str = None, type_group_old: str = None, fetch_limit_old: int = None, mdl_fq_name_old: str = None, name_regexp_old: str = None, fetch_offset_old: int = None, is_connected_old: bool = None, is_edge_node_old: bool = None, do_connection_path_old: bool = False, filter_params_dict_old: dict = None, sorting_params_list_old: list = None, is_internal_connected_old: bool = None, do_connection_dest_only_old: bool = False) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if speed_old is not None and not (isinstance(speed_old, str)):
			raise ValueError(f"'speed' of incorrect type. Expected str, got {type(speed_old)}")
		if is_nnl_old is not None and not (isinstance(is_nnl_old, bool)):
			raise ValueError(f"'is_nnl' of incorrect type. Expected bool, got {type(is_nnl_old)}")
		if mdl_bldg_old is not None and not (isinstance(mdl_bldg_old, str)):
			raise ValueError(f"'mdl_bldg' of incorrect type. Expected str, got {type(mdl_bldg_old)}")
		if mdl_room_old is not None and not (isinstance(mdl_room_old, str)):
			raise ValueError(f"'mdl_room' of incorrect type. Expected str, got {type(mdl_room_old)}")
		if protocol_old is not None and not (isinstance(protocol_old, str)):
			raise ValueError(f"'protocol' of incorrect type. Expected str, got {type(protocol_old)}")
		if type_group_old is not None and not (isinstance(type_group_old, str)):
			raise ValueError(f"'type_group' of incorrect type. Expected str, got {type(type_group_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if mdl_fq_name_old is not None and not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")
		if name_regexp_old is not None and not (isinstance(name_regexp_old, str)):
			raise ValueError(f"'name_regexp' of incorrect type. Expected str, got {type(name_regexp_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_connected_old is not None and not (isinstance(is_connected_old, bool)):
			raise ValueError(f"'is_connected' of incorrect type. Expected bool, got {type(is_connected_old)}")
		if is_edge_node_old is not None and not (isinstance(is_edge_node_old, bool)):
			raise ValueError(f"'is_edge_node' of incorrect type. Expected bool, got {type(is_edge_node_old)}")
		if do_connection_path_old is not None and not (isinstance(do_connection_path_old, bool)):
			raise ValueError(f"'do_connection_path' of incorrect type. Expected bool, got {type(do_connection_path_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")
		if is_internal_connected_old is not None and not (isinstance(is_internal_connected_old, bool)):
			raise ValueError(f"'is_internal_connected' of incorrect type. Expected bool, got {type(is_internal_connected_old)}")
		if do_connection_dest_only_old is not None and not (isinstance(do_connection_dest_only_old, bool)):
			raise ValueError(f"'do_connection_dest_only' of incorrect type. Expected bool, got {type(do_connection_dest_only_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, type_old=type_old, speed_old=speed_old, is_nnl_old=is_nnl_old, mdl_bldg_old=mdl_bldg_old, mdl_room_old=mdl_room_old, protocol_old=protocol_old, type_group_old=type_group_old, fetch_limit_old=fetch_limit_old, mdl_fq_name_old=mdl_fq_name_old, name_regexp_old=name_regexp_old, fetch_offset_old=fetch_offset_old, is_connected_old=is_connected_old, is_edge_node_old=is_edge_node_old, do_connection_path_old=do_connection_path_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old, is_internal_connected_old=is_internal_connected_old, do_connection_dest_only_old=do_connection_dest_only_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, mdl_fq_name_old: str, description_new: Union[str, ExplicitNull] = None, is_defective_new: bool = False, mdl_bldg_old: str = None, mdl_room_old: str = None) -> dict:
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if is_defective_new is not None and not (isinstance(is_defective_new, bool)):
			raise ValueError(f"'is_defective' of incorrect type. Expected bool, got {type(is_defective_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if mdl_bldg_old is not None and not (isinstance(mdl_bldg_old, str) or isinstance(mdl_bldg_old, ExplicitNull)):
			raise ValueError(f"'mdl_bldg' of incorrect type. Expected str, got {type(mdl_bldg_old)}")
		if mdl_room_old is not None and not (isinstance(mdl_room_old, str) or isinstance(mdl_room_old, ExplicitNull)):
			raise ValueError(f"'mdl_room' of incorrect type. Expected str, got {type(mdl_room_old)}")
		if not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")

		return {'name': 'nd.p_port.update', 'new': _denullify_dict({'description': description_new, 'is_defective': is_defective_new}), 'old': _denullify_dict({'name': name_old, 'mdl_bldg': mdl_bldg_old, 'mdl_room': mdl_room_old, 'mdl_fq_name': mdl_fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, mdl_fq_name_old: str, description_new: Union[str, ExplicitNull] = None, is_defective_new: bool = False, mdl_bldg_old: str = None, mdl_room_old: str = None) -> list:
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if is_defective_new is not None and not (isinstance(is_defective_new, bool)):
			raise ValueError(f"'is_defective' of incorrect type. Expected bool, got {type(is_defective_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if mdl_bldg_old is not None and not (isinstance(mdl_bldg_old, str) or isinstance(mdl_bldg_old, ExplicitNull)):
			raise ValueError(f"'mdl_bldg' of incorrect type. Expected str, got {type(mdl_bldg_old)}")
		if mdl_room_old is not None and not (isinstance(mdl_room_old, str) or isinstance(mdl_room_old, ExplicitNull)):
			raise ValueError(f"'mdl_room' of incorrect type. Expected str, got {type(mdl_room_old)}")
		if not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(description_new=description_new, is_defective_new=is_defective_new, name_old=name_old, mdl_bldg_old=mdl_bldg_old, mdl_room_old=mdl_room_old, mdl_fq_name_old=mdl_fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Site(APIObject):
	gpk: str
	name: str
	type: str
	fq_name: str
	is_child: bool
	has_parent: bool
	description: str
	force_is_child: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if not isinstance(self.fq_name, str):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(self.fq_name)}")
		if not isinstance(self.is_child, bool):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(self.is_child)}")
		if not isinstance(self.has_parent, bool):
			raise ValueError(f"'has_parent' of incorrect type. Expected bool, got {type(self.has_parent)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.force_is_child, bool):
			raise ValueError(f"'force_is_child' of incorrect type. Expected bool, got {type(self.force_is_child)}")

	@staticmethod
	def create_ta(type_new: str, fq_name_new: str, description_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		return {'name': 'nd.site.create', 'new': _denullify_dict({'type': type_new, 'fq_name': fq_name_new, 'description': description_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, type_new: str, fq_name_new: str, description_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(type_new=type_new, fq_name_new=fq_name_new, description_new=description_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(fq_name_old: str) -> dict:
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")

		return {'name': 'nd.site.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'fq_name': fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, fq_name_old: str) -> list:
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(fq_name_old=fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, type_old: str = None, fq_name_old: str = None, is_child_old: bool = None, has_parent_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, force_is_child_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if fq_name_old is not None and not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")
		if is_child_old is not None and not (isinstance(is_child_old, bool)):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(is_child_old)}")
		if has_parent_old is not None and not (isinstance(has_parent_old, bool)):
			raise ValueError(f"'has_parent' of incorrect type. Expected bool, got {type(has_parent_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if force_is_child_old is not None and not (isinstance(force_is_child_old, bool)):
			raise ValueError(f"'force_is_child' of incorrect type. Expected bool, got {type(force_is_child_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.site.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'type': type_old, 'fq_name': fq_name_old, 'is_child': is_child_old, 'has_parent': has_parent_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'force_is_child': force_is_child_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, type_old: str = None, fq_name_old: str = None, is_child_old: bool = None, has_parent_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, force_is_child_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if fq_name_old is not None and not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")
		if is_child_old is not None and not (isinstance(is_child_old, bool)):
			raise ValueError(f"'is_child' of incorrect type. Expected bool, got {type(is_child_old)}")
		if has_parent_old is not None and not (isinstance(has_parent_old, bool)):
			raise ValueError(f"'has_parent' of incorrect type. Expected bool, got {type(has_parent_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if force_is_child_old is not None and not (isinstance(force_is_child_old, bool)):
			raise ValueError(f"'force_is_child' of incorrect type. Expected bool, got {type(force_is_child_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, type_old=type_old, fq_name_old=fq_name_old, is_child_old=is_child_old, has_parent_old=has_parent_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, force_is_child_old=force_is_child_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(fq_name_old: str, type_new: str = None, fq_name_new: str = None, description_new: Union[str, ExplicitNull] = None) -> dict:
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if fq_name_new is not None and not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")

		return {'name': 'nd.site.update', 'new': _denullify_dict({'type': type_new, 'fq_name': fq_name_new, 'description': description_new}), 'old': _denullify_dict({'fq_name': fq_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, fq_name_old: str, type_new: str = None, fq_name_new: str = None, description_new: Union[str, ExplicitNull] = None) -> list:
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if fq_name_new is not None and not (isinstance(fq_name_new, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(fq_name_old, str)):
			raise ValueError(f"'fq_name' of incorrect type. Expected str, got {type(fq_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(type_new=type_new, fq_name_new=fq_name_new, description_new=description_new, fq_name_old=fq_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Module2ap(APIObject):
	gpk: str
	bldg: str
	room: str
	ap_name: str
	mdl_fq_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.bldg, str):
			raise ValueError(f"'bldg' of incorrect type. Expected str, got {type(self.bldg)}")
		if not isinstance(self.room, str):
			raise ValueError(f"'room' of incorrect type. Expected str, got {type(self.room)}")
		if not isinstance(self.ap_name, str):
			raise ValueError(f"'ap_name' of incorrect type. Expected str, got {type(self.ap_name)}")
		if not isinstance(self.mdl_fq_name, str):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(self.mdl_fq_name)}")

	@staticmethod
	def list_ta(gpk_old: str = None, fetch_limit_old: int = None, mdl_fq_name_old: str = None, ap_name_list_old: list = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if mdl_fq_name_old is not None and not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")
		if ap_name_list_old is not None and not (isinstance(ap_name_list_old, list)):
			raise ValueError(f"'ap_name_list' of incorrect type. Expected list, got {type(ap_name_list_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.module2ap.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'fetch_limit': fetch_limit_old, 'mdl_fq_name': mdl_fq_name_old, 'ap_name_list': ap_name_list_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, fetch_limit_old: int = None, mdl_fq_name_old: str = None, ap_name_list_old: list = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if mdl_fq_name_old is not None and not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")
		if ap_name_list_old is not None and not (isinstance(ap_name_list_old, list)):
			raise ValueError(f"'ap_name_list' of incorrect type. Expected list, got {type(ap_name_list_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, fetch_limit_old=fetch_limit_old, mdl_fq_name_old=mdl_fq_name_old, ap_name_list_old=ap_name_list_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Bcd(APIObject):
	gpk: str
	name: str
	categ: str
	is_own: bool
	seclvl: int
	vlan_count: int
	description: str
	dhcp_domain: str
	dhcp_enabled: bool
	subnet_count: int
	admin_description: str
	dhcp_accept_new_leases: bool
	dhcp_ttl_value_percent: int
	dhcp_leasetime_dyn_days: int
	dhcp_leasetime_dyn_hours: int
	dhcp_leasetime_dyn_minutes: int
	dhcp_leasetime_static_days: int
	dhcp_leasetime_static_hours: int
	dhcp_offer_rsv_time_minutes: int
	dhcp_offer_rsv_time_seconds: int
	dhcp_leasetime_static_minutes: int
	dhcp_accept_requested_hostname: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.categ, str):
			raise ValueError(f"'categ' of incorrect type. Expected str, got {type(self.categ)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.seclvl, int):
			raise ValueError(f"'seclvl' of incorrect type. Expected int, got {type(self.seclvl)}")
		if not isinstance(self.vlan_count, int):
			raise ValueError(f"'vlan_count' of incorrect type. Expected int, got {type(self.vlan_count)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if self.dhcp_domain is not None and not isinstance(self.dhcp_domain, str):
			raise ValueError(f"'dhcp_domain' of incorrect type. Expected str, got {type(self.dhcp_domain)}")
		if not isinstance(self.dhcp_enabled, bool):
			raise ValueError(f"'dhcp_enabled' of incorrect type. Expected bool, got {type(self.dhcp_enabled)}")
		if not isinstance(self.subnet_count, int):
			raise ValueError(f"'subnet_count' of incorrect type. Expected int, got {type(self.subnet_count)}")
		if self.admin_description is not None and not isinstance(self.admin_description, str):
			raise ValueError(f"'admin_description' of incorrect type. Expected str, got {type(self.admin_description)}")
		if not isinstance(self.dhcp_accept_new_leases, bool):
			raise ValueError(f"'dhcp_accept_new_leases' of incorrect type. Expected bool, got {type(self.dhcp_accept_new_leases)}")
		if not isinstance(self.dhcp_ttl_value_percent, int):
			raise ValueError(f"'dhcp_ttl_value_percent' of incorrect type. Expected int, got {type(self.dhcp_ttl_value_percent)}")
		if not isinstance(self.dhcp_leasetime_dyn_days, int):
			raise ValueError(f"'dhcp_leasetime_dyn_days' of incorrect type. Expected int, got {type(self.dhcp_leasetime_dyn_days)}")
		if not isinstance(self.dhcp_leasetime_dyn_hours, int):
			raise ValueError(f"'dhcp_leasetime_dyn_hours' of incorrect type. Expected int, got {type(self.dhcp_leasetime_dyn_hours)}")
		if not isinstance(self.dhcp_leasetime_dyn_minutes, int):
			raise ValueError(f"'dhcp_leasetime_dyn_minutes' of incorrect type. Expected int, got {type(self.dhcp_leasetime_dyn_minutes)}")
		if not isinstance(self.dhcp_leasetime_static_days, int):
			raise ValueError(f"'dhcp_leasetime_static_days' of incorrect type. Expected int, got {type(self.dhcp_leasetime_static_days)}")
		if not isinstance(self.dhcp_leasetime_static_hours, int):
			raise ValueError(f"'dhcp_leasetime_static_hours' of incorrect type. Expected int, got {type(self.dhcp_leasetime_static_hours)}")
		if not isinstance(self.dhcp_offer_rsv_time_minutes, int):
			raise ValueError(f"'dhcp_offer_rsv_time_minutes' of incorrect type. Expected int, got {type(self.dhcp_offer_rsv_time_minutes)}")
		if not isinstance(self.dhcp_offer_rsv_time_seconds, int):
			raise ValueError(f"'dhcp_offer_rsv_time_seconds' of incorrect type. Expected int, got {type(self.dhcp_offer_rsv_time_seconds)}")
		if not isinstance(self.dhcp_leasetime_static_minutes, int):
			raise ValueError(f"'dhcp_leasetime_static_minutes' of incorrect type. Expected int, got {type(self.dhcp_leasetime_static_minutes)}")
		if self.dhcp_accept_requested_hostname is not None and not isinstance(self.dhcp_accept_requested_hostname, bool):
			raise ValueError(f"'dhcp_accept_requested_hostname' of incorrect type. Expected bool, got {type(self.dhcp_accept_requested_hostname)}")

	@staticmethod
	def copy_ta(name_new: str, create_from_name_old: str) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(create_from_name_old, str)):
			raise ValueError(f"'create_from_name' of incorrect type. Expected str, got {type(create_from_name_old)}")

		return {'name': 'nd.bcd.copy', 'new': _denullify_dict({'name': name_new}), 'old': _denullify_dict({'create_from_name': create_from_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def copy(cls, api_session: APISession, name_new: str, create_from_name_old: str) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(create_from_name_old, str)):
			raise ValueError(f"'create_from_name' of incorrect type. Expected str, got {type(create_from_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.copy_ta(name_new=name_new, create_from_name_old=create_from_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def create_ta(name_new: str, categ_new: str, seclvl_new: int, description_new: Union[str, ExplicitNull] = None, dhcp_domain_new: Union[str, ExplicitNull] = None, dhcp_enabled_new: bool = False, admin_description_new: Union[str, ExplicitNull] = None, dhcp_accept_new_leases_new: bool = True, dhcp_ttl_value_percent_new: int = 60, dhcp_leasetime_dyn_days_new: int = 0, dhcp_leasetime_dyn_hours_new: int = 2, dhcp_leasetime_dyn_minutes_new: int = 0, dhcp_leasetime_static_days_new: int = 0, dhcp_leasetime_static_hours_new: int = 6, dhcp_offer_rsv_time_minutes_new: int = 0, dhcp_offer_rsv_time_seconds_new: int = 15, dhcp_leasetime_static_minutes_new: int = 0, dhcp_accept_requested_hostname_new: Union[bool, ExplicitNull] = False) -> dict:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(categ_new, str)):
			raise ValueError(f"'categ' of incorrect type. Expected str, got {type(categ_new)}")
		if not (isinstance(seclvl_new, int)):
			raise ValueError(f"'seclvl' of incorrect type. Expected int, got {type(seclvl_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if dhcp_domain_new is not None and not (isinstance(dhcp_domain_new, str) or isinstance(dhcp_domain_new, ExplicitNull)):
			raise ValueError(f"'dhcp_domain' of incorrect type. Expected str, got {type(dhcp_domain_new)}")
		if dhcp_enabled_new is not None and not (isinstance(dhcp_enabled_new, bool)):
			raise ValueError(f"'dhcp_enabled' of incorrect type. Expected bool, got {type(dhcp_enabled_new)}")
		if admin_description_new is not None and not (isinstance(admin_description_new, str) or isinstance(admin_description_new, ExplicitNull)):
			raise ValueError(f"'admin_description' of incorrect type. Expected str, got {type(admin_description_new)}")
		if dhcp_accept_new_leases_new is not None and not (isinstance(dhcp_accept_new_leases_new, bool)):
			raise ValueError(f"'dhcp_accept_new_leases' of incorrect type. Expected bool, got {type(dhcp_accept_new_leases_new)}")
		if dhcp_ttl_value_percent_new is not None and not (isinstance(dhcp_ttl_value_percent_new, int)):
			raise ValueError(f"'dhcp_ttl_value_percent' of incorrect type. Expected int, got {type(dhcp_ttl_value_percent_new)}")
		if dhcp_leasetime_dyn_days_new is not None and not (isinstance(dhcp_leasetime_dyn_days_new, int)):
			raise ValueError(f"'dhcp_leasetime_dyn_days' of incorrect type. Expected int, got {type(dhcp_leasetime_dyn_days_new)}")
		if dhcp_leasetime_dyn_hours_new is not None and not (isinstance(dhcp_leasetime_dyn_hours_new, int)):
			raise ValueError(f"'dhcp_leasetime_dyn_hours' of incorrect type. Expected int, got {type(dhcp_leasetime_dyn_hours_new)}")
		if dhcp_leasetime_dyn_minutes_new is not None and not (isinstance(dhcp_leasetime_dyn_minutes_new, int)):
			raise ValueError(f"'dhcp_leasetime_dyn_minutes' of incorrect type. Expected int, got {type(dhcp_leasetime_dyn_minutes_new)}")
		if dhcp_leasetime_static_days_new is not None and not (isinstance(dhcp_leasetime_static_days_new, int)):
			raise ValueError(f"'dhcp_leasetime_static_days' of incorrect type. Expected int, got {type(dhcp_leasetime_static_days_new)}")
		if dhcp_leasetime_static_hours_new is not None and not (isinstance(dhcp_leasetime_static_hours_new, int)):
			raise ValueError(f"'dhcp_leasetime_static_hours' of incorrect type. Expected int, got {type(dhcp_leasetime_static_hours_new)}")
		if dhcp_offer_rsv_time_minutes_new is not None and not (isinstance(dhcp_offer_rsv_time_minutes_new, int)):
			raise ValueError(f"'dhcp_offer_rsv_time_minutes' of incorrect type. Expected int, got {type(dhcp_offer_rsv_time_minutes_new)}")
		if dhcp_offer_rsv_time_seconds_new is not None and not (isinstance(dhcp_offer_rsv_time_seconds_new, int)):
			raise ValueError(f"'dhcp_offer_rsv_time_seconds' of incorrect type. Expected int, got {type(dhcp_offer_rsv_time_seconds_new)}")
		if dhcp_leasetime_static_minutes_new is not None and not (isinstance(dhcp_leasetime_static_minutes_new, int)):
			raise ValueError(f"'dhcp_leasetime_static_minutes' of incorrect type. Expected int, got {type(dhcp_leasetime_static_minutes_new)}")
		if dhcp_accept_requested_hostname_new is not None and not (isinstance(dhcp_accept_requested_hostname_new, bool) or isinstance(dhcp_accept_requested_hostname_new, ExplicitNull)):
			raise ValueError(f"'dhcp_accept_requested_hostname' of incorrect type. Expected bool, got {type(dhcp_accept_requested_hostname_new)}")

		return {'name': 'nd.bcd.create', 'new': _denullify_dict({'name': name_new, 'categ': categ_new, 'seclvl': seclvl_new, 'description': description_new, 'dhcp_domain': dhcp_domain_new, 'dhcp_enabled': dhcp_enabled_new, 'admin_description': admin_description_new, 'dhcp_accept_new_leases': dhcp_accept_new_leases_new, 'dhcp_ttl_value_percent': dhcp_ttl_value_percent_new, 'dhcp_leasetime_dyn_days': dhcp_leasetime_dyn_days_new, 'dhcp_leasetime_dyn_hours': dhcp_leasetime_dyn_hours_new, 'dhcp_leasetime_dyn_minutes': dhcp_leasetime_dyn_minutes_new, 'dhcp_leasetime_static_days': dhcp_leasetime_static_days_new, 'dhcp_leasetime_static_hours': dhcp_leasetime_static_hours_new, 'dhcp_offer_rsv_time_minutes': dhcp_offer_rsv_time_minutes_new, 'dhcp_offer_rsv_time_seconds': dhcp_offer_rsv_time_seconds_new, 'dhcp_leasetime_static_minutes': dhcp_leasetime_static_minutes_new, 'dhcp_accept_requested_hostname': dhcp_accept_requested_hostname_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, name_new: str, categ_new: str, seclvl_new: int, description_new: Union[str, ExplicitNull] = None, dhcp_domain_new: Union[str, ExplicitNull] = None, dhcp_enabled_new: bool = False, admin_description_new: Union[str, ExplicitNull] = None, dhcp_accept_new_leases_new: bool = True, dhcp_ttl_value_percent_new: int = 60, dhcp_leasetime_dyn_days_new: int = 0, dhcp_leasetime_dyn_hours_new: int = 2, dhcp_leasetime_dyn_minutes_new: int = 0, dhcp_leasetime_static_days_new: int = 0, dhcp_leasetime_static_hours_new: int = 6, dhcp_offer_rsv_time_minutes_new: int = 0, dhcp_offer_rsv_time_seconds_new: int = 15, dhcp_leasetime_static_minutes_new: int = 0, dhcp_accept_requested_hostname_new: Union[bool, ExplicitNull] = False) -> list:
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(categ_new, str)):
			raise ValueError(f"'categ' of incorrect type. Expected str, got {type(categ_new)}")
		if not (isinstance(seclvl_new, int)):
			raise ValueError(f"'seclvl' of incorrect type. Expected int, got {type(seclvl_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if dhcp_domain_new is not None and not (isinstance(dhcp_domain_new, str) or isinstance(dhcp_domain_new, ExplicitNull)):
			raise ValueError(f"'dhcp_domain' of incorrect type. Expected str, got {type(dhcp_domain_new)}")
		if dhcp_enabled_new is not None and not (isinstance(dhcp_enabled_new, bool)):
			raise ValueError(f"'dhcp_enabled' of incorrect type. Expected bool, got {type(dhcp_enabled_new)}")
		if admin_description_new is not None and not (isinstance(admin_description_new, str) or isinstance(admin_description_new, ExplicitNull)):
			raise ValueError(f"'admin_description' of incorrect type. Expected str, got {type(admin_description_new)}")
		if dhcp_accept_new_leases_new is not None and not (isinstance(dhcp_accept_new_leases_new, bool)):
			raise ValueError(f"'dhcp_accept_new_leases' of incorrect type. Expected bool, got {type(dhcp_accept_new_leases_new)}")
		if dhcp_ttl_value_percent_new is not None and not (isinstance(dhcp_ttl_value_percent_new, int)):
			raise ValueError(f"'dhcp_ttl_value_percent' of incorrect type. Expected int, got {type(dhcp_ttl_value_percent_new)}")
		if dhcp_leasetime_dyn_days_new is not None and not (isinstance(dhcp_leasetime_dyn_days_new, int)):
			raise ValueError(f"'dhcp_leasetime_dyn_days' of incorrect type. Expected int, got {type(dhcp_leasetime_dyn_days_new)}")
		if dhcp_leasetime_dyn_hours_new is not None and not (isinstance(dhcp_leasetime_dyn_hours_new, int)):
			raise ValueError(f"'dhcp_leasetime_dyn_hours' of incorrect type. Expected int, got {type(dhcp_leasetime_dyn_hours_new)}")
		if dhcp_leasetime_dyn_minutes_new is not None and not (isinstance(dhcp_leasetime_dyn_minutes_new, int)):
			raise ValueError(f"'dhcp_leasetime_dyn_minutes' of incorrect type. Expected int, got {type(dhcp_leasetime_dyn_minutes_new)}")
		if dhcp_leasetime_static_days_new is not None and not (isinstance(dhcp_leasetime_static_days_new, int)):
			raise ValueError(f"'dhcp_leasetime_static_days' of incorrect type. Expected int, got {type(dhcp_leasetime_static_days_new)}")
		if dhcp_leasetime_static_hours_new is not None and not (isinstance(dhcp_leasetime_static_hours_new, int)):
			raise ValueError(f"'dhcp_leasetime_static_hours' of incorrect type. Expected int, got {type(dhcp_leasetime_static_hours_new)}")
		if dhcp_offer_rsv_time_minutes_new is not None and not (isinstance(dhcp_offer_rsv_time_minutes_new, int)):
			raise ValueError(f"'dhcp_offer_rsv_time_minutes' of incorrect type. Expected int, got {type(dhcp_offer_rsv_time_minutes_new)}")
		if dhcp_offer_rsv_time_seconds_new is not None and not (isinstance(dhcp_offer_rsv_time_seconds_new, int)):
			raise ValueError(f"'dhcp_offer_rsv_time_seconds' of incorrect type. Expected int, got {type(dhcp_offer_rsv_time_seconds_new)}")
		if dhcp_leasetime_static_minutes_new is not None and not (isinstance(dhcp_leasetime_static_minutes_new, int)):
			raise ValueError(f"'dhcp_leasetime_static_minutes' of incorrect type. Expected int, got {type(dhcp_leasetime_static_minutes_new)}")
		if dhcp_accept_requested_hostname_new is not None and not (isinstance(dhcp_accept_requested_hostname_new, bool) or isinstance(dhcp_accept_requested_hostname_new, ExplicitNull)):
			raise ValueError(f"'dhcp_accept_requested_hostname' of incorrect type. Expected bool, got {type(dhcp_accept_requested_hostname_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(name_new=name_new, categ_new=categ_new, seclvl_new=seclvl_new, description_new=description_new, dhcp_domain_new=dhcp_domain_new, dhcp_enabled_new=dhcp_enabled_new, admin_description_new=admin_description_new, dhcp_accept_new_leases_new=dhcp_accept_new_leases_new, dhcp_ttl_value_percent_new=dhcp_ttl_value_percent_new, dhcp_leasetime_dyn_days_new=dhcp_leasetime_dyn_days_new, dhcp_leasetime_dyn_hours_new=dhcp_leasetime_dyn_hours_new, dhcp_leasetime_dyn_minutes_new=dhcp_leasetime_dyn_minutes_new, dhcp_leasetime_static_days_new=dhcp_leasetime_static_days_new, dhcp_leasetime_static_hours_new=dhcp_leasetime_static_hours_new, dhcp_offer_rsv_time_minutes_new=dhcp_offer_rsv_time_minutes_new, dhcp_offer_rsv_time_seconds_new=dhcp_offer_rsv_time_seconds_new, dhcp_leasetime_static_minutes_new=dhcp_leasetime_static_minutes_new, dhcp_accept_requested_hostname_new=dhcp_accept_requested_hostname_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(name_old: str) -> dict:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'nd.bcd.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, name_old: str) -> list:
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, is_own_old: bool = None, has_vlan_old: bool = None, name_list_old: list = None, has_subnet_old: bool = None, fetch_limit_old: int = None, name_regexp_old: str = None, dhcp_enabled_old: bool = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if has_vlan_old is not None and not (isinstance(has_vlan_old, bool)):
			raise ValueError(f"'has_vlan' of incorrect type. Expected bool, got {type(has_vlan_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if has_subnet_old is not None and not (isinstance(has_subnet_old, bool)):
			raise ValueError(f"'has_subnet' of incorrect type. Expected bool, got {type(has_subnet_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if name_regexp_old is not None and not (isinstance(name_regexp_old, str)):
			raise ValueError(f"'name_regexp' of incorrect type. Expected str, got {type(name_regexp_old)}")
		if dhcp_enabled_old is not None and not (isinstance(dhcp_enabled_old, bool)):
			raise ValueError(f"'dhcp_enabled' of incorrect type. Expected bool, got {type(dhcp_enabled_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.bcd.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'is_own': is_own_old, 'has_vlan': has_vlan_old, 'name_list': name_list_old, 'has_subnet': has_subnet_old, 'fetch_limit': fetch_limit_old, 'name_regexp': name_regexp_old, 'dhcp_enabled': dhcp_enabled_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, is_own_old: bool = None, has_vlan_old: bool = None, name_list_old: list = None, has_subnet_old: bool = None, fetch_limit_old: int = None, name_regexp_old: str = None, dhcp_enabled_old: bool = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if has_vlan_old is not None and not (isinstance(has_vlan_old, bool)):
			raise ValueError(f"'has_vlan' of incorrect type. Expected bool, got {type(has_vlan_old)}")
		if name_list_old is not None and not (isinstance(name_list_old, list)):
			raise ValueError(f"'name_list' of incorrect type. Expected list, got {type(name_list_old)}")
		if has_subnet_old is not None and not (isinstance(has_subnet_old, bool)):
			raise ValueError(f"'has_subnet' of incorrect type. Expected bool, got {type(has_subnet_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if name_regexp_old is not None and not (isinstance(name_regexp_old, str)):
			raise ValueError(f"'name_regexp' of incorrect type. Expected str, got {type(name_regexp_old)}")
		if dhcp_enabled_old is not None and not (isinstance(dhcp_enabled_old, bool)):
			raise ValueError(f"'dhcp_enabled' of incorrect type. Expected bool, got {type(dhcp_enabled_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, is_own_old=is_own_old, has_vlan_old=has_vlan_old, name_list_old=name_list_old, has_subnet_old=has_subnet_old, fetch_limit_old=fetch_limit_old, name_regexp_old=name_regexp_old, dhcp_enabled_old=dhcp_enabled_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(name_old: str, name_new: str = None, categ_new: str = None, seclvl_new: int = None, description_new: Union[str, ExplicitNull] = None, dhcp_domain_new: Union[str, ExplicitNull] = None, dhcp_enabled_new: bool = None, admin_description_new: Union[str, ExplicitNull] = None, dhcp_accept_new_leases_new: bool = None, dhcp_ttl_value_percent_new: int = None, dhcp_leasetime_dyn_days_new: int = None, dhcp_leasetime_dyn_hours_new: int = None, dhcp_leasetime_dyn_minutes_new: int = None, dhcp_leasetime_static_days_new: int = None, dhcp_leasetime_static_hours_new: int = None, dhcp_offer_rsv_time_minutes_new: int = None, dhcp_offer_rsv_time_seconds_new: int = None, dhcp_leasetime_static_minutes_new: int = None, dhcp_accept_requested_hostname_new: Union[bool, ExplicitNull] = None) -> dict:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if categ_new is not None and not (isinstance(categ_new, str)):
			raise ValueError(f"'categ' of incorrect type. Expected str, got {type(categ_new)}")
		if seclvl_new is not None and not (isinstance(seclvl_new, int)):
			raise ValueError(f"'seclvl' of incorrect type. Expected int, got {type(seclvl_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if dhcp_domain_new is not None and not (isinstance(dhcp_domain_new, str) or isinstance(dhcp_domain_new, ExplicitNull)):
			raise ValueError(f"'dhcp_domain' of incorrect type. Expected str, got {type(dhcp_domain_new)}")
		if dhcp_enabled_new is not None and not (isinstance(dhcp_enabled_new, bool)):
			raise ValueError(f"'dhcp_enabled' of incorrect type. Expected bool, got {type(dhcp_enabled_new)}")
		if admin_description_new is not None and not (isinstance(admin_description_new, str) or isinstance(admin_description_new, ExplicitNull)):
			raise ValueError(f"'admin_description' of incorrect type. Expected str, got {type(admin_description_new)}")
		if dhcp_accept_new_leases_new is not None and not (isinstance(dhcp_accept_new_leases_new, bool)):
			raise ValueError(f"'dhcp_accept_new_leases' of incorrect type. Expected bool, got {type(dhcp_accept_new_leases_new)}")
		if dhcp_ttl_value_percent_new is not None and not (isinstance(dhcp_ttl_value_percent_new, int)):
			raise ValueError(f"'dhcp_ttl_value_percent' of incorrect type. Expected int, got {type(dhcp_ttl_value_percent_new)}")
		if dhcp_leasetime_dyn_days_new is not None and not (isinstance(dhcp_leasetime_dyn_days_new, int)):
			raise ValueError(f"'dhcp_leasetime_dyn_days' of incorrect type. Expected int, got {type(dhcp_leasetime_dyn_days_new)}")
		if dhcp_leasetime_dyn_hours_new is not None and not (isinstance(dhcp_leasetime_dyn_hours_new, int)):
			raise ValueError(f"'dhcp_leasetime_dyn_hours' of incorrect type. Expected int, got {type(dhcp_leasetime_dyn_hours_new)}")
		if dhcp_leasetime_dyn_minutes_new is not None and not (isinstance(dhcp_leasetime_dyn_minutes_new, int)):
			raise ValueError(f"'dhcp_leasetime_dyn_minutes' of incorrect type. Expected int, got {type(dhcp_leasetime_dyn_minutes_new)}")
		if dhcp_leasetime_static_days_new is not None and not (isinstance(dhcp_leasetime_static_days_new, int)):
			raise ValueError(f"'dhcp_leasetime_static_days' of incorrect type. Expected int, got {type(dhcp_leasetime_static_days_new)}")
		if dhcp_leasetime_static_hours_new is not None and not (isinstance(dhcp_leasetime_static_hours_new, int)):
			raise ValueError(f"'dhcp_leasetime_static_hours' of incorrect type. Expected int, got {type(dhcp_leasetime_static_hours_new)}")
		if dhcp_offer_rsv_time_minutes_new is not None and not (isinstance(dhcp_offer_rsv_time_minutes_new, int)):
			raise ValueError(f"'dhcp_offer_rsv_time_minutes' of incorrect type. Expected int, got {type(dhcp_offer_rsv_time_minutes_new)}")
		if dhcp_offer_rsv_time_seconds_new is not None and not (isinstance(dhcp_offer_rsv_time_seconds_new, int)):
			raise ValueError(f"'dhcp_offer_rsv_time_seconds' of incorrect type. Expected int, got {type(dhcp_offer_rsv_time_seconds_new)}")
		if dhcp_leasetime_static_minutes_new is not None and not (isinstance(dhcp_leasetime_static_minutes_new, int)):
			raise ValueError(f"'dhcp_leasetime_static_minutes' of incorrect type. Expected int, got {type(dhcp_leasetime_static_minutes_new)}")
		if dhcp_accept_requested_hostname_new is not None and not (isinstance(dhcp_accept_requested_hostname_new, bool) or isinstance(dhcp_accept_requested_hostname_new, ExplicitNull)):
			raise ValueError(f"'dhcp_accept_requested_hostname' of incorrect type. Expected bool, got {type(dhcp_accept_requested_hostname_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		return {'name': 'nd.bcd.update', 'new': _denullify_dict({'name': name_new, 'categ': categ_new, 'seclvl': seclvl_new, 'description': description_new, 'dhcp_domain': dhcp_domain_new, 'dhcp_enabled': dhcp_enabled_new, 'admin_description': admin_description_new, 'dhcp_accept_new_leases': dhcp_accept_new_leases_new, 'dhcp_ttl_value_percent': dhcp_ttl_value_percent_new, 'dhcp_leasetime_dyn_days': dhcp_leasetime_dyn_days_new, 'dhcp_leasetime_dyn_hours': dhcp_leasetime_dyn_hours_new, 'dhcp_leasetime_dyn_minutes': dhcp_leasetime_dyn_minutes_new, 'dhcp_leasetime_static_days': dhcp_leasetime_static_days_new, 'dhcp_leasetime_static_hours': dhcp_leasetime_static_hours_new, 'dhcp_offer_rsv_time_minutes': dhcp_offer_rsv_time_minutes_new, 'dhcp_offer_rsv_time_seconds': dhcp_offer_rsv_time_seconds_new, 'dhcp_leasetime_static_minutes': dhcp_leasetime_static_minutes_new, 'dhcp_accept_requested_hostname': dhcp_accept_requested_hostname_new}), 'old': _denullify_dict({'name': name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, name_old: str, name_new: str = None, categ_new: str = None, seclvl_new: int = None, description_new: Union[str, ExplicitNull] = None, dhcp_domain_new: Union[str, ExplicitNull] = None, dhcp_enabled_new: bool = None, admin_description_new: Union[str, ExplicitNull] = None, dhcp_accept_new_leases_new: bool = None, dhcp_ttl_value_percent_new: int = None, dhcp_leasetime_dyn_days_new: int = None, dhcp_leasetime_dyn_hours_new: int = None, dhcp_leasetime_dyn_minutes_new: int = None, dhcp_leasetime_static_days_new: int = None, dhcp_leasetime_static_hours_new: int = None, dhcp_offer_rsv_time_minutes_new: int = None, dhcp_offer_rsv_time_seconds_new: int = None, dhcp_leasetime_static_minutes_new: int = None, dhcp_accept_requested_hostname_new: Union[bool, ExplicitNull] = None) -> list:
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if categ_new is not None and not (isinstance(categ_new, str)):
			raise ValueError(f"'categ' of incorrect type. Expected str, got {type(categ_new)}")
		if seclvl_new is not None and not (isinstance(seclvl_new, int)):
			raise ValueError(f"'seclvl' of incorrect type. Expected int, got {type(seclvl_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if dhcp_domain_new is not None and not (isinstance(dhcp_domain_new, str) or isinstance(dhcp_domain_new, ExplicitNull)):
			raise ValueError(f"'dhcp_domain' of incorrect type. Expected str, got {type(dhcp_domain_new)}")
		if dhcp_enabled_new is not None and not (isinstance(dhcp_enabled_new, bool)):
			raise ValueError(f"'dhcp_enabled' of incorrect type. Expected bool, got {type(dhcp_enabled_new)}")
		if admin_description_new is not None and not (isinstance(admin_description_new, str) or isinstance(admin_description_new, ExplicitNull)):
			raise ValueError(f"'admin_description' of incorrect type. Expected str, got {type(admin_description_new)}")
		if dhcp_accept_new_leases_new is not None and not (isinstance(dhcp_accept_new_leases_new, bool)):
			raise ValueError(f"'dhcp_accept_new_leases' of incorrect type. Expected bool, got {type(dhcp_accept_new_leases_new)}")
		if dhcp_ttl_value_percent_new is not None and not (isinstance(dhcp_ttl_value_percent_new, int)):
			raise ValueError(f"'dhcp_ttl_value_percent' of incorrect type. Expected int, got {type(dhcp_ttl_value_percent_new)}")
		if dhcp_leasetime_dyn_days_new is not None and not (isinstance(dhcp_leasetime_dyn_days_new, int)):
			raise ValueError(f"'dhcp_leasetime_dyn_days' of incorrect type. Expected int, got {type(dhcp_leasetime_dyn_days_new)}")
		if dhcp_leasetime_dyn_hours_new is not None and not (isinstance(dhcp_leasetime_dyn_hours_new, int)):
			raise ValueError(f"'dhcp_leasetime_dyn_hours' of incorrect type. Expected int, got {type(dhcp_leasetime_dyn_hours_new)}")
		if dhcp_leasetime_dyn_minutes_new is not None and not (isinstance(dhcp_leasetime_dyn_minutes_new, int)):
			raise ValueError(f"'dhcp_leasetime_dyn_minutes' of incorrect type. Expected int, got {type(dhcp_leasetime_dyn_minutes_new)}")
		if dhcp_leasetime_static_days_new is not None and not (isinstance(dhcp_leasetime_static_days_new, int)):
			raise ValueError(f"'dhcp_leasetime_static_days' of incorrect type. Expected int, got {type(dhcp_leasetime_static_days_new)}")
		if dhcp_leasetime_static_hours_new is not None and not (isinstance(dhcp_leasetime_static_hours_new, int)):
			raise ValueError(f"'dhcp_leasetime_static_hours' of incorrect type. Expected int, got {type(dhcp_leasetime_static_hours_new)}")
		if dhcp_offer_rsv_time_minutes_new is not None and not (isinstance(dhcp_offer_rsv_time_minutes_new, int)):
			raise ValueError(f"'dhcp_offer_rsv_time_minutes' of incorrect type. Expected int, got {type(dhcp_offer_rsv_time_minutes_new)}")
		if dhcp_offer_rsv_time_seconds_new is not None and not (isinstance(dhcp_offer_rsv_time_seconds_new, int)):
			raise ValueError(f"'dhcp_offer_rsv_time_seconds' of incorrect type. Expected int, got {type(dhcp_offer_rsv_time_seconds_new)}")
		if dhcp_leasetime_static_minutes_new is not None and not (isinstance(dhcp_leasetime_static_minutes_new, int)):
			raise ValueError(f"'dhcp_leasetime_static_minutes' of incorrect type. Expected int, got {type(dhcp_leasetime_static_minutes_new)}")
		if dhcp_accept_requested_hostname_new is not None and not (isinstance(dhcp_accept_requested_hostname_new, bool) or isinstance(dhcp_accept_requested_hostname_new, ExplicitNull)):
			raise ValueError(f"'dhcp_accept_requested_hostname' of incorrect type. Expected bool, got {type(dhcp_accept_requested_hostname_new)}")
		if not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(name_new=name_new, categ_new=categ_new, seclvl_new=seclvl_new, description_new=description_new, dhcp_domain_new=dhcp_domain_new, dhcp_enabled_new=dhcp_enabled_new, admin_description_new=admin_description_new, dhcp_accept_new_leases_new=dhcp_accept_new_leases_new, dhcp_ttl_value_percent_new=dhcp_ttl_value_percent_new, dhcp_leasetime_dyn_days_new=dhcp_leasetime_dyn_days_new, dhcp_leasetime_dyn_hours_new=dhcp_leasetime_dyn_hours_new, dhcp_leasetime_dyn_minutes_new=dhcp_leasetime_dyn_minutes_new, dhcp_leasetime_static_days_new=dhcp_leasetime_static_days_new, dhcp_leasetime_static_hours_new=dhcp_leasetime_static_hours_new, dhcp_offer_rsv_time_minutes_new=dhcp_offer_rsv_time_minutes_new, dhcp_offer_rsv_time_seconds_new=dhcp_offer_rsv_time_seconds_new, dhcp_leasetime_static_minutes_new=dhcp_leasetime_static_minutes_new, dhcp_accept_requested_hostname_new=dhcp_accept_requested_hostname_new, name_old=name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Device(APIObject):
	nc: str
	acg: str
	gpk: str
	fqdn: str
	type: str
	is_valid: bool
	sysdescr: str
	uses_vlans: bool
	description: str
	assigned_parser: str
	executable_parser: str

	def __post_init__(self):
		if not isinstance(self.nc, str):
			raise ValueError(f"'nc' of incorrect type. Expected str, got {type(self.nc)}")
		if not isinstance(self.acg, str):
			raise ValueError(f"'acg' of incorrect type. Expected str, got {type(self.acg)}")
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.fqdn, str):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(self.fqdn)}")
		if not isinstance(self.type, str):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(self.type)}")
		if not isinstance(self.is_valid, bool):
			raise ValueError(f"'is_valid' of incorrect type. Expected bool, got {type(self.is_valid)}")
		if self.sysdescr is not None and not isinstance(self.sysdescr, str):
			raise ValueError(f"'sysdescr' of incorrect type. Expected str, got {type(self.sysdescr)}")
		if not isinstance(self.uses_vlans, bool):
			raise ValueError(f"'uses_vlans' of incorrect type. Expected bool, got {type(self.uses_vlans)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.assigned_parser, str):
			raise ValueError(f"'assigned_parser' of incorrect type. Expected str, got {type(self.assigned_parser)}")
		if not isinstance(self.executable_parser, str):
			raise ValueError(f"'executable_parser' of incorrect type. Expected str, got {type(self.executable_parser)}")

	@staticmethod
	def create_ta(nc_new: str, acg_new: str, fqdn_new: str, type_new: str, assigned_parser_new: str, description_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(nc_new, str)):
			raise ValueError(f"'nc' of incorrect type. Expected str, got {type(nc_new)}")
		if not (isinstance(acg_new, str)):
			raise ValueError(f"'acg' of incorrect type. Expected str, got {type(acg_new)}")
		if not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(assigned_parser_new, str)):
			raise ValueError(f"'assigned_parser' of incorrect type. Expected str, got {type(assigned_parser_new)}")

		return {'name': 'nd.device.create', 'new': _denullify_dict({'nc': nc_new, 'acg': acg_new, 'fqdn': fqdn_new, 'type': type_new, 'description': description_new, 'assigned_parser': assigned_parser_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, nc_new: str, acg_new: str, fqdn_new: str, type_new: str, assigned_parser_new: str, description_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(nc_new, str)):
			raise ValueError(f"'nc' of incorrect type. Expected str, got {type(nc_new)}")
		if not (isinstance(acg_new, str)):
			raise ValueError(f"'acg' of incorrect type. Expected str, got {type(acg_new)}")
		if not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(assigned_parser_new, str)):
			raise ValueError(f"'assigned_parser' of incorrect type. Expected str, got {type(assigned_parser_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(nc_new=nc_new, acg_new=acg_new, fqdn_new=fqdn_new, type_new=type_new, description_new=description_new, assigned_parser_new=assigned_parser_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(fqdn_old: str) -> dict:
		if not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")

		return {'name': 'nd.device.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'fqdn': fqdn_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, fqdn_old: str) -> list:
		if not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(fqdn_old=fqdn_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def imp_ta(fqdn_new: str, nc_new: str = None, acg_new: str = None, type_new: str = None, sysdescr_new: Union[str, ExplicitNull] = None, do_import_new: bool = True, description_new: Union[str, ExplicitNull] = None, import_data_new: dict = None, assigned_parser_new: str = None) -> dict:
		if nc_new is not None and not (isinstance(nc_new, str)):
			raise ValueError(f"'nc' of incorrect type. Expected str, got {type(nc_new)}")
		if acg_new is not None and not (isinstance(acg_new, str)):
			raise ValueError(f"'acg' of incorrect type. Expected str, got {type(acg_new)}")
		if not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if sysdescr_new is not None and not (isinstance(sysdescr_new, str) or isinstance(sysdescr_new, ExplicitNull)):
			raise ValueError(f"'sysdescr' of incorrect type. Expected str, got {type(sysdescr_new)}")
		if do_import_new is not None and not (isinstance(do_import_new, bool)):
			raise ValueError(f"'do_import' of incorrect type. Expected bool, got {type(do_import_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if import_data_new is not None and not (isinstance(import_data_new, dict)):
			raise ValueError(f"'import_data' of incorrect type. Expected dict, got {type(import_data_new)}")
		if assigned_parser_new is not None and not (isinstance(assigned_parser_new, str)):
			raise ValueError(f"'assigned_parser' of incorrect type. Expected str, got {type(assigned_parser_new)}")

		return {'name': 'nd.device.imp', 'new': _denullify_dict({'nc': nc_new, 'acg': acg_new, 'fqdn': fqdn_new, 'type': type_new, 'sysdescr': sysdescr_new, 'do_import': do_import_new, 'description': description_new, 'import_data': import_data_new, 'assigned_parser': assigned_parser_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def imp(cls, api_session: APISession, fqdn_new: str, nc_new: str = None, acg_new: str = None, type_new: str = None, sysdescr_new: Union[str, ExplicitNull] = None, do_import_new: bool = True, description_new: Union[str, ExplicitNull] = None, import_data_new: dict = None, assigned_parser_new: str = None) -> list:
		if nc_new is not None and not (isinstance(nc_new, str)):
			raise ValueError(f"'nc' of incorrect type. Expected str, got {type(nc_new)}")
		if acg_new is not None and not (isinstance(acg_new, str)):
			raise ValueError(f"'acg' of incorrect type. Expected str, got {type(acg_new)}")
		if not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if sysdescr_new is not None and not (isinstance(sysdescr_new, str) or isinstance(sysdescr_new, ExplicitNull)):
			raise ValueError(f"'sysdescr' of incorrect type. Expected str, got {type(sysdescr_new)}")
		if do_import_new is not None and not (isinstance(do_import_new, bool)):
			raise ValueError(f"'do_import' of incorrect type. Expected bool, got {type(do_import_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if import_data_new is not None and not (isinstance(import_data_new, dict)):
			raise ValueError(f"'import_data' of incorrect type. Expected dict, got {type(import_data_new)}")
		if assigned_parser_new is not None and not (isinstance(assigned_parser_new, str)):
			raise ValueError(f"'assigned_parser' of incorrect type. Expected str, got {type(assigned_parser_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.imp_ta(nc_new=nc_new, acg_new=acg_new, fqdn_new=fqdn_new, type_new=type_new, sysdescr_new=sysdescr_new, do_import_new=do_import_new, description_new=description_new, import_data_new=import_data_new, assigned_parser_new=assigned_parser_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(nc_old: str = None, acg_old: str = None, gpk_old: str = None, fqdn_old: str = None, type_old: str = None, is_valid_old: bool = None, uses_vlans_old: bool = None, fetch_limit_old: int = None, fqdn_regexp_old: str = None, fetch_offset_old: int = None, assigned_parser_old: str = None, executable_parser_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if nc_old is not None and not (isinstance(nc_old, str)):
			raise ValueError(f"'nc' of incorrect type. Expected str, got {type(nc_old)}")
		if acg_old is not None and not (isinstance(acg_old, str)):
			raise ValueError(f"'acg' of incorrect type. Expected str, got {type(acg_old)}")
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fqdn_old is not None and not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if is_valid_old is not None and not (isinstance(is_valid_old, bool)):
			raise ValueError(f"'is_valid' of incorrect type. Expected bool, got {type(is_valid_old)}")
		if uses_vlans_old is not None and not (isinstance(uses_vlans_old, bool)):
			raise ValueError(f"'uses_vlans' of incorrect type. Expected bool, got {type(uses_vlans_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fqdn_regexp_old is not None and not (isinstance(fqdn_regexp_old, str)):
			raise ValueError(f"'fqdn_regexp' of incorrect type. Expected str, got {type(fqdn_regexp_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if assigned_parser_old is not None and not (isinstance(assigned_parser_old, str)):
			raise ValueError(f"'assigned_parser' of incorrect type. Expected str, got {type(assigned_parser_old)}")
		if executable_parser_old is not None and not (isinstance(executable_parser_old, str)):
			raise ValueError(f"'executable_parser' of incorrect type. Expected str, got {type(executable_parser_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.device.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'nc': nc_old, 'acg': acg_old, 'gpk': gpk_old, 'fqdn': fqdn_old, 'type': type_old, 'is_valid': is_valid_old, 'uses_vlans': uses_vlans_old, 'fetch_limit': fetch_limit_old, 'fqdn_regexp': fqdn_regexp_old, 'fetch_offset': fetch_offset_old, 'assigned_parser': assigned_parser_old, 'executable_parser': executable_parser_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, nc_old: str = None, acg_old: str = None, gpk_old: str = None, fqdn_old: str = None, type_old: str = None, is_valid_old: bool = None, uses_vlans_old: bool = None, fetch_limit_old: int = None, fqdn_regexp_old: str = None, fetch_offset_old: int = None, assigned_parser_old: str = None, executable_parser_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if nc_old is not None and not (isinstance(nc_old, str)):
			raise ValueError(f"'nc' of incorrect type. Expected str, got {type(nc_old)}")
		if acg_old is not None and not (isinstance(acg_old, str)):
			raise ValueError(f"'acg' of incorrect type. Expected str, got {type(acg_old)}")
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fqdn_old is not None and not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")
		if type_old is not None and not (isinstance(type_old, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_old)}")
		if is_valid_old is not None and not (isinstance(is_valid_old, bool)):
			raise ValueError(f"'is_valid' of incorrect type. Expected bool, got {type(is_valid_old)}")
		if uses_vlans_old is not None and not (isinstance(uses_vlans_old, bool)):
			raise ValueError(f"'uses_vlans' of incorrect type. Expected bool, got {type(uses_vlans_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fqdn_regexp_old is not None and not (isinstance(fqdn_regexp_old, str)):
			raise ValueError(f"'fqdn_regexp' of incorrect type. Expected str, got {type(fqdn_regexp_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if assigned_parser_old is not None and not (isinstance(assigned_parser_old, str)):
			raise ValueError(f"'assigned_parser' of incorrect type. Expected str, got {type(assigned_parser_old)}")
		if executable_parser_old is not None and not (isinstance(executable_parser_old, str)):
			raise ValueError(f"'executable_parser' of incorrect type. Expected str, got {type(executable_parser_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(nc_old=nc_old, acg_old=acg_old, gpk_old=gpk_old, fqdn_old=fqdn_old, type_old=type_old, is_valid_old=is_valid_old, uses_vlans_old=uses_vlans_old, fetch_limit_old=fetch_limit_old, fqdn_regexp_old=fqdn_regexp_old, fetch_offset_old=fetch_offset_old, assigned_parser_old=assigned_parser_old, executable_parser_old=executable_parser_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(fqdn_old: str, nc_new: str = None, acg_new: str = None, fqdn_new: str = None, type_new: str = None, description_new: Union[str, ExplicitNull] = None, assigned_parser_new: str = None) -> dict:
		if nc_new is not None and not (isinstance(nc_new, str)):
			raise ValueError(f"'nc' of incorrect type. Expected str, got {type(nc_new)}")
		if acg_new is not None and not (isinstance(acg_new, str)):
			raise ValueError(f"'acg' of incorrect type. Expected str, got {type(acg_new)}")
		if fqdn_new is not None and not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if assigned_parser_new is not None and not (isinstance(assigned_parser_new, str)):
			raise ValueError(f"'assigned_parser' of incorrect type. Expected str, got {type(assigned_parser_new)}")
		if not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")

		return {'name': 'nd.device.update', 'new': _denullify_dict({'nc': nc_new, 'acg': acg_new, 'fqdn': fqdn_new, 'type': type_new, 'description': description_new, 'assigned_parser': assigned_parser_new}), 'old': _denullify_dict({'fqdn': fqdn_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, fqdn_old: str, nc_new: str = None, acg_new: str = None, fqdn_new: str = None, type_new: str = None, description_new: Union[str, ExplicitNull] = None, assigned_parser_new: str = None) -> list:
		if nc_new is not None and not (isinstance(nc_new, str)):
			raise ValueError(f"'nc' of incorrect type. Expected str, got {type(nc_new)}")
		if acg_new is not None and not (isinstance(acg_new, str)):
			raise ValueError(f"'acg' of incorrect type. Expected str, got {type(acg_new)}")
		if fqdn_new is not None and not (isinstance(fqdn_new, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_new)}")
		if type_new is not None and not (isinstance(type_new, str)):
			raise ValueError(f"'type' of incorrect type. Expected str, got {type(type_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if assigned_parser_new is not None and not (isinstance(assigned_parser_new, str)):
			raise ValueError(f"'assigned_parser' of incorrect type. Expected str, got {type(assigned_parser_new)}")
		if not (isinstance(fqdn_old, str)):
			raise ValueError(f"'fqdn' of incorrect type. Expected str, got {type(fqdn_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(nc_new=nc_new, acg_new=acg_new, fqdn_new=fqdn_new, type_new=type_new, description_new=description_new, assigned_parser_new=assigned_parser_new, fqdn_old=fqdn_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class IpIntf(APIObject):
	gpk: str
	l_port: str
	ip_addr: str
	is_vrrp: bool
	dev_fqdn: str
	is_secondary: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.l_port, str):
			raise ValueError(f"'l_port' of incorrect type. Expected str, got {type(self.l_port)}")
		if not isinstance(self.ip_addr, str):
			raise ValueError(f"'ip_addr' of incorrect type. Expected str, got {type(self.ip_addr)}")
		if not isinstance(self.is_vrrp, bool):
			raise ValueError(f"'is_vrrp' of incorrect type. Expected bool, got {type(self.is_vrrp)}")
		if not isinstance(self.dev_fqdn, str):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(self.dev_fqdn)}")
		if not isinstance(self.is_secondary, bool):
			raise ValueError(f"'is_secondary' of incorrect type. Expected bool, got {type(self.is_secondary)}")

	@staticmethod
	def list_ta(gpk_old: str = None, l_port_old: str = None, ip_addr_old: str = None, is_vrrp_old: bool = None, dev_fqdn_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_secondary_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if l_port_old is not None and not (isinstance(l_port_old, str)):
			raise ValueError(f"'l_port' of incorrect type. Expected str, got {type(l_port_old)}")
		if ip_addr_old is not None and not (isinstance(ip_addr_old, str)):
			raise ValueError(f"'ip_addr' of incorrect type. Expected str, got {type(ip_addr_old)}")
		if is_vrrp_old is not None and not (isinstance(is_vrrp_old, bool)):
			raise ValueError(f"'is_vrrp' of incorrect type. Expected bool, got {type(is_vrrp_old)}")
		if dev_fqdn_old is not None and not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_secondary_old is not None and not (isinstance(is_secondary_old, bool)):
			raise ValueError(f"'is_secondary' of incorrect type. Expected bool, got {type(is_secondary_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.ip_intf.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'l_port': l_port_old, 'ip_addr': ip_addr_old, 'is_vrrp': is_vrrp_old, 'dev_fqdn': dev_fqdn_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'is_secondary': is_secondary_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, l_port_old: str = None, ip_addr_old: str = None, is_vrrp_old: bool = None, dev_fqdn_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_secondary_old: bool = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if l_port_old is not None and not (isinstance(l_port_old, str)):
			raise ValueError(f"'l_port' of incorrect type. Expected str, got {type(l_port_old)}")
		if ip_addr_old is not None and not (isinstance(ip_addr_old, str)):
			raise ValueError(f"'ip_addr' of incorrect type. Expected str, got {type(ip_addr_old)}")
		if is_vrrp_old is not None and not (isinstance(is_vrrp_old, bool)):
			raise ValueError(f"'is_vrrp' of incorrect type. Expected bool, got {type(is_vrrp_old)}")
		if dev_fqdn_old is not None and not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_secondary_old is not None and not (isinstance(is_secondary_old, bool)):
			raise ValueError(f"'is_secondary' of incorrect type. Expected bool, got {type(is_secondary_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, l_port_old=l_port_old, ip_addr_old=ip_addr_old, is_vrrp_old=is_vrrp_old, dev_fqdn_old=dev_fqdn_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, is_secondary_old=is_secondary_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class IpRoute(APIObject):
	gpk: str
	cidr: str
	is_own: bool
	metric: int
	dev_fqdn: str
	dest_l_port: str
	dest_ip_addr: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.cidr, str):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(self.cidr)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.metric, int):
			raise ValueError(f"'metric' of incorrect type. Expected int, got {type(self.metric)}")
		if not isinstance(self.dev_fqdn, str):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(self.dev_fqdn)}")
		if self.dest_l_port is not None and not isinstance(self.dest_l_port, str):
			raise ValueError(f"'dest_l_port' of incorrect type. Expected str, got {type(self.dest_l_port)}")
		if self.dest_ip_addr is not None and not isinstance(self.dest_ip_addr, str):
			raise ValueError(f"'dest_ip_addr' of incorrect type. Expected str, got {type(self.dest_ip_addr)}")

	@staticmethod
	def list_ta(gpk_old: str = None, cidr_old: str = None, is_own_old: bool = None, dev_fqdn_old: str = None, dest_l_port_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, dest_ip_addr_cidr_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if cidr_old is not None and not (isinstance(cidr_old, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if dev_fqdn_old is not None and not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if dest_l_port_old is not None and not (isinstance(dest_l_port_old, str) or isinstance(dest_l_port_old, ExplicitNull)):
			raise ValueError(f"'dest_l_port' of incorrect type. Expected str, got {type(dest_l_port_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if dest_ip_addr_cidr_old is not None and not (isinstance(dest_ip_addr_cidr_old, str)):
			raise ValueError(f"'dest_ip_addr_cidr' of incorrect type. Expected str, got {type(dest_ip_addr_cidr_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.ip_route.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'cidr': cidr_old, 'is_own': is_own_old, 'dev_fqdn': dev_fqdn_old, 'dest_l_port': dest_l_port_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'dest_ip_addr_cidr': dest_ip_addr_cidr_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, cidr_old: str = None, is_own_old: bool = None, dev_fqdn_old: str = None, dest_l_port_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, dest_ip_addr_cidr_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if cidr_old is not None and not (isinstance(cidr_old, str)):
			raise ValueError(f"'cidr' of incorrect type. Expected str, got {type(cidr_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if dev_fqdn_old is not None and not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if dest_l_port_old is not None and not (isinstance(dest_l_port_old, str) or isinstance(dest_l_port_old, ExplicitNull)):
			raise ValueError(f"'dest_l_port' of incorrect type. Expected str, got {type(dest_l_port_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if dest_ip_addr_cidr_old is not None and not (isinstance(dest_ip_addr_cidr_old, str)):
			raise ValueError(f"'dest_ip_addr_cidr' of incorrect type. Expected str, got {type(dest_ip_addr_cidr_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, cidr_old=cidr_old, is_own_old=is_own_old, dev_fqdn_old=dev_fqdn_old, dest_l_port_old=dest_l_port_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, dest_ip_addr_cidr_old=dest_ip_addr_cidr_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class LPort(APIObject):
	gpk: str
	lag: int
	name: str
	level: int
	dev_fqdn: str
	priority: int
	tag_list: list
	adm_state: int
	description: str
	name_sortby: str
	has_egress_vlans: bool
	ingress_vlan_gfk: str
	adm_state_description: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if self.lag is not None and not isinstance(self.lag, int):
			raise ValueError(f"'lag' of incorrect type. Expected int, got {type(self.lag)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.level, int):
			raise ValueError(f"'level' of incorrect type. Expected int, got {type(self.level)}")
		if not isinstance(self.dev_fqdn, str):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(self.dev_fqdn)}")
		if not isinstance(self.priority, int):
			raise ValueError(f"'priority' of incorrect type. Expected int, got {type(self.priority)}")
		if self.tag_list is not None and not isinstance(self.tag_list, list):
			raise ValueError(f"'tag_list' of incorrect type. Expected list, got {type(self.tag_list)}")
		if not isinstance(self.adm_state, int):
			raise ValueError(f"'adm_state' of incorrect type. Expected int, got {type(self.adm_state)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if not isinstance(self.name_sortby, str):
			raise ValueError(f"'name_sortby' of incorrect type. Expected str, got {type(self.name_sortby)}")
		if not isinstance(self.has_egress_vlans, bool):
			raise ValueError(f"'has_egress_vlans' of incorrect type. Expected bool, got {type(self.has_egress_vlans)}")
		if self.ingress_vlan_gfk is not None and not isinstance(self.ingress_vlan_gfk, str):
			raise ValueError(f"'ingress_vlan_gfk' of incorrect type. Expected str, got {type(self.ingress_vlan_gfk)}")
		if not isinstance(self.adm_state_description, str):
			raise ValueError(f"'adm_state_description' of incorrect type. Expected str, got {type(self.adm_state_description)}")

	@staticmethod
	def list_ta(gpk_old: str = None, name_old: str = None, level_old: int = None, dev_fqdn_old: str = None, tag_list_old: list = None, adm_state_old: int = None, fetch_limit_old: int = None, fetch_offset_old: int = None, has_egress_vlans_old: bool = None, has_ingress_vlan_old: bool = None, tag_list_operator_old: str = 'eq', filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if level_old is not None and not (isinstance(level_old, int)):
			raise ValueError(f"'level' of incorrect type. Expected int, got {type(level_old)}")
		if dev_fqdn_old is not None and not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if tag_list_old is not None and not (isinstance(tag_list_old, list)):
			raise ValueError(f"'tag_list' of incorrect type. Expected list, got {type(tag_list_old)}")
		if adm_state_old is not None and not (isinstance(adm_state_old, int)):
			raise ValueError(f"'adm_state' of incorrect type. Expected int, got {type(adm_state_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if has_egress_vlans_old is not None and not (isinstance(has_egress_vlans_old, bool)):
			raise ValueError(f"'has_egress_vlans' of incorrect type. Expected bool, got {type(has_egress_vlans_old)}")
		if has_ingress_vlan_old is not None and not (isinstance(has_ingress_vlan_old, bool)):
			raise ValueError(f"'has_ingress_vlan' of incorrect type. Expected bool, got {type(has_ingress_vlan_old)}")
		if tag_list_operator_old is not None and not (isinstance(tag_list_operator_old, str)):
			raise ValueError(f"'tag_list_operator' of incorrect type. Expected str, got {type(tag_list_operator_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.l_port.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'name': name_old, 'level': level_old, 'dev_fqdn': dev_fqdn_old, 'tag_list': tag_list_old, 'adm_state': adm_state_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'has_egress_vlans': has_egress_vlans_old, 'has_ingress_vlan': has_ingress_vlan_old, 'tag_list_operator': tag_list_operator_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, name_old: str = None, level_old: int = None, dev_fqdn_old: str = None, tag_list_old: list = None, adm_state_old: int = None, fetch_limit_old: int = None, fetch_offset_old: int = None, has_egress_vlans_old: bool = None, has_ingress_vlan_old: bool = None, tag_list_operator_old: str = 'eq', filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if level_old is not None and not (isinstance(level_old, int)):
			raise ValueError(f"'level' of incorrect type. Expected int, got {type(level_old)}")
		if dev_fqdn_old is not None and not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if tag_list_old is not None and not (isinstance(tag_list_old, list)):
			raise ValueError(f"'tag_list' of incorrect type. Expected list, got {type(tag_list_old)}")
		if adm_state_old is not None and not (isinstance(adm_state_old, int)):
			raise ValueError(f"'adm_state' of incorrect type. Expected int, got {type(adm_state_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if has_egress_vlans_old is not None and not (isinstance(has_egress_vlans_old, bool)):
			raise ValueError(f"'has_egress_vlans' of incorrect type. Expected bool, got {type(has_egress_vlans_old)}")
		if has_ingress_vlan_old is not None and not (isinstance(has_ingress_vlan_old, bool)):
			raise ValueError(f"'has_ingress_vlan' of incorrect type. Expected bool, got {type(has_ingress_vlan_old)}")
		if tag_list_operator_old is not None and not (isinstance(tag_list_operator_old, str)):
			raise ValueError(f"'tag_list_operator' of incorrect type. Expected str, got {type(tag_list_operator_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, name_old=name_old, level_old=level_old, dev_fqdn_old=dev_fqdn_old, tag_list_old=tag_list_old, adm_state_old=adm_state_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, has_egress_vlans_old=has_egress_vlans_old, has_ingress_vlan_old=has_ingress_vlan_old, tag_list_operator_old=tag_list_operator_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Vlan(APIObject):
	id: int
	bcd: str
	gpk: str
	name: str
	net_instnc: str
	description: str

	def __post_init__(self):
		if not isinstance(self.id, int):
			raise ValueError(f"'id' of incorrect type. Expected int, got {type(self.id)}")
		if not isinstance(self.bcd, str):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(self.bcd)}")
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if not isinstance(self.net_instnc, str):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(self.net_instnc)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")

	@staticmethod
	def create_ta(bcd_new: str, name_new: str, net_instnc_new: str, id_new: int = None, description_new: Union[str, ExplicitNull] = None) -> dict:
		if id_new is not None and not (isinstance(id_new, int)):
			raise ValueError(f"'id' of incorrect type. Expected int, got {type(id_new)}")
		if not (isinstance(bcd_new, str)):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(bcd_new)}")
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(net_instnc_new, str)):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(net_instnc_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		return {'name': 'nd.vlan.create', 'new': _denullify_dict({'id': id_new, 'bcd': bcd_new, 'name': name_new, 'net_instnc': net_instnc_new, 'description': description_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, bcd_new: str, name_new: str, net_instnc_new: str, id_new: int = None, description_new: Union[str, ExplicitNull] = None) -> list:
		if id_new is not None and not (isinstance(id_new, int)):
			raise ValueError(f"'id' of incorrect type. Expected int, got {type(id_new)}")
		if not (isinstance(bcd_new, str)):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(bcd_new)}")
		if not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if not (isinstance(net_instnc_new, str)):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(net_instnc_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(id_new=id_new, bcd_new=bcd_new, name_new=name_new, net_instnc_new=net_instnc_new, description_new=description_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'nd.vlan.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(id_old: int = None, bcd_old: str = None, gpk_old: str = None, name_old: str = None, id_list_old: list = None, net_instnc_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if id_old is not None and not (isinstance(id_old, int)):
			raise ValueError(f"'id' of incorrect type. Expected int, got {type(id_old)}")
		if bcd_old is not None and not (isinstance(bcd_old, str)):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(bcd_old)}")
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if id_list_old is not None and not (isinstance(id_list_old, list)):
			raise ValueError(f"'id_list' of incorrect type. Expected list, got {type(id_list_old)}")
		if net_instnc_old is not None and not (isinstance(net_instnc_old, str)):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(net_instnc_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.vlan.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'id': id_old, 'bcd': bcd_old, 'gpk': gpk_old, 'name': name_old, 'id_list': id_list_old, 'net_instnc': net_instnc_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, id_old: int = None, bcd_old: str = None, gpk_old: str = None, name_old: str = None, id_list_old: list = None, net_instnc_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if id_old is not None and not (isinstance(id_old, int)):
			raise ValueError(f"'id' of incorrect type. Expected int, got {type(id_old)}")
		if bcd_old is not None and not (isinstance(bcd_old, str)):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(bcd_old)}")
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if name_old is not None and not (isinstance(name_old, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_old)}")
		if id_list_old is not None and not (isinstance(id_list_old, list)):
			raise ValueError(f"'id_list' of incorrect type. Expected list, got {type(id_list_old)}")
		if net_instnc_old is not None and not (isinstance(net_instnc_old, str)):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(net_instnc_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(id_old=id_old, bcd_old=bcd_old, gpk_old=gpk_old, name_old=name_old, id_list_old=id_list_old, net_instnc_old=net_instnc_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(gpk_old: str, id_new: int = None, bcd_new: str = None, name_new: str = None, net_instnc_new: str = None, description_new: Union[str, ExplicitNull] = None) -> dict:
		if id_new is not None and not (isinstance(id_new, int)):
			raise ValueError(f"'id' of incorrect type. Expected int, got {type(id_new)}")
		if bcd_new is not None and not (isinstance(bcd_new, str)):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(bcd_new)}")
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if net_instnc_new is not None and not (isinstance(net_instnc_new, str)):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(net_instnc_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'nd.vlan.update', 'new': _denullify_dict({'id': id_new, 'bcd': bcd_new, 'name': name_new, 'net_instnc': net_instnc_new, 'description': description_new}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, gpk_old: str, id_new: int = None, bcd_new: str = None, name_new: str = None, net_instnc_new: str = None, description_new: Union[str, ExplicitNull] = None) -> list:
		if id_new is not None and not (isinstance(id_new, int)):
			raise ValueError(f"'id' of incorrect type. Expected int, got {type(id_new)}")
		if bcd_new is not None and not (isinstance(bcd_new, str)):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(bcd_new)}")
		if name_new is not None and not (isinstance(name_new, str)):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(name_new)}")
		if net_instnc_new is not None and not (isinstance(net_instnc_new, str)):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(net_instnc_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(id_new=id_new, bcd_new=bcd_new, name_new=name_new, net_instnc_new=net_instnc_new, description_new=description_new, gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class L2pPort(APIObject):
	gpk: str
	l_port_gfk: str
	p_port_gfk: str
	port_order: int

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.l_port_gfk, str):
			raise ValueError(f"'l_port_gfk' of incorrect type. Expected str, got {type(self.l_port_gfk)}")
		if not isinstance(self.p_port_gfk, str):
			raise ValueError(f"'p_port_gfk' of incorrect type. Expected str, got {type(self.p_port_gfk)}")
		if not isinstance(self.port_order, int):
			raise ValueError(f"'port_order' of incorrect type. Expected int, got {type(self.port_order)}")

	@staticmethod
	def list_ta(gpk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.l2p_port.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class DeviceAttributeImp(APIObject):
	value: str
	key_word: str

	def __post_init__(self):
		if self.value is not None and not isinstance(self.value, str):
			raise ValueError(f"'value' of incorrect type. Expected str, got {type(self.value)}")
		if not isinstance(self.key_word, str):
			raise ValueError(f"'key_word' of incorrect type. Expected str, got {type(self.key_word)}")

@dataclass()
class IpIntfImp(APIObject):
	ip_addr: str
	is_vrrp: bool
	vrrp_id: int
	l_port_name: str
	is_secondary: bool

	def __post_init__(self):
		if not isinstance(self.ip_addr, str):
			raise ValueError(f"'ip_addr' of incorrect type. Expected str, got {type(self.ip_addr)}")
		if not isinstance(self.is_vrrp, bool):
			raise ValueError(f"'is_vrrp' of incorrect type. Expected bool, got {type(self.is_vrrp)}")
		if self.vrrp_id is not None and not isinstance(self.vrrp_id, int):
			raise ValueError(f"'vrrp_id' of incorrect type. Expected int, got {type(self.vrrp_id)}")
		if not isinstance(self.l_port_name, str):
			raise ValueError(f"'l_port_name' of incorrect type. Expected str, got {type(self.l_port_name)}")
		if not isinstance(self.is_secondary, bool):
			raise ValueError(f"'is_secondary' of incorrect type. Expected bool, got {type(self.is_secondary)}")

@dataclass()
class IpRouteImp(APIObject):
	net: str
	metric: int
	is_routable: bool
	dest_ip_addr: str
	dest_l_port_name: str

	def __post_init__(self):
		if not isinstance(self.net, str):
			raise ValueError(f"'net' of incorrect type. Expected str, got {type(self.net)}")
		if not isinstance(self.metric, int):
			raise ValueError(f"'metric' of incorrect type. Expected int, got {type(self.metric)}")
		if not isinstance(self.is_routable, bool):
			raise ValueError(f"'is_routable' of incorrect type. Expected bool, got {type(self.is_routable)}")
		if self.dest_ip_addr is not None and not isinstance(self.dest_ip_addr, str):
			raise ValueError(f"'dest_ip_addr' of incorrect type. Expected str, got {type(self.dest_ip_addr)}")
		if self.dest_l_port_name is not None and not isinstance(self.dest_l_port_name, str):
			raise ValueError(f"'dest_l_port_name' of incorrect type. Expected str, got {type(self.dest_l_port_name)}")

@dataclass()
class L2pPortImp(APIObject):
	port_order: int
	l_port_name: str
	p_port_name: str
	fq_module_name: str

	def __post_init__(self):
		if not isinstance(self.port_order, int):
			raise ValueError(f"'port_order' of incorrect type. Expected int, got {type(self.port_order)}")
		if not isinstance(self.l_port_name, str):
			raise ValueError(f"'l_port_name' of incorrect type. Expected str, got {type(self.l_port_name)}")
		if not isinstance(self.p_port_name, str):
			raise ValueError(f"'p_port_name' of incorrect type. Expected str, got {type(self.p_port_name)}")
		if self.fq_module_name is not None and not isinstance(self.fq_module_name, str):
			raise ValueError(f"'fq_module_name' of incorrect type. Expected str, got {type(self.fq_module_name)}")

@dataclass()
class LPortImp(APIObject):
	lag: int
	name: str
	prio: int
	status: int
	tag_list: list
	port_level: int
	description: str
	vlan_id_ingress: int

	def __post_init__(self):
		if self.lag is not None and not isinstance(self.lag, int):
			raise ValueError(f"'lag' of incorrect type. Expected int, got {type(self.lag)}")
		if not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if self.prio is not None and not isinstance(self.prio, int):
			raise ValueError(f"'prio' of incorrect type. Expected int, got {type(self.prio)}")
		if self.status is not None and not isinstance(self.status, int):
			raise ValueError(f"'status' of incorrect type. Expected int, got {type(self.status)}")
		if self.tag_list is not None and not isinstance(self.tag_list, list):
			raise ValueError(f"'tag_list' of incorrect type. Expected list, got {type(self.tag_list)}")
		if self.port_level is not None and not isinstance(self.port_level, int):
			raise ValueError(f"'port_level' of incorrect type. Expected int, got {type(self.port_level)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")
		if self.vlan_id_ingress is not None and not isinstance(self.vlan_id_ingress, int):
			raise ValueError(f"'vlan_id_ingress' of incorrect type. Expected int, got {type(self.vlan_id_ingress)}")

@dataclass()
class VlanEgressImp(APIObject):
	id: int
	is_tagged: bool
	l_port_name: str

	def __post_init__(self):
		if not isinstance(self.id, int):
			raise ValueError(f"'id' of incorrect type. Expected int, got {type(self.id)}")
		if not isinstance(self.is_tagged, bool):
			raise ValueError(f"'is_tagged' of incorrect type. Expected bool, got {type(self.is_tagged)}")
		if not isinstance(self.l_port_name, str):
			raise ValueError(f"'l_port_name' of incorrect type. Expected str, got {type(self.l_port_name)}")

@dataclass()
class VlanImp(APIObject):
	id: int
	name: str
	vxlan_vni: int
	net_instnc: str

	def __post_init__(self):
		if not isinstance(self.id, int):
			raise ValueError(f"'id' of incorrect type. Expected int, got {type(self.id)}")
		if self.name is not None and not isinstance(self.name, str):
			raise ValueError(f"'name' of incorrect type. Expected str, got {type(self.name)}")
		if self.vxlan_vni is not None and not isinstance(self.vxlan_vni, int):
			raise ValueError(f"'vxlan_vni' of incorrect type. Expected int, got {type(self.vxlan_vni)}")
		if self.net_instnc is not None and not isinstance(self.net_instnc, str):
			raise ValueError(f"'net_instnc' of incorrect type. Expected str, got {type(self.net_instnc)}")

@dataclass()
class Module2device(APIObject):
	gpk: str
	dev_fqdn: str
	mdl_fq_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.dev_fqdn, str):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(self.dev_fqdn)}")
		if not isinstance(self.mdl_fq_name, str):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(self.mdl_fq_name)}")

	@staticmethod
	def create_ta(dev_fqdn_new: str, mdl_fq_name_new: str, include_all_submdls_new: bool = True) -> dict:
		if not (isinstance(dev_fqdn_new, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_new)}")
		if not (isinstance(mdl_fq_name_new, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_new)}")
		if include_all_submdls_new is not None and not (isinstance(include_all_submdls_new, bool)):
			raise ValueError(f"'include_all_submdls' of incorrect type. Expected bool, got {type(include_all_submdls_new)}")

		return {'name': 'nd.module2device.create', 'new': _denullify_dict({'dev_fqdn': dev_fqdn_new, 'mdl_fq_name': mdl_fq_name_new, 'include_all_submdls': include_all_submdls_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, dev_fqdn_new: str, mdl_fq_name_new: str, include_all_submdls_new: bool = True) -> list:
		if not (isinstance(dev_fqdn_new, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_new)}")
		if not (isinstance(mdl_fq_name_new, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_new)}")
		if include_all_submdls_new is not None and not (isinstance(include_all_submdls_new, bool)):
			raise ValueError(f"'include_all_submdls' of incorrect type. Expected bool, got {type(include_all_submdls_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(dev_fqdn_new=dev_fqdn_new, mdl_fq_name_new=mdl_fq_name_new, include_all_submdls_new=include_all_submdls_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(dev_fqdn_old: str, mdl_fq_name_old: str, include_all_submdls_old: bool = True) -> dict:
		if not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")
		if include_all_submdls_old is not None and not (isinstance(include_all_submdls_old, bool)):
			raise ValueError(f"'include_all_submdls' of incorrect type. Expected bool, got {type(include_all_submdls_old)}")

		return {'name': 'nd.module2device.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'dev_fqdn': dev_fqdn_old, 'mdl_fq_name': mdl_fq_name_old, 'include_all_submdls': include_all_submdls_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, dev_fqdn_old: str, mdl_fq_name_old: str, include_all_submdls_old: bool = True) -> list:
		if not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")
		if include_all_submdls_old is not None and not (isinstance(include_all_submdls_old, bool)):
			raise ValueError(f"'include_all_submdls' of incorrect type. Expected bool, got {type(include_all_submdls_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(dev_fqdn_old=dev_fqdn_old, mdl_fq_name_old=mdl_fq_name_old, include_all_submdls_old=include_all_submdls_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, dev_fqdn_old: str = None, fetch_limit_old: int = None, mdl_fq_name_old: str = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if dev_fqdn_old is not None and not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if mdl_fq_name_old is not None and not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.module2device.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'dev_fqdn': dev_fqdn_old, 'fetch_limit': fetch_limit_old, 'mdl_fq_name': mdl_fq_name_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, dev_fqdn_old: str = None, fetch_limit_old: int = None, mdl_fq_name_old: str = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if dev_fqdn_old is not None and not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if mdl_fq_name_old is not None and not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, dev_fqdn_old=dev_fqdn_old, fetch_limit_old=fetch_limit_old, mdl_fq_name_old=mdl_fq_name_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(dev_fqdn_old: str, mdl_fq_name_old: str, dev_fqdn_new: str = None, mdl_fq_name_new: str = None, include_all_submdls_old: bool = True) -> dict:
		if dev_fqdn_new is not None and not (isinstance(dev_fqdn_new, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_new)}")
		if mdl_fq_name_new is not None and not (isinstance(mdl_fq_name_new, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_new)}")
		if not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")
		if include_all_submdls_old is not None and not (isinstance(include_all_submdls_old, bool)):
			raise ValueError(f"'include_all_submdls' of incorrect type. Expected bool, got {type(include_all_submdls_old)}")

		return {'name': 'nd.module2device.update', 'new': _denullify_dict({'dev_fqdn': dev_fqdn_new, 'mdl_fq_name': mdl_fq_name_new}), 'old': _denullify_dict({'dev_fqdn': dev_fqdn_old, 'mdl_fq_name': mdl_fq_name_old, 'include_all_submdls': include_all_submdls_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, dev_fqdn_old: str, mdl_fq_name_old: str, dev_fqdn_new: str = None, mdl_fq_name_new: str = None, include_all_submdls_old: bool = True) -> list:
		if dev_fqdn_new is not None and not (isinstance(dev_fqdn_new, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_new)}")
		if mdl_fq_name_new is not None and not (isinstance(mdl_fq_name_new, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_new)}")
		if not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if not (isinstance(mdl_fq_name_old, str)):
			raise ValueError(f"'mdl_fq_name' of incorrect type. Expected str, got {type(mdl_fq_name_old)}")
		if include_all_submdls_old is not None and not (isinstance(include_all_submdls_old, bool)):
			raise ValueError(f"'include_all_submdls' of incorrect type. Expected bool, got {type(include_all_submdls_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(dev_fqdn_new=dev_fqdn_new, mdl_fq_name_new=mdl_fq_name_new, dev_fqdn_old=dev_fqdn_old, mdl_fq_name_old=mdl_fq_name_old, include_all_submdls_old=include_all_submdls_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class DiqTa(APIObject):
	gpk: str
	owner: str
	is_own: bool
	position: int
	is_active: bool
	is_working: bool
	parent_gfk: str
	mail_on_error: bool
	last_devimp_ts: str
	last_devimp_msg: str
	mail_on_success: bool
	preserve_on_error: bool
	last_devimp_success: bool
	preserve_on_success: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.owner, str):
			raise ValueError(f"'owner' of incorrect type. Expected str, got {type(self.owner)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if self.position is not None and not isinstance(self.position, int):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(self.position)}")
		if not isinstance(self.is_active, bool):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(self.is_active)}")
		if not isinstance(self.is_working, bool):
			raise ValueError(f"'is_working' of incorrect type. Expected bool, got {type(self.is_working)}")
		if self.parent_gfk is not None and not isinstance(self.parent_gfk, str):
			raise ValueError(f"'parent_gfk' of incorrect type. Expected str, got {type(self.parent_gfk)}")
		if not isinstance(self.mail_on_error, bool):
			raise ValueError(f"'mail_on_error' of incorrect type. Expected bool, got {type(self.mail_on_error)}")
		if self.last_devimp_ts is not None and not isinstance(self.last_devimp_ts, str):
			raise ValueError(f"'last_devimp_ts' of incorrect type. Expected str, got {type(self.last_devimp_ts)}")
		if self.last_devimp_msg is not None and not isinstance(self.last_devimp_msg, str):
			raise ValueError(f"'last_devimp_msg' of incorrect type. Expected str, got {type(self.last_devimp_msg)}")
		if not isinstance(self.mail_on_success, bool):
			raise ValueError(f"'mail_on_success' of incorrect type. Expected bool, got {type(self.mail_on_success)}")
		if not isinstance(self.preserve_on_error, bool):
			raise ValueError(f"'preserve_on_error' of incorrect type. Expected bool, got {type(self.preserve_on_error)}")
		if self.last_devimp_success is not None and not isinstance(self.last_devimp_success, bool):
			raise ValueError(f"'last_devimp_success' of incorrect type. Expected bool, got {type(self.last_devimp_success)}")
		if not isinstance(self.preserve_on_success, bool):
			raise ValueError(f"'preserve_on_success' of incorrect type. Expected bool, got {type(self.preserve_on_success)}")

	@staticmethod
	def bulk_delete_ta(is_active_old: bool) -> dict:
		if not (isinstance(is_active_old, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_old)}")

		return {'name': 'nd.diq_ta.bulk_delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'is_active': is_active_old})}

	# TODO: Consider is_returning
	@classmethod
	def bulk_delete(cls, api_session: APISession, is_active_old: bool) -> list:
		if not (isinstance(is_active_old, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.bulk_delete_ta(is_active_old=is_active_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def create_ta(is_active_new: bool = False, do_set_top_new: bool = False, parent_gfk_new: str = None, mail_on_error_new: bool = False, mail_on_success_new: bool = False, preserve_on_error_new: bool = True, preserve_on_success_new: bool = False) -> dict:
		if is_active_new is not None and not (isinstance(is_active_new, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_new)}")
		if do_set_top_new is not None and not (isinstance(do_set_top_new, bool)):
			raise ValueError(f"'do_set_top' of incorrect type. Expected bool, got {type(do_set_top_new)}")
		if parent_gfk_new is not None and not (isinstance(parent_gfk_new, str)):
			raise ValueError(f"'parent_gfk' of incorrect type. Expected str, got {type(parent_gfk_new)}")
		if mail_on_error_new is not None and not (isinstance(mail_on_error_new, bool)):
			raise ValueError(f"'mail_on_error' of incorrect type. Expected bool, got {type(mail_on_error_new)}")
		if mail_on_success_new is not None and not (isinstance(mail_on_success_new, bool)):
			raise ValueError(f"'mail_on_success' of incorrect type. Expected bool, got {type(mail_on_success_new)}")
		if preserve_on_error_new is not None and not (isinstance(preserve_on_error_new, bool)):
			raise ValueError(f"'preserve_on_error' of incorrect type. Expected bool, got {type(preserve_on_error_new)}")
		if preserve_on_success_new is not None and not (isinstance(preserve_on_success_new, bool)):
			raise ValueError(f"'preserve_on_success' of incorrect type. Expected bool, got {type(preserve_on_success_new)}")

		return {'name': 'nd.diq_ta.create', 'new': _denullify_dict({'is_active': is_active_new, 'do_set_top': do_set_top_new, 'parent_gfk': parent_gfk_new, 'mail_on_error': mail_on_error_new, 'mail_on_success': mail_on_success_new, 'preserve_on_error': preserve_on_error_new, 'preserve_on_success': preserve_on_success_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, is_active_new: bool = False, do_set_top_new: bool = False, parent_gfk_new: str = None, mail_on_error_new: bool = False, mail_on_success_new: bool = False, preserve_on_error_new: bool = True, preserve_on_success_new: bool = False) -> list:
		if is_active_new is not None and not (isinstance(is_active_new, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_new)}")
		if do_set_top_new is not None and not (isinstance(do_set_top_new, bool)):
			raise ValueError(f"'do_set_top' of incorrect type. Expected bool, got {type(do_set_top_new)}")
		if parent_gfk_new is not None and not (isinstance(parent_gfk_new, str)):
			raise ValueError(f"'parent_gfk' of incorrect type. Expected str, got {type(parent_gfk_new)}")
		if mail_on_error_new is not None and not (isinstance(mail_on_error_new, bool)):
			raise ValueError(f"'mail_on_error' of incorrect type. Expected bool, got {type(mail_on_error_new)}")
		if mail_on_success_new is not None and not (isinstance(mail_on_success_new, bool)):
			raise ValueError(f"'mail_on_success' of incorrect type. Expected bool, got {type(mail_on_success_new)}")
		if preserve_on_error_new is not None and not (isinstance(preserve_on_error_new, bool)):
			raise ValueError(f"'preserve_on_error' of incorrect type. Expected bool, got {type(preserve_on_error_new)}")
		if preserve_on_success_new is not None and not (isinstance(preserve_on_success_new, bool)):
			raise ValueError(f"'preserve_on_success' of incorrect type. Expected bool, got {type(preserve_on_success_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(is_active_new=is_active_new, do_set_top_new=do_set_top_new, parent_gfk_new=parent_gfk_new, mail_on_error_new=mail_on_error_new, mail_on_success_new=mail_on_success_new, preserve_on_error_new=preserve_on_error_new, preserve_on_success_new=preserve_on_success_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(gpk_old: str) -> dict:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'nd.diq_ta.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, gpk_old: str) -> list:
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, owner_old: str = None, is_own_old: bool = None, position_old: int = None, is_active_old: bool = None, is_working_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, last_devimp_success_old: bool = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if owner_old is not None and not (isinstance(owner_old, str)):
			raise ValueError(f"'owner' of incorrect type. Expected str, got {type(owner_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if position_old is not None and not (isinstance(position_old, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_old)}")
		if is_active_old is not None and not (isinstance(is_active_old, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_old)}")
		if is_working_old is not None and not (isinstance(is_working_old, bool)):
			raise ValueError(f"'is_working' of incorrect type. Expected bool, got {type(is_working_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if last_devimp_success_old is not None and not (isinstance(last_devimp_success_old, bool)):
			raise ValueError(f"'last_devimp_success' of incorrect type. Expected bool, got {type(last_devimp_success_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.diq_ta.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'owner': owner_old, 'is_own': is_own_old, 'position': position_old, 'is_active': is_active_old, 'is_working': is_working_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'last_devimp_success': last_devimp_success_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, owner_old: str = None, is_own_old: bool = None, position_old: int = None, is_active_old: bool = None, is_working_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, last_devimp_success_old: bool = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if owner_old is not None and not (isinstance(owner_old, str)):
			raise ValueError(f"'owner' of incorrect type. Expected str, got {type(owner_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if position_old is not None and not (isinstance(position_old, int)):
			raise ValueError(f"'position' of incorrect type. Expected int, got {type(position_old)}")
		if is_active_old is not None and not (isinstance(is_active_old, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_old)}")
		if is_working_old is not None and not (isinstance(is_working_old, bool)):
			raise ValueError(f"'is_working' of incorrect type. Expected bool, got {type(is_working_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if last_devimp_success_old is not None and not (isinstance(last_devimp_success_old, bool)):
			raise ValueError(f"'last_devimp_success' of incorrect type. Expected bool, got {type(last_devimp_success_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, owner_old=owner_old, is_own_old=is_own_old, position_old=position_old, is_active_old=is_active_old, is_working_old=is_working_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, last_devimp_success_old=last_devimp_success_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(gpk_old: str, is_active_new: bool = None, do_set_top_new: bool = None, parent_gfk_new: str = None, mail_on_error_new: bool = None, mail_on_success_new: bool = None, preserve_on_error_new: bool = None, preserve_on_success_new: bool = None) -> dict:
		if is_active_new is not None and not (isinstance(is_active_new, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_new)}")
		if do_set_top_new is not None and not (isinstance(do_set_top_new, bool)):
			raise ValueError(f"'do_set_top' of incorrect type. Expected bool, got {type(do_set_top_new)}")
		if parent_gfk_new is not None and not (isinstance(parent_gfk_new, str)):
			raise ValueError(f"'parent_gfk' of incorrect type. Expected str, got {type(parent_gfk_new)}")
		if mail_on_error_new is not None and not (isinstance(mail_on_error_new, bool)):
			raise ValueError(f"'mail_on_error' of incorrect type. Expected bool, got {type(mail_on_error_new)}")
		if mail_on_success_new is not None and not (isinstance(mail_on_success_new, bool)):
			raise ValueError(f"'mail_on_success' of incorrect type. Expected bool, got {type(mail_on_success_new)}")
		if preserve_on_error_new is not None and not (isinstance(preserve_on_error_new, bool)):
			raise ValueError(f"'preserve_on_error' of incorrect type. Expected bool, got {type(preserve_on_error_new)}")
		if preserve_on_success_new is not None and not (isinstance(preserve_on_success_new, bool)):
			raise ValueError(f"'preserve_on_success' of incorrect type. Expected bool, got {type(preserve_on_success_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		return {'name': 'nd.diq_ta.update', 'new': _denullify_dict({'is_active': is_active_new, 'do_set_top': do_set_top_new, 'parent_gfk': parent_gfk_new, 'mail_on_error': mail_on_error_new, 'mail_on_success': mail_on_success_new, 'preserve_on_error': preserve_on_error_new, 'preserve_on_success': preserve_on_success_new}), 'old': _denullify_dict({'gpk': gpk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, gpk_old: str, is_active_new: bool = None, do_set_top_new: bool = None, parent_gfk_new: str = None, mail_on_error_new: bool = None, mail_on_success_new: bool = None, preserve_on_error_new: bool = None, preserve_on_success_new: bool = None) -> list:
		if is_active_new is not None and not (isinstance(is_active_new, bool)):
			raise ValueError(f"'is_active' of incorrect type. Expected bool, got {type(is_active_new)}")
		if do_set_top_new is not None and not (isinstance(do_set_top_new, bool)):
			raise ValueError(f"'do_set_top' of incorrect type. Expected bool, got {type(do_set_top_new)}")
		if parent_gfk_new is not None and not (isinstance(parent_gfk_new, str)):
			raise ValueError(f"'parent_gfk' of incorrect type. Expected str, got {type(parent_gfk_new)}")
		if mail_on_error_new is not None and not (isinstance(mail_on_error_new, bool)):
			raise ValueError(f"'mail_on_error' of incorrect type. Expected bool, got {type(mail_on_error_new)}")
		if mail_on_success_new is not None and not (isinstance(mail_on_success_new, bool)):
			raise ValueError(f"'mail_on_success' of incorrect type. Expected bool, got {type(mail_on_success_new)}")
		if preserve_on_error_new is not None and not (isinstance(preserve_on_error_new, bool)):
			raise ValueError(f"'preserve_on_error' of incorrect type. Expected bool, got {type(preserve_on_error_new)}")
		if preserve_on_success_new is not None and not (isinstance(preserve_on_success_new, bool)):
			raise ValueError(f"'preserve_on_success' of incorrect type. Expected bool, got {type(preserve_on_success_new)}")
		if not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(is_active_new=is_active_new, do_set_top_new=do_set_top_new, parent_gfk_new=parent_gfk_new, mail_on_error_new=mail_on_error_new, mail_on_success_new=mail_on_success_new, preserve_on_error_new=preserve_on_error_new, preserve_on_success_new=preserve_on_success_new, gpk_old=gpk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class DiqTaEntry(APIObject):
	gpk: str
	dev_nc: str
	dev_acg: str
	do_save: bool
	dev_fqdn: str
	dev_type: str
	do_parse: bool
	do_import: bool
	dev_parser: str
	diq_ta_gfk: str
	diq_ta_is_own: bool
	dev_description: str
	last_devimp_msg: str
	upload_filename: str
	output_verbosity: bool
	dev_attributes_dict: dict
	last_devimp_success: bool
	rplc_charset_errors: bool

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.dev_nc, str):
			raise ValueError(f"'dev_nc' of incorrect type. Expected str, got {type(self.dev_nc)}")
		if not isinstance(self.dev_acg, str):
			raise ValueError(f"'dev_acg' of incorrect type. Expected str, got {type(self.dev_acg)}")
		if not isinstance(self.do_save, bool):
			raise ValueError(f"'do_save' of incorrect type. Expected bool, got {type(self.do_save)}")
		if not isinstance(self.dev_fqdn, str):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(self.dev_fqdn)}")
		if not isinstance(self.dev_type, str):
			raise ValueError(f"'dev_type' of incorrect type. Expected str, got {type(self.dev_type)}")
		if not isinstance(self.do_parse, bool):
			raise ValueError(f"'do_parse' of incorrect type. Expected bool, got {type(self.do_parse)}")
		if not isinstance(self.do_import, bool):
			raise ValueError(f"'do_import' of incorrect type. Expected bool, got {type(self.do_import)}")
		if not isinstance(self.dev_parser, str):
			raise ValueError(f"'dev_parser' of incorrect type. Expected str, got {type(self.dev_parser)}")
		if not isinstance(self.diq_ta_gfk, str):
			raise ValueError(f"'diq_ta_gfk' of incorrect type. Expected str, got {type(self.diq_ta_gfk)}")
		if not isinstance(self.diq_ta_is_own, bool):
			raise ValueError(f"'diq_ta_is_own' of incorrect type. Expected bool, got {type(self.diq_ta_is_own)}")
		if self.dev_description is not None and not isinstance(self.dev_description, str):
			raise ValueError(f"'dev_description' of incorrect type. Expected str, got {type(self.dev_description)}")
		if self.last_devimp_msg is not None and not isinstance(self.last_devimp_msg, str):
			raise ValueError(f"'last_devimp_msg' of incorrect type. Expected str, got {type(self.last_devimp_msg)}")
		if self.upload_filename is not None and not isinstance(self.upload_filename, str):
			raise ValueError(f"'upload_filename' of incorrect type. Expected str, got {type(self.upload_filename)}")
		if not isinstance(self.output_verbosity, bool):
			raise ValueError(f"'output_verbosity' of incorrect type. Expected bool, got {type(self.output_verbosity)}")
		if not isinstance(self.dev_attributes_dict, dict):
			raise ValueError(f"'dev_attributes_dict' of incorrect type. Expected dict, got {type(self.dev_attributes_dict)}")
		if self.last_devimp_success is not None and not isinstance(self.last_devimp_success, bool):
			raise ValueError(f"'last_devimp_success' of incorrect type. Expected bool, got {type(self.last_devimp_success)}")
		if not isinstance(self.rplc_charset_errors, bool):
			raise ValueError(f"'rplc_charset_errors' of incorrect type. Expected bool, got {type(self.rplc_charset_errors)}")

	@staticmethod
	def create_ta(dev_fqdn_new: str, diq_ta_gfk_new: str, dev_nc_new: str = None, dev_acg_new: str = None, do_save_new: bool = True, dev_type_new: str = None, do_parse_new: bool = True, do_import_new: bool = True, dev_parser_new: str = None, dev_description_new: Union[str, ExplicitNull] = None, upload_filename_new: Union[str, ExplicitNull] = None, output_verbosity_new: bool = False, dev_attributes_dict_new: dict = None, rplc_charset_errors_new: bool = False) -> dict:
		if dev_nc_new is not None and not (isinstance(dev_nc_new, str)):
			raise ValueError(f"'dev_nc' of incorrect type. Expected str, got {type(dev_nc_new)}")
		if dev_acg_new is not None and not (isinstance(dev_acg_new, str)):
			raise ValueError(f"'dev_acg' of incorrect type. Expected str, got {type(dev_acg_new)}")
		if do_save_new is not None and not (isinstance(do_save_new, bool)):
			raise ValueError(f"'do_save' of incorrect type. Expected bool, got {type(do_save_new)}")
		if not (isinstance(dev_fqdn_new, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_new)}")
		if dev_type_new is not None and not (isinstance(dev_type_new, str)):
			raise ValueError(f"'dev_type' of incorrect type. Expected str, got {type(dev_type_new)}")
		if do_parse_new is not None and not (isinstance(do_parse_new, bool)):
			raise ValueError(f"'do_parse' of incorrect type. Expected bool, got {type(do_parse_new)}")
		if do_import_new is not None and not (isinstance(do_import_new, bool)):
			raise ValueError(f"'do_import' of incorrect type. Expected bool, got {type(do_import_new)}")
		if dev_parser_new is not None and not (isinstance(dev_parser_new, str)):
			raise ValueError(f"'dev_parser' of incorrect type. Expected str, got {type(dev_parser_new)}")
		if not (isinstance(diq_ta_gfk_new, str)):
			raise ValueError(f"'diq_ta_gfk' of incorrect type. Expected str, got {type(diq_ta_gfk_new)}")
		if dev_description_new is not None and not (isinstance(dev_description_new, str) or isinstance(dev_description_new, ExplicitNull)):
			raise ValueError(f"'dev_description' of incorrect type. Expected str, got {type(dev_description_new)}")
		if upload_filename_new is not None and not (isinstance(upload_filename_new, str) or isinstance(upload_filename_new, ExplicitNull)):
			raise ValueError(f"'upload_filename' of incorrect type. Expected str, got {type(upload_filename_new)}")
		if output_verbosity_new is not None and not (isinstance(output_verbosity_new, bool)):
			raise ValueError(f"'output_verbosity' of incorrect type. Expected bool, got {type(output_verbosity_new)}")
		if dev_attributes_dict_new is not None and not (isinstance(dev_attributes_dict_new, dict)):
			raise ValueError(f"'dev_attributes_dict' of incorrect type. Expected dict, got {type(dev_attributes_dict_new)}")
		if rplc_charset_errors_new is not None and not (isinstance(rplc_charset_errors_new, bool)):
			raise ValueError(f"'rplc_charset_errors' of incorrect type. Expected bool, got {type(rplc_charset_errors_new)}")

		return {'name': 'nd.diq_ta_entry.create', 'new': _denullify_dict({'dev_nc': dev_nc_new, 'dev_acg': dev_acg_new, 'do_save': do_save_new, 'dev_fqdn': dev_fqdn_new, 'dev_type': dev_type_new, 'do_parse': do_parse_new, 'do_import': do_import_new, 'dev_parser': dev_parser_new, 'diq_ta_gfk': diq_ta_gfk_new, 'dev_description': dev_description_new, 'upload_filename': upload_filename_new, 'output_verbosity': output_verbosity_new, 'dev_attributes_dict': dev_attributes_dict_new, 'rplc_charset_errors': rplc_charset_errors_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, dev_fqdn_new: str, diq_ta_gfk_new: str, dev_nc_new: str = None, dev_acg_new: str = None, do_save_new: bool = True, dev_type_new: str = None, do_parse_new: bool = True, do_import_new: bool = True, dev_parser_new: str = None, dev_description_new: Union[str, ExplicitNull] = None, upload_filename_new: Union[str, ExplicitNull] = None, output_verbosity_new: bool = False, dev_attributes_dict_new: dict = None, rplc_charset_errors_new: bool = False) -> list:
		if dev_nc_new is not None and not (isinstance(dev_nc_new, str)):
			raise ValueError(f"'dev_nc' of incorrect type. Expected str, got {type(dev_nc_new)}")
		if dev_acg_new is not None and not (isinstance(dev_acg_new, str)):
			raise ValueError(f"'dev_acg' of incorrect type. Expected str, got {type(dev_acg_new)}")
		if do_save_new is not None and not (isinstance(do_save_new, bool)):
			raise ValueError(f"'do_save' of incorrect type. Expected bool, got {type(do_save_new)}")
		if not (isinstance(dev_fqdn_new, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_new)}")
		if dev_type_new is not None and not (isinstance(dev_type_new, str)):
			raise ValueError(f"'dev_type' of incorrect type. Expected str, got {type(dev_type_new)}")
		if do_parse_new is not None and not (isinstance(do_parse_new, bool)):
			raise ValueError(f"'do_parse' of incorrect type. Expected bool, got {type(do_parse_new)}")
		if do_import_new is not None and not (isinstance(do_import_new, bool)):
			raise ValueError(f"'do_import' of incorrect type. Expected bool, got {type(do_import_new)}")
		if dev_parser_new is not None and not (isinstance(dev_parser_new, str)):
			raise ValueError(f"'dev_parser' of incorrect type. Expected str, got {type(dev_parser_new)}")
		if not (isinstance(diq_ta_gfk_new, str)):
			raise ValueError(f"'diq_ta_gfk' of incorrect type. Expected str, got {type(diq_ta_gfk_new)}")
		if dev_description_new is not None and not (isinstance(dev_description_new, str) or isinstance(dev_description_new, ExplicitNull)):
			raise ValueError(f"'dev_description' of incorrect type. Expected str, got {type(dev_description_new)}")
		if upload_filename_new is not None and not (isinstance(upload_filename_new, str) or isinstance(upload_filename_new, ExplicitNull)):
			raise ValueError(f"'upload_filename' of incorrect type. Expected str, got {type(upload_filename_new)}")
		if output_verbosity_new is not None and not (isinstance(output_verbosity_new, bool)):
			raise ValueError(f"'output_verbosity' of incorrect type. Expected bool, got {type(output_verbosity_new)}")
		if dev_attributes_dict_new is not None and not (isinstance(dev_attributes_dict_new, dict)):
			raise ValueError(f"'dev_attributes_dict' of incorrect type. Expected dict, got {type(dev_attributes_dict_new)}")
		if rplc_charset_errors_new is not None and not (isinstance(rplc_charset_errors_new, bool)):
			raise ValueError(f"'rplc_charset_errors' of incorrect type. Expected bool, got {type(rplc_charset_errors_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(dev_nc_new=dev_nc_new, dev_acg_new=dev_acg_new, do_save_new=do_save_new, dev_fqdn_new=dev_fqdn_new, dev_type_new=dev_type_new, do_parse_new=do_parse_new, do_import_new=do_import_new, dev_parser_new=dev_parser_new, diq_ta_gfk_new=diq_ta_gfk_new, dev_description_new=dev_description_new, upload_filename_new=upload_filename_new, output_verbosity_new=output_verbosity_new, dev_attributes_dict_new=dev_attributes_dict_new, rplc_charset_errors_new=rplc_charset_errors_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(dev_fqdn_old: str, diq_ta_gfk_old: str) -> dict:
		if not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if not (isinstance(diq_ta_gfk_old, str)):
			raise ValueError(f"'diq_ta_gfk' of incorrect type. Expected str, got {type(diq_ta_gfk_old)}")

		return {'name': 'nd.diq_ta_entry.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'dev_fqdn': dev_fqdn_old, 'diq_ta_gfk': diq_ta_gfk_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, dev_fqdn_old: str, diq_ta_gfk_old: str) -> list:
		if not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if not (isinstance(diq_ta_gfk_old, str)):
			raise ValueError(f"'diq_ta_gfk' of incorrect type. Expected str, got {type(diq_ta_gfk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(dev_fqdn_old=dev_fqdn_old, diq_ta_gfk_old=diq_ta_gfk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, dev_fqdn_old: str = None, diq_ta_gfk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, diq_ta_is_own_old: bool = None, filter_params_dict_old: dict = None, last_devimp_success_old: bool = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if dev_fqdn_old is not None and not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if diq_ta_gfk_old is not None and not (isinstance(diq_ta_gfk_old, str)):
			raise ValueError(f"'diq_ta_gfk' of incorrect type. Expected str, got {type(diq_ta_gfk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if diq_ta_is_own_old is not None and not (isinstance(diq_ta_is_own_old, bool)):
			raise ValueError(f"'diq_ta_is_own' of incorrect type. Expected bool, got {type(diq_ta_is_own_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if last_devimp_success_old is not None and not (isinstance(last_devimp_success_old, bool)):
			raise ValueError(f"'last_devimp_success' of incorrect type. Expected bool, got {type(last_devimp_success_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.diq_ta_entry.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'dev_fqdn': dev_fqdn_old, 'diq_ta_gfk': diq_ta_gfk_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'diq_ta_is_own': diq_ta_is_own_old, 'filter_params_dict': filter_params_dict_old, 'last_devimp_success': last_devimp_success_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, dev_fqdn_old: str = None, diq_ta_gfk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, diq_ta_is_own_old: bool = None, filter_params_dict_old: dict = None, last_devimp_success_old: bool = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if dev_fqdn_old is not None and not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if diq_ta_gfk_old is not None and not (isinstance(diq_ta_gfk_old, str)):
			raise ValueError(f"'diq_ta_gfk' of incorrect type. Expected str, got {type(diq_ta_gfk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if diq_ta_is_own_old is not None and not (isinstance(diq_ta_is_own_old, bool)):
			raise ValueError(f"'diq_ta_is_own' of incorrect type. Expected bool, got {type(diq_ta_is_own_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if last_devimp_success_old is not None and not (isinstance(last_devimp_success_old, bool)):
			raise ValueError(f"'last_devimp_success' of incorrect type. Expected bool, got {type(last_devimp_success_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, dev_fqdn_old=dev_fqdn_old, diq_ta_gfk_old=diq_ta_gfk_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, diq_ta_is_own_old=diq_ta_is_own_old, filter_params_dict_old=filter_params_dict_old, last_devimp_success_old=last_devimp_success_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(dev_fqdn_old: str, diq_ta_gfk_old: str, dev_nc_new: str = None, dev_acg_new: str = None, do_save_new: bool = None, dev_fqdn_new: str = None, dev_type_new: str = None, do_parse_new: bool = None, do_import_new: bool = None, dev_parser_new: str = None, diq_ta_gfk_new: str = None, dev_description_new: Union[str, ExplicitNull] = None, upload_filename_new: Union[str, ExplicitNull] = None, output_verbosity_new: bool = None, dev_attributes_dict_new: dict = None, rplc_charset_errors_new: bool = None) -> dict:
		if dev_nc_new is not None and not (isinstance(dev_nc_new, str)):
			raise ValueError(f"'dev_nc' of incorrect type. Expected str, got {type(dev_nc_new)}")
		if dev_acg_new is not None and not (isinstance(dev_acg_new, str)):
			raise ValueError(f"'dev_acg' of incorrect type. Expected str, got {type(dev_acg_new)}")
		if do_save_new is not None and not (isinstance(do_save_new, bool)):
			raise ValueError(f"'do_save' of incorrect type. Expected bool, got {type(do_save_new)}")
		if dev_fqdn_new is not None and not (isinstance(dev_fqdn_new, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_new)}")
		if dev_type_new is not None and not (isinstance(dev_type_new, str)):
			raise ValueError(f"'dev_type' of incorrect type. Expected str, got {type(dev_type_new)}")
		if do_parse_new is not None and not (isinstance(do_parse_new, bool)):
			raise ValueError(f"'do_parse' of incorrect type. Expected bool, got {type(do_parse_new)}")
		if do_import_new is not None and not (isinstance(do_import_new, bool)):
			raise ValueError(f"'do_import' of incorrect type. Expected bool, got {type(do_import_new)}")
		if dev_parser_new is not None and not (isinstance(dev_parser_new, str)):
			raise ValueError(f"'dev_parser' of incorrect type. Expected str, got {type(dev_parser_new)}")
		if diq_ta_gfk_new is not None and not (isinstance(diq_ta_gfk_new, str)):
			raise ValueError(f"'diq_ta_gfk' of incorrect type. Expected str, got {type(diq_ta_gfk_new)}")
		if dev_description_new is not None and not (isinstance(dev_description_new, str) or isinstance(dev_description_new, ExplicitNull)):
			raise ValueError(f"'dev_description' of incorrect type. Expected str, got {type(dev_description_new)}")
		if upload_filename_new is not None and not (isinstance(upload_filename_new, str) or isinstance(upload_filename_new, ExplicitNull)):
			raise ValueError(f"'upload_filename' of incorrect type. Expected str, got {type(upload_filename_new)}")
		if output_verbosity_new is not None and not (isinstance(output_verbosity_new, bool)):
			raise ValueError(f"'output_verbosity' of incorrect type. Expected bool, got {type(output_verbosity_new)}")
		if dev_attributes_dict_new is not None and not (isinstance(dev_attributes_dict_new, dict)):
			raise ValueError(f"'dev_attributes_dict' of incorrect type. Expected dict, got {type(dev_attributes_dict_new)}")
		if rplc_charset_errors_new is not None and not (isinstance(rplc_charset_errors_new, bool)):
			raise ValueError(f"'rplc_charset_errors' of incorrect type. Expected bool, got {type(rplc_charset_errors_new)}")
		if not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if not (isinstance(diq_ta_gfk_old, str)):
			raise ValueError(f"'diq_ta_gfk' of incorrect type. Expected str, got {type(diq_ta_gfk_old)}")

		return {'name': 'nd.diq_ta_entry.update', 'new': _denullify_dict({'dev_nc': dev_nc_new, 'dev_acg': dev_acg_new, 'do_save': do_save_new, 'dev_fqdn': dev_fqdn_new, 'dev_type': dev_type_new, 'do_parse': do_parse_new, 'do_import': do_import_new, 'dev_parser': dev_parser_new, 'diq_ta_gfk': diq_ta_gfk_new, 'dev_description': dev_description_new, 'upload_filename': upload_filename_new, 'output_verbosity': output_verbosity_new, 'dev_attributes_dict': dev_attributes_dict_new, 'rplc_charset_errors': rplc_charset_errors_new}), 'old': _denullify_dict({'dev_fqdn': dev_fqdn_old, 'diq_ta_gfk': diq_ta_gfk_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, dev_fqdn_old: str, diq_ta_gfk_old: str, dev_nc_new: str = None, dev_acg_new: str = None, do_save_new: bool = None, dev_fqdn_new: str = None, dev_type_new: str = None, do_parse_new: bool = None, do_import_new: bool = None, dev_parser_new: str = None, diq_ta_gfk_new: str = None, dev_description_new: Union[str, ExplicitNull] = None, upload_filename_new: Union[str, ExplicitNull] = None, output_verbosity_new: bool = None, dev_attributes_dict_new: dict = None, rplc_charset_errors_new: bool = None) -> list:
		if dev_nc_new is not None and not (isinstance(dev_nc_new, str)):
			raise ValueError(f"'dev_nc' of incorrect type. Expected str, got {type(dev_nc_new)}")
		if dev_acg_new is not None and not (isinstance(dev_acg_new, str)):
			raise ValueError(f"'dev_acg' of incorrect type. Expected str, got {type(dev_acg_new)}")
		if do_save_new is not None and not (isinstance(do_save_new, bool)):
			raise ValueError(f"'do_save' of incorrect type. Expected bool, got {type(do_save_new)}")
		if dev_fqdn_new is not None and not (isinstance(dev_fqdn_new, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_new)}")
		if dev_type_new is not None and not (isinstance(dev_type_new, str)):
			raise ValueError(f"'dev_type' of incorrect type. Expected str, got {type(dev_type_new)}")
		if do_parse_new is not None and not (isinstance(do_parse_new, bool)):
			raise ValueError(f"'do_parse' of incorrect type. Expected bool, got {type(do_parse_new)}")
		if do_import_new is not None and not (isinstance(do_import_new, bool)):
			raise ValueError(f"'do_import' of incorrect type. Expected bool, got {type(do_import_new)}")
		if dev_parser_new is not None and not (isinstance(dev_parser_new, str)):
			raise ValueError(f"'dev_parser' of incorrect type. Expected str, got {type(dev_parser_new)}")
		if diq_ta_gfk_new is not None and not (isinstance(diq_ta_gfk_new, str)):
			raise ValueError(f"'diq_ta_gfk' of incorrect type. Expected str, got {type(diq_ta_gfk_new)}")
		if dev_description_new is not None and not (isinstance(dev_description_new, str) or isinstance(dev_description_new, ExplicitNull)):
			raise ValueError(f"'dev_description' of incorrect type. Expected str, got {type(dev_description_new)}")
		if upload_filename_new is not None and not (isinstance(upload_filename_new, str) or isinstance(upload_filename_new, ExplicitNull)):
			raise ValueError(f"'upload_filename' of incorrect type. Expected str, got {type(upload_filename_new)}")
		if output_verbosity_new is not None and not (isinstance(output_verbosity_new, bool)):
			raise ValueError(f"'output_verbosity' of incorrect type. Expected bool, got {type(output_verbosity_new)}")
		if dev_attributes_dict_new is not None and not (isinstance(dev_attributes_dict_new, dict)):
			raise ValueError(f"'dev_attributes_dict' of incorrect type. Expected dict, got {type(dev_attributes_dict_new)}")
		if rplc_charset_errors_new is not None and not (isinstance(rplc_charset_errors_new, bool)):
			raise ValueError(f"'rplc_charset_errors' of incorrect type. Expected bool, got {type(rplc_charset_errors_new)}")
		if not (isinstance(dev_fqdn_old, str)):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(dev_fqdn_old)}")
		if not (isinstance(diq_ta_gfk_old, str)):
			raise ValueError(f"'diq_ta_gfk' of incorrect type. Expected str, got {type(diq_ta_gfk_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(dev_nc_new=dev_nc_new, dev_acg_new=dev_acg_new, do_save_new=do_save_new, dev_fqdn_new=dev_fqdn_new, dev_type_new=dev_type_new, do_parse_new=do_parse_new, do_import_new=do_import_new, dev_parser_new=dev_parser_new, diq_ta_gfk_new=diq_ta_gfk_new, dev_description_new=dev_description_new, upload_filename_new=upload_filename_new, output_verbosity_new=output_verbosity_new, dev_attributes_dict_new=dev_attributes_dict_new, rplc_charset_errors_new=rplc_charset_errors_new, dev_fqdn_old=dev_fqdn_old, diq_ta_gfk_old=diq_ta_gfk_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Vlan2device(APIObject):
	gpk: str
	dev_fqdn: str
	vlan_gfk: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.dev_fqdn, str):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(self.dev_fqdn)}")
		if not isinstance(self.vlan_gfk, str):
			raise ValueError(f"'vlan_gfk' of incorrect type. Expected str, got {type(self.vlan_gfk)}")

	@staticmethod
	def list_ta(gpk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.vlan2device.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Vxlan(APIObject):
	bcd: str
	gpk: str
	vni: int
	description: str

	def __post_init__(self):
		if not isinstance(self.bcd, str):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(self.bcd)}")
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.vni, int):
			raise ValueError(f"'vni' of incorrect type. Expected int, got {type(self.vni)}")
		if self.description is not None and not isinstance(self.description, str):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(self.description)}")

	@staticmethod
	def create_ta(bcd_new: str, vni_new: int = None, description_new: Union[str, ExplicitNull] = None) -> dict:
		if not (isinstance(bcd_new, str)):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(bcd_new)}")
		if vni_new is not None and not (isinstance(vni_new, int)):
			raise ValueError(f"'vni' of incorrect type. Expected int, got {type(vni_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		return {'name': 'nd.vxlan.create', 'new': _denullify_dict({'bcd': bcd_new, 'vni': vni_new, 'description': description_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, bcd_new: str, vni_new: int = None, description_new: Union[str, ExplicitNull] = None) -> list:
		if not (isinstance(bcd_new, str)):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(bcd_new)}")
		if vni_new is not None and not (isinstance(vni_new, int)):
			raise ValueError(f"'vni' of incorrect type. Expected int, got {type(vni_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(bcd_new=bcd_new, vni_new=vni_new, description_new=description_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(vni_old: int) -> dict:
		if not (isinstance(vni_old, int)):
			raise ValueError(f"'vni' of incorrect type. Expected int, got {type(vni_old)}")

		return {'name': 'nd.vxlan.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'vni': vni_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, vni_old: int) -> list:
		if not (isinstance(vni_old, int)):
			raise ValueError(f"'vni' of incorrect type. Expected int, got {type(vni_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(vni_old=vni_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, vni_old: int = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if vni_old is not None and not (isinstance(vni_old, int)):
			raise ValueError(f"'vni' of incorrect type. Expected int, got {type(vni_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.vxlan.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'vni': vni_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, vni_old: int = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if vni_old is not None and not (isinstance(vni_old, int)):
			raise ValueError(f"'vni' of incorrect type. Expected int, got {type(vni_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, vni_old=vni_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(vni_old: int, bcd_new: str = None, vni_new: int = None, description_new: Union[str, ExplicitNull] = None) -> dict:
		if bcd_new is not None and not (isinstance(bcd_new, str)):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(bcd_new)}")
		if vni_new is not None and not (isinstance(vni_new, int)):
			raise ValueError(f"'vni' of incorrect type. Expected int, got {type(vni_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(vni_old, int)):
			raise ValueError(f"'vni' of incorrect type. Expected int, got {type(vni_old)}")

		return {'name': 'nd.vxlan.update', 'new': _denullify_dict({'bcd': bcd_new, 'vni': vni_new, 'description': description_new}), 'old': _denullify_dict({'vni': vni_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, vni_old: int, bcd_new: str = None, vni_new: int = None, description_new: Union[str, ExplicitNull] = None) -> list:
		if bcd_new is not None and not (isinstance(bcd_new, str)):
			raise ValueError(f"'bcd' of incorrect type. Expected str, got {type(bcd_new)}")
		if vni_new is not None and not (isinstance(vni_new, int)):
			raise ValueError(f"'vni' of incorrect type. Expected int, got {type(vni_new)}")
		if description_new is not None and not (isinstance(description_new, str) or isinstance(description_new, ExplicitNull)):
			raise ValueError(f"'description' of incorrect type. Expected str, got {type(description_new)}")
		if not (isinstance(vni_old, int)):
			raise ValueError(f"'vni' of incorrect type. Expected int, got {type(vni_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(bcd_new=bcd_new, vni_new=vni_new, description_new=description_new, vni_old=vni_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Vxlan2device(APIObject):
	gpk: str
	dev_fqdn: str
	vxlan_vni: int

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.dev_fqdn, str):
			raise ValueError(f"'dev_fqdn' of incorrect type. Expected str, got {type(self.dev_fqdn)}")
		if not isinstance(self.vxlan_vni, int):
			raise ValueError(f"'vxlan_vni' of incorrect type. Expected int, got {type(self.vxlan_vni)}")

	@staticmethod
	def list_ta(gpk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.vxlan2device.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Bcd2group(APIObject):
	gpk: str
	is_own: bool
	bcd_name: str
	group_name: str
	parent_group_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.bcd_name, str):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(self.bcd_name)}")
		if not isinstance(self.group_name, str):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(self.group_name)}")
		if not isinstance(self.parent_group_name, str):
			raise ValueError(f"'parent_group_name' of incorrect type. Expected str, got {type(self.parent_group_name)}")

	@staticmethod
	def bulk_update_ta(bcd_name_list_new: list = None, group_name_list_new: list = None, bcd_name_old: str = None, group_name_old: str = None, bcd_name_list_old: list = None, group_name_list_old: list = None) -> dict:
		if bcd_name_list_new is not None and not (isinstance(bcd_name_list_new, list)):
			raise ValueError(f"'bcd_name_list' of incorrect type. Expected list, got {type(bcd_name_list_new)}")
		if group_name_list_new is not None and not (isinstance(group_name_list_new, list)):
			raise ValueError(f"'group_name_list' of incorrect type. Expected list, got {type(group_name_list_new)}")
		if bcd_name_old is not None and not (isinstance(bcd_name_old, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_old)}")
		if group_name_old is not None and not (isinstance(group_name_old, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_old)}")
		if bcd_name_list_old is not None and not (isinstance(bcd_name_list_old, list)):
			raise ValueError(f"'bcd_name_list' of incorrect type. Expected list, got {type(bcd_name_list_old)}")
		if group_name_list_old is not None and not (isinstance(group_name_list_old, list)):
			raise ValueError(f"'group_name_list' of incorrect type. Expected list, got {type(group_name_list_old)}")

		return {'name': 'nd.bcd2group.bulk_update', 'new': _denullify_dict({'bcd_name_list': bcd_name_list_new, 'group_name_list': group_name_list_new}), 'old': _denullify_dict({'bcd_name': bcd_name_old, 'group_name': group_name_old, 'bcd_name_list': bcd_name_list_old, 'group_name_list': group_name_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def bulk_update(cls, api_session: APISession, bcd_name_list_new: list = None, group_name_list_new: list = None, bcd_name_old: str = None, group_name_old: str = None, bcd_name_list_old: list = None, group_name_list_old: list = None) -> list:
		if bcd_name_list_new is not None and not (isinstance(bcd_name_list_new, list)):
			raise ValueError(f"'bcd_name_list' of incorrect type. Expected list, got {type(bcd_name_list_new)}")
		if group_name_list_new is not None and not (isinstance(group_name_list_new, list)):
			raise ValueError(f"'group_name_list' of incorrect type. Expected list, got {type(group_name_list_new)}")
		if bcd_name_old is not None and not (isinstance(bcd_name_old, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_old)}")
		if group_name_old is not None and not (isinstance(group_name_old, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_old)}")
		if bcd_name_list_old is not None and not (isinstance(bcd_name_list_old, list)):
			raise ValueError(f"'bcd_name_list' of incorrect type. Expected list, got {type(bcd_name_list_old)}")
		if group_name_list_old is not None and not (isinstance(group_name_list_old, list)):
			raise ValueError(f"'group_name_list' of incorrect type. Expected list, got {type(group_name_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.bulk_update_ta(bcd_name_list_new=bcd_name_list_new, group_name_list_new=group_name_list_new, bcd_name_old=bcd_name_old, group_name_old=group_name_old, bcd_name_list_old=bcd_name_list_old, group_name_list_old=group_name_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def create_ta(bcd_name_new: str, group_name_new: str) -> dict:
		if not (isinstance(bcd_name_new, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_new)}")
		if not (isinstance(group_name_new, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_new)}")

		return {'name': 'nd.bcd2group.create', 'new': _denullify_dict({'bcd_name': bcd_name_new, 'group_name': group_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, bcd_name_new: str, group_name_new: str) -> list:
		if not (isinstance(bcd_name_new, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_new)}")
		if not (isinstance(group_name_new, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(bcd_name_new=bcd_name_new, group_name_new=group_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(bcd_name_old: str, group_name_old: str) -> dict:
		if not (isinstance(bcd_name_old, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_old)}")
		if not (isinstance(group_name_old, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_old)}")

		return {'name': 'nd.bcd2group.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'bcd_name': bcd_name_old, 'group_name': group_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, bcd_name_old: str, group_name_old: str) -> list:
		if not (isinstance(bcd_name_old, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_old)}")
		if not (isinstance(group_name_old, str)):
			raise ValueError(f"'group_name' of incorrect type. Expected str, got {type(group_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(bcd_name_old=bcd_name_old, group_name_old=group_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, is_own_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, bcd_name_list_old: list = None, group_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if bcd_name_list_old is not None and not (isinstance(bcd_name_list_old, list)):
			raise ValueError(f"'bcd_name_list' of incorrect type. Expected list, got {type(bcd_name_list_old)}")
		if group_name_list_old is not None and not (isinstance(group_name_list_old, list)):
			raise ValueError(f"'group_name_list' of incorrect type. Expected list, got {type(group_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.bcd2group.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_own': is_own_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'bcd_name_list': bcd_name_list_old, 'group_name_list': group_name_list_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_own_old: bool = None, fetch_limit_old: int = None, fetch_offset_old: int = None, bcd_name_list_old: list = None, group_name_list_old: list = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if bcd_name_list_old is not None and not (isinstance(bcd_name_list_old, list)):
			raise ValueError(f"'bcd_name_list' of incorrect type. Expected list, got {type(bcd_name_list_old)}")
		if group_name_list_old is not None and not (isinstance(group_name_list_old, list)):
			raise ValueError(f"'group_name_list' of incorrect type. Expected list, got {type(group_name_list_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_own_old=is_own_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, bcd_name_list_old=bcd_name_list_old, group_name_list_old=group_name_list_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

@dataclass()
class Bcd2ou(APIObject):
	gpk: str
	is_own: bool
	bcd_name: str
	is_recursive: bool
	ou_short_name: str

	def __post_init__(self):
		if not isinstance(self.gpk, str):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(self.gpk)}")
		if not isinstance(self.is_own, bool):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(self.is_own)}")
		if not isinstance(self.bcd_name, str):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(self.bcd_name)}")
		if not isinstance(self.is_recursive, bool):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(self.is_recursive)}")
		if not isinstance(self.ou_short_name, str):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(self.ou_short_name)}")

	@staticmethod
	def create_ta(bcd_name_new: str, ou_short_name_new: str, is_recursive_new: bool = False) -> dict:
		if not (isinstance(bcd_name_new, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_new)}")
		if is_recursive_new is not None and not (isinstance(is_recursive_new, bool)):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(is_recursive_new)}")
		if not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")

		return {'name': 'nd.bcd2ou.create', 'new': _denullify_dict({'bcd_name': bcd_name_new, 'is_recursive': is_recursive_new, 'ou_short_name': ou_short_name_new}), 'old': _denullify_dict({})}

	# TODO: Consider is_returning
	@classmethod
	def create(cls, api_session: APISession, bcd_name_new: str, ou_short_name_new: str, is_recursive_new: bool = False) -> list:
		if not (isinstance(bcd_name_new, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_new)}")
		if is_recursive_new is not None and not (isinstance(is_recursive_new, bool)):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(is_recursive_new)}")
		if not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.create_ta(bcd_name_new=bcd_name_new, is_recursive_new=is_recursive_new, ou_short_name_new=ou_short_name_new, )])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def delete_ta(bcd_name_old: str, ou_short_name_old: str) -> dict:
		if not (isinstance(bcd_name_old, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_old)}")
		if not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")

		return {'name': 'nd.bcd2ou.delete', 'new': _denullify_dict({}), 'old': _denullify_dict({'bcd_name': bcd_name_old, 'ou_short_name': ou_short_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def delete(cls, api_session: APISession, bcd_name_old: str, ou_short_name_old: str) -> list:
		if not (isinstance(bcd_name_old, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_old)}")
		if not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.delete_ta(bcd_name_old=bcd_name_old, ou_short_name_old=ou_short_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def list_ta(gpk_old: str = None, is_own_old: bool = None, bcd_name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_recursive_old: bool = None, ou_short_name_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> dict:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if bcd_name_old is not None and not (isinstance(bcd_name_old, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_recursive_old is not None and not (isinstance(is_recursive_old, bool)):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(is_recursive_old)}")
		if ou_short_name_old is not None and not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		return {'name': 'nd.bcd2ou.list', 'new': _denullify_dict({}), 'old': _denullify_dict({'gpk': gpk_old, 'is_own': is_own_old, 'bcd_name': bcd_name_old, 'fetch_limit': fetch_limit_old, 'fetch_offset': fetch_offset_old, 'is_recursive': is_recursive_old, 'ou_short_name': ou_short_name_old, 'filter_params_dict': filter_params_dict_old, 'sorting_params_list': sorting_params_list_old})}

	# TODO: Consider is_returning
	@classmethod
	def list(cls, api_session: APISession, gpk_old: str = None, is_own_old: bool = None, bcd_name_old: str = None, fetch_limit_old: int = None, fetch_offset_old: int = None, is_recursive_old: bool = None, ou_short_name_old: str = None, filter_params_dict_old: dict = None, sorting_params_list_old: list = None) -> list:
		if gpk_old is not None and not (isinstance(gpk_old, str)):
			raise ValueError(f"'gpk' of incorrect type. Expected str, got {type(gpk_old)}")
		if is_own_old is not None and not (isinstance(is_own_old, bool)):
			raise ValueError(f"'is_own' of incorrect type. Expected bool, got {type(is_own_old)}")
		if bcd_name_old is not None and not (isinstance(bcd_name_old, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_old)}")
		if fetch_limit_old is not None and not (isinstance(fetch_limit_old, int)):
			raise ValueError(f"'fetch_limit' of incorrect type. Expected int, got {type(fetch_limit_old)}")
		if fetch_offset_old is not None and not (isinstance(fetch_offset_old, int)):
			raise ValueError(f"'fetch_offset' of incorrect type. Expected int, got {type(fetch_offset_old)}")
		if is_recursive_old is not None and not (isinstance(is_recursive_old, bool)):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(is_recursive_old)}")
		if ou_short_name_old is not None and not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")
		if filter_params_dict_old is not None and not (isinstance(filter_params_dict_old, dict)):
			raise ValueError(f"'filter_params_dict' of incorrect type. Expected dict, got {type(filter_params_dict_old)}")
		if sorting_params_list_old is not None and not (isinstance(sorting_params_list_old, list)):
			raise ValueError(f"'sorting_params_list' of incorrect type. Expected list, got {type(sorting_params_list_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.list_ta(gpk_old=gpk_old, is_own_old=is_own_old, bcd_name_old=bcd_name_old, fetch_limit_old=fetch_limit_old, fetch_offset_old=fetch_offset_old, is_recursive_old=is_recursive_old, ou_short_name_old=ou_short_name_old, filter_params_dict_old=filter_params_dict_old, sorting_params_list_old=sorting_params_list_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]

	@staticmethod
	def update_ta(bcd_name_old: str, ou_short_name_old: str, is_recursive_new: bool = None, ou_short_name_new: str = None) -> dict:
		if is_recursive_new is not None and not (isinstance(is_recursive_new, bool)):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(is_recursive_new)}")
		if ou_short_name_new is not None and not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if not (isinstance(bcd_name_old, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_old)}")
		if not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")

		return {'name': 'nd.bcd2ou.update', 'new': _denullify_dict({'is_recursive': is_recursive_new, 'ou_short_name': ou_short_name_new}), 'old': _denullify_dict({'bcd_name': bcd_name_old, 'ou_short_name': ou_short_name_old})}

	# TODO: Consider is_returning
	@classmethod
	def update(cls, api_session: APISession, bcd_name_old: str, ou_short_name_old: str, is_recursive_new: bool = None, ou_short_name_new: str = None) -> list:
		if is_recursive_new is not None and not (isinstance(is_recursive_new, bool)):
			raise ValueError(f"'is_recursive' of incorrect type. Expected bool, got {type(is_recursive_new)}")
		if ou_short_name_new is not None and not (isinstance(ou_short_name_new, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_new)}")
		if not (isinstance(bcd_name_old, str)):
			raise ValueError(f"'bcd_name' of incorrect type. Expected str, got {type(bcd_name_old)}")
		if not (isinstance(ou_short_name_old, str)):
			raise ValueError(f"'ou_short_name' of incorrect type. Expected str, got {type(ou_short_name_old)}")

		res = api_session.session.post(api_session.base_url + '/wapi/transaction/execute', json=[cls.update_ta(is_recursive_new=is_recursive_new, ou_short_name_new=ou_short_name_new, bcd_name_old=bcd_name_old, ou_short_name_old=ou_short_name_old)])
		if not res.ok:
			raise ExecutionError(res.status_code, res.reason, res.json() if "json" in res.headers["content-type"] else res.text)
		return [cls(**s) for s in res.json()[0]]
